'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMaterialResponsiveGrid = require('react-material-responsive-grid');

var _AppControls = require('./AppControls');

var _KmPlot = require('./KmPlot');

var _SheetControls = require('./SheetControls');

var _SheetControls2 = _interopRequireDefault(_SheetControls);

var _StateError = require('./StateError');

var _StateError2 = _interopRequireDefault(_StateError);

var _underscore_ext = require('./underscore_ext');

var _underscore_ext2 = _interopRequireDefault(_underscore_ext);

var _Stepper = require('./views/Stepper');

var _WelcomeContainer = require('./containers/WelcomeContainer');

var _WelcomeContainer2 = _interopRequireDefault(_WelcomeContainer);

require('../css/index.css');

var _reactCssThemr = require('react-css-themr');

var _appTheme = require('./appTheme');

var _appTheme2 = _interopRequireDefault(_appTheme);

var _nav = require('./nav');

var _nav2 = _interopRequireDefault(_nav);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var gaEvents = require('./gaEvents');
//var Perf = require('react/lib/ReactDefaultPerf');

// Root styles file (reset, fonts, globals)
var stepperSteps = [{ label: 'Select a Study to Explore' }, { label: 'Select Your First Variable' }, { label: 'Select Your Second Variable' }];
var stepperStateIndex = {
	'COHORT': 0,
	'FIRST_COLUMN': 1,
	'SECOND_COLUMN': 2
};

// should really be in a config file.
var searchHelp = 'https://ucsc-xena.gitbook.io/project/overview-of-features/filter-and-subgrouping';

function clearZoom(samples, zoom) {
	return _underscore_ext2.default.merge(zoom, { count: samples, index: 0 });
}

function zoomOut(samples, zoom) {
	var count = zoom.count,
	    index = zoom.index;

	var nCount = Math.min(samples, Math.round(count * 3)),
	    maxIndex = samples - nCount,
	    nIndex = Math.max(0, Math.min(Math.round(index + (count - nCount) / 2), maxIndex));

	return _underscore_ext2.default.merge(zoom, { count: nCount, index: nIndex });
}

var Application = function (_Component) {
	(0, _inherits3.default)(Application, _Component);

	function Application() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Application);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Application.__proto__ || (0, _getPrototypeOf2.default)(Application)).call.apply(_ref, [this].concat(args))), _this), _this.onClearZoom = function () {
			var _this$props$state = _this.props.state,
			    samples = _this$props$state.samples,
			    zoom = _this$props$state.zoom;

			_this.props.callback(['zoom', clearZoom(samples.length, zoom)]);
		}, _this.onHideError = function () {
			_this.props.callback(['stateError', undefined]);
		}, _this.onShowWelcome = function () {
			_this.props.onShowWelcome(true);
		}, _this.onHideWelcome = function () {
			_this.props.onShowWelcome(false);
		}, _this.onZoomOut = function () {
			var _this$props$state2 = _this.props.state,
			    samples = _this$props$state2.samples,
			    zoom = _this$props$state2.zoom;

			gaEvents('spreadsheet', 'zoom', 'out');
			_this.props.callback(['zoom', zoomOut(samples.length, zoom)]);
			_this.props.callback(['enableTransition', false]);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Application, [{
		key: 'componentDidUpdate',

		//	onPerf = () => {
		//		if (this.perf) {
		//			this.perf = false;
		//			console.log('stop perf');
		//			Perf.stop();
		//			var m = Perf.getLastMeasurements();
		//			console.log('inclusive');
		//			Perf.printInclusive(m);
		//			console.log('exclusive');
		//			Perf.printExclusive(m);
		//			console.log('wasted');
		//			Perf.printWasted(m);
		//		} else {
		//			this.perf = true;
		//			console.log('start perf');
		//			Perf.start();
		//		}
		//	}
		value: function componentDidUpdate() {
			var _props = this.props,
			    getState = _props.getState,
			    onImport = _props.onImport,
			    onNavigate = _props.onNavigate,
			    isPublic = _props.state.isPublic;

			// nested render to different DOM tree

			(0, _nav2.default)({ isPublic: isPublic, getState: getState, onImport: onImport, onNavigate: onNavigate, activeLink: 'heatmap' });
		}
	}, {
		key: 'render',

		//	onSearchIDAndFilterColumn = (qsamplesList) => {
		//		var {state: {samples, cohortSamples}} = this.props,
		//			qsampleListObj = {},
		//			cohortSamplesList = [];
		//
		//		_.map(qsamplesList, (s, i)=>{
		//			qsampleListObj[s] = i + 1;
		//		});
		//		cohortSamplesList = _.flatten(_.map(Object.keys(cohortSamples), i => cohortSamples[i]));
		//
		//		var matches = _.filter(samples, s => qsampleListObj[cohortSamplesList[s]]),
		//			fieldLabel = matches.length + ((matches.length === 1) ? ' match' : ' matches');
		//		this.onFilterColumn(matches, 'sample list', fieldLabel);
		//	};
		value: function render() {
			var _props2 = this.props,
			    state = _props2.state,
			    stateError = _props2.stateError,
			    children = _props2.children,
			    stepperState = _props2.stepperState,
			    loadPending = _props2.loadPending,
			    otherProps = (0, _objectWithoutProperties3.default)(_props2, ['state', 'stateError', 'children', 'stepperState', 'loadPending']),
			    callback = otherProps.callback,
			    editing = state.editing,
			    wizardMode = state.wizardMode,
			    showWelcome = state.showWelcome,
			    zoom = state.zoom;
			//			onSearchIDAndFilterColumn = this.onSearchIDAndFilterColumn;

			if (loadPending) {
				return _react2.default.createElement(
					'p',
					{ style: { margin: 10 } },
					'Loading your view...'
				);
			}

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ style: { position: 'relative' } },
					' ',
					showWelcome ? _react2.default.createElement(_WelcomeContainer2.default, { onClick: this.onHideWelcome }) : null,
					wizardMode ? _react2.default.createElement(_Stepper.Stepper, { mode: stepperState, steps: stepperSteps, stateIndex: stepperStateIndex }) : _react2.default.createElement(
						'div',
						null,
						_react2.default.createElement(_AppControls.AppControls, (0, _extends3.default)({}, otherProps, { appState: state, help: searchHelp,
							zoom: zoom, onShowWelcome: this.onShowWelcome })),
						_react2.default.createElement(_SheetControls2.default, { actionsDisabled: true, appState: state, clearZoom: this.onClearZoom,
							statusDisabled: editing !== null, zoom: zoom, zoomOut: this.onZoomOut })
					),
					_react2.default.createElement(
						_reactMaterialResponsiveGrid.Grid,
						{ onClick: this.onClick },
						_react2.default.createElement(
							_reactMaterialResponsiveGrid.Row,
							null,
							_react2.default.createElement(
								_reactMaterialResponsiveGrid.Col,
								{ xs4: 4, style: { position: 'relative' } },
								children
							)
						)
					),
					_underscore_ext2.default.getIn(state, ['km', 'id']) ? _react2.default.createElement(_KmPlot.KmPlot, {
						callback: callback,
						survivalKeys: _underscore_ext2.default.keys(state.survival),
						km: state.km,
						cohort: state.cohort.name }) : null,
					stateError ? _react2.default.createElement(_StateError2.default, { onHide: this.onHideError, error: stateError }) : null
				)
			);
		}
	}]);
	return Application;
}(_react.Component);

var ThemedApplication = function ThemedApplication(props) {
	return _react2.default.createElement(
		_reactCssThemr.ThemeProvider,
		{ theme: _appTheme2.default },
		_react2.default.createElement(Application, props)
	);
};

module.exports = ThemedApplication;