'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

var tickPadding = 3;
function horzLayout(domain, range, scale, tickfn, tickHeight) {
	return tickfn.apply(null, domain).map(function (x) {
		return [[scale(x), 0], [0, tickHeight], [0, tickHeight + tickPadding], x.toLocaleString(), 'middle', '.71em'];
	});
}

function vertLayout(domain, range, scale, tickfn, tickHeight) {
	return tickfn.apply(null, domain).map(function (y) {
		return [[0, scale(y)], [-tickHeight, 0], [-(tickHeight + tickPadding), 0], y.toLocaleString(), 'end', '.32em'];
	});
}

var layout = {
	bottom: horzLayout,
	left: vertLayout
};

var domainPath = {
	bottom: function bottom(_ref, height) {
		var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
		    start = _ref2[0],
		    end = _ref2[1];

		return 'M' + start + ',' + height + 'V0H' + end + 'V' + height;
	},
	left: function left(_ref3, height) {
		var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
		    start = _ref4[0],
		    end = _ref4[1];

		return 'M' + -height + ',' + start + 'H0V' + end + 'H' + -height;
	}
};

var Axis = function (_React$Component) {
	(0, _inherits3.default)(Axis, _React$Component);

	function Axis() {
		(0, _classCallCheck3.default)(this, Axis);
		return (0, _possibleConstructorReturn3.default)(this, (Axis.__proto__ || (0, _getPrototypeOf2.default)(Axis)).apply(this, arguments));
	}

	(0, _createClass3.default)(Axis, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    domain = _props.domain,
			    range = _props.range,
			    scale = _props.scale,
			    tickfn = _props.tickfn,
			    orientation = _props.orientation,
			    _props$groupProps = _props.groupProps,
			    groupProps = _props$groupProps === undefined ? {} : _props$groupProps,
			    _props$tickHeight = _props.tickHeight,
			    tickHeight = _props$tickHeight === undefined ? 6 : _props$tickHeight;

			var ticks = layout[orientation](domain, range, scale, tickfn, tickHeight);
			return React.createElement(
				'g',
				groupProps,
				React.createElement('path', { className: 'domain', d: domainPath[orientation](range, tickHeight) }),
				ticks.map(function (_ref5, i) {
					var _ref6 = (0, _slicedToArray3.default)(_ref5, 6),
					    _ref6$ = (0, _slicedToArray3.default)(_ref6[0], 2),
					    x = _ref6$[0],
					    y = _ref6$[1],
					    _ref6$2 = (0, _slicedToArray3.default)(_ref6[1], 2),
					    dx = _ref6$2[0],
					    dy = _ref6$2[1],
					    _ref6$3 = (0, _slicedToArray3.default)(_ref6[2], 2),
					    lx = _ref6$3[0],
					    ly = _ref6$3[1],
					    label = _ref6[3],
					    anchor = _ref6[4],
					    off = _ref6[5];

					return React.createElement(
						'g',
						{ key: i, transform: 'translate(' + x + ', ' + y + ')' },
						React.createElement('line', { x2: dx, y2: dy }),
						React.createElement(
							'text',
							{ dy: off, y: ly, x: lx, style: { textAnchor: anchor } },
							label
						)
					);
				}),
				this.props.children
			);
		}
	}]);
	return Axis;
}(React.Component);

module.exports = Axis;