'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// React component to manages redrawing a canvas element.


var _ = require('./underscore_ext');
var vgmixed = require('./vgmixed');
var React = require('react');
var ReactDOM = require('react-dom');

// Styles
var compStyles = require('./CanvasDrawing.module.css');
var classNames = require('classnames');

var CanvasDrawing = function (_React$Component) {
	(0, _inherits3.default)(CanvasDrawing, _React$Component);

	function CanvasDrawing() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, CanvasDrawing);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CanvasDrawing.__proto__ || (0, _getPrototypeOf2.default)(CanvasDrawing)).call.apply(_ref, [this].concat(args))), _this), _this.setHeight = function (height) {
			_this.vg.height(height);
			_this.refs.div.style.height = height + 'px';
			_this.refs.labels.style.height = height + 'px';
			_this.refs.labels.style.top = '-' + height + 'px';
		}, _this.setWidth = function (width) {
			_this.vg.width(width);
			_this.refs.div.style.width = width + 'px';
			_this.refs.labels.style.width = width + 'px';
		}, _this.draw = function (props) {
			var draw = props.draw,
			    drawProps = (0, _objectWithoutProperties3.default)(props, ['draw']),
			    zoom = drawProps.zoom,
			    width = drawProps.width,
			    height = zoom.height,
			    vg = _this.vg;


			if (vg.width() !== width) {
				_this.setWidth(width);
			}

			if (vg.height() !== height) {
				_this.setHeight(height);
			}

			draw(vg, drawProps);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(CanvasDrawing, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (this.vg && !_.isEqual(newProps, this.props)) {
				this.draw(newProps);
			}
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate() {
			return false;
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    width = _props.width,
			    height = _props.zoom.height,
			    wrapperProps = _props.wrapperProps,
			    _ref2 = wrapperProps || {},
			    className = _ref2.className,
			    props = (0, _objectWithoutProperties3.default)(_ref2, ['className']),
			    classes = classNames(className, compStyles.wrapper); // Must add tooltip class, if specified in props


			return React.createElement(
				'div',
				(0, _extends3.default)({ ref: 'div' }, props, { className: classes, style: { width: width, height: height } }),
				React.createElement('canvas', { className: compStyles.canvas, ref: 'canvas' }),
				React.createElement('div', { className: compStyles.labels, style: { top: -height, width: width, height: height }, ref: 'labels' })
			);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _props2 = this.props,
			    width = _props2.width,
			    height = _props2.zoom.height;

			this.vg = vgmixed(ReactDOM.findDOMNode(this.refs.canvas), width, height, ReactDOM.findDOMNode(this.refs.labels));
			this.draw(this.props);
		}
	}]);
	return CanvasDrawing;
}(React.Component);

module.exports = CanvasDrawing;