'use strict';

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// React component to manages redrawing a canvas element.


var _ = require('./underscore_ext');
var vgcanvas = require('./vgcanvas');
var React = require('react');
var ReactDOM = require('react-dom');

// This is a quick hack to work around the very different styling requirements
// of BandLegend, vs. the other canvas elements we have. Here we never change
// the pixel buffer size, but manipulate the canvas css size to scale over
// resize. The main point of this is that the size of the canvas width is
// driven by the css, so we're not holding the final width when we draw.

var CanvasDrawing = function (_React$Component) {
	(0, _inherits3.default)(CanvasDrawing, _React$Component);

	function CanvasDrawing() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, CanvasDrawing);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CanvasDrawing.__proto__ || (0, _getPrototypeOf2.default)(CanvasDrawing)).call.apply(_ref, [this].concat(args))), _this), _this.setHeight = function (height) {
			_this.vg.height(height);
		}, _this.setWidth = function (width) {
			_this.vg.width(width);
		}, _this.draw = function (props) {
			var draw = props.draw,
			    drawProps = (0, _objectWithoutProperties3.default)(props, ['draw']),
			    zoom = drawProps.zoom,
			    width = drawProps.width,
			    height = zoom.height,
			    vg = _this.vg;


			if (vg.width() !== width) {
				_this.setWidth(width);
			}

			if (vg.height() !== height) {
				_this.setHeight(height);
			}

			draw(vg, drawProps);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(CanvasDrawing, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (this.vg && !_.isEqual(newProps, this.props)) {
				this.draw(newProps);
			}
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate() {
			return false;
		}
	}, {
		key: 'render',
		value: function render() {
			var style = this.props.style;

			return React.createElement('canvas', { style: style, ref: 'canvas' });
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _props = this.props,
			    width = _props.width,
			    height = _props.zoom.height;

			this.vg = vgcanvas(ReactDOM.findDOMNode(this.refs.canvas), width, height);
			this.draw(this.props);
		}
	}]);
	return CanvasDrawing;
}(React.Component);

module.exports = CanvasDrawing;