'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _class, _temp6;

var _link = require('react-toolbox/lib/link');

var _link2 = _interopRequireDefault(_link);

var _checkbox = require('react-toolbox/lib/checkbox');

var _button = require('react-toolbox/lib/button');

var _dialog = require('react-toolbox/lib/dialog');

var _dialog2 = _interopRequireDefault(_dialog);

var _urlParams = require('./urlParams');

var _reactCssThemr = require('react-css-themr');

var _PureComponent3 = require('./PureComponent');

var _PureComponent4 = _interopRequireDefault(_PureComponent3);

var _LaunchHelper = require('./LaunchHelper');

var _LaunchHelper2 = _interopRequireDefault(_LaunchHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

require('./base');
var React = require('react');

var _require = require('./underscore_ext'),
    uniq = _require.uniq,
    flatten = _require.flatten,
    sortBy = _require.sortBy,
    groupBy = _require.groupBy,
    map = _require.map,
    flatmap = _require.flatmap,
    partitionN = _require.partitionN,
    mapObject = _require.mapObject,
    contains = _require.contains,
    get = _require.get,
    updateIn = _require.updateIn,
    range = _require.range,
    Let = _require.Let,
    pick = _require.pick,
    zip = _require.zip,
    identity = _require.identity,
    getIn = _require.getIn,
    sum = _require.sum,
    keys = _require.keys,
    values = _require.values,
    mmap = _require.mmap;

var _require2 = require('./rx'),
    from = _require2.Observable.from,
    animationFrame = _require2.Scheduler.animationFrame;

var _require3 = require('./xenaQuery'),
    parseDsID = _require3.parseDsID;

var styles = require('./Datapages.module.css');
var nav = require('./nav');

var showdown = require('showdown');

var _require4 = require('./dom_helper'),
    stripHTML = _require4.stripHTML;

var treehouseImg = require('../images/Treehouse.jpg');

var _require5 = require('./react-utils'),
    rxEvents = _require5.rxEvents;

var _require6 = require('./defaultServers'),
    localHub = _require6.servers.localHub,
    serverNames = _require6.serverNames;

var _require7 = require('./util'),
    encodeObject = _require7.encodeObject,
    urlParams = _require7.urlParams;

var appTheme = require('./appTheme');
var classNames = require('classnames');

var _require8 = require('./hubParams'),
    getHubParams = _require8.getHubParams;

var getHubName = function getHubName(host) {
	return get(serverNames, host, host);
};

var isLocalHub = function isLocalHub(host) {
	return host === localHub;
};

var pluralize = function pluralize(str, count) {
	return count === 1 ? '1 ' + str : count + ' ' + str + 's';
};

// Get params from the anchor href. With RT Link, the anchor is parentElement.
var paramFromHref = function paramFromHref(ev) {
	return mapObject(urlParams(ev.target.parentElement.href), function (a) {
		return a[0];
	});
};

//
// event handler for navigating within datapages. Prevents page load, and
// sets url params.
//

function navHandler(ev) {
	ev.preventDefault();
	this.props.callback(['navigate', 'datapages', paramFromHref(ev, this.props.state)]);
}

var getUserServers = function getUserServers(servers) {
	return keys(servers).filter(function (k) {
		return servers[k].user;
	});
};

//
// Data hubs sidebar
//

var hubLink = function hubLink(host, onClick, hubParams) {
	return React.createElement(_link2.default, {
		className: classNames(styles.link, styles.checkboxLink),
		href: '?' + encodeObject((0, _extends3.default)({ host: host }, hubParams)),
		label: getHubName(host),
		onClick: onClick });
};

var DataHubs = function (_React$Component) {
	(0, _inherits3.default)(DataHubs, _React$Component);

	function DataHubs() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, DataHubs);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DataHubs.__proto__ || (0, _getPrototypeOf2.default)(DataHubs)).call.apply(_ref, [this].concat(args))), _this), _this.onHub = function (ev) {
			navHandler.call(_this, ev);
		}, _this.onSelect = function (isOn, ev) {
			var checked = ev.target.checked,
			    host = ev.target.getAttribute('data-host');

			_this.props.callback([checked ? 'enable-host' : 'disable-host', host, 'user']);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(DataHubs, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    hubParams = _props.hubParams,
			    servers = _props.state.spreadsheet.servers;

			return React.createElement(
				'div',
				{ className: styles.dataHubs },
				React.createElement(
					'h2',
					null,
					'Active Data Hubs'
				),
				React.createElement(
					'ul',
					null,
					map(servers, function (_ref2, host) {
						var user = _ref2.user;
						return React.createElement(
							'li',
							{ key: host },
							React.createElement(_checkbox.Checkbox, {
								label: hubLink(host, _this2.onHub, hubParams),
								onChange: _this2.onSelect,
								checked: user,
								'data-host': host })
						);
					})
				)
			);
		}
	}]);
	return DataHubs;
}(React.Component);

//
// Cohort Summary Page
//

var treehouse = function treehouse(cohort) {
	return cohort.search(/^Treehouse/gi) === -1 ? null : React.createElement('img', { src: treehouseImg, height: '40px' });
};

var cohortLink = function cohortLink(cohort, onClick, hubParams) {
	return React.createElement(_link2.default, {
		className: styles.link,
		href: '?' + encodeObject((0, _extends3.default)({ cohort: cohort }, hubParams)),
		label: cohort,
		onClick: onClick });
};

var collateCohorts = function collateCohorts(hubCohorts) {
	return flatten(values(hubCohorts)).reduce(function (acc, cohort) {
		return cohort.cohort ? updateIn(acc, [cohort.cohort], function () {
			var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
			return cohort.count + v;
		}) : acc;
	}, {});
};

var CohortSummary = function CohortSummary(_ref3) {
	var cohorts = _ref3.cohorts,
	    onCohort = _ref3.onCohort,
	    hubParams = _ref3.hubParams,
	    action = _ref3.action;

	var names = sortBy(keys(cohorts), function (c) {
		return c.toLowerCase();
	}),
	    nCohorts = names.length,
	    nDatasets = sum(values(cohorts));
	return React.createElement(
		'div',
		null,
		React.createElement(
			'h2',
			null,
			pluralize('Cohort', nCohorts),
			', ',
			pluralize('Dataset', nDatasets),
			' ',
			action
		),
		React.createElement(
			'ul',
			{ className: styles.list },
			map(names, function (name) {
				return React.createElement(
					'li',
					{ key: name },
					treehouse(name),
					cohortLink(name, onCohort, hubParams),
					' (' + pluralize('dataset', cohorts[name]) + ')'
				);
			})
		)
	);
};

var CohortHeader = function CohortHeader(_ref4) {
	var inHubs = _ref4.inHubs,
	    host = _ref4.host,
	    onImport = _ref4.onImport,
	    badge = _ref4.badge;

	var localHubUp = getIn(badge, ['props', 'title']) === "Connected to local Xena Hub";

	return React.createElement(
		'div',
		null,
		React.createElement(
			'h2',
			{ className: styles.inline },
			getHubName(host),
			inHubs,
			badge
		),
		isLocalHub(host) && React.createElement(
			'div',
			{ className: styles.headerButtons },
			localHubUp ? React.createElement(_button.Button, { label: "Load Data", onClick: onImport, accent: true }) : null,
			React.createElement(_button.Button, { label: "Help", target: '_blank', href: 'https://ucsc-xena.gitbook.io/project/local-xena-hub', accent: true })
		),
		isLocalHub(host) ? null : React.createElement(
			'p',
			null,
			'Hub address: ',
			host
		),
		isLocalHub(host) && React.createElement(
			'div',
			{ className: styles.descriptionBox },
			React.createElement(
				'p',
				null,
				'A Local Xena Hub is an application on your computer for loading and storing data.'
			),
			React.createElement(
				'p',
				null,
				'We support most types of genomic and/or phenotypic/clinical/annotation data. This data can be your own or from another source, such as a publication.'
			),
			React.createElement(
				'p',
				null,
				'Data on a Local Xena Hub can only be viewed or accessed by the same computer on which it is running.'
			)
		)
	);
};

var CohortSummaryPage = function (_React$Component2) {
	(0, _inherits3.default)(CohortSummaryPage, _React$Component2);

	function CohortSummaryPage() {
		var _ref5;

		var _temp2, _this3, _ret2;

		(0, _classCallCheck3.default)(this, CohortSummaryPage);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this3 = (0, _possibleConstructorReturn3.default)(this, (_ref5 = CohortSummaryPage.__proto__ || (0, _getPrototypeOf2.default)(CohortSummaryPage)).call.apply(_ref5, [this].concat(args))), _this3), _this3.onCohort = function (ev) {
			navHandler.call(_this3, ev);
		}, _temp2), (0, _possibleConstructorReturn3.default)(_this3, _ret2);
	}

	(0, _createClass3.default)(CohortSummaryPage, [{
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    hubParams = _props2.hubParams,
			    state = _props2.state,
			    servers = state.spreadsheet.servers,
			    userServers = getUserServers(servers),
			    cohorts = getIn(this.props.state, ['datapages', 'cohorts'], {}),
			    activeCohorts = pick(cohorts, userServers),
			    combined = collateCohorts(activeCohorts);

			return React.createElement(
				'div',
				{ className: styles.datapages },
				React.createElement(DataHubs, this.props),
				React.createElement(CohortSummary, { hubParams: hubParams, cohorts: combined, onCohort: this.onCohort })
			);
		}
	}]);
	return CohortSummaryPage;
}(React.Component);

//
// Dataset delete button
//

var DeleteButton = function (_React$Component3) {
	(0, _inherits3.default)(DeleteButton, _React$Component3);

	function DeleteButton() {
		var _ref6;

		var _temp3, _this4, _ret3;

		(0, _classCallCheck3.default)(this, DeleteButton);

		for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
			args[_key3] = arguments[_key3];
		}

		return _ret3 = (_temp3 = (_this4 = (0, _possibleConstructorReturn3.default)(this, (_ref6 = DeleteButton.__proto__ || (0, _getPrototypeOf2.default)(DeleteButton)).call.apply(_ref6, [this].concat(args))), _this4), _this4.state = { active: false }, _this4.onDelete = function () {
			_this4.setState({ active: !_this4.state.active });
		}, _this4.onReally = function () {
			var name = _this4.props.name;

			_this4.setState({ active: false });
			_this4.props.callback(['delete-dataset', localHub, name]);
		}, _this4.actions = function () {
			return [{ label: 'Cancel', onClick: _this4.onDelete }, { label: 'Really Delete', onClick: _this4.onReally }];
		}, _temp3), (0, _possibleConstructorReturn3.default)(_this4, _ret3);
	}

	(0, _createClass3.default)(DeleteButton, [{
		key: 'render',
		value: function render() {
			var active = this.state.active,
			    label = this.props.label;

			return React.createElement(
				'div',
				{ className: styles.deleteButton },
				React.createElement(
					_dialog2.default,
					{ actions: this.actions(), active: active,
						onEscKeyDown: this.onDelete, onOverlayClick: this.onDelete,
						title: 'Delete dataset' },
					label
				),
				React.createElement(
					_button.Button,
					{ onClick: this.onDelete, accent: true },
					'Delete'
				)
			);
		}
	}]);
	return DeleteButton;
}(React.Component);

var canDelete = function canDelete(_ref7, host) {
	var status = _ref7.status;
	return host === localHub && contains(['loaded', 'error'], status);
};

var markdownValue = function markdownValue(value) {
	if (value && !value.error) {
		var converter = new showdown.Converter();
		return React.createElement('div', { className: styles.header,
			dangerouslySetInnerHTML: { __html: converter.makeHtml(value) } });
	}
};

//
// Cohort Datasets Page
//

var datasetLink = function datasetLink(callback, preferred, onClick, hubParams) {
	return function (ds) {
		var _parseDsID = parseDsID(ds.dsID),
		    _parseDsID2 = (0, _slicedToArray3.default)(_parseDsID, 1),
		    host = _parseDsID2[0];

		return React.createElement(
			'li',
			{ key: ds.name },
			React.createElement(_link2.default, {
				className: styles.link,
				href: '?' + encodeObject((0, _extends3.default)({ dataset: ds.name, host: host }, hubParams)),
				label: ds.label,
				onClick: onClick }),
			preferred.has(ds.dsID) ? React.createElement(
				'span',
				{ className: styles.star },
				'*'
			) : null,
			ds.status !== 'loaded' ? React.createElement(
				'span',
				{ className: styles.count },
				' [',
				ds.status,
				']'
			) : null,
			ds.status === 'loaded' ? React.createElement(
				'span',
				{ className: styles.count },
				' (n=',
				(ds.count || 0).toLocaleString(),
				')'
			) : null,
			React.createElement(
				'span',
				null,
				' ',
				getHubName(host)
			),
			canDelete(ds, host) ? React.createElement(DeleteButton, { callback: callback, name: ds.name, label: ds.label || ds.name }) : null,
			React.createElement(
				'div',
				{ className: styles.lineClamp },
				React.createElement(
					'span',
					{ className: styles.description },
					stripHTML(ds.description)
				)
			)
		);
	};
};

var drawGroup = function drawGroup(callback, groups, preferred, onClick, hubParams) {
	return function (dataSubType) {
		var list = sortBy(groups[dataSubType], function (g) {
			return g.label.toLowerCase();
		});
		return React.createElement(
			'div',
			{ key: dataSubType },
			React.createElement(
				'h3',
				null,
				dataSubType
			),
			React.createElement(
				'ul',
				{ className: styles.groupList },
				map(list, datasetLink(callback, preferred, onClick, hubParams))
			)
		);
	};
};

var COHORT_NULL = '(unassigned)';

var getPreferred = function getPreferred(wizard, cohort) {
	return new _set2.default(values(getIn(wizard, ['cohortPreferred', cohort], {})));
};

var CohortPage = function (_React$Component4) {
	(0, _inherits3.default)(CohortPage, _React$Component4);

	function CohortPage() {
		var _ref8;

		var _temp4, _this5, _ret4;

		(0, _classCallCheck3.default)(this, CohortPage);

		for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
			args[_key4] = arguments[_key4];
		}

		return _ret4 = (_temp4 = (_this5 = (0, _possibleConstructorReturn3.default)(this, (_ref8 = CohortPage.__proto__ || (0, _getPrototypeOf2.default)(CohortPage)).call.apply(_ref8, [this].concat(args))), _this5), _this5.onViz = function () {
			var _this5$props$state = _this5.props.state,
			    params = _this5$props$state.params,
			    currentCohort = _this5$props$state.spreadsheet.cohort,
			    cohort = params.cohort;


			if (cohort !== get(currentCohort, 'name')) {
				_this5.props.callback(['cohort', cohort]);
			}
			_this5.props.callback(['navigate', 'heatmap']);
		}, _this5.clickVizButton = function (ev) {
			if (ev.target.className === 'cohortButton') {
				_this5.onViz();
			}
		}, _this5.onDataset = function (ev) {
			navHandler.call(_this5, ev);
		}, _temp4), (0, _possibleConstructorReturn3.default)(_this5, _ret4);
	}

	(0, _createClass3.default)(CohortPage, [{
		key: 'render',
		value: function render() {
			var _props3 = this.props,
			    hubParams = _props3.hubParams,
			    callback = _props3.callback,
			    _props3$state = _props3.state,
			    datapages = _props3$state.datapages,
			    spreadsheet = _props3$state.spreadsheet,
			    cohort = _props3$state.params.cohort,
			    wizard = _props3$state.wizard,
			    servers = getUserServers(spreadsheet.servers),
			    meta = getIn(datapages, ['cohort', cohort]),
			    datasetsByHost = pick(getIn(datapages, ['cohortDatasets', cohort], {}), servers),
			    datasets = flatten(values(datasetsByHost)),
			    dsGroups = groupBy(values(datasets), 'dataSubType'),
			    dataSubTypes = sortBy(keys(dsGroups), function (g) {
				return g.toLowerCase();
			}),
			    preferred = getPreferred(wizard, cohort);


			return React.createElement(
				'div',
				{ className: styles.datapages, onClick: this.clickVizButton },
				markdownValue(meta),
				React.createElement(
					'div',
					{ className: styles.sidebar },
					React.createElement(
						_button.Button,
						{ onClick: this.onViz, accent: true },
						'Visualize'
					)
				),
				React.createElement(
					'h2',
					null,
					'cohort: ',
					treehouse(cohort),
					cohort
				),
				dataSubTypes.map(drawGroup(callback, dsGroups, preferred, this.onDataset, hubParams)),
				preferred.size === 0 ? null : React.createElement(
					'span',
					null,
					React.createElement(
						'span',
						{ className: styles.star },
						'*'
					),
					React.createElement(
						'span',
						null,
						'default dataset in visualization'
					)
				)
			);
		}
	}]);
	return CohortPage;
}(React.Component);

//
// Dataset Page
//

var TYPE_NULL = 'genomicMatrix',
    FORMAT_MAPPING = {
	'clinicalMatrix': "ROWs (samples)  x  COLUMNs (identifiers) (i.e. clinicalMatrix)",
	'genomicMatrix': "ROWs (identifiers)  x  COLUMNs (samples) (i.e. genomicMatrix)",
	'mutationVector': "Variant by Position (i.e. mutationVector)",
	'genomicSegment': 'Genomic Segment (i.e. genomicSegment)',
	'unknown': "unknown"
};

var dataPair = function dataPair(key, value) {
	var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : identity;
	return value == null ? [] : [React.createElement(
		'span',
		{ className: styles.key },
		key
	), React.createElement(
		'span',
		{ className: styles.value },
		method(value)
	), React.createElement('br', null)];
};

var toLink = function toLink(value) {
	return React.createElement(
		'a',
		{ href: value },
		value
	);
};
var toCohortLink = function toCohortLink(onClick, hubParams) {
	return function (cohort) {
		return React.createElement(_link2.default, {
			href: '?' + encodeObject((0, _extends3.default)({ cohort: cohort }, hubParams)),
			onClick: onClick,
			label: cohort });
	};
};
var toPMIDLink = function toPMIDLink(value) {
	return React.createElement(
		'a',
		{ href: 'http://www.ncbi.nlm.nih.gov/pubmed/?term=' + value.toString() },
		value
	);
};

var jsonLink = function jsonLink(link) {
	return link.replace(/(.gz)?$/, '.json');
};
var toDownloadLink = function toDownloadLink(value) {
	return React.createElement(
		'span',
		null,
		React.createElement(
			'a',
			{ href: value },
			value
		),
		'; ',
		React.createElement(
			'a',
			{ href: jsonLink(value) },
			'Full metadata'
		)
	);
};
var toHTML = function toHTML(value) {
	return React.createElement('span', { dangerouslySetInnerHTML: { __html: value } });
};

var headerValue = function headerValue(value) {
	return value && React.createElement(
		'p',
		{ className: styles.header },
		value
	);
};
var htmlValue = function htmlValue(value) {
	return value && React.createElement('p', { className: styles.header, dangerouslySetInnerHTML: { __html: value } });
};

// XXX Does not display load warning in pop-up
// XXX Does not use red/blue coloring for error vs. other load status (e.g. 'loading')
var getStatus = function getStatus(status, loaderWarning) {
	return status === 'loaded' && !loaderWarning ? [] : status === 'loaded' ? dataPair('status', 'loaded with warning') : dataPair('status', status);
};

// split, handling falsey values
var split = function split(str, pat) {
	return str ? str.split(pat) : [];
};

var resolveCodes = function resolveCodes(probes, codes, data) {
	return mmap(probes, data, function (probe, row) {
		return codes[probe] ? map(row, function (v) {
			return isNaN(v) ? v : codes[probe][v];
		}) : row;
	});
};

// not the most efficient algorithm :-/
var addHeaders = function addHeaders(fields, samples, data) {
	return mmap([''].concat((0, _toConsumableArray3.default)(fields)), [samples].concat((0, _toConsumableArray3.default)(data)), function (header, row) {
		return [header].concat((0, _toConsumableArray3.default)(row));
	});
};

var transpose = function transpose(data) {
	return zip.apply(null, data);
};

// Transpose matrix if it's clinical
var transposeClinical = function transposeClinical(meta, data) {
	return get(meta, 'type') === 'clinicalMatrix' ? transpose(data) : data;
};

var table = function table(data) {
	return React.createElement(
		'table',
		{ className: styles.dataSnippetTable },
		React.createElement(
			'tbody',
			null,
			map(data, function (row, i) {
				return React.createElement(
					'tr',
					{ key: i },
					map(row, function (c, j) {
						return React.createElement(
							'td',
							{ key: j },
							c
						);
					})
				);
			})
		)
	);
};

var matrixTable = function matrixTable(meta, _ref9) {
	var fields = _ref9.fields,
	    samples = _ref9.samples,
	    codes = _ref9.codes,
	    data = _ref9.data;
	return table(transposeClinical(meta, addHeaders(fields, samples, resolveCodes(fields, codes, data))));
};

// swap chromend & chromstart when sorting fields
var cmpSparseFields = function cmpSparseFields(a, b) {
	return a === 'chromend' && b === 'chromstart' ? 1 : a === 'chromstart' && b === 'chromend' ? -1 : a.localeCompare(b);
};

var sparseTable = function sparseTable(meta, data) {
	var fields = keys(data).sort(cmpSparseFields),
	    rows = fields.map(function (field) {
		return data[field];
	}),
	    samples = data.sampleID;
	return table(transpose(addHeaders(fields, samples, rows)));
};

var noTable = function noTable() {
	return null;
};

var dataMethod = function dataMethod() {
	var _ref10 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
	    _ref10$type = _ref10.type,
	    type = _ref10$type === undefined ? 'genomicMatrix' : _ref10$type,
	    status = _ref10.status;

	return status !== 'loaded' ? noTable : type === 'genomicMatrix' ? matrixTable : type === 'clinicalMatrix' ? matrixTable : type === 'mutationVector' ? sparseTable : type === 'genomicSegment' ? sparseTable : noTable;
};

var setKey = function setKey(arr) {
	return arr.map(function (el, i) {
		return React.cloneElement(el, { key: i });
	});
};

var DatasetPage = (0, _LaunchHelper2.default)(function (props) {
	return getIn(props, ['state', 'params', 'host']) === localHub;
}, (_temp6 = _class = function (_PureComponent) {
	(0, _inherits3.default)(_class, _PureComponent);

	function _class() {
		var _ref11;

		var _temp5, _this6, _ret5;

		(0, _classCallCheck3.default)(this, _class);

		for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
			args[_key5] = arguments[_key5];
		}

		return _ret5 = (_temp5 = (_this6 = (0, _possibleConstructorReturn3.default)(this, (_ref11 = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref11, [this].concat(args))), _this6), _this6.onCohort = function (ev) {
			navHandler.call(_this6, ev);
		}, _this6.onViz = function () {
			var _this6$props$state = _this6.props.state,
			    _this6$props$state$pa = _this6$props$state.params,
			    host = _this6$props$state$pa.host,
			    dataset = _this6$props$state$pa.dataset,
			    datapages = _this6$props$state.datapages,
			    currentCohort = _this6$props$state.spreadsheet.cohort,
			    cohort = getIn(datapages, ['dataset', host, dataset, 'meta', 'cohort'], COHORT_NULL);


			if (getIn(_this6.props.state, ['spreadsheet', 'servers', host, 'user']) !== true) {
				_this6.props.callback(['add-host', host]);
			}
			if (cohort !== get(currentCohort, 'name')) {
				_this6.props.callback(['cohort', cohort]);
			}
			_this6.props.callback(['navigate', 'heatmap']);
		}, _this6.onIdentifiers = function (ev) {
			navHandler.call(_this6, ev);
		}, _this6.onSamples = function (ev) {
			navHandler.call(_this6, ev);
		}, _temp5), (0, _possibleConstructorReturn3.default)(_this6, _ret5);
	}

	(0, _createClass3.default)(_class, [{
		key: 'render',
		value: function render() {
			var _props4 = this.props,
			    callback = _props4.callback,
			    state = _props4.state,
			    hubParams = _props4.hubParams,
			    children = _props4.children,
			    badge = _props4.badge,
			    _state$params = state.params,
			    host = _state$params.host,
			    dataset = _state$params.dataset,
			    datapages = state.datapages,
			    _getIn = getIn(datapages, ['dataset', host, dataset], {}),
			    meta = _getIn.meta,
			    _getIn$probeCount = _getIn.probeCount,
			    probeCount = _getIn$probeCount === undefined ? 0 : _getIn$probeCount,
			    data = _getIn.data,
			    downloadLink = _getIn.downloadLink,
			    probemapLink = _getIn.probemapLink,
			    githubDescripton = getIn(datapages, ['datasetDescription', dataset], null);

			if (!meta) {
				return React.createElement(
					'div',
					{ className: styles.datapages },
					children /* LaunchHelper */,
					React.createElement(
						'h2',
						null,
						'dataset: ',
						dataset,
						'...'
					),
					React.createElement(
						'h3',
						null,
						'hub: ',
						host,
						badge
					)
				);
			}
			var name = meta.name,
			    _meta$label = meta.label,
			    label = _meta$label === undefined ? name : _meta$label,
			    description = meta.description,
			    longTitle = meta.longTitle,
			    _meta$cohort = meta.cohort,
			    cohort = _meta$cohort === undefined ? COHORT_NULL : _meta$cohort,
			    dataSubType = meta.dataSubType,
			    platform = meta.platform,
			    unit = meta.unit,
			    assembly = meta.assembly,
			    version = meta.version,
			    url = meta.url,
			    articletitle = meta.articletitle,
			    citation = meta.citation,
			    pmid = meta.pmid,
			    dataproducer = meta.dataproducer,
			    _meta$author = meta.author,
			    author = _meta$author === undefined ? dataproducer : _meta$author,
			    wranglingProcedure = meta['wrangling_procedure'],
			    _meta$type = meta.type,
			    type = _meta$type === undefined ? TYPE_NULL : _meta$type,
			    status = meta.status,
			    loader = meta.loader,
			    count = meta.count;


			return React.createElement(
				'div',
				{ className: styles.datapages },
				children /* LaunchHelper */,
				React.createElement(
					'div',
					{ className: styles.sidebar },
					React.createElement(
						_button.Button,
						{ onClick: this.onViz, accent: true },
						'Visualize'
					),
					canDelete(meta, host) ? React.createElement(DeleteButton, { callback: callback, name: name, label: label }) : null
				),
				React.createElement(
					'h2',
					null,
					'dataset: ',
					(dataSubType ? dataSubType + ' - ' : '') + label
				),
				React.createElement(
					'h3',
					null,
					'hub: ',
					host,
					badge
				),
				headerValue(longTitle),
				markdownValue(githubDescripton) || htmlValue(description),
				setKey(flatten([dataPair('cohort', cohort, toCohortLink(this.onCohort, hubParams)), dataPair('dataset ID', name), getStatus(status, loader), dataPair('download', downloadLink, toDownloadLink), dataPair('samples', count), dataPair('version', version), dataPair('type of data', dataSubType), dataPair('assembly', assembly), dataPair('unit', unit), dataPair('platform', platform), dataPair('ID/Gene Mapping', probemapLink, toDownloadLink), dataPair('publication', articletitle), dataPair('citation', citation), dataPair('author', author), dataPair('PMID', pmid, toPMIDLink), flatmap(uniq(split(url, /,/)), function (url) {
					return dataPair('raw data', url, toLink);
				}), dataPair('wrangling', wranglingProcedure, toHTML), dataPair('input data format', FORMAT_MAPPING[type])])),
				status === 'loaded' ? React.createElement(
					'span',
					{ className: styles.tableControls },
					type === 'genomicMatrix' ? probeCount.toLocaleString() + ' identifiers X ' + count + ' samples ' : null,
					type === 'clinicalMatrix' ? count + ' samples X ' + probeCount.toLocaleString() + ' identifiers ' : null,
					React.createElement(_link2.default, {
						href: '?' + encodeObject((0, _extends3.default)({ host: host, dataset: dataset, allIdentifiers: true }, hubParams)),
						onClick: this.onIdentifiers, label: 'All Identifiers' }),
					React.createElement(_link2.default, {
						href: '?' + encodeObject((0, _extends3.default)({ host: host, dataset: dataset, allSamples: true }, hubParams)),
						onClick: this.onSamples, label: 'All Samples' })
				) : null,
				dataMethod(meta)(meta, data)
			);
		}
	}]);
	return _class;
}(_PureComponent4.default), _class.displayName = 'DatasetPage', _temp6));

//
// Hub page
//

var HubPage = (0, _LaunchHelper2.default)(function (props) {
	return (0, _urlParams.defaultHost)(props.state.params).host === localHub;
}, function (_PureComponent2) {
	(0, _inherits3.default)(_class3, _PureComponent2);

	function _class3() {
		var _ref12;

		var _temp7, _this7, _ret6;

		(0, _classCallCheck3.default)(this, _class3);

		for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
			args[_key6] = arguments[_key6];
		}

		return _ret6 = (_temp7 = (_this7 = (0, _possibleConstructorReturn3.default)(this, (_ref12 = _class3.__proto__ || (0, _getPrototypeOf2.default)(_class3)).call.apply(_ref12, [this].concat(args))), _this7), _this7.onCohort = function (ev) {
			navHandler.call(_this7, ev);
		}, _this7.onImport = function () {
			_this7.props.callback(['reset-import-state']);
			_this7.props.callback(['navigate', 'import']);
		}, _this7.onViz = function (cohort) {
			if (!cohort) {
				return;
			}

			var currentCohort = _this7.props.state.spreadsheet.cohort;


			if (cohort !== get(currentCohort, 'name')) {
				_this7.props.callback(['cohort', cohort]);
			}
			_this7.props.callback(['navigate', 'heatmap']);
		}, _this7.clickVizButton = function (ev) {
			if (ev.target.className === 'hubButton') {
				_this7.onViz(ev.target.dataset.cohort);
			}
		}, _temp7), (0, _possibleConstructorReturn3.default)(_this7, _ret6);
	}

	(0, _createClass3.default)(_class3, [{
		key: 'render',
		value: function render() {
			var _props5 = this.props,
			    state = _props5.state,
			    hubParams = _props5.hubParams,
			    badge = _props5.badge,
			    children = _props5.children,
			    servers = state.spreadsheet.servers,
			    userServers = getUserServers(servers),
			    _defaultHost = (0, _urlParams.defaultHost)(state.params),
			    host = _defaultHost.host,
			    hubCohorts = getIn(state, ['datapages', 'cohorts', host], []),
			    coll = collateCohorts(hubCohorts),
			    inHubs = contains(userServers, host) ? '' : ' (not in my data hubs)';

			if (!contains(userServers, host)) {
				this.props.callback(['add-host', host]);
			}

			return React.createElement(
				'div',
				{ className: styles.datapages, onClick: this.clickVizButton },
				children /* LaunchHelper */,
				markdownValue(getIn(state, ['datapages', 'hubMeta', host])),
				React.createElement(CohortHeader, { inHubs: inHubs, host: host, onImport: this.onImport, badge: badge }),
				React.createElement(CohortSummary, {
					hubParams: hubParams,
					cohorts: coll,
					onCohort: this.onCohort })
			);
		}
	}]);
	return _class3;
}(_PureComponent4.default));

//
// Samples / Identifiers page
//


var binSize = 1000;

// The point of ListPage is to render a potentially very long list
// incrementally, so we get a fast first render, and don't lock up the UI.
// We do that by rendering binSize rows at a time, on a requestAnimationFrame
// timeout.

var ListPage = function (_React$Component5) {
	(0, _inherits3.default)(ListPage, _React$Component5);

	function ListPage() {
		var _ref13;

		var _temp8, _this8, _ret7;

		(0, _classCallCheck3.default)(this, ListPage);

		for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
			args[_key7] = arguments[_key7];
		}

		return _ret7 = (_temp8 = (_this8 = (0, _possibleConstructorReturn3.default)(this, (_ref13 = ListPage.__proto__ || (0, _getPrototypeOf2.default)(ListPage)).call.apply(_ref13, [this].concat(args))), _this8), _this8.state = {}, _temp8), (0, _possibleConstructorReturn3.default)(_this8, _ret7);
	}

	(0, _createClass3.default)(ListPage, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this9 = this;

			var events = rxEvents(this, 'list');
			var chunks = events.list.startWith(this.props.list).distinctUntilChanged().filter(identity).switchMap(function (ids) {
				var chunks = partitionN(ids, binSize).map(function (a) {
					return a.join('\n');
				});
				return from(range(chunks.length), animationFrame).map(function (i) {
					return { chunks: chunks.slice(0, i + 1), total: chunks.length };
				});
			});

			this.sub = chunks.subscribe(function (chunks) {
				_this9.setState(chunks);
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.sub.unsubscribe();
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			this.on.list(props.list);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props6 = this.props,
			    dataset = _props6.dataset,
			    title = _props6.title,
			    _state = this.state,
			    chunks = _state.chunks,
			    total = _state.total,
			    percent = !chunks ? ' 0%' : chunks.length === total ? '' : ' ' + Math.floor(chunks.length / total * 100) + '%';


			return React.createElement(
				'div',
				{ className: styles.datapages },
				React.createElement(
					'h3',
					null,
					'dataset: ',
					dataset
				),
				React.createElement(
					'h4',
					null,
					title,
					percent
				),
				chunks ? chunks.map(function (c, i) {
					return React.createElement(
						'pre',
						{ key: i, className: styles.list },
						c
					);
				}) : 'Loading...'
			);
		}
	}]);
	return ListPage;
}(React.Component);

var markdownPage = function (_React$Component6) {
	(0, _inherits3.default)(markdownPage, _React$Component6);

	function markdownPage() {
		(0, _classCallCheck3.default)(this, markdownPage);
		return (0, _possibleConstructorReturn3.default)(this, (markdownPage.__proto__ || (0, _getPrototypeOf2.default)(markdownPage)).apply(this, arguments));
	}

	(0, _createClass3.default)(markdownPage, [{
		key: 'render',
		value: function render() {
			var state = this.props.state,
			    content = getIn(state, ['datapages', 'markdown', state.params.markdown]);


			return React.createElement(
				'div',
				{ className: styles.datapages },
				markdownValue(content)
			);
		}
	}]);
	return markdownPage;
}(React.Component);

var IdentifiersPage = function IdentifiersPage(props) {
	return Let(function () {
		var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : props,
		    _ref14$state$params = _ref14.state.params,
		    host = _ref14$state$params.host,
		    dataset = _ref14$state$params.dataset;

		return React.createElement(ListPage, { title: 'Identifiers',
			dataset: dataset,
			list: getIn(props.state, ['datapages', 'identifiers', host, dataset]) });
	});
};

var SamplesPage = function SamplesPage(props) {
	return Let(function () {
		var _ref15 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : props,
		    _ref15$state$params = _ref15.state.params,
		    host = _ref15$state$params.host,
		    dataset = _ref15$state$params.dataset;

		return React.createElement(ListPage, { title: 'Samples',
			dataset: dataset,
			list: getIn(props.state, ['datapages', 'samples', host, dataset]) });
	});
};

//
// Top-level dispatch to sub-pages
//

var getPage = function getPage(_ref16) {
	var dataset = _ref16.dataset,
	    host = _ref16.host,
	    cohort = _ref16.cohort,
	    allIdentifiers = _ref16.allIdentifiers,
	    allSamples = _ref16.allSamples,
	    markdown = _ref16.markdown;
	return markdown ? markdownPage : allSamples ? SamplesPage : allIdentifiers ? IdentifiersPage : dataset && host ? DatasetPage : host ? HubPage : cohort ? CohortPage : CohortSummaryPage;
};

var Datapages = function (_React$Component7) {
	(0, _inherits3.default)(Datapages, _React$Component7);

	function Datapages() {
		var _ref17;

		var _temp9, _this11, _ret8;

		(0, _classCallCheck3.default)(this, Datapages);

		for (var _len8 = arguments.length, args = Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
			args[_key8] = arguments[_key8];
		}

		return _ret8 = (_temp9 = (_this11 = (0, _possibleConstructorReturn3.default)(this, (_ref17 = Datapages.__proto__ || (0, _getPrototypeOf2.default)(Datapages)).call.apply(_ref17, [this].concat(args))), _this11), _this11.onNavigate = function (page, params) {
			_this11.props.callback(['navigate', page, params]);
		}, _temp9), (0, _possibleConstructorReturn3.default)(_this11, _ret8);
	}

	(0, _createClass3.default)(Datapages, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			nav({ activeLink: 'datapages', onNavigate: this.onNavigate });
		}
	}, {
		key: 'render',
		value: function render() {
			var state = this.props.state,
			    params = state.params,
			    hubParams = getHubParams(state),
			    Page = getPage((0, _urlParams.defaultHost)(params));

			return React.createElement(Page, (0, _extends3.default)({}, this.props, { hubParams: hubParams }));
		}
	}]);
	return Datapages;
}(React.Component);

var ThemedDatapages = function (_React$Component8) {
	(0, _inherits3.default)(ThemedDatapages, _React$Component8);

	function ThemedDatapages() {
		(0, _classCallCheck3.default)(this, ThemedDatapages);
		return (0, _possibleConstructorReturn3.default)(this, (ThemedDatapages.__proto__ || (0, _getPrototypeOf2.default)(ThemedDatapages)).apply(this, arguments));
	}

	(0, _createClass3.default)(ThemedDatapages, [{
		key: 'render',
		value: function render() {
			return React.createElement(
				_reactCssThemr.ThemeProvider,
				{ theme: appTheme },
				React.createElement(Datapages, this.props)
			);
		}
	}]);
	return ThemedDatapages;
}(React.Component);

var selector = function selector(state) {
	return state;
};

module.exports = function (props) {
	return React.createElement(ThemedDatapages, (0, _extends3.default)({}, props, { selector: selector }));
};