'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _kmModule = require('./km.module.css');

var _kmModule2 = _interopRequireDefault(_kmModule);

var _PureComponent4 = require('./PureComponent');

var _PureComponent5 = _interopRequireDefault(_PureComponent4);

var _button = require('react-toolbox/lib/button');

var _dropdown = require('react-toolbox/lib/dropdown');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _dialog = require('react-toolbox/lib/dialog');

var _dialog2 = _interopRequireDefault(_dialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('./underscore_ext');

var React = require('react');


var Axis = require('./Axis');

var _require = require('./scale'),
    linear = _require.linear,
    linearTicks = _require.linearTicks;

var pdf = require('./kmpdf');
var NumberForm = require('./views/NumberForm');

var _require2 = require('./models/km'),
    survivalOptions = _require2.survivalOptions,
    getSplits = _require2.getSplits;

var gaEvents = require('./gaEvents');

// Basic sizes. Should make these responsive. How to make the svg responsive?
var margin = { top: 20, right: 30, bottom: 30, left: 50 };

// XXX point at 100%? [xdomain[0] - 1, 1]
function line(xScale, yScale, values) {
	var coords = values.map(function (_ref) {
		var t = _ref.t,
		    s = _ref.s;
		return [xScale(t), yScale(s)];
	});
	return ['M0,0'].concat((0, _toConsumableArray3.default)(coords.map(function (_ref2) {
		var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
		    t = _ref3[0],
		    s = _ref3[1];

		return 'H' + t + 'V' + s;
	}))).join(' ');
}

function censorLines(xScale, yScale, censors, className) {
	return censors.map(function (_ref4, i) {
		var t = _ref4.t,
		    s = _ref4.s;
		return React.createElement('line', {
			key: i,
			className: className,
			x1: 0, x2: 0, y1: -5, y2: 5,
			transform: 'translate(' + xScale(t) + ',' + yScale(s) + ')' });
	});
}

function calcDims(viewDims, sizeRatios) {
	return _.mapObject(sizeRatios, function (section) {
		return _.mapObject(section, function (ratio, side) {
			return viewDims[side] * ratio;
		});
	});
}

function checkIfActive(currentLabel, activeLabel) {
	// check whether this line group should be set to Active
	return !!activeLabel && activeLabel === currentLabel;
}

var LineGroup = function (_React$Component) {
	(0, _inherits3.default)(LineGroup, _React$Component);

	function LineGroup() {
		(0, _classCallCheck3.default)(this, LineGroup);
		return (0, _possibleConstructorReturn3.default)(this, (LineGroup.__proto__ || (0, _getPrototypeOf2.default)(LineGroup)).apply(this, arguments));
	}

	(0, _createClass3.default)(LineGroup, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(newProps) {
			return !_.isEqual(_.omit(newProps, 'xScale', 'yScale'), _.omit(this.props, 'xScale', 'yScale'));
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    xScale = _props.xScale,
			    yScale = _props.yScale,
			    g = _props.g,
			    setActiveLabel = _props.setActiveLabel,
			    isActive = _props.isActive;

			var _g = (0, _slicedToArray3.default)(g, 3),
			    color = _g[0],
			    label = _g[1],
			    curve = _g[2];

			var censors = curve.filter(function (pt) {
				return !pt.e;
			});

			var outlineStyle = isActive ? _kmModule2.default.outlineHover : _kmModule2.default.outline;
			var lineStyle = isActive ? _kmModule2.default.lineHover : _kmModule2.default.line;

			return React.createElement(
				'g',
				{ key: label, className: _kmModule2.default.subgroup, stroke: color,
					onMouseOver: function onMouseOver(e) {
						return setActiveLabel(e, label);
					},
					onMouseOut: function onMouseOut(e) {
						return setActiveLabel(e, '');
					} },
				React.createElement('path', { className: outlineStyle, d: line(xScale, yScale, curve) }),
				React.createElement('path', { className: lineStyle, d: line(xScale, yScale, curve) }),
				censorLines(xScale, yScale, censors, outlineStyle),
				censorLines(xScale, yScale, censors, lineStyle)
			);
		}
	}]);
	return LineGroup;
}(React.Component);

var bounds = function bounds(x) {
	return [_.min(x), _.max(x)];
};

function svg(_ref5, setActiveLabel, activeLabel, size) {
	var colors = _ref5.colors,
	    labels = _ref5.labels,
	    curves = _ref5.curves;

	var height = size.height - margin.top - margin.bottom,
	    width = size.width - margin.left - margin.right,
	    xdomain = bounds(_.pluck(_.flatten(curves), 't')),
	    xrange = [0, width],
	    ydomain = [0, 1],
	    yrange = [height, 0],
	    xScale = linear(xdomain, xrange),
	    yScale = linear(ydomain, yrange);

	var groupSvg = _.zip(colors, labels, curves).map(function (g, index) {
		var _g2 = (0, _slicedToArray3.default)(g, 2),
		    label = _g2[1];
		// passing bounds to force update when scales change


		return React.createElement(LineGroup, {
			key: index,
			bounds: [xdomain, xrange, ydomain, yrange],
			xScale: xScale,
			yScale: yScale,
			g: g,
			isActive: label === activeLabel,
			setActiveLabel: setActiveLabel });
	});

	return React.createElement(
		'svg',
		{ width: size.width, height: size.height },
		React.createElement(
			'g',
			{ transform: 'translate(' + margin.left + ', ' + margin.top + ')' },
			React.createElement(Axis, {
				groupProps: {
					className: 'x ' + _kmModule2.default.axis,
					transform: 'translate(0, ' + height + ')'
				},
				domain: xdomain,
				range: xrange,
				scale: xScale,
				tickfn: linearTicks,
				orientation: 'bottom'
			}),
			React.createElement(
				Axis,
				{
					groupProps: {
						className: 'y ' + _kmModule2.default.axis
					},
					domain: ydomain,
					range: yrange,
					scale: yScale,
					tickfn: linearTicks,
					orientation: 'left' },
				React.createElement(
					'text',
					{
						transform: 'rotate(-90)',
						y: '5',
						x: -height + 5,
						dy: '.71em',
						textAnchor: 'start' },
					'Survival probability'
				)
			),
			groupSvg
		)
	);
}

var formatPValue = function formatPValue(v) {
	return v == null ? String.fromCharCode(8709) : v.toPrecision(4);
};

var WarningTrigger = function (_React$Component2) {
	(0, _inherits3.default)(WarningTrigger, _React$Component2);

	function WarningTrigger() {
		var _ref6;

		var _temp, _this2, _ret;

		(0, _classCallCheck3.default)(this, WarningTrigger);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref6 = WarningTrigger.__proto__ || (0, _getPrototypeOf2.default)(WarningTrigger)).call.apply(_ref6, [this].concat(args))), _this2), _this2.state = { show: false }, _this2.close = function () {
			_this2.setState({ show: false });
		}, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
	}

	(0, _createClass3.default)(WarningTrigger, [{
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props2 = this.props,
			    header = _props2.header,
			    body = _props2.body;


			return React.createElement(
				'div',
				{ className: _kmModule2.default.warningContainer },
				React.createElement(
					_button.Button,
					{
						onClick: function onClick() {
							return _this3.setState({ show: true });
						},
						className: _kmModule2.default.showPWarningButton },
					React.createElement(
						'i',
						{ className: 'material-icons ' + _kmModule2.default.pWarningIcon },
						'warning'
					)
				),
				this.state.show ? React.createElement(WarningDialog, { onHide: this.close, header: header, body: body }) : null
			);
		}
	}]);
	return WarningTrigger;
}(React.Component);

var WarningDialog = function (_React$Component3) {
	(0, _inherits3.default)(WarningDialog, _React$Component3);

	function WarningDialog() {
		(0, _classCallCheck3.default)(this, WarningDialog);
		return (0, _possibleConstructorReturn3.default)(this, (WarningDialog.__proto__ || (0, _getPrototypeOf2.default)(WarningDialog)).apply(this, arguments));
	}

	(0, _createClass3.default)(WarningDialog, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.documentElement.scrollTop = 0;
			var body = document.getElementById("body");
			body.style.overflow = "auto";
		}
	}, {
		key: 'render',
		value: function render() {

			var actions = [{
				children: [React.createElement(
					'i',
					{ className: 'material-icons' },
					'close'
				)],
				className: _kmModule2.default.warningDialogClose,
				onClick: this.props.onHide
			}];

			return React.createElement(
				_dialog2.default,
				{
					actions: actions,
					active: true,
					title: this.props.header,
					className: _kmModule2.default.warningDialog,
					onEscKeyDown: this.props.onHide,
					onOverlayClick: this.props.onHide,
					theme: {
						wrapper: _kmModule2.default.dialogWrapper,
						overlay: _kmModule2.default.dialogOverlay } },
				this.props.body
			);
		}
	}]);
	return WarningDialog;
}(React.Component);

var PValue = function (_PureComponent) {
	(0, _inherits3.default)(PValue, _PureComponent);

	function PValue() {
		(0, _classCallCheck3.default)(this, PValue);
		return (0, _possibleConstructorReturn3.default)(this, (PValue.__proto__ || (0, _getPrototypeOf2.default)(PValue)).apply(this, arguments));
	}

	(0, _createClass3.default)(PValue, [{
		key: 'render',
		value: function render() {
			var _props3 = this.props,
			    logRank = _props3.logRank,
			    pValue = _props3.pValue,
			    patientWarning = _props3.patientWarning;

			return React.createElement(
				'div',
				null,
				React.createElement(
					'div',
					{ className: _kmModule2.default.PValueArea },
					React.createElement(
						'div',
						{ className: _kmModule2.default.PValueP },
						React.createElement(
							'i',
							null,
							'P'
						),
						'-value = ',
						formatPValue(pValue)
					),
					patientWarning ? React.createElement(WarningTrigger, {
						header: 'P value warning',
						body: patientWarning
					}) : null
				),
				React.createElement(
					'div',
					null,
					React.createElement(
						'span',
						null,
						'Log-rank test statistics = ',
						formatPValue(logRank)
					)
				)
			);
		}
	}]);
	return PValue;
}(_PureComponent5.default);

// Sample count is 'n' at 1st time point.


function sampleCount(curve) {
	return _.getIn(curve, [0, 'n'], String.fromCharCode(8709));
}

function makeLegendKey(_ref7, setActiveLabel, activeLabel) {
	var _ref8 = (0, _slicedToArray3.default)(_ref7, 3),
	    color = _ref8[0],
	    curves = _ref8[1],
	    label = _ref8[2];

	// show colored line and category of curve
	var isActive = checkIfActive(label, activeLabel);
	var labelClassName = isActive ? _kmModule2.default.activeListItem : _kmModule2.default.listItem;
	var legendLineStyle = {
		backgroundColor: color,
		border: (isActive ? 2 : 1).toString() + 'px solid',
		display: 'inline-block',
		height: 6,
		width: 25,
		verticalAlign: 'middle'
	};

	return React.createElement(
		'li',
		{
			key: label,
			className: labelClassName,
			onMouseOver: function onMouseOver(e) {
				return setActiveLabel(e, label);
			},
			onMouseOut: function onMouseOut(e) {
				return setActiveLabel(e, '');
			} },
		React.createElement('span', { style: legendLineStyle }),
		' ',
		label,
		' (n=',
		sampleCount(curves),
		')'
	);
}

var Legend = function (_PureComponent2) {
	(0, _inherits3.default)(Legend, _PureComponent2);

	function Legend() {
		(0, _classCallCheck3.default)(this, Legend);
		return (0, _possibleConstructorReturn3.default)(this, (Legend.__proto__ || (0, _getPrototypeOf2.default)(Legend)).apply(this, arguments));
	}

	(0, _createClass3.default)(Legend, [{
		key: 'render',
		value: function render() {
			var _props4 = this.props,
			    groups = _props4.groups,
			    setActiveLabel = _props4.setActiveLabel,
			    activeLabel = _props4.activeLabel;
			var colors = groups.colors,
			    curves = groups.curves,
			    labels = groups.labels;

			var sets = _.zip(colors, curves, labels).map(function (set) {
				return makeLegendKey(set, setActiveLabel, activeLabel);
			});

			return React.createElement(
				'div',
				{ className: _kmModule2.default.legend },
				sets
			);
		}
	}]);
	return Legend;
}(_PureComponent5.default);

var survURL = {
	"TCGA PanCanAtlas": encodeURI("https://www.cell.com/action/showFullTableImage?isHtml=true&tableId=tbl3&pii=S0092867418302290&code=cell-site")
};

function makeSurvivalTypeUI(cohort, survInfoURL, survType, survivalTypes, onSurvType) {
	return React.createElement(
		'div',
		{ className: _kmModule2.default.survTypeContainer },
		React.createElement(_dropdown2.default, { className: _kmModule2.default.survType,
			source: survivalTypes.map(function (t) {
				return {
					value: t,
					label: survivalOptions[t].label
				};
			}),
			value: survType || survivalTypes[0],
			onChange: onSurvType
		}),
		survInfoURL ? React.createElement(
			_button.IconButton,
			{ onClick: function onClick() {
					return window.location.href = survInfoURL;
				} },
			React.createElement(
				'i',
				{ className: 'material-icons ' + _kmModule2.default.infoIcon },
				'info'
			)
		) : null
	);
}

function makeGraph(groups, setActiveLabel, activeLabel, size, cohort, survInfoURL, survType, survivalTypes, onSurvType, min, max, onCutoff, cutoff) {
	return React.createElement(
		'div',
		{ className: _kmModule2.default.graph },
		svg(groups, setActiveLabel, activeLabel, { height: 0.8 * size.height, width: 0.9 * size.width }),
		makeSurvivalTypeUI(cohort, survInfoURL, survType, survivalTypes, onSurvType),
		React.createElement(
			'div',
			null,
			React.createElement(NumberForm, {
				onChange: onCutoff,
				dflt: max,
				min: min,
				max: max,
				initialValue: cutoff })
		)
	);
}

function makeSplits(splits, onSplits) {
	return React.createElement(
		'form',
		null,
		React.createElement(
			'div',
			{ className: _kmModule2.default.splits },
			React.createElement(
				'label',
				{ className: _kmModule2.default.splitLabel, title: '2 groups: top 50%, bottom 50%' },
				React.createElement('input', { value: 2, type: 'radio', name: 'splits', checked: splits === 2, onChange: onSplits }),
				React.createElement(
					'span',
					{ className: _kmModule2.default.splitHint },
					'2 groups'
				)
			),
			React.createElement(
				'label',
				{ className: _kmModule2.default.splitLabel, title: '3 groups: top 33%, middle 33%, bottom 33%' },
				React.createElement('input', { value: 3, type: 'radio', name: 'splits', checked: splits === 3, onChange: onSplits }),
				React.createElement(
					'span',
					{ className: _kmModule2.default.splitHint },
					'3 groups'
				)
			),
			React.createElement(
				'label',
				{ className: _kmModule2.default.splitLabel, title: 'Quartiles: top 25%, bottom 25%' },
				React.createElement('input', { value: -4, type: 'radio', name: 'splits', checked: splits === -4, onChange: onSplits }),
				React.createElement(
					'span',
					{ className: _kmModule2.default.splitHint },
					'Quartiles'
				)
			)
		)
	);
}

function makeDefinitions(groups, setActiveLabel, activeLabel, size, maySplit, splits, onSplits, label, clarification, warning) {
	// get new size based on size ratio for definitions column
	return React.createElement(
		'div',
		{ className: _kmModule2.default.definitions, style: { width: size.width } },
		React.createElement(PValue, { pValue: groups.pValue, logRank: groups.KM_stats,
			patientWarning: groups.patientWarning }),
		React.createElement('br', null),
		React.createElement(
			'label',
			null,
			label,
			' ',
			clarification
		),
		React.createElement(Legend, { groups: groups,
			setActiveLabel: setActiveLabel,
			activeLabel: activeLabel }),
		maySplit ? makeSplits(getSplits(splits), onSplits) : null,
		warning
	);
}

var plotSize = {
	ratios: {
		graph: {
			width: 0.75,
			height: 1.0
		},
		definitions: {
			width: 0.4,
			height: 1.0
		}
	}
};

var KmPlot = function (_PureComponent3) {
	(0, _inherits3.default)(KmPlot, _PureComponent3);

	function KmPlot() {
		var _ref9;

		var _temp2, _this7, _ret2;

		(0, _classCallCheck3.default)(this, KmPlot);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this7 = (0, _possibleConstructorReturn3.default)(this, (_ref9 = KmPlot.__proto__ || (0, _getPrototypeOf2.default)(KmPlot)).call.apply(_ref9, [this].concat(args))), _this7), _this7.state = { activeLabel: '' }, _this7.hide = function () {
			var _this7$props = _this7.props,
			    callback = _this7$props.callback,
			    eventClose = _this7$props.eventClose;

			callback([eventClose]);
		}, _this7.onCutoff = function (v) {
			var callback = _this7.props.callback;

			callback(['km-cutoff', v]);
		}, _this7.setActiveLabel = function (e, label) {
			_this7.setState({ activeLabel: label });
		}, _this7.pdf = function () {
			gaEvents('spreadsheet', 'pdf', 'km');
			pdf(_this7.props.km.groups);
		}, _this7.help = function () {
			window.location.href = "https://ucsc-xena.gitbook.io/project/overview-of-features/kaplan-meier-plots";
		}, _this7.onSplits = function (ev) {
			var callback = _this7.props.callback;

			callback(['km-splits', parseInt(ev.target.value, 10)]);
		}, _this7.onSurvType = function (ev) {
			var callback = _this7.props.callback;

			callback(['km-survivalType', ev]);
		}, _temp2), (0, _possibleConstructorReturn3.default)(_this7, _ret2);
	}

	// cutoff needs to rewrite the group calc, but we need
	// the full range in order to range-check the bound. So
	// the compute should stash the domain.


	(0, _createClass3.default)(KmPlot, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.documentElement.scrollTop = 0;
			var body = document.getElementById("body");
			body.style.overflow = "auto";
		}
	}, {
		key: 'render',
		value: function render() {
			var _props5 = this.props,
			    _props5$km = _props5.km,
			    _props5$km$splits = _props5$km.splits,
			    splits = _props5$km$splits === undefined ? 2 : _props5$km$splits,
			    title = _props5$km.title,
			    label = _props5$km.label,
			    groups = _props5$km.groups,
			    cutoff = _props5$km.cutoff,
			    survivalType = _props5$km.survivalType,
			    survivalKeys = _props5.survivalKeys,
			    cohort = _props5.cohort,
			    dims = _props5.dims,
			    maySplit = _.get(groups, 'maySplit', false),
			    min = _.getIn(groups, ['domain', 0]),
			    max = _.getIn(groups, ['domain', 1]),
			    warning = _.get(groups, 'warning'),
			    clarification = _.get(groups, 'clarification'),
			    activeLabel = this.state.activeLabel,
			    sectionDims = calcDims(dims, plotSize.ratios),
			    survivalTypes = _.intersection(survivalKeys, _.keys(survivalOptions)),
			    survInfoURL = _.getIn(survURL, [cohort], null);

			var Content = _.isEmpty(groups) ? React.createElement(
				'div',
				{
					style: {
						height: dims.height,
						textAlign: 'center',
						verticalAlign: 'center'
					} },
				React.createElement(
					'h1',
					null,
					'Loading...'
				)
			) : _.isEmpty(groups.colors) ? React.createElement(
				'div',
				null,
				React.createElement(
					'div',
					null,
					makeSurvivalTypeUI(cohort, survInfoURL, survivalType, survivalTypes, this.onSurvType)
				),
				React.createElement(
					'div',
					null,
					React.createElement(
						'h3',
						null,
						'Unfortunately, KM plot can not be made. There is no survival data overlapping column data.'
					)
				)
			) : React.createElement(
				'div',
				null,
				React.createElement(
					_button.Button,
					{ onClick: this.pdf, className: _kmModule2.default.PDFButton },
					React.createElement(
						'i',
						{ className: 'material-icons ' + _kmModule2.default.buttonIcon },
						'file_download'
					),
					React.createElement(
						'span',
						{ className: _kmModule2.default.buttonText },
						'PDF'
					)
				),
				React.createElement(
					_button.Button,
					{ onClick: this.help, className: _kmModule2.default.helpButton },
					React.createElement(
						'i',
						{ className: 'material-icons ' + _kmModule2.default.buttonIcon },
						'help'
					),
					React.createElement(
						'span',
						{ className: _kmModule2.default.buttonText },
						'Help'
					)
				),
				makeGraph(groups, this.setActiveLabel, activeLabel, sectionDims.graph, cohort, survInfoURL, survivalType, survivalTypes, this.onSurvType, min, max, this.onCutoff, cutoff),
				makeDefinitions(groups, this.setActiveLabel, activeLabel, sectionDims.definitions, maySplit, splits, this.onSplits, label, clarification, warning)
			);

			var actions = [{
				children: [React.createElement(
					'i',
					{ className: 'material-icons' },
					'close'
				)],
				className: _kmModule2.default.mainDialogClose,
				onClick: this.hide
			}];
			return React.createElement(
				'div',
				null,
				React.createElement(
					_dialog2.default,
					{
						actions: actions,
						active: true,
						title: 'Kaplan Meier ' + title,
						className: _kmModule2.default.mainDialog,
						onEscKeyDown: this.hide,
						onOverlayClick: this.hide,
						theme: {
							wrapper: _kmModule2.default.dialogWrapper,
							overlay: _kmModule2.default.dialogOverlay } },
					Content
				)
			);
		}
	}]);
	return KmPlot;
}(_PureComponent5.default);

KmPlot.defaultProps = {
	eventClose: 'km-close',
	dims: {
		height: 450,
		width: 700
	}
};


module.exports = { KmPlot: KmPlot };