'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('react'),
    Component = _require.Component;

var _require2 = require('./underscore_ext'),
    isEqual = _require2.isEqual;

var logDiff; //eslint-disable-line no-unused-vars

if (process.env.NODE_ENV !== 'production') {
	logDiff = function logDiff(comp, nextProps, nextState) {
		if (!isEqual(comp.props, nextProps)) {
			console.log(comp.constructor.displayName, 'props differ:');
			(0, _keys2.default)(comp.props).forEach(function (p) {
				if (!nextProps.hasOwnProperty(p)) {
					console.log('key deleted:', p);
				} else if (!isEqual(comp.props[p], nextProps[p])) {
					console.log('key changed:', p);
				}
			});
			(0, _keys2.default)(nextProps).forEach(function (p) {
				if (!comp.props.hasOwnProperty(p)) {
					console.log('key added:', p);
				};
			});
		}
		if (!isEqual(comp.state, nextState)) {
			console.log(comp.constructor.displayName, 'state differs:');
			(0, _keys2.default)(comp.state).forEach(function (p) {
				if (!nextState.hasOwnProperty(p)) {
					console.log('key deleted:', p);
				} else if (!isEqual(comp.state[p], nextState[p])) {
					console.log('key changed:', p);
				}
			});
			(0, _keys2.default)(nextState).forEach(function (p) {
				if (!comp.state.hasOwnProperty(p)) {
					console.log('key added:', p);
				};
			});
		}
	};
}

var PureComponent = function (_Component) {
	(0, _inherits3.default)(PureComponent, _Component);

	function PureComponent() {
		(0, _classCallCheck3.default)(this, PureComponent);
		return (0, _possibleConstructorReturn3.default)(this, (PureComponent.__proto__ || (0, _getPrototypeOf2.default)(PureComponent)).apply(this, arguments));
	}

	(0, _createClass3.default)(PureComponent, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			//		logDiff(this, nextProps, nextState);
			return !isEqual(nextProps, this.props) || !isEqual(nextState, this.state);
		}
	}]);
	return PureComponent;
}(Component);

exports.default = PureComponent;