'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _tooltip = require('react-toolbox/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet control toolbar. Displays state of zoom and filter and,
 * additional actions to show/hide null data or show/hide gene zoom.
 *
 */

// Core dependencies, components
var React = require('react');
var _ = require('./underscore_ext');

// App dependencies
var SheetStatus = require('./views/SheetStatus');


// Styles
var compStyles = require('./SheetControls.module.css');
var classNames = require('classnames');

var SheetControls = function (_React$Component) {
	(0, _inherits3.default)(SheetControls, _React$Component);

	function SheetControls() {
		(0, _classCallCheck3.default)(this, SheetControls);
		return (0, _possibleConstructorReturn3.default)(this, (SheetControls.__proto__ || (0, _getPrototypeOf2.default)(SheetControls)).apply(this, arguments));
	}

	(0, _createClass3.default)(SheetControls, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    appState = _props.appState,
			    clearZoom = _props.clearZoom,
			    statusDisabled = _props.statusDisabled,
			    zoomOut = _props.zoomOut,
			    count = _.getIn(this.props, ['zoom', 'count']) || 0,
			    index = _.getIn(this.props, ['zoom', 'index']) || 0,
			    mode = appState.mode,
			    zoomed = count !== appState.samples.length,
			    zoomLabel = zoomed ? 'Zoomed' : 'Zoom:',
			    zoomState = zoomed ? index === index + count - 1 ? 'to row ' + (index + 1) : 'to rows ' + (index + 1) + ' - ' + (index + count) : 'None',
			    zoomStatus = React.createElement(SheetStatus, { className: compStyles.zoomAnimate, disabled: statusDisabled, label: zoomLabel, sheetState: zoomState }),
			    ZoomTooltip = (0, _tooltip2.default)('zoomStatus');

			return React.createElement(
				'div',
				{ className: compStyles.sheetControls },
				mode === "chart" ? null : React.createElement(
					'div',
					{ className: compStyles.sheetStatus },
					zoomed ? zoomStatus : React.createElement(
						ZoomTooltip,
						{ tooltip: 'Click and drag to zoom' },
						zoomStatus
					),
					zoomed ? React.createElement(
						'div',
						{ className: classNames(compStyles.zoomActions, compStyles.zoomAnimate) },
						React.createElement(
							'span',
							{ className: compStyles.action, onClick: zoomOut },
							'Zoom Out'
						),
						React.createElement(
							'span',
							{ className: compStyles.action, onClick: clearZoom },
							'Clear Zoom'
						)
					) : null
				)
			);
		}
	}]);
	return SheetControls;
}(React.Component);

module.exports = SheetControls;