'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('./underscore_ext');
var vgcanvas = require('./vgcanvas');

var tickWidth = 5,
    borderWidth = 5;

var style = {
	position: 'absolute',
	background: 'transparent',
	left: -(tickWidth + borderWidth),
	top: -borderWidth,
	pointerEvents: 'none',
	zIndex: 2,
	borderWidth: borderWidth,
	borderColor: 'transparent',
	borderStyle: 'solid',
	transition: 'border-color 0.3s linear'
};

var SpreadSheetHighlight = function (_React$Component) {
	(0, _inherits3.default)(SpreadSheetHighlight, _React$Component);

	function SpreadSheetHighlight() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, SpreadSheetHighlight);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = SpreadSheetHighlight.__proto__ || (0, _getPrototypeOf2.default)(SpreadSheetHighlight)).call.apply(_ref, [this].concat(args))), _this), _this.state = { animate: false }, _this.draw = function (props) {
			var samples = props.samples,
			    samplesMatched = props.samplesMatched,
			    height = props.height,
			    _this2 = _this,
			    vg = _this2.vg;


			if (vg.height() !== height) {
				vg.height(height);
			}

			vg.clear(0, 0, tickWidth, height);
			if (!samplesMatched) {
				return;
			}
			// Previously we used _.object, but hit a Safari bug https://bugs.webkit.org/show_bug.cgi?id=177772
			// with assigning numeric values to numeric keys. So, using an Array instead.
			var matchMap = samplesMatched.reduce(function (acc, v, i) {
				acc[v] = i;return acc;
			}, new Array(samples.length)),
			    stripeGroups = _.groupByConsec(samples, function (s) {
				return _.has(matchMap, s);
			}),
			    stripes = _.scan(stripeGroups, function (acc, g) {
				return acc + g.length;
			}, 0),
			    hasMatch = _.map(stripeGroups, function (s, i) {
				return _.has(matchMap, stripeGroups[i][0]);
			}),
			    pixPerRow = height / samples.length;

			vg.box(0, 0, tickWidth, height, 'rgba(0, 0, 0, 0)'); // transparent black

			var rects = _.flatmap(_.initial(stripes).map(function (offset, i) {
				return !hasMatch[i] ? [] : [[0, offset * pixPerRow, tickWidth, Math.max(pixPerRow * (stripes[i + 1] - offset), 1)]];
			}));
			if (rects.length > 0) {
				vg.drawRectangles(rects, { fillStyle: 'rgba(0, 0, 0, 1)' });
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(SpreadSheetHighlight, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			// ignore props.
			return !_.isEqual(this.state, nextState);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this3 = this;

			var height = this.props.height;

			this.vg = vgcanvas(this.refs.canvas, tickWidth, height);
			this.draw(this.props);
			this.animate = this.props.animate.subscribe(function (ev) {
				return _this3.setState({ animate: ev });
			}); //eslint-disable-line react/no-did-mount-set-state
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.animate.unsubscribe();
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			if (this.vg && !_.isEqual(newProps, this.props)) {
				this.draw(newProps);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var animate = this.state.animate,
			    border = animate ? {
				borderColor: 'red'
			} : {};

			return React.createElement('canvas', { style: (0, _extends3.default)({}, style, border), ref: 'canvas' });
		}
	}]);
	return SpreadSheetHighlight;
}(React.Component);

module.exports = SpreadSheetHighlight;