'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactDOM = require('react-dom');
var Rx = require('../rx');
var main = window.document.getElementById('main');

var _require = require('../util'),
    allParameters = _require.allParameters;

var _require2 = require('../underscore_ext'),
    sortBy = _require2.sortBy;

var compStyles = require('./bookmarks.module.css');

var Weekly = function (_Component) {
	(0, _inherits3.default)(Weekly, _Component);

	function Weekly() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Weekly);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Weekly.__proto__ || (0, _getPrototypeOf2.default)(Weekly)).call.apply(_ref, [this].concat(args))), _this), _this.state = { weeks: null }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Weekly, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			Rx.Observable.ajax({
				url: '/api/bookmarks/weekly',
				method: 'GET'
			}).subscribe(function (req) {
				_this2.setState({ weeks: req.response });
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var weeks = this.state.weeks;

			return weeks ? _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'h2',
					null,
					'Bookmarks last-use-date by week'
				),
				_react2.default.createElement(
					'ul',
					{ className: compStyles.weeks },
					weeks.map(function (w) {
						return _react2.default.createElement(
							'li',
							{ key: w.week },
							_react2.default.createElement(
								'span',
								{ className: compStyles.week },
								w.week.split(/ /)[0]
							),
							_react2.default.createElement(
								'a',
								{ href: '?week=' + w.week },
								_react2.default.createElement(
									'span',
									null,
									w.count
								)
							)
						);
					})
				)
			) : _react2.default.createElement(
				'span',
				null,
				'Loading...'
			);
		}
	}]);
	return Weekly;
}(_react.Component);

var Week = function (_Component2) {
	(0, _inherits3.default)(Week, _Component2);

	function Week() {
		var _ref2;

		var _temp2, _this3, _ret2;

		(0, _classCallCheck3.default)(this, Week);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this3 = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Week.__proto__ || (0, _getPrototypeOf2.default)(Week)).call.apply(_ref2, [this].concat(args))), _this3), _this3.state = { list: null }, _temp2), (0, _possibleConstructorReturn3.default)(_this3, _ret2);
	}

	(0, _createClass3.default)(Week, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this4 = this;

			var week = this.props.week;

			Rx.Observable.ajax({
				url: '/api/bookmarks/weekof?week=' + encodeURIComponent(week),
				method: 'GET'
			}).subscribe(function (req) {
				_this4.setState({ list: sortBy(req.response, 'lastUse') });
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var list = this.state.list,
			    week = this.props.week;

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'h2',
					null,
					'Bookkmarks for week of ',
					week.split(/ /)[0]
				),
				list ? _react2.default.createElement(
					'ul',
					{ className: compStyles.bookmarks },
					list.map(function (b) {
						return _react2.default.createElement(
							'li',
							{ key: b.id },
							_react2.default.createElement(
								'a',
								{ href: window.location.origin + '/heatmap/?bookmark=_' + b.id },
								_react2.default.createElement(
									'span',
									{ className: compStyles.id },
									b.id
								)
							),
							_react2.default.createElement(
								'span',
								null,
								b.lastUse
							)
						);
					})
				) : _react2.default.createElement(
					'span',
					null,
					'Loading...'
				),
				_react2.default.createElement('br', null),
				_react2.default.createElement(
					'a',
					{ href: window.location.origin + '/bookmarks/' },
					'All bookmarks'
				)
			);
		}
	}]);
	return Week;
}(_react.Component);

var params = allParameters();
var Main = params.week ? Week : Weekly;

ReactDOM.render(_react2.default.createElement(Main, { week: params.week && params.week[0] }), main);