'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LZ = require('./lz-string');

var _require = require('./underscore_ext'),
    uniq = _require.uniq;

var _require2 = require('./compactData'),
    compactState = _require2.compactState,
    expandState = _require2.expandState;

var migrateState = require('./migrateState');

var _require3 = require('./schemaCheck'),
    schemaCheckThrow = _require3.schemaCheckThrow;

var version = 1;

// XXX This encode version never worked, because it's encoded inside the blob.
// Needs to be outside the blob. We would need to rewrite the db or API to
// fix this. Maybe should be a POST param, instead of part of the json.

// Serialization
var stringify = function stringify(state) {
	return LZ.compressToUTF16((0, _stringify2.default)({ version: version, appState: compactState(state) }));
};
var parse = function parse(bookmark) {
	return schemaCheckThrow(expandState(migrateState(JSON.parse(LZ.decompressFromUTF16(bookmark)).appState)));
};

function getRecent() {
	try {
		return JSON.parse(localStorage.bookmarks);
	} catch (e) {
		return [];
	}
}

function setRecent(id) {
	var recent = getRecent(),
	    time = new Date().toString();
	localStorage.bookmarks = (0, _stringify2.default)(uniq([{ id: id, time: time }].concat(recent), function (e) {
		return e.id;
	}).slice(0, 15));
}

module.exports = {
	version: version,
	hasBookmark: function hasBookmark() {
		return location.search.match(/^\?bookmark=/);
	},
	getBookmark: function getBookmark() {
		return location.search.replace(/^\?bookmark=(_?[0-9a-z]+)/, '$1');
	},
	resetBookmarkLocation: function resetBookmarkLocation() {
		return history.replaceState({}, 'UCSC Xena', location.pathname + location.search.replace(/\?bookmark=(_?[0-9a-z]+)/, ''));
	},
	createBookmark: stringify,
	// Need to add version check & merge of state + bookmark.
	parseBookmark: parse,
	getRecent: getRecent,
	setRecent: setRecent
};