'use strict';

var multi = require('./multi');

var fieldTypeSelector = function fieldTypeSelector(x) {
	return x.fieldType;
};
var fieldTypeOrSamplesSelector = function fieldTypeOrSamplesSelector(id, x) {
	return id === 'samples' ? 'samples' : x.fieldType;
};
var columnFieldTypeOrSamplesSelector = function columnFieldTypeOrSamplesSelector(x) {
	return x.id === 'samples' ? 'samples' : x.column.fieldType;
};
var columnFieldTypeSelector = function columnFieldTypeSelector(x) {
	return x.column.fieldType;
};

var widget = {
	cmp: multi(fieldTypeSelector),
	index: multi(function (x) {
		return x;
	}),
	transform: multi(fieldTypeSelector),
	avg: multi(fieldTypeSelector),
	download: multi(columnFieldTypeSelector),
	specialDownload: multi(columnFieldTypeSelector),
	column: multi(columnFieldTypeOrSamplesSelector),
	legend: multi(columnFieldTypeOrSamplesSelector),
	pdf: multi(fieldTypeOrSamplesSelector)
};

widget.index.dflt = function () {
	return null;
};
widget.avg.dflt = function () {
	return null;
};

module.exports = widget;