'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _LaunchHelper = require('../LaunchHelper');

var _LaunchHelper2 = _interopRequireDefault(_LaunchHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// XXX move Application to views
var React = require('react');
//var _ = require('../underscore_ext');

var _require = require('./SpreadsheetContainer'),
    getSpreadsheetContainer = _require.getSpreadsheetContainer;

var ChartView = require('../ChartView');
var Column = require('../views/Column');
var _ = require('../underscore_ext');

var _require2 = require('../react-utils'),
    rxEvents = _require2.rxEvents;

var Rx = require('../rx');
// Spreadsheet options
var addTooltip = require('./addTooltip');
//var disableSelect = require('./disableSelect');
var addWizardColumns = require('./addWizardColumns');
var addVizEditor = require('./addVizEditor');
var makeSortable = require('./makeSortable');
var addColumnAdd = require('./addColumnAdd');
var addLegend = require('./addLegend');
var addHelp = require('./addHelp');
var getSpreadsheet = require('../Spreadsheet');
var getStepperState = require('./getStepperState');
var Application = require('../Application');
//import TiesContainer from './TiesContainer';

var _require3 = require('../schemaCheck'),
    schemaCheckThrow = _require3.schemaCheckThrow;

var migrateState = require('../migrateState');

function getFieldFormat(uuid, columns, data) {
	var columnFields = _.getIn(columns, [uuid, 'fields']),
	    label = _.getIn(columns, [uuid, 'fieldLabel']),
	    fields = _.getIn(data, [uuid, 'req', 'probes'], columnFields);
	if (fields.length === 1) {
		// 1 gene/probe, or 1 probe in gene
		return function (field) {
			return field === label ? label : label + ' (' + field + ')';
		};
	} else if (fields.length === columnFields.length) {
		// n > 1 genes/probes
		return _.identity;
	} else {
		// n > 1 probes in gene
		return function (field) {
			return label + ' (' + field + ')';
		};
	}
}

var columnsWrapper = function columnsWrapper(c) {
	return addHelp(addTooltip(addWizardColumns(addColumnAdd(addLegend(makeSortable(addVizEditor(c)))))));
};
var Spreadsheet = getSpreadsheet(columnsWrapper);
// XXX without tooltip, we have no mouse pointer. Should make the wrapper add the css
// that hides the mouse. Currently this is in Column.
//var columnsWrapper = c => makeSortable(disableSelect(c));
var SpreadsheetContainer = getSpreadsheetContainer(Column, Spreadsheet);

var ApplicationContainer = function (_React$Component) {
	(0, _inherits3.default)(ApplicationContainer, _React$Component);

	function ApplicationContainer() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ApplicationContainer);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ApplicationContainer.__proto__ || (0, _getPrototypeOf2.default)(ApplicationContainer)).call.apply(_ref, [this].concat(args))), _this), _this.onSearch = function (value) {
			var callback = _this.props.callback;

			callback(['sample-search', value]);
		}, _this.fieldFormat = function (uuid) {
			var _this$props$state$spr = _this.props.state.spreadsheet,
			    columns = _this$props$state$spr.columns,
			    data = _this$props$state$spr.data;

			return getFieldFormat(uuid, columns, data);
		}, _this.sampleFormat = function (index) {
			var cohortSamples = _this.props.state.spreadsheet.cohortSamples;

			return _.get(cohortSamples, index);
		}, _this.getState = function () {
			return _.pick(_this.props.state, 'version', 'page', 'spreadsheet');
		}, _this.onWizardMode = function (mode) {
			_this.props.callback(['wizardMode', mode]);
		}, _this.onShowWelcome = function (show) {
			_this.props.callback(['showWelcome', show]);
		}, _this.onReset = function () {
			_this.props.callback(['cohortReset']);
		}, _this.onResetSampleFilter = function () {
			_this.props.callback(['sampleFilter', null]);
		}, _this.onNavigate = function (page, params) {
			_this.props.callback(['navigate', page, params]);
		}, _this.onImport = function (content) {
			try {
				_this.props.callback(['import', schemaCheckThrow(migrateState(JSON.parse(content)))]);
			} catch (err) {
				_this.props.callback(['import-error']);
			}
		}, _this.onHighlightSelect = function (highlight) {
			_this.props.callback(['highlightSelect', highlight]);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ApplicationContainer, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var events = rxEvents(this, 'highlightChange');
			this.change = events.highlightChange.debounceTime(200).subscribe(this.onSearch);
			// high on 1st change, low after some delay
			this.highlight = events.highlightChange.switchMap(function () {
				return Rx.Observable.of(true).concat(Rx.Observable.of(false).delay(300));
			}).distinctUntilChanged(_.isEqual);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.change.unsubscribe();
			this.highlight.unsubscribe();
		}

		// raw (before selector) state

	}, {
		key: 'render',


		// XXX Change state to appState in Application, for consistency.
		value: function render() {
			var _props = this.props,
			    state = _props.state,
			    selector = _props.selector,
			    callback = _props.callback,
			    children = _props.children,
			    stateError = state.stateError,
			    computedState = selector(state),
			    _computedState$spread = computedState.spreadsheet,
			    mode = _computedState$spread.mode,
			    _computedState$spread2 = _computedState$spread.ties;
			_computedState$spread2 = _computedState$spread2 === undefined ? {} : _computedState$spread2;
			var open = _computedState$spread2.open,
			    loadPending = computedState.loadPending,
			    stepperState = getStepperState(computedState.spreadsheet),
			    View = {
				heatmap: SpreadsheetContainer,
				chart: ChartView
				//				ties: TiesContainer,
			}[open ? 'ties' : mode];

			return React.createElement(
				Application,
				{
					onReset: this.onReset,
					onResetSampleFilter: this.onResetSampleFilter,
					onWizardMode: this.onWizardMode,
					onShowWelcome: this.onShowWelcome,
					stepperState: stepperState,
					Spreadsheet: SpreadsheetContainer,
					onHighlightChange: this.on.highlightChange,
					onHighlightSelect: this.onHighlightSelect,
					sampleFormat: this.sampleFormat,
					getState: this.getState,
					onNavigate: this.onNavigate,
					onImport: this.onImport,
					loadPending: loadPending,
					stateError: stateError,
					state: computedState.spreadsheet,
					callback: callback },
				React.createElement(View, {
					stepperState: stepperState,
					searching: this.highlight,
					fieldFormat: this.fieldFormat,
					sampleFormat: this.sampleFormat,
					appState: computedState.spreadsheet,
					wizard: computedState.wizard,
					callback: callback }),
				children
			);
		}
	}]);
	return ApplicationContainer;
}(React.Component);

// add pop-up notification for old hubs.


module.exports = (0, _LaunchHelper2.default)(function (props) {
	return _.getIn(props, ['state', 'localStatus']) === 'old';
}, ApplicationContainer);