'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('../underscore_ext');
var getLabel = require('../getLabel');

var _require = require('../models/fieldSpec'),
    supportsEdit = _require.supportsEdit;

var _require2 = require('../util'),
    addCommas = _require2.addCommas;

function fixSampleTitle(column, i, samples, wizardMode, cohort) {
	return i === 0 ? _.updateIn(column, ['user', 'fieldLabel'], function (label) {
		return wizardMode ? addCommas(samples.length) + ' samples' : label;
	}, ['user', 'columnLabel'], function (label) {
		return wizardMode ? cohort.name : label;
	}) : column;
}

function columnSelector(id, i, appState) {
	var data = appState.data,
	    zoom = appState.zoom,
	    columns = appState.columns,
	    samples = appState.samples,
	    samplesMatched = appState.samplesMatched,
	    wizardMode = appState.wizardMode,
	    cohort = appState.cohort;

	return {
		id: id,
		key: id,
		samples: samples,
		samplesMatched: samplesMatched,
		zoom: zoom,
		index: _.getIn(appState, ['index', id]),
		vizSettings: _.getIn(appState, ['columns', id, 'vizSettings']),
		data: _.getIn(data, [id]) /* refGene */
		, column: fixSampleTitle(_.getIn(columns, [id]), i, samples, wizardMode, cohort),
		label: getLabel(i) // <<- put in Spreadsheet? We don't really need it here.
	};
}

function isInteractive(props, state) {
	var interactive = state.interactive,
	    _props$appState = props.appState,
	    wizardMode = _props$appState.wizardMode,
	    editing = _props$appState.editing;

	return !wizardMode && editing == null && _.every(interactive);
}

var getSpreadsheetContainer = function getSpreadsheetContainer(Column, Spreadsheet) {
	var _class, _temp2;

	return _temp2 = _class = function (_React$Component) {
		(0, _inherits3.default)(_class, _React$Component);

		function _class() {
			var _ref;

			var _temp, _this, _ret;

			(0, _classCallCheck3.default)(this, _class);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
				interactive: {}
			}, _this.onInteractive = function (key, interactive) {
				_this.setState({ interactive: _.assoc(_this.state.interactive, key, interactive) });
			}, _this.onResize = function (id, size) {
				_this.props.callback(['resize', id, size]);
			}, _this.onXZoom = function (id, xzoom) {
				_this.props.callback(['xzoom', id, xzoom]);
			}, _this.onYZoom = function (yzoom) {
				_this.props.callback(['enableTransition'], false);
				_this.props.callback(['zoom', yzoom]);
			}, _this.onRemove = function (id) {
				_this.props.callback(['remove', id]);
			}, _this.onKm = function (id) {
				_this.props.callback(['km-open', id]);
			}, _this.onSortDirection = function (id, newDir) {
				_this.props.callback(['sortDirection', id, newDir]);
			}, _this.onMode = function (id, newMode) {
				_this.props.callback(['fieldType', id, newMode]);
			}, _this.onColumnLabel = function (id, value) {
				_this.props.callback(['columnLabel', id, value]);
			}, _this.onFieldLabel = function (id, value) {
				_this.props.callback(['fieldLabel', id, value]);
			}, _this.onShowIntrons = function (id) {
				_this.props.callback(['showIntrons', id]);
			}, _this.onChart = function (id) {
				_this.props.callback(['chart-set-column', id]);
				_this.props.callback(['chart']);
			}, _this.onCluster = function (id, value, data) {
				_this.props.callback(['cluster', id, value, data]);
			}, _this.onSortVisible = function (id, value) {
				_this.props.callback(['sortVisible', id, value]);
			}, _this.onOpenVizSettings = function (id) {
				_this.props.callback(['vizSettings-open', id]);
			}, _this.onVizSettings = function (id, state) {
				_this.props.callback(['vizSettings', id, state]);
			}, _this.onEdit = function (id) {
				_this.props.callback(['edit-column', id]);
			}, _this.onAddColumn = function (pos) {
				_this.props.callback(['edit-column', pos]);
			}, _this.onReload = function (id) {
				_this.props.callback(['reload', id]);
			}, _this.onReset = function () {
				_this.props.callback(['cohortReset']);
			}, _this.onAbout = function (host, dataset) {
				_this.props.callback(['navigate', 'datapages', { host: host, dataset: dataset }]);
			}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
		}

		(0, _createClass3.default)(_class, [{
			key: 'render',
			value: function render() {
				var _this2 = this;

				var columnProps = _.pick(this.props, ['searching', 'fieldFormat', 'sampleFormat', 'samplesMatched']),
				    _props = this.props,
				    appState = _props.appState,
				    cohortTumorMap = _props.wizard.cohortTumorMap,
				    columnOrder = appState.columnOrder,
				    wizardMode = appState.wizardMode,
				    hasSurvival = appState.hasSurvival,
				    interactive = isInteractive(this.props, this.state);

				// XXX prune callback from this.props
				// Currently it's required for ColumnEdit2 and zoom helper.
				return React.createElement(
					Spreadsheet,
					(0, _extends3.default)({
						onAddColumn: this.onAddColumn,
						onOpenVizSettings: this.onOpenVizSettings,
						onVizSettings: this.onVizSettings,
						interactive: interactive,
						onInteractive: this.onInteractive
					}, this.props),
					_.map(columnOrder, function (id, i) {
						return React.createElement(Column, (0, _extends3.default)({
							interactive: interactive,
							hasSurvival: hasSurvival,
							cohort: appState.cohort,
							onAbout: _this2.onAbout,
							onViz: _this2.onOpenVizSettings,
							onEdit: supportsEdit(_.get(appState.columns, id)) && interactive ? _this2.onEdit : null,
							onFieldLabel: _this2.onFieldLabel,
							onColumnLabel: _this2.onColumnLabel,
							onReset: _this2.onReset,
							onShowIntrons: _this2.onShowIntrons,
							onCluster: _this2.onCluster,
							onSortVisible: _this2.onSortVisible,
							onMode: _this2.onMode,
							onInteractive: _this2.onInteractive,
							onKm: _this2.onKm,
							onChart: _this2.onChart,
							onSortDirection: _this2.onSortDirection,
							onXZoom: _this2.onXZoom,
							onYZoom: _this2.onYZoom,
							onRemove: _this2.onRemove,
							onResize: _this2.onResize,
							onReload: _this2.onReload,
							actionKey: id,
							first: i === 0
						}, columnProps, columnSelector(id, i, appState), {
							wizardMode: wizardMode,
							editing: appState.editing,
							tumorMap: cohortTumorMap }));
					})
				);
			}
		}]);
		return _class;
	}(React.Component), _class.displayName = 'SpreadsheetContainer', _temp2;
};

module.exports = { getSpreadsheetContainer: getSpreadsheetContainer };