'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var Rx = require('../rx');
var Welcome = require('../views/Welcome');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var links = [['heatmap', 'bc7f3f46b042bcf5c099439c2816ff01', 'FOXM1a, FOXM1b, FOXM1c transcript expression in tumor vs. normal samples'], ['heatmap', 'cd6d8adead7d720fea7df197dc807147', 'ERG-TMPRSS2 fusion by chr21 deletion in prostate cancer'], ['heatmap', 'ff06e17b50faa9ec3045ab174dd19907', 'KM plot (overall survival) of breast cancer PAM50 subtypes'], ['heatmap', '6451afae2ee964475a2eb9c79d46900c', 'Genetic separation of lower grade gliomas: one characterized by loss of chromosomes 1p & 19q, \
		the other by TP53 & ATRX mutations.'], ['heatmap', '3f4b3fa8901f4c24f5f791e036566424', 'PDL1 and PD1 expression across 39 cancer types in TCGA and TARGET'], ['heatmap', '2dc4735dd97964b7c2a57afe053a9764', 'MGMT promoter DNA methylation is inversely correlated with MGMT expression'], ['heatmap', '0f9954a525987445ba7faef1e2081027', 'Copy number for EGFR, PTEN, chromosome 1, 7, 10, 19 in TCGA brain tumors'], ['transcripts', '75fd7d99bbc1bb04aae9b4e5e34b077f', 'KRAS isoform expression in TCGA pancreatic cancer vs. GTEx pancreas normal'], ['heatmap', 'dfc37064d62ea0c0302881c05277b7b3', 'Mutation pile-ups in intron enhancers in ICGC lymphoma']];

var evToIndex = function evToIndex(ev) {
	return parseInt(ev.currentTarget.dataset.index, 10);
};

var refresh = 5000; // ms between link switch

var WelcomeContainer = function (_PureComponent) {
	(0, _inherits3.default)(WelcomeContainer, _PureComponent);

	function WelcomeContainer() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, WelcomeContainer);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = WelcomeContainer.__proto__ || (0, _getPrototypeOf2.default)(WelcomeContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = { link: 0 }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(WelcomeContainer, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var events = rxEvents(this, 'mouseover', 'mouseout', 'bulletover');
			var mouseover = events.mouseover,
			    mouseout = events.mouseout,
			    bulletover = events.bulletover;

			// Emit events on an interval, pausing if the user mouses-over
			// the target link. The timer restarts on mouse-out, so it won't
			// change immediately.

			this.sub = Rx.Observable.of(true).merge(mouseout).flatMap(function () {
				return Rx.Observable.interval(refresh).takeUntil(mouseover.merge(bulletover)).map(function () {
					return undefined;
				});
			}).merge(bulletover.map(evToIndex)).subscribe(function (i) {
				return _this2.setState({ link: i === undefined ? (_this2.state.link + 1) % links.length : i });
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.sub.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var link = this.state.link;

			return React.createElement(Welcome, (0, _extends3.default)({
				count: links.length,
				i: link,
				linkProps: { onMouseOver: this.on.mouseover, onMouseOut: this.on.mouseout },
				bulletProps: { onMouseOver: this.on.bulletover, onMouseOut: this.on.mouseout }
			}, this.props, {
				link: links[link] }));
		}
	}]);
	return WelcomeContainer;
}(_PureComponent3.default);

module.exports = WelcomeContainer;