'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'); /**
                               * UCSC Xena Client
                               * http://xena.ucsc.edu
                               *
                               * Structural component, giving each column a sibling "add column" component.
                               */

// Core dependencies, components

var classNames = require('classnames');
var ColumnAdd = require('../views/ColumnAdd');

// Styles
var compStyles = require('./addColumnAdd.module.css');

var hoverClass = function hoverClass(index, hover) {
	return index === hover ? compStyles.hoverLeft : index - 1 === hover ? compStyles.hoverRight : undefined;
};

// XXX move layout to a view, after we know what the final layout will be.
function addColumnAdd(Component) {
	var _class, _temp2;

	return _temp2 = _class = function (_PureComponent) {
		(0, _inherits3.default)(_class, _PureComponent);

		function _class() {
			var _ref;

			var _temp, _this, _ret;

			(0, _classCallCheck3.default)(this, _class);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = { hover: null }, _this.onClick = function (index) {
				_this.props.onAddColumn(index);
				_this.setState({ hover: null });
			}, _this.onHover = function (index, hovering) {

				if (index === 0) {
					_this.props.callback(['enableTransition', true]);
					_this.props.callback(['addColumnAddHover', hovering]);
				}

				_this.setState({ hover: hovering ? index : null });
			}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
		}

		(0, _createClass3.default)(_class, [{
			key: 'render',
			value: function render() {
				var _this2 = this;

				var _props = this.props,
				    children = _props.children,
				    otherProps = (0, _objectWithoutProperties3.default)(_props, ['children']),
				    wizardMode = otherProps.appState.wizardMode,
				    interactive = otherProps.interactive,
				    hover = this.state.hover,
				    lastIndex = children.length - 1,
				    columns = React.Children.map(children, function (child, i) {
					return React.createElement(
						'div',
						{
							className: classNames(compStyles.visualizationOrWizardMode, hoverClass(i, hover), (0, _defineProperty3.default)({}, compStyles.wizardModeMargins, wizardMode)),
							'data-actionKey': child.props.actionKey },
						child,
						React.createElement(ColumnAdd, {
							show: interactive,
							actionKey: i,
							last: i === lastIndex,
							onHover: _this2.onHover,
							onClick: _this2.onClick })
					);
				});

				return React.createElement(
					Component,
					otherProps,
					columns
				);
			}
		}]);
		return _class;
	}(_PureComponent3.default), _class.displayName = 'SpreadsheetColumnAdd', _temp2;
}

module.exports = addColumnAdd;