'use strict';

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var HelpBox = require('../views/HelpBox');
//old text:  The left-most column is used for the initial row sort. In case of a tie, the value in the next column to the right is used to break the tie.
var columnHelp = function columnHelp(onClose) {
	return React.createElement(
		HelpBox,
		{ w: 400, o: 'Below', onClose: onClose },
		React.createElement(
			'p',
			null,
			'Column B value is used to sort the rows. In case of a tie, the next columns to the right are used to break the tie.'
		)
	);
};

var rowHelp = function rowHelp(onClose) {
	return React.createElement(
		HelpBox,
		{ w: 400, o: 'Right', onClose: onClose },
		React.createElement(
			'p',
			null,
			'Each row contains data from a single sample.'
		),
		React.createElement(
			'p',
			null,
			'Row order is determined by sorting the rows by their column values.'
		)
	);
};

function addHelp(Component) {
	var _class, _temp2;

	return _temp2 = _class = function (_React$Component) {
		(0, _inherits3.default)(_class, _React$Component);

		function _class() {
			var _ref;

			var _temp, _this, _ret;

			(0, _classCallCheck3.default)(this, _class);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref, [this].concat(args))), _this), _this.onColumnHelp = function () {
				_this.props.callback(['notifications-disable', 'columnHelp']);
			}, _this.onRowHelp = function () {
				_this.props.callback(['notifications-disable', 'rowHelp']);
			}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
		}

		(0, _createClass3.default)(_class, [{
			key: 'render',
			value: function render() {
				var _this2 = this;

				var _props = this.props,
				    children = _props.children,
				    props = (0, _objectWithoutProperties3.default)(_props, ['children']),
				    _props$appState = this.props.appState,
				    columnOrder = _props$appState.columnOrder,
				    notifications = _props$appState.notifications,
				    wizardMode = _props$appState.wizardMode,
				    last = columnOrder.length - 1;

				return React.createElement(
					Component,
					props,
					React.Children.map(children, function (el, i) {
						var append = wizardMode ? undefined : i === 1 && !notifications.columnHelp ? columnHelp(_this2.onColumnHelp) : i === last && !notifications.rowHelp ? rowHelp(_this2.onRowHelp) : undefined;

						return append ? React.cloneElement(el, { append: append }) : el;
					})
				);
			}
		}]);
		return _class;
	}(React.Component), _class.displayName = 'SpreadsheetHelp', _temp2;
}

module.exports = addHelp;