'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tooltip = require('../views/Tooltip');

var React = require('react');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var meta = require('../meta');
var _ = require('../underscore_ext');
var Rx = require('../rx');

function addTooltip(Component) {
	var _class, _temp2;

	return _temp2 = _class = function (_PureComponent) {
		(0, _inherits3.default)(_class, _PureComponent);

		function _class() {
			var _ref;

			var _temp, _this, _ret;

			(0, _classCallCheck3.default)(this, _class);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
				tooltip: { open: false }
			}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
		}

		(0, _createClass3.default)(_class, [{
			key: 'componentWillMount',
			value: function componentWillMount() {
				var _this2 = this;

				var events = this.ev = rxEvents(this, 'tooltip', 'click', 'close');

				var toggle = events.click.filter(function (ev) {
					return ev[meta.key];
				}).map(function () {
					return 'toggle';
				}),
				    close = events.close.map(function () {
					return 'toggle';
				});

				var tooltip = events.tooltip.merge(toggle).merge(close)
				// If open + user clicks, toggle freeze of display.
				.scan(function (_ref2, ev) {
					var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
					    tt = _ref3[0],
					    frozen = _ref3[1];

					return ev === 'toggle' ? [tt, tt.open && !frozen] : [ev, frozen];
				}, [{ open: false }, false])
				// Filter frozen events until frozen state changes.
				.distinctUntilChanged(_.isEqual, function (_ref4) {
					var _ref5 = (0, _slicedToArray3.default)(_ref4, 2),
					    ev = _ref5[0],
					    frozen = _ref5[1];

					return frozen ? frozen : [ev, frozen];
				}).map(function (_ref6) {
					var _ref7 = (0, _slicedToArray3.default)(_ref6, 2),
					    ev = _ref7[0],
					    frozen = _ref7[1];

					return _.assoc(ev, 'frozen', frozen);
				}).share();

				// XXX Overwrite this.ev.tooltip with a Subject that includes
				// the 'frozen' functionality. This allows listeners to 'freeze',
				// e.g. the probe position highlight.
				this.ev.tooltip = Rx.Subject.create(events.tooltip, tooltip);

				this.sub = tooltip.subscribe(function (ev) {
					return _this2.setState({ tooltip: ev });
				});
			}
		}, {
			key: 'componentWillUnmount',
			value: function componentWillUnmount() {
				this.sub.unsubscribe();
			}
		}, {
			key: 'render',
			value: function render() {
				var _this3 = this;

				var _props = this.props,
				    children = _props.children,
				    props = (0, _objectWithoutProperties3.default)(_props, ['children']),
				    appState = props.appState,
				    interactive = props.interactive,
				    wizardMode = appState.wizardMode,
				    open = this.state.tooltip.open && interactive,
				    onClick = interactive ? this.on.click : null;

				return React.createElement(
					Component,
					(0, _extends3.default)({}, props, {
						onClick: onClick,
						append: wizardMode ? null : React.createElement(Tooltip, (0, _extends3.default)({ show: interactive, onClose: this.on.close, onClick: this.on.click }, (0, _extends3.default)({}, this.state.tooltip, { open: open }))) }),
					React.Children.map(children, function (el) {
						return React.cloneElement(el, {
							tooltip: _this3.ev.tooltip,
							frozen: _this3.state.tooltip.frozen
						});
					})
				);
			}
		}]);
		return _class;
	}(_PureComponent3.default), _class.displayName = 'SpreadsheetTooltip', _temp2;
}

module.exports = addTooltip;