'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Utilities for handling errors in async actions.

var Rx = require('../rx');
var _ = require('../underscore_ext');

var _require = require('../errors'),
    compositeError = _require.compositeError;

// Put error object on stream, extending with context.


function reifyErrors(obs, context) {
	return obs.catch(function (err) {
		return Rx.Observable.of(_.extend(err, { context: context }));
	});
}

// From an array of values, some of them errors, combine the successes into a
// single event, combine the errors and re-throw. This is a flatmap function.
var collectResults = _.curry(function (filter, arr, selector) {
	var groups = _.groupBy(arr, function (r) {
		return r instanceof Error;
	}),
	    response = selector(filter ? groups.false || [] : arr),
	    errors = groups.true;

	// XXX This mechanism needs work. It doesn't compose well. Operators on
	// this (e.g. zip) may cause the error to be caught in the wrong place.
	return errors ? Rx.Observable.of(response).concat(Rx.Observable.throw(compositeError.apply(undefined, ['Composite Error'].concat((0, _toConsumableArray3.default)(errors))))) : Rx.Observable.of(response);
});

module.exports = {
	reifyErrors: reifyErrors,
	collectResults: collectResults(true),
	collectAlignedResults: collectResults(false)
};