'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../underscore_ext'),
    identity = _require.identity,
    updateIn = _require.updateIn,
    getIn = _require.getIn;

var make = function make(controls) {
	return {
		action: function action(state, _ref) {
			var _ref2 = (0, _toArray3.default)(_ref),
			    tag = _ref2[0],
			    args = _ref2.slice(1);

			return (controls[tag] || identity).apply(undefined, [state].concat((0, _toConsumableArray3.default)(args)));
		},
		postAction: function postAction(serverBus, state, newState, _ref3) {
			var _ref4 = (0, _toArray3.default)(_ref3),
			    tag = _ref4[0],
			    args = _ref4.slice(1);

			return (controls[tag + '-post!'] || identity).apply(undefined, [serverBus, state, newState].concat((0, _toConsumableArray3.default)(args)));
		}
	};
};

var mount = function mount(controller, path) {
	return {
		action: function action(state, ac) {
			return updateIn(state, path, function (subtree) {
				return controller.action(subtree, ac);
			});
		},
		postAction: function postAction(serverBus, state, newState, ac) {
			return controller.postAction(serverBus, getIn(state, path), getIn(newState, path), ac);
		}
	};
};

// might want to optimize this with for loops.
var compose = function compose() {
	for (var _len = arguments.length, controllers = Array(_len), _key = 0; _key < _len; _key++) {
		controllers[_key] = arguments[_key];
	}

	var rcontrollers = controllers.slice(0).reverse();
	return {
		action: function action(state, ac) {
			return rcontrollers.reduce(function (state, c) {
				return c.action(state, ac);
			}, state);
		},
		postAction: function postAction(bus, state, nextState, action) {
			return rcontrollers.forEach(function (c) {
				return c.postAction(bus, state, nextState, action);
			});
		}
	};
};

module.exports = {
	make: make,
	mount: mount,
	compose: compose
};