'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _serverNames;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var servers = {
	oldLocalHub: 'https://local.xena.ucsc.edu:7223',
	localHub: 'http://127.0.0.1:7222',
	publicHub: 'https://ucscpublic.xenahubs.net',
	tcgaHub: 'https://tcga.xenahubs.net',
	icgcHub: 'https://icgc.xenahubs.net',
	toilHub: 'https://toil.xenahubs.net',
	pcawgHub: 'https://pcawg.xenahubs.net',
	singlecellHub: 'https://singlecell.xenahubs.net',
	pancanAtlasHub: 'https://pancanatlas.xenahubs.net',
	treehouseHub: 'https://xena.treehouse.gi.ucsc.edu:443',
	gdcHub: "https://gdc.xenahubs.net",
	atacSeqHub: "https://atacseq.xenahubs.net",
	kidsFirstHub: "https://kidsfirst.xenahubs.net"
};

module.exports = {
	servers: servers,
	serverNames: (_serverNames = {}, (0, _defineProperty3.default)(_serverNames, servers.localHub, "My computer hub"), (0, _defineProperty3.default)(_serverNames, servers.publicHub, 'UCSC Public Hub'), (0, _defineProperty3.default)(_serverNames, servers.tcgaHub, 'TCGA Hub'), (0, _defineProperty3.default)(_serverNames, servers.icgcHub, 'ICGC Hub'), (0, _defineProperty3.default)(_serverNames, servers.toilHub, 'UCSC Toil RNA-seq Recompute'), (0, _defineProperty3.default)(_serverNames, servers.pcawgHub, 'PCAWG Hub'), (0, _defineProperty3.default)(_serverNames, servers.singlecellHub, 'Single-cell RNAseq Hub'), (0, _defineProperty3.default)(_serverNames, servers.pancanAtlasHub, 'Pan-Cancer Atlas Hub'), (0, _defineProperty3.default)(_serverNames, servers.treehouseHub, 'Treehouse Hub'), (0, _defineProperty3.default)(_serverNames, servers.gdcHub, 'GDC Hub'), (0, _defineProperty3.default)(_serverNames, servers.atacSeqHub, 'ATAC-seq Hub'), (0, _defineProperty3.default)(_serverNames, servers.kidsFirstHub, 'Kids First Hub'), _serverNames),
	defaultServers: [servers.localHub, servers.publicHub, servers.tcgaHub, servers.pancanAtlasHub, servers.icgcHub, servers.pcawgHub, servers.toilHub, servers.treehouseHub, servers.gdcHub, servers.atacSeqHub, servers.kidsFirstHub],
	enabledServers: [servers.localHub, servers.publicHub, servers.tcgaHub, servers.pancanAtlasHub, servers.icgcHub, servers.pcawgHub, servers.toilHub, servers.gdcHub, servers.atacSeqHub, servers.kidsFirstHub],
	publicServers: [servers.publicHub, servers.tcgaHub, servers.icgcHub, servers.toilHub, servers.pancanAtlasHub, servers.pcawgHub, servers.treehouseHub, servers.gdcHub, servers.atacSeqHub, servers.singlecellHub, servers.kidsFirstHub, 'https://tdi.xenahubs.net', 'https://luad.xenahubs.net']
};