'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Xena footer, writes itself into the element with ID "footer" in page.template.
 */

// Core dependencies, components
var React = require('react');
var ReactDOM = require('react-dom');

// Styles
var compStyles = require('./footer.module.css');

var Footer = function (_React$Component) {
	(0, _inherits3.default)(Footer, _React$Component);

	function Footer() {
		(0, _classCallCheck3.default)(this, Footer);
		return (0, _possibleConstructorReturn3.default)(this, (Footer.__proto__ || (0, _getPrototypeOf2.default)(Footer)).apply(this, arguments));
	}

	(0, _createClass3.default)(Footer, [{
		key: 'render',
		value: function render() {
			return React.createElement(
				'div',
				{ className: compStyles.footer },
				React.createElement(
					'div',
					{ className: compStyles.footerLinks },
					React.createElement(
						'ul',
						null,
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'https://www.ucsc.edu/', target: '_blank' },
								'UCSC'
							)
						),
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'https://ucscgenomics.soe.ucsc.edu/', target: '_blank' },
								'UCSC Genomics Institute'
							)
						),
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'https://cgl.genomics.ucsc.edu/', target: '_blank' },
								'UCSC Computational Genomics Laboratory'
							)
						),
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'http://xena.ucsc.edu/', target: '_blank' },
								'UCSC Xena'
							)
						)
					),
					React.createElement(
						'ul',
						null,
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'mailto:genome-cancer@soe.ucsc.edu' },
								'Email'
							)
						),
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'https://twitter.com/ucscxena', target: '_blank' },
								'Twitter'
							)
						),
						React.createElement(
							'li',
							null,
							React.createElement(
								'a',
								{ href: 'https://github.com/ucscXena', target: '_blank' },
								'Github'
							)
						)
					)
				),
				React.createElement(
					'div',
					{ className: compStyles.footerCR },
					'Copyright \xA9 2016, The Regents of the University of California, Santa Cruz All. Rights Reserved. Apache-2.0 license.'
				)
			);
		}
	}]);
	return Footer;
}(React.Component);

var footer = document.getElementById('footer');

ReactDOM.render(React.createElement(Footer, null), footer);