'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent3 = require('./PureComponent');

var _PureComponent4 = _interopRequireDefault(_PureComponent3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');


var geneLableFont = 12;
var maxLane = 5;

var GeneLabel = function (_PureComponent) {
	(0, _inherits3.default)(GeneLabel, _PureComponent);

	function GeneLabel() {
		(0, _classCallCheck3.default)(this, GeneLabel);
		return (0, _possibleConstructorReturn3.default)(this, (GeneLabel.__proto__ || (0, _getPrototypeOf2.default)(GeneLabel)).apply(this, arguments));
	}

	(0, _createClass3.default)(GeneLabel, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    left = _props.left,
			    bottom = _props.bottom,
			    textWidth = _props.textWidth,
			    textAlign = _props.textAlign,
			    text = _props.text,
			    color = _props.color,
			    fontWeight = _props.fontWeight,
			    wordWrap = _props.wordWrap;


			return React.createElement(
				'div',
				{ style: {
						left: left,
						bottom: bottom,
						position: 'absolute',
						width: textWidth,
						textAlign: textAlign,
						wordWrap: wordWrap,
						overflow: 'hidden',
						fontSize: geneLableFont } },
				React.createElement(
					'label',
					{ style: { color: color, fontWeight: fontWeight } },
					text
				)
			);
		}
	}]);
	return GeneLabel;
}(_PureComponent4.default);

var GeneLabelAnnotation = function (_PureComponent2) {
	(0, _inherits3.default)(GeneLabelAnnotation, _PureComponent2);

	function GeneLabelAnnotation() {
		(0, _classCallCheck3.default)(this, GeneLabelAnnotation);
		return (0, _possibleConstructorReturn3.default)(this, (GeneLabelAnnotation.__proto__ || (0, _getPrototypeOf2.default)(GeneLabelAnnotation)).apply(this, arguments));
	}

	(0, _createClass3.default)(GeneLabelAnnotation, [{
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    width = _props2.width,
			    height = _props2.height,
			    list = _props2.list,
			    subColumnIndex = _props2.subColumnIndex;


			var subColWidth = width / list.length,
			    aveSize = subColumnIndex.aveSize,
			    textAlign = list.length === 1 ? 'center' : 'left',
			    wordWrap = list.length === 1 ? 'break-word' : 'normal',
			    laneNum = list.length === 1 ? 1 : Math.ceil(list.length / (width / aveSize)),
			    laneHeight = height / laneNum;

			var items = laneNum > maxLane ? null : list.map(function (text, index) {
				// display at most 5 lanes
				var left = subColWidth * index,
				    bottom = laneHeight * (index % laneNum),
				    textWidth = width - left,
				    color = subColumnIndex && index === subColumnIndex.index && list.length !== 1 ? 'red' : 'black',
				    fontWeight = subColumnIndex && index === subColumnIndex.index && list.length !== 1 ? 'bold' : 'normal';

				if (list.length === 1) {
					// for single probe/gene/signature column, shorten text so that it will not go over vertically due to line wrapping
					text = text.slice(0, subColWidth * maxLane / geneLableFont) + (subColWidth * maxLane / geneLableFont < text.length ? ' ...' : '');
				}

				return React.createElement(GeneLabel, {
					key: index,
					left: left,
					bottom: bottom,
					textWidth: textWidth,
					textAlign: textAlign,
					text: text,
					color: color,
					wordWrap: wordWrap,
					fontWeight: fontWeight });
			});

			return React.createElement(
				'div',
				{ style: { width: width, height: height } },
				items
			);
		}
	}]);
	return GeneLabelAnnotation;
}(_PureComponent4.default);

module.exports = { GeneLabelAnnotation: GeneLabelAnnotation, geneLableFont: geneLableFont, maxLane: maxLane };