'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _class, _temp2;

var _reactCssThemr = require('react-css-themr');

require('../css/index.css');

var _button = require('react-toolbox/lib/button');

var _card = require('react-toolbox/lib/card');

var _checkbox = require('react-toolbox/lib/checkbox');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

require('./base');
var React = require('react');
var Rx = require('./rx');
// Root styles file (reset, fonts, globals)
var appTheme = require('./appTheme');
var classNames = require('classnames');

var typStyles = require('../css/typography.module.css');

var _require = require('./xenaQuery'),
    testHost = _require.testHost;

var _ = require('./underscore_ext');

var _require2 = require('./defaultServers'),
    localHub = _require2.servers.localHub,
    serverNames = _require2.serverNames;

var styles = require('./hubPage.module.css');

var _require3 = require('./hubParams'),
    parseServer = _require3.parseServer,
    getHubParams = _require3.getHubParams;

var nav = require('./nav');

var _require4 = require('./util'),
    encodeObject = _require4.encodeObject;

var RETURN = 13;

var getName = function getName(h) {
	return _.get(serverNames, h, h);
};

var getStatus = function getStatus(user, ping) {
	return user ? ping === true ? 'connected' : 'selected' : '';
};

var getStyle = function getStyle(statusStr) {
	return statusStr === 'connected' ? styles.connected : null;
};

var reqStatus = function reqStatus(ping) {
	return ping == null ? ' (connecting...)' : ping ? '' : ' (not running)';
};

var checkHost = function checkHost(host) {
	return testHost(host).take(1).map(function (v) {
		return (0, _defineProperty3.default)({}, host, v);
	});
};

var Hub = (_temp2 = _class = function (_React$Component) {
	(0, _inherits3.default)(Hub, _React$Component);

	function Hub() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Hub);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Hub.__proto__ || (0, _getPrototypeOf2.default)(Hub)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
			ping: {}
		}, _this.onNavigate = function (page, params) {
			_this.props.callback(['navigate', page, params]);
		}, _this.onStartup = function () {
			_this.ping.next();
		}, _this.updatePing = function (h) {
			_this.setState({ ping: (0, _extends3.default)({}, _this.state.ping, h) });
		}, _this.onKeyDown = function (ev) {
			if (ev.keyCode === RETURN) {
				ev.preventDefault();
				_this.onAdd();
			}
		}, _this.onSelect = function (isOn, ev) {
			var checked = ev.target.checked,
			    host = ev.target.getAttribute('data-host');

			_this.props.callback([checked ? 'enable-host' : 'disable-host', host, 'user']);
		}, _this.onAdd = function () {
			var target = _this.refs.newHost,
			    value = target.value.trim();
			if (value !== '') {
				_this.props.callback(['add-host', parseServer(value)]);
				target.value = '';
			}
		}, _this.onRemove = function (ev) {
			var host = ev.currentTarget.getAttribute('data-host');
			_this.props.callback(['remove-host', host]);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Hub, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			// XXX Use a connector to get rid of selector, here.
			// Or use a sub-component.
			var _props = this.props,
			    state = _props.state,
			    selector = _props.selector,
			    allHosts = _.keys(selector(state));

			nav({ activeLink: 'hub', onNavigate: this.onNavigate });
			this.ping = new Rx.Subject();

			this.sub = this.ping.switchMapTo(Rx.Observable.from(allHosts.map(checkHost)).mergeAll()).subscribe(this.updatePing);

			this.ping.next();
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.sub.unsubscribe();
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			var _this2 = this;

			var ping = this.state.ping,
			    state = newProps.state,
			    selector = newProps.selector,
			    servers = selector(state),
			    old = _.omit(ping, _.keys(servers));


			this.setState({ ping: _.omit(ping, old) });

			_.difference(_.keys(servers), _.keys(ping)).forEach(function (h) {
				return checkHost(h).subscribe(_this2.updatePing);
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props2 = this.props,
			    state = _props2.state,
			    selector = _props2.selector,
			    badge = _props2.badge,
			    hubParams = getHubParams(state),
			    ping = this.state.ping,
			    servers = selector(state),
			    hostList = _.mapObject(servers, function (s, h) {
				return {
					selected: s.user,
					host: h,
					name: getName(h),
					statusStr: getStatus(s.user, ping[h]),
					reqStatus: reqStatus(ping[h])
				};
			});

			return React.createElement(
				'div',
				{ className: styles.hubPage },
				React.createElement(
					'h1',
					{ className: typStyles.mdHeadline },
					'Data Hubs'
				),
				React.createElement(
					_card.Card,
					null,
					React.createElement(
						'ul',
						{ className: styles.hubList },
						_.values(hostList).map(function (h) {
							return React.createElement(
								'li',
								{ key: h.host },
								React.createElement(_checkbox.Checkbox, { className: styles.checkbox, onChange: _this3.onSelect, checked: h.selected,
									'data-host': h.host }),
								React.createElement(
									'div',
									{ className: styles.statusContainer },
									React.createElement(
										'span',
										{ className: classNames(styles.status, getStyle(h.statusStr)) },
										h.statusStr
									)
								),
								React.createElement(
									'div',
									{ className: styles.hubNameContainer },
									React.createElement(
										'a',
										{ href: '../datapages/?' + encodeObject({
												host: h.host,
												addHub: hubParams.addHub,
												removeHub: hubParams.removeHub.filter(function (hub) {
													return hub !== h.host;
												}) }) },
										h.name
									),
									h.host === localHub ? badge : h.reqStatus
								),
								React.createElement(
									'i',
									{ className: classNames('material-icons', styles.remove), 'data-host': h.host,
										onClick: _this3.onRemove },
									'close'
								)
							);
						}),
						React.createElement(
							'li',
							null,
							React.createElement(
								'div',
								{ className: styles.hostForm },
								React.createElement('input', { className: styles.input, onKeyDown: this.onKeyDown, ref: 'newHost',
									type: 'text', placeholder: 'Add Hub' }),
								React.createElement(
									_button.Button,
									{ onClick: this.onAdd, accent: true },
									'Add'
								)
							)
						)
					)
				)
			);
		}
	}]);
	return Hub;
}(React.Component), _class.displayName = 'Hub', _temp2);

var selector = function selector(state) {
	return state.spreadsheet.servers;
};

var ThemedHub = function (_React$Component2) {
	(0, _inherits3.default)(ThemedHub, _React$Component2);

	function ThemedHub() {
		(0, _classCallCheck3.default)(this, ThemedHub);
		return (0, _possibleConstructorReturn3.default)(this, (ThemedHub.__proto__ || (0, _getPrototypeOf2.default)(ThemedHub)).apply(this, arguments));
	}

	(0, _createClass3.default)(ThemedHub, [{
		key: 'render',
		value: function render() {
			return React.createElement(
				_reactCssThemr.ThemeProvider,
				{ theme: appTheme },
				React.createElement(Hub, (0, _extends3.default)({}, this.props, { selector: selector }))
			);
		}
	}]);
	return ThemedHub;
}(React.Component);

module.exports = ThemedHub;