'use strict';

var util = require('./util');
var _ = require('./underscore_ext');

var _require = require('./defaultServers'),
    defaultServers = _require.defaultServers;

function parseServer(s) {
	// XXX should throw or otherwise indicate parse error on no match
	var tokens = s.match(/^(https?:\/\/)?([^:\/]+)(:([0-9]+))?(\/(.*))?$/),
	    host = tokens[2],
	    defproto = 'https://',
	    proto = tokens[1] || defproto,
	    defport = proto === defproto ? 443 : '7222',
	    port = tokens[4] || defport,
	    path = tokens[5] || '',
	    serverUrl = proto + host + (port ? ':' + port : '') + path;

	//*.xenahubs.net:443 server drop 443
	serverUrl = serverUrl.replace(/.xenahubs.net:443$/, ".xenahubs.net");
	return serverUrl;
}

var getUserServers = function getUserServers(servers) {
	return _.keys(servers).filter(function (k) {
		return servers[k].user;
	});
};

var getHubParams = function getHubParams(state) {
	return _.Let(function () {
		var hubs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getUserServers(_.getIn(state, ['spreadsheet', 'servers'], {}));
		return {
			addHub: _.difference(hubs, defaultServers),
			removeHub: _.difference(defaultServers, hubs)
		};
	});
};

// normalize: add http[s]? add port? Do standard replacements?
// What are our standard replacements?

module.exports = {
	hubParams: function hubParams() {
		return _.map(util.allParameters().hub, parseServer);
	},
	getHubParams: getHubParams,
	parseServer: parseServer
};