'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ImportPageModule = require('./ImportPage.module.css');

var _ImportPageModule2 = _interopRequireDefault(_ImportPageModule);

var _nav = require('../nav');

var _nav2 = _interopRequireDefault(_nav);

var _underscore_ext = require('../underscore_ext');

var _underscore_ext2 = _interopRequireDefault(_underscore_ext);

var _lib = require('react-toolbox/lib');

var _defaultServers = require('../defaultServers');

var _defaultServers2 = _interopRequireDefault(_defaultServers);

var _loader = require('./loader.gif');

var _loader2 = _interopRequireDefault(_loader);

var _constants = require('./constants');

var _Stepper = require('../views/Stepper');

var _WizardSection = require('./WizardSection');

var _WizardSection2 = _interopRequireDefault(_WizardSection);

var _staticComponents = require('./staticComponents');

var _CohortSuggest = require('../views/CohortSuggest');

var _CohortSuggest2 = _interopRequireDefault(_CohortSuggest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var localHub = _defaultServers2.default.servers.localHub;


var pageStates = _underscore_ext2.default.range((0, _keys2.default)(_constants.PAGES).length);
var pageRanges = [0].concat((0, _toConsumableArray3.default)(Array(4).fill(1)), [2, 3]); // XXX need a better way to express this
var pageStateIndex = _underscore_ext2.default.object(pageStates, pageRanges);

var getDropdownOptions = function getDropdownOptions(strArr) {
	return strArr.map(function (val) {
		return { label: val, value: val };
	});
};
var getProbemapOptions = function getProbemapOptions(probes) {
	return [].concat((0, _toConsumableArray3.default)(probes.map(function (_ref) {
		var label = _ref.label,
		    name = _ref.value.name;
		return { label: label, value: name };
	})), [{ label: _constants.NONE_STR, value: _constants.NONE_STR }]);
};

var isPhenotypeData = function isPhenotypeData(dataType) {
	return dataType === _constants.DATA_TYPE.PHENOTYPE;
};
var isMutationOrSegmentedData = function isMutationOrSegmentedData(dataType) {
	return dataType === _constants.DATA_TYPE.MUTATION_BY_POS || dataType === _constants.DATA_TYPE.SEGMENTED_CN;
};
var isMutationSegmentedOrPhenotype = function isMutationSegmentedOrPhenotype(dataType) {
	return isPhenotypeData(dataType) || isMutationOrSegmentedData(dataType);
};

var getNextPageByDataType = _underscore_ext2.default.Let(function () {
	var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.PAGES,
	    FILE = _ref2.FILE,
	    DATA_TYPE_SELECT = _ref2.DATA_TYPE_SELECT,
	    DENSE_ORIENTATION = _ref2.DENSE_ORIENTATION,
	    STUDY = _ref2.STUDY,
	    PROBE = _ref2.PROBE,
	    ASSEMBLY = _ref2.ASSEMBLY,
	    PROGRESS = _ref2.PROGRESS;

	return function (currIndex, dataType) {
		var pages = [];
		switch (dataType) {
			case _constants.DATA_TYPE.MUTATION_BY_POS:
			case _constants.DATA_TYPE.SEGMENTED_CN:
				pages = [FILE, DATA_TYPE_SELECT, STUDY, ASSEMBLY, PROGRESS];
				break;
			case _constants.DATA_TYPE.PHENOTYPE:
				pages = [FILE, DATA_TYPE_SELECT, DENSE_ORIENTATION, STUDY, PROGRESS];
				break;
			default:
				pages = [FILE, DATA_TYPE_SELECT, DENSE_ORIENTATION, STUDY, PROBE, PROGRESS];
		}

		return pages[pages.indexOf(currIndex) + 1];
	};
});

var hasErrorsOrLoading = function hasErrorsOrLoading(_ref3) {
	var errors = _ref3.errors,
	    errorCheckInprogress = _ref3.errorCheckInprogress,
	    serverError = _ref3.serverError,
	    probemapError = _ref3.probemapError;
	return errorCheckInprogress === true || serverError || probemapError || errors && errors.length;
};
var hasWarnings = function hasWarnings(_ref4) {
	var warnings = _ref4.warnings;
	return warnings && warnings.length;
};

var isImportSuccessful = function isImportSuccessful(state) {
	return !hasErrorsOrLoading(state) && !hasWarnings(state);
};

var ImportForm = function (_React$Component) {
	(0, _inherits3.default)(ImportForm, _React$Component);

	function ImportForm() {
		var _ref5;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ImportForm);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref5 = ImportForm.__proto__ || (0, _getPrototypeOf2.default)(ImportForm)).call.apply(_ref5, [this].concat(args))), _this), _this.state = { showMoreErrors: false, showMoreDataTypes: false }, _this.setLocalCohortRef = function (ref) {
			if (ref && !_this.props.state.localCohort) {
				// XXX inputNode has gone away in rt 2.0.0-beta.13. Not sure
				// why. For now, pinning the version to beta.12.
				ref.inputNode.focus();
			}
			_this.localCohortRef = ref;
		}, _this.isCohortPageNextEnabled = function () {
			var cohortRadio = _this.props.state.cohortRadio;


			return !!(cohortRadio && _this.props.state[cohortRadio]);
		}, _this.isProbesNextPageEnabled = function () {
			return true;
		}, _this.onWizardBack = function () {
			_this.props.callback(['wizard-page', _this.props.wizardHistory.pop()]);
			_this.props.callback(['wizard-page-history', _this.props.wizardHistory]);
		}, _this.onWizardNext = function (currPageIndex) {
			return function () {
				_this.props.callback(['wizard-page-history', [].concat((0, _toConsumableArray3.default)(_this.props.wizardHistory), [currPageIndex])]);

				var newPageIndex = getNextPageByDataType(currPageIndex, _underscore_ext2.default.getIn(_this.props, ['state', 'dataType']));
				_this.props.callback(['wizard-page', newPageIndex]);
			};
		}, _this.onFileChange = function (fileProp) {
			return function (evt) {
				if (evt.target.files.length > 0) {
					_this.props.callback(['file-content', []]);
					var file = evt.target.files[0];
					_this.props.callback([fileProp, file]);

					_this.props.callback(['file-read-inprogress']);
					_this.props.callback(['read-file', file]);
					_this.props.callback(['set-status', 'Reading the file...']);
				}
			};
		}, _this.onCohortRadioChange = function (value) {
			_this.props.callback(['cohort-radio', value]);
		}, _this.onProbemapChange = function (value) {
			var probemaps = _this.props.probemaps,
			    pm = probemaps.find(function (_ref6) {
				var name = _ref6.value.name;
				return name === value;
			});

			_this.props.callback(['probemap', pm ? pm.value : undefined]);
		}, _this.onFileFormatChange = function (format) {
			return _this.props.callback(['file-format', format]);
		}, _this.onDataTypeChange = function (type) {
			_this.resetFieldsOnDataTypeChange(type);
			_this.setFileFormatForSparse(type);
			_this.props.callback(['data-type', type]);
		}, _this.onPublicCohortChange = function (cohort) {
			return _this.props.callback(['import-publicCohort', cohort]);
		}, _this.onLocalCohortChange = function (cohort) {
			return _this.props.callback(['import-localCohort', cohort]);
		}, _this.onNewCohortChange = function (cohort) {
			return _this.props.callback(['import-newCohort', cohort]);
		}, _this.onShowMoreToggle = function () {
			return _this.setState({ showMoreErrors: !_this.state.showMoreErrors });
		}, _this.onShowMoreDataTypesToggle = function () {
			return _this.setState({ showMoreDataTypes: !_this.state.showMoreDataTypes });
		}, _this.onAssemblyChange = function (assembly) {
			return _this.props.callback(['assembly', assembly]);
		}, _this.onRetryMetadata = function () {
			_this.props.callback(['clear-metadata']);
			_this.props.callback(['wizard-page', _constants.PAGES.DATA_TYPE_SELECT]);
			_this.props.callback(['retry-meta-data']);
		}, _this.onRetryFile = function () {
			_this.props.callback(['error-check-inprogress']);
			_this.props.callback(['retry-file', _this.props.file]);
		}, _this.onCancelImport = function () {
			_this.props.callback(['navigate', 'datapages', { host: localHub }]);
			_this.props.callback(['reset-import-state']);
		}, _this.onFinishClick = function () {
			_this.props.callback(['navigate', 'datapages', { dataset: _this.props.fileName, host: localHub }]);
			_this.props.callback(['reset-import-state']);
		}, _this.onViewDataClick = function () {
			_this.props.onViz();
			_this.props.callback(['reset-import-state']);
		}, _this.onImportMoreData = function () {
			_this.props.callback(['reset-import-state']);
			_this.props.callback(['get-local-cohorts']);
			_this.props.callback(['get-probemaps']);
		}, _this.onImportClick = function () {
			_this.props.callback(['wizard-page-history', [].concat((0, _toConsumableArray3.default)(_this.props.wizardHistory), [_this.props.wizardPage])]);

			_this.props.callback(['wizard-page', _constants.PAGES.PROGRESS]);
			_this.props.callback(['error-check-inprogress']);
			_this.props.callback(['import-file']);
		}, _this.onLoadWithWarnings = function () {
			_this.props.callback(['error-check-inprogress']);
			_this.props.callback(['load-with-warnings']);
		}, _this.setFileFormatForSparse = function (dataType) {
			if (isMutationOrSegmentedData(dataType)) {
				var fileFormat = dataType === _constants.DATA_TYPE.MUTATION_BY_POS ? _constants.FILE_FORMAT.MUTATION_VECTOR : _constants.FILE_FORMAT.GENOMIC_SEGMENT;
				_this.props.callback(['file-format', fileFormat]);
			}
		}, _this.resetFieldsOnDataTypeChange = function (dataType) {
			if (isMutationOrSegmentedData(dataType)) {
				_this.resetProbemap();
			} else if (isPhenotypeData(dataType)) {
				_this.resetProbemap();
				_this.props.callback(['assembly', '']);
			} else {
				_this.props.callback(['assembly', '']);
			}
		}, _this.resetProbemap = function () {
			_this.props.callback(['probemap', '']);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ImportForm, [{
		key: 'render',
		value: function render() {
			var _ref7 = this.props.state || {},
			    fileFormat = _ref7.fileFormat,
			    dataType = _ref7.dataType,
			    assembly = _ref7.assembly,
			    errorCheckInprogress = _ref7.errorCheckInprogress,
			    serverError = _ref7.serverError,
			    _props = this.props,
			    file = _props.file,
			    wizardPage = _props.wizardPage,
			    fileName = _props.fileName,
			    fileReadInProgress = _props.fileReadInProgress,
			    fileSelected = file && !!file.size && !serverError;

			var wizardProps = {},
			    component = null;

			switch (wizardPage) {
				case _constants.PAGES.FILE:
					wizardProps = { nextEnabled: fileSelected };
					component = this.fileSelectionPage(fileSelected, file);
					break;
				case _constants.PAGES.DATA_TYPE_SELECT:
					wizardProps = { nextEnabled: !!dataType && !fileReadInProgress, fileName: fileName };
					component = this.dataTypePage(fileReadInProgress);
					break;
				case _constants.PAGES.DENSE_ORIENTATION:
					wizardProps = { fileName: fileName, nextEnabled: !!fileFormat };
					component = this.denseOrientationPage();
					break;
				case _constants.PAGES.STUDY:
					wizardProps = {
						fileName: fileName,
						onImport: !isMutationOrSegmentedData(dataType) ? this.onImportClick : null,
						showAdvancedNextLabel: !isMutationSegmentedOrPhenotype(dataType),
						nextEnabled: this.isCohortPageNextEnabled()
					};
					component = this.studySelectionPage();
					break;
				case _constants.PAGES.PROBE:
					wizardProps = {
						fileName: fileName,
						onImport: this.onImportClick,
						nextEnabled: this.isProbesNextPageEnabled()
					};
					component = this.probeSelectionPage();
					break;
				case _constants.PAGES.ASSEMBLY:
					wizardProps = {
						fileName: fileName,
						onImport: this.onImportClick,
						nextEnabled: !!assembly
					};
					component = this.assemblySelectionPage();
					break;
				case _constants.PAGES.PROGRESS:
					wizardProps = {
						fileName: fileName,
						showRetry: !errorCheckInprogress && !isImportSuccessful(this.props.state),
						showSuccess: isImportSuccessful(this.props.state),
						showLoadWithWarnings: hasWarnings(this.props.state) && !hasErrorsOrLoading(this.props.state),
						onRetryFile: this.onRetryFile,
						onRetryMetadata: this.onRetryMetadata,
						onImportMoreData: this.onImportMoreData,
						onLoadWithWarnings: this.onLoadWithWarnings,
						onFinish: this.onFinishClick,
						onViewData: this.onViewDataClick
					};
					component = this.importProgressPage();
					break;
			};

			return _react2.default.createElement(
				_WizardSection2.default,
				(0, _extends3.default)({ isFirst: wizardPage === 0, isLast: wizardPage === pageStates.length - 1,
					onNextPage: this.onWizardNext(wizardPage),
					onPreviousPage: this.onWizardBack,
					callback: this.props.callback,
					onCancelImport: this.onCancelImport,
					onFileReload: this.onFileChange('file')
				}, wizardProps),
				component
			);
		}
	}, {
		key: 'fileSelectionPage',
		value: function fileSelectionPage(fileSelected) {
			var serverError = _underscore_ext2.default.getIn(this.props, ['state', 'serverError']);
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement('input', { type: 'file', id: 'file-input', style: { display: 'none' },
					onChange: this.onFileChange('file')
				}),
				_react2.default.createElement(
					'label',
					{ htmlFor: 'file-input', className: _ImportPageModule2.default.importFileLabel },
					'Select Data File'
				),
				fileSelected && _react2.default.createElement(
					'b',
					null,
					'Selected file: ',
					this.props.fileName,
					' '
				),
				serverError ? _react2.default.createElement(
					'div',
					null,
					_react2.default.createElement(
						'p',
						null,
						'We were unable to read this file, due to the following error:'
					),
					_react2.default.createElement(
						'pre',
						null,
						serverError
					)
				) : null,
				_react2.default.createElement(
					'div',
					{ style: { marginTop: '1em' } },
					_react2.default.createElement(_lib.Button, { icon: 'help_outline', target: '_blank', href: 'https://ucsc-xena.gitbook.io/project/local-xena-hub/data-format-specifications', label: 'Help on data file formatting', accent: true, flat: false })
				)
			);
		}
	}, {
		key: 'dataTypePage',
		value: function dataTypePage(fileReadInProgress) {
			var dataType = _underscore_ext2.default.getIn(this.props, ['state', 'dataType']),
			    showMoreDataTypes = this.state.showMoreDataTypes;


			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_lib.RadioGroup,
					{ value: dataType, onChange: this.onDataTypeChange },
					_constants.dataTypeOptions.slice(0, showMoreDataTypes ? 4 : 2).map(function (_ref8) {
						var label = _ref8.label,
						    value = _ref8.value;
						return _react2.default.createElement(_lib.RadioButton, { disabled: !!fileReadInProgress, key: value, label: label, value: value });
					})
				),
				_react2.default.createElement(
					'p',
					{ className: _ImportPageModule2.default.showMore, onClick: this.onShowMoreDataTypesToggle },
					showMoreDataTypes ? 'Less data types...' : 'More data types...'
				),
				_react2.default.createElement(_lib.Button, { href: 'https://ucsc-xena.gitbook.io/project/local-xena-hub/data-format-specifications', target: '_blank', className: _ImportPageModule2.default.dataTypeHelp, label: 'HELP', accent: true, flat: false }),
				_react2.default.createElement(
					'h4',
					null,
					'File preview'
				),
				this.renderFilePreview()
			);
		}
	}, {
		key: 'denseOrientationPage',
		value: function denseOrientationPage() {
			var fileFormat = this.props.state.fileFormat;

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_lib.RadioGroup,
					{ value: fileFormat, onChange: this.onFileFormatChange },
					_react2.default.createElement(_lib.RadioButton, { label: 'The first column is sample IDs', value: _constants.FILE_FORMAT.CLINICAL_MATRIX }),
					_react2.default.createElement(_lib.RadioButton, { label: 'The first row is sample IDs', value: _constants.FILE_FORMAT.GENOMIC_MATRIX })
				),
				this.renderFilePreview(true)
			);
		}
	}, {
		key: 'studySelectionPage',
		value: function studySelectionPage() {
			var _props$state = this.props.state,
			    cohortRadio = _props$state.cohortRadio,
			    newCohort = _props$state.newCohort,
			    publicCohort = _props$state.publicCohort,
			    localCohort = _props$state.localCohort,
			    cohorts = _underscore_ext2.default.getIn(this.props, ['recommended', 'cohorts']);

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_lib.RadioGroup,
					{ value: cohortRadio, onChange: this.onCohortRadioChange },
					_react2.default.createElement(_lib.RadioButton, { label: 'These are the first data on these samples.', value: 'newCohort' }),
					cohortRadio === 'newCohort' && _react2.default.createElement(_lib.Input, { label: 'Study name', type: 'text', className: _ImportPageModule2.default.field,
						onChange: this.onNewCohortChange, value: newCohort
					}),
					_react2.default.createElement(_lib.RadioButton, { label: 'I have loaded other data on these samples and want to connect to it.',
						value: 'localCohort' }),
					cohortRadio === 'localCohort' && _react2.default.createElement(_lib.Dropdown, { innerRef: this.setLocalCohortRef, onChange: this.onLocalCohortChange,
						source: getDropdownOptions([""].concat((0, _toConsumableArray3.default)(this.props.localCohorts))),
						value: localCohort,
						label: "Select a study",
						className: [_ImportPageModule2.default.field, _ImportPageModule2.default.inline].join(' ')
					}),
					_react2.default.createElement(_lib.RadioButton, { label: 'There is other public data in Xena on these samples (e.g. TCGA) and want to connect to it.',
						value: 'publicCohort' }),
					cohortRadio === 'publicCohort' && _react2.default.createElement(
						'div',
						{ className: _ImportPageModule2.default.field },
						_react2.default.createElement(_CohortSuggest2.default, { cohort: publicCohort, cohorts: _underscore_ext2.default.pluck(cohorts, 'name'),
							onSelect: this.onPublicCohortChange
						})
					)
				),
				this.renderFilePreview(true)
			);
		}
	}, {
		key: 'probeSelectionPage',
		value: function probeSelectionPage() {
			var recommendedProbemaps = _underscore_ext2.default.getIn(this.props, ['recommended', 'probemaps'], []);
			var existingProbemaps = _underscore_ext2.default.getIn(this.props, ['probemaps']);
			var probemapsToShow = recommendedProbemaps.map(function (p) {
				return existingProbemaps.find(function (existing) {
					return existing.value.name === p.name;
				});
			}).filter(_underscore_ext2.default.identity);
			var recommendationsExist = recommendedProbemaps.length;
			var _props$state$probemap = this.props.state.probemap,
			    probemap = _props$state$probemap === undefined ? { name: _constants.NONE_STR } : _props$state$probemap;


			var seletedProbeMapLabel = _underscore_ext2.default.getIn(probemapsToShow, [0, 'label'], '');

			var text = recommendationsExist ? _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'h4',
					null,
					'We predict your data uses ',
					_react2.default.createElement(
						'b',
						null,
						seletedProbeMapLabel
					),
					' type file.'
				),
				_react2.default.createElement(
					'h4',
					null,
					'If this is not correct, choose the correct one from the drop down'
				)
			) : _react2.default.createElement(
				'h4',
				null,
				'We don\'t recognize the identifiers in your data. Sorry!'
			);

			return _react2.default.createElement(
				'div',
				null,
				text,
				!!recommendationsExist && _react2.default.createElement(_lib.Dropdown, {
					onChange: this.onProbemapChange,
					source: getProbemapOptions(probemapsToShow),
					value: _underscore_ext2.default.get(probemap, 'name'),
					className: [_ImportPageModule2.default.probemap, _ImportPageModule2.default.inline].join(' ')
				}),
				this.renderMailto("Xena import missing identifiers", "identifiers", probemap === _constants.NONE_STR || !recommendationsExist),
				this.renderFilePreview(true)
			);
		}
	}, {
		key: 'assemblySelectionPage',
		value: function assemblySelectionPage() {
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'h4',
					null,
					'Which reference genome was used to create this file?'
				),
				_react2.default.createElement(
					_lib.RadioGroup,
					{ value: this.props.state.assembly, onChange: this.onAssemblyChange },
					_react2.default.createElement(_lib.RadioButton, { label: 'hg18/GRCh36', value: 'hg18' }),
					_react2.default.createElement(_lib.RadioButton, { label: 'hg19/GRCh37', value: 'hg19' }),
					_react2.default.createElement(_lib.RadioButton, { label: 'hg38/GRCh38', value: 'hg38' })
				),
				this.renderFilePreview()
			);
		}
	}, {
		key: 'importProgressPage',
		value: function importProgressPage() {
			var _props$state2 = this.props.state,
			    errors = _props$state2.errors,
			    warnings = _props$state2.warnings,
			    errorCheckInprogress = _props$state2.errorCheckInprogress,
			    serverError = _props$state2.serverError,
			    probemapError = _props$state2.probemapError,
			    errorSnippets = _props$state2.errorSnippets,
			    fileContent = this.props.fileContent,
			    serverOrProbemapError = serverError || probemapError,
			    hasErr = errors && !!errors.length;


			var errorText = null;

			if (hasErr) {
				errorText = _react2.default.createElement(
					'p',
					null,
					'There were some errors found in the file:'
				);
			} else if (hasWarnings(this.props.state)) {
				errorText = _react2.default.createElement(
					'p',
					null,
					'There were some warnings found in the file:'
				);
			}

			return _react2.default.createElement(
				'div',
				null,
				errorCheckInprogress && _react2.default.createElement(
					'p',
					null,
					'Loading file...'
				),
				errorText,
				_react2.default.createElement(ErrorArea, { errors: hasErr ? errors : warnings,
					showMore: this.state.showMoreErrors,
					onShowMoreToggle: this.onShowMoreToggle,
					errorCheckInProgress: errorCheckInprogress,
					textClass: !hasErr ? _ImportPageModule2.default.warningLine : _ImportPageModule2.default.errorLine
				}),
				serverOrProbemapError && _react2.default.createElement(
					'div',
					null,
					_react2.default.createElement(
						'p',
						{ style: { color: 'red' } },
						'Unexpected server error occured: ',
						serverOrProbemapError
					),
					_react2.default.createElement(
						'p',
						null,
						'Please ',
						_react2.default.createElement(
							'a',
							{ href: 'mailto:genome-cancer@soe.ucsc.edu?subject="Xena import: java error"' },
							'contact'
						),
						' the Xena team for help.'
					)
				),
				_react2.default.createElement(_staticComponents.ErrorPreview, { errorSnippets: errorSnippets, errorLines: fileContent.slice(0, 2) }),
				isImportSuccessful(this.props.state) && _react2.default.createElement(
					'div',
					null,
					_react2.default.createElement(
						'p',
						null,
						'Success!'
					)
				)
			);
		}
	}, {
		key: 'renderFilePreview',
		value: function renderFilePreview() {
			var showHighlighting = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
			var _props2 = this.props,
			    fileContent = _props2.fileContent,
			    fileReadInProgress = _props2.fileReadInProgress;
			var fileFormat = this.props.state.fileFormat;


			return _react2.default.createElement(_staticComponents.FilePreview, {
				fileContent: fileContent,
				isLoading: fileReadInProgress,
				highlightRow: fileFormat === _constants.FILE_FORMAT.GENOMIC_MATRIX && showHighlighting,
				highlightColumn: fileFormat === _constants.FILE_FORMAT.CLINICAL_MATRIX && showHighlighting
			});
		}
	}, {
		key: 'renderDropdown',
		value: function renderDropdown(onChange, source, value, label, display) {
			return display ? _react2.default.createElement(_lib.Dropdown, { onChange: onChange, source: source, value: value, label: label,
				className: [_ImportPageModule2.default.field, _ImportPageModule2.default.inline].join(' ')
			}) : null;
		}
	}, {
		key: 'renderMailto',
		value: function renderMailto(subject, keyword, display) {
			return display ? _react2.default.createElement(
				'p',
				{ className: _ImportPageModule2.default.mailTo },
				_react2.default.createElement(
					'a',
					{ href: 'mailto:genome-cancer@soe.ucsc.edu?subject=' + subject },
					'Let us know which ',
					keyword,
					' you\'re using'
				),
				' so we can better support you in the future.'
			) : null;
		}
	}]);
	return ImportForm;
}(_react2.default.Component);

var ImportPage = function (_React$Component2) {
	(0, _inherits3.default)(ImportPage, _React$Component2);

	function ImportPage() {
		(0, _classCallCheck3.default)(this, ImportPage);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (ImportPage.__proto__ || (0, _getPrototypeOf2.default)(ImportPage)).call(this));

		_this2.onNavigate = function (page, params) {
			_this2.props.callback(['navigate', page, params]);
		};

		_this2.onViz = function () {
			var form = _this2.props.state.import.form,
			    cohort = form[form.cohortRadio];
			_this2.props.callback(['cohort', cohort]);
			_this2.props.callback(['navigate', 'heatmap']);
		};

		return _this2;
	}

	(0, _createClass3.default)(ImportPage, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.props.callback(['get-local-cohorts']);
			this.props.callback(['get-probemaps']);
			(0, _nav2.default)({ activeLink: 'datapages', onNavigate: this.onNavigate });
		}
	}, {
		key: 'render',
		value: function render() {
			var cohorts = this.props.state.wizard.cohorts || [];

			var _ref9 = this.props.state.import || {},
			    probemaps = _ref9.probemaps,
			    _ref9$wizardPage = _ref9.wizardPage,
			    wizardPage = _ref9$wizardPage === undefined ? 0 : _ref9$wizardPage,
			    fileContent = _ref9.fileContent,
			    fileReadInProgress = _ref9.fileReadInProgress,
			    localCohorts = _ref9.localCohorts,
			    file = _ref9.file,
			    fileName = _ref9.fileName,
			    form = _ref9.form,
			    _ref9$wizardHistory = _ref9.wizardHistory,
			    wizardHistory = _ref9$wizardHistory === undefined ? [] : _ref9$wizardHistory,
			    recommended = _ref9.recommended;

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ className: _ImportPageModule2.default.wizardTitle },
					'Loading data...',
					_react2.default.createElement(_lib.Button, { label: 'Help', target: '_blank', href: 'https://ucsc-xena.gitbook.io/project/local-xena-hub', accent: true, style: { marginLeft: '30px', backgroundColor: '#f7f7f7' } }),
					_react2.default.createElement(
						'div',
						{ className: _ImportPageModule2.default.stepperBox },
						_react2.default.createElement(_Stepper.Stepper, { mode: wizardPage, steps: _constants.steps, stateIndex: pageStateIndex, flat: true, wideStep: true })
					)
				),
				_react2.default.createElement(
					'div',
					{ className: _ImportPageModule2.default.container },
					_react2.default.createElement(ImportForm, { cohorts: cohorts,
						callback: this.props.callback,

						recommended: recommended,
						wizardPage: wizardPage,
						wizardHistory: wizardHistory,
						fileContent: fileContent,
						fileReadInProgress: fileReadInProgress,
						localCohorts: localCohorts,
						probemaps: probemaps,
						file: file, fileName: fileName,
						onViz: this.onViz,

						state: form
					})
				)
			);
		}
	}]);
	return ImportPage;
}(_react2.default.Component);

var ErrorArea = function ErrorArea(_ref10) {
	var errors = _ref10.errors,
	    showMore = _ref10.showMore,
	    errorCheckInProgress = _ref10.errorCheckInProgress,
	    onShowMoreToggle = _ref10.onShowMoreToggle,
	    textClass = _ref10.textClass;

	errors = errors || [];
	var items = errors.map(function (error, i) {
		return _react2.default.createElement(
			'p',
			{ key: i, className: textClass },
			error
		);
	}),
	    showMoreText = null;

	if (items.length > 3 && !showMore) {
		items = items.slice(0, 3);
		showMoreText = _react2.default.createElement(
			'p',
			{ className: _ImportPageModule2.default.showMore, onClick: onShowMoreToggle },
			'Show more... (',
			errors.length,
			' in total)'
		);
	} else if (showMore) {
		showMoreText = _react2.default.createElement(
			'p',
			{ className: _ImportPageModule2.default.showMore, onClick: onShowMoreToggle },
			'Show less...'
		);
	}

	return _react2.default.createElement(
		'div',
		{ className: _ImportPageModule2.default.errorContainer },
		items,
		showMoreText,
		_react2.default.createElement(
			'div',
			{ style: { textAlign: 'center' } },
			errorCheckInProgress && _react2.default.createElement('img', { src: _loader2.default })
		)
	);
};

exports.default = ImportPage;