'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lib = require('react-toolbox/lib');

var _ImportPageModule = require('./ImportPage.module.css');

var _ImportPageModule2 = _interopRequireDefault(_ImportPageModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var style = {
    next: { float: 'right', color: 'rgb(33, 33, 33)', marginLeft: '20px' },
    cancel: { float: 'right', display: 'inline-block' },
    buttons: { paddingTop: '20px' }
};

var WizardSection = function (_React$Component) {
    (0, _inherits3.default)(WizardSection, _React$Component);

    function WizardSection() {
        (0, _classCallCheck3.default)(this, WizardSection);
        return (0, _possibleConstructorReturn3.default)(this, (WizardSection.__proto__ || (0, _getPrototypeOf2.default)(WizardSection)).apply(this, arguments));
    }

    (0, _createClass3.default)(WizardSection, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                isLast = _props.isLast,
                isFirst = _props.isFirst,
                nextEnabled = _props.nextEnabled,
                onImport = _props.onImport,
                fileName = _props.fileName,
                showRetry = _props.showRetry,
                showSuccess = _props.showSuccess,
                showAdvancedNextLabel = _props.showAdvancedNextLabel;

            var showNext = !isLast && !onImport && !showRetry;
            var showBack = !isFirst && !showSuccess;

            return _react2.default.createElement(
                'div',
                null,
                fileName && _react2.default.createElement(
                    'p',
                    null,
                    _react2.default.createElement(
                        'b',
                        null,
                        'File to Import: ',
                        fileName
                    )
                ),
                this.props.children,
                _react2.default.createElement(
                    'div',
                    { className: _ImportPageModule2.default.wizardButtons },
                    _react2.default.createElement(_lib.Button, {
                        label: 'Back',
                        raised: true,
                        style: { visibility: showBack ? 'visible' : 'hidden' },
                        onClick: this.props.onPreviousPage
                    }),
                    showNext && _react2.default.createElement(_lib.Button, {
                        label: 'Next',
                        raised: true,
                        style: style.next,
                        accent: nextEnabled, disabled: !nextEnabled,
                        onClick: this.props.onNextPage
                    }),
                    !!onImport && _react2.default.createElement(_lib.Button, {
                        label: 'Import',
                        raised: true, style: style.next,
                        accent: nextEnabled,
                        disabled: !nextEnabled,
                        onClick: onImport
                    }),
                    showAdvancedNextLabel && _react2.default.createElement(_lib.Button, {
                        label: 'Advanced',
                        raised: true,
                        style: style.next,
                        disabled: !nextEnabled,
                        onClick: this.props.onNextPage
                    }),
                    showRetry && this.renderRetryButtons(),
                    showSuccess && this.renderSuccessButtons(),
                    !showSuccess && _react2.default.createElement(CancelButton, { onCancelImport: this.props.onCancelImport })
                )
            );
        }
    }, {
        key: 'renderRetryButtons',
        value: function renderRetryButtons() {
            return _react2.default.createElement(
                'div',
                { className: _ImportPageModule2.default.retryButtons },
                _react2.default.createElement(_lib.Button, { label: 'Edit Data Details', raised: true, style: style.next, accent: true,
                    onClick: this.props.onRetryMetadata
                }),
                _react2.default.createElement(_lib.Button, { label: 'Reload file', raised: true, style: style.retryButton, accent: true,
                    onClick: this.props.onRetryFile
                }),
                !!this.props.showLoadWithWarnings && _react2.default.createElement(_lib.Button, { label: 'Load with warnings', raised: true, style: style.next,
                    accent: true, onClick: this.props.onLoadWithWarnings
                })
            );
        }
    }, {
        key: 'renderSuccessButtons',
        value: function renderSuccessButtons() {
            return _react2.default.createElement(
                'div',
                { className: _ImportPageModule2.default.retryButtons },
                _react2.default.createElement(_lib.Button, { label: 'Finish', raised: true, style: style.next, accent: true,
                    onClick: this.props.onFinish
                }),
                _react2.default.createElement(_lib.Button, { label: 'Load more data', raised: true, style: style.next, accent: true,
                    onClick: this.props.onImportMoreData
                }),
                _react2.default.createElement(_lib.Button, { label: 'View data', raised: true, style: style.next, accent: true,
                    onClick: this.props.onViewData
                })
            );
        }
    }]);
    return WizardSection;
}(_react2.default.Component);

exports.default = WizardSection;
;

var CancelButton = function (_React$Component2) {
    (0, _inherits3.default)(CancelButton, _React$Component2);

    function CancelButton() {
        var _ref;

        var _temp, _this2, _ret;

        (0, _classCallCheck3.default)(this, CancelButton);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref = CancelButton.__proto__ || (0, _getPrototypeOf2.default)(CancelButton)).call.apply(_ref, [this].concat(args))), _this2), _this2.state = { active: false }, _this2.onToggle = function () {
            _this2.setState({ active: !_this2.state.active });
        }, _this2.actions = function () {
            return [{ label: 'No, I want to continue', onClick: _this2.onToggle, style: { color: '#377937' } }, { label: 'Yes, cancel import', onClick: _this2.props.onCancelImport, style: { color: '#c95252' } }];
        }, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
    }

    (0, _createClass3.default)(CancelButton, [{
        key: 'render',
        value: function render() {
            var active = this.state.active;


            return _react2.default.createElement(
                'div',
                { style: style.cancel },
                _react2.default.createElement(
                    _lib.Dialog,
                    { actions: this.actions(), active: active,
                        onEscKeyDown: this.onToggle, onOverlayClick: this.onToggle,
                        title: 'Are you sure you want to cancel import process ?' },
                    'Current progress will be lost'
                ),
                _react2.default.createElement(
                    _lib.Button,
                    { onClick: this.onToggle, flat: true, style: { backgroundColor: '#f7f7f7' } },
                    'Cancel'
                )
            );
        }
    }]);
    return CancelButton;
}(_react2.default.Component);