"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _iterator = require("babel-runtime/core-js/symbol/iterator");

var _iterator2 = _interopRequireDefault(_iterator);

exports.default = chunkFile;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// iterable that returns slices of a file (or blob, I suppose), for working on
// large data in chunks.
// If we use a generator it can only be iterated once. So, manually creating
// an iterable, instead.
function chunkFile(file) {
	var n = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100 * 1000;

	return (0, _defineProperty3.default)({}, _iterator2.default, function () {
		var size = file.size,
		    i = 0;
		return {
			next: function next() {
				if (n * i < size) {
					i += 1;
					return { value: file.slice(n * (i - 1), Math.min(n * i, size)) };
				}
				return { done: true };
			}
		};
	});
}