'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ErrorPreview = exports.FilePreview = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ImportPageModule = require('./ImportPage.module.css');

var _ImportPageModule2 = _interopRequireDefault(_ImportPageModule);

var _loader = require('./loader.gif');

var _loader2 = _interopRequireDefault(_loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var maxColumns = 6,
    numRows = 5,
    maxNumRows = 20,
    maxSymbolsInCell = 20;

var cropColumnContent = function cropColumnContent(cell) {
    return cell.length > maxSymbolsInCell ? cell.slice(0, maxSymbolsInCell) + '...' : cell;
};
var cropLines = function cropLines(lines) {
    return lines.map(function (line) {
        var cropped = line.length > maxColumns ? line.slice(0, maxColumns) : line;
        return cropped.map(cropColumnContent);
    });
};

// To keep proper table shape when some columns are missing
var padLines = function padLines(lines) {
    var maxLines = Math.min(Math.max.apply(Math, (0, _toConsumableArray3.default)(lines.map(function (l) {
        return l.length;
    }))), maxColumns);
    lines = cropLines(lines);
    return lines.map(function (line) {
        var diff = maxLines - line.length;
        return diff > 0 ? [].concat((0, _toConsumableArray3.default)(line), (0, _toConsumableArray3.default)(Array(diff).fill(" "))) : line;
    });
};

var getSimpleTableRows = function getSimpleTableRows(lines) {
    return lines.map(function (line, i) {
        return _react2.default.createElement(
            'tr',
            { key: i },
            line.map(function (col, j) {
                return _react2.default.createElement(
                    'td',
                    { key: j },
                    col
                );
            })
        );
    });
};

var FilePreview = function (_React$Component) {
    (0, _inherits3.default)(FilePreview, _React$Component);

    function FilePreview() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, FilePreview);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FilePreview.__proto__ || (0, _getPrototypeOf2.default)(FilePreview)).call.apply(_ref, [this].concat(args))), _this), _this.state = { showMore: false }, _this.onShowMore = function () {
            return _this.setState({ showMore: !_this.state.showMore });
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(FilePreview, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                fileContent = _props.fileContent,
                highlightRow = _props.highlightRow,
                highlightColumn = _props.highlightColumn,
                isLoading = _props.isLoading,
                takeLines = this.state.showMore ? maxNumRows : numRows,
                lineCount = fileContent.length,
                lines = padLines(fileContent.slice(0, takeLines));


            var tableRows = lines.map(function (r, i) {
                return _react2.default.createElement(
                    'tr',
                    { key: i },
                    r.map(function (rr, j) {
                        return _react2.default.createElement(
                            'td',
                            { key: j,
                                className: highlightRow && i === 0 || highlightColumn && j === 0 ? _ImportPageModule2.default.highlighted : null },
                            rr
                        );
                    })
                );
            });

            return isLoading ? _react2.default.createElement(
                'div',
                { style: { textAlign: 'center' } },
                _react2.default.createElement('img', { src: _loader2.default })
            ) : _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'table',
                    { className: _ImportPageModule2.default.denseExample },
                    _react2.default.createElement(
                        'tbody',
                        null,
                        tableRows
                    )
                ),
                this.renderShowMore(lineCount > numRows)
            );
        }
    }, {
        key: 'renderShowMore',
        value: function renderShowMore(hasEnoughLines) {
            return !hasEnoughLines ? null : _react2.default.createElement(
                'i',
                { className: _ImportPageModule2.default.showMore, onClick: this.onShowMore },
                this.state.showMore ? "Show less..." : "Show more..."
            );
        }
    }]);
    return FilePreview;
}(_react2.default.Component);

;

var ErrorPreview = function ErrorPreview(_ref2) {
    var _ref2$errorSnippets = _ref2.errorSnippets,
        errorSnippets = _ref2$errorSnippets === undefined ? [] : _ref2$errorSnippets,
        errorLines = _ref2.errorLines;


    if (!errorSnippets.length) {
        return null;
    }

    var exampleLines = errorSnippets[0].exampleLines;


    var errLines = getSimpleTableRows(padLines(errorLines));
    var exampLines = getSimpleTableRows(padLines(exampleLines));

    return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
            'p',
            null,
            'Your file:'
        ),
        _react2.default.createElement(
            'table',
            { className: _ImportPageModule2.default.denseExample, style: { background: '#f69292' } },
            errLines
        ),
        _react2.default.createElement(
            'p',
            null,
            'Example of correct file:'
        ),
        _react2.default.createElement(
            'table',
            { className: _ImportPageModule2.default.denseExample, style: { background: '#c7f2c7' } },
            exampLines
        )
    );
};

exports.FilePreview = FilePreview;
exports.ErrorPreview = ErrorPreview;