'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = parse;

var _underscore_ext = require('./underscore_ext');

var schemaCheck = function schemaCheck(data) {
	return (0, _underscore_ext.isObject)(data) && (0, _underscore_ext.isString)(data.cohort) && (0, _underscore_ext.isArray)(data.samples) && data.samples.every(_underscore_ext.isString) && data || undefined;
};

function parse(manifest) {
	var m = schemaCheck(JSON.parse(manifest));
	if (!m) {
		throw new Error('Unable to read manifest', manifest);
	}
	// XXX need to handle manifest-error action & report to user.
	return m;
}