'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('underscore');

// Using a modifier works differently on different os.
// On OSX, ctrl-click will do browser context menu, so
// only alt-click is usable by the app.
// On linux, alt-click will do window operations, so
// only ctrl-click is usable by the app.
// Need to test Windows.
var keys = {
	alt: {
		key: 'altKey',
		name: 'alt'
	},
	ctrl: {
		key: 'ctrlKey',
		name: 'control'
	}
};

var patterns = [[/^Linux/, keys.ctrl], [/^.*/, keys.alt]];

module.exports = _.find(patterns, function (_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
	    p = _ref2[0];

	return navigator.platform.match(p);
})[1];