'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('../underscore_ext');

var canEdit = function canEdit(_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
	    type = _ref2[0];

	return type === 'geneSignature';
};

function supportsEdit(fs) {
	return fs.fetchType === 'signature' ? canEdit(fs.signature) : true;
}

var setFieldType = _.curry(function (type, fs) {
	return _.assoc(fs, 'fieldType', type);
});

var signatureField = function signatureField(fieldName, opts) {
	return (0, _extends3.default)({
		fetchType: 'signature',
		valueType: 'float',
		fieldType: 'clinical',
		colorClass: 'clinical',
		fields: [fieldName],
		columnLabel: 'signature',
		fieldLabel: fieldName
	}, opts);
};

module.exports = {
	setFieldType: setFieldType,
	signatureField: signatureField,
	supportsEdit: supportsEdit
};