'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _underscore_ext = require('../underscore_ext');

var _underscore_ext2 = _interopRequireDefault(_underscore_ext);

var _layoutPlot = require('../layoutPlot');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*eslint-disable no-unused-vars */

var probeLayout = function probeLayout(layout, positions) {
	return (0, _layoutPlot.pxTransformFlatmap)(layout, function (toPx) {
		return positions.map(function (pos, i) {
			return [i, toPx(pos.start, pos.end)];
		});
	});
};

var cmpGap = function cmpGap(g0, g1) {
	return g1.gap - g0.gap;
};

var maxConduits = 5;

var partitionProbes = function partitionProbes(probes) {
	var gaps = _underscore_ext2.default.first(_underscore_ext2.default.partition(probes, 2, 1).map(function (_ref, i) {
		var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
		    p0 = _ref2[0],
		    p1 = _ref2[1];

		return { i: i, gap: p1.end - p1.start };
	}).sort(cmpGap), maxConduits - 1).map(function (g) {
		return g.i;
	});
};

var x = {
	chrom: [[100, 200], [300, 400], [410, 500]],
	screen: [[0, 10], [12, 15], [20, 30]],
	reversed: false,
	baseLen: 290,
	pxLen: 32,
	chromName: 'chr10',
	zoom: { start: 100, end: 500 }
};