'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _app_bar = require('react-toolbox/lib/app_bar');

var _app_bar2 = _interopRequireDefault(_app_bar);

var _navigation = require('react-toolbox/lib/navigation');

var _navigation2 = _interopRequireDefault(_navigation);

var _reactCssThemr = require('react-css-themr');

var _link = require('react-toolbox/lib/link');

var _link2 = _interopRequireDefault(_link);

var _menu = require('react-toolbox/lib/menu');

var _button = require('react-toolbox/lib/button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Navigation component.
 *
 * This is a light wrapper component around React Toolbox's AppBar component.
 */

// Core dependencies, components
var React = require('react');
var ReactDOM = require('react-dom');
var _ = require('./underscore_ext');

var navTheme = require('./navTheme');
var BookmarkMenu = require('./views/BookmarkMenu');

var _require = require('./defaultServers'),
    localHub = _require.servers.localHub;

// Styles


var compStyles = require('./nav.module.css');

// Images
var logoSantaCruzImg = require('../images/logoSantaCruz.png');
var logoSantaCruz2xImg = require('../images/logoSantaCruz@2x.png');
var logoSantaCruz3xImg = require('../images/logoSantaCruz@3x.png');

// Locals
var links = [{ label: 'Data Sets', nav: 'datapages' }, { label: 'Visualization', nav: 'heatmap' }, { label: 'Transcripts', nav: 'transcripts' }, { label: 'Data Hubs', nav: 'hub' }, { label: 'View My Data', nav: 'datapages', params: { addHub: localHub, host: localHub } }];

var helproot = 'https://ucsc-xena.gitbook.io/project/';

var helpLink = {
	href: helproot,
	label: 'Help',
	target: '_blank'
};

var geneSetsLink = {
	href: 'https://xenageneset.berkeleybop.io/xena/',
	label: 'Gene Sets',
	target: '_blank'
};

var pythonLink = {
	href: helproot + 'overview-of-features/accessing-data-through-python',
	label: 'Python',
	target: '_blank'
};

var active = function active(l, activeLink) {
	return l.nav === activeLink;
};

var MoreToolsMenu = function (_React$Component) {
	(0, _inherits3.default)(MoreToolsMenu, _React$Component);

	function MoreToolsMenu() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, MoreToolsMenu);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MoreToolsMenu.__proto__ || (0, _getPrototypeOf2.default)(MoreToolsMenu)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			anchorEl: null
		}, _this.onClick = function (event) {
			_this.setState({ anchorEl: event.currentTarget });
		}, _this.handleClose = function () {
			_this.setState({ anchorEl: null });
		}, _this.handleSelect = function (url) {
			window.open(url);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(MoreToolsMenu, [{
		key: 'render',
		value: function render() {
			var anchorEl = this.state.anchorEl;


			return React.createElement(
				'div',
				{ style: { display: "inline", position: 'relative' } },
				React.createElement(
					_button.Button,
					{
						onClick: this.onClick },
					'More Tools'
				),
				React.createElement(
					_menu.Menu,
					{ position: 'topLeft',
						active: Boolean(anchorEl),
						onHide: this.handleClose,
						className: compStyles.menu
					},
					React.createElement(_menu.MenuItem, { onClick: this.handleSelect.bind(this, pythonLink.href), caption: pythonLink.label }),
					React.createElement(_menu.MenuItem, { onClick: this.handleSelect.bind(this, geneSetsLink.href), caption: geneSetsLink.label })
				)
			);
		}
	}]);
	return MoreToolsMenu;
}(React.Component);

var XenaNav = function (_React$Component2) {
	(0, _inherits3.default)(XenaNav, _React$Component2);

	function XenaNav() {
		(0, _classCallCheck3.default)(this, XenaNav);
		return (0, _possibleConstructorReturn3.default)(this, (XenaNav.__proto__ || (0, _getPrototypeOf2.default)(XenaNav)).apply(this, arguments));
	}

	(0, _createClass3.default)(XenaNav, [{
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    isPublic = _props.isPublic,
			    activeLink = _props.activeLink,
			    getState = _props.getState,
			    onImport = _props.onImport;

			var routes = _.map(links, function (l) {
				var nav = l.nav,
				    params = l.params,
				    others = (0, _objectWithoutProperties3.default)(l, ['nav', 'params']),
				    onClick = nav ? function () {
					return _this3.props.onNavigate(nav, params);
				} : undefined;

				return (0, _extends3.default)({}, others, { onClick: onClick, active: active(l, activeLink) });
			});
			var logoSrcSet = logoSantaCruz2xImg + ' 2x, ' + logoSantaCruz3xImg + ' 3x';
			return React.createElement(
				_app_bar2.default,
				{ className: compStyles.NavAppBar },
				React.createElement(
					'a',
					{ href: 'http://xena.ucsc.edu/', className: compStyles.logoXena },
					React.createElement('img', { title: window.ga ? '' : 'no analytics', src: logoSantaCruzImg, srcSet: logoSrcSet })
				),
				React.createElement(
					_navigation2.default,
					{ type: 'horizontal', routes: routes },
					getState ? React.createElement(BookmarkMenu, { isPublic: isPublic, getState: getState, onImport: onImport }) : null,
					React.createElement(_link2.default, helpLink),
					React.createElement(MoreToolsMenu, null)
				)
			);
		}
	}]);
	return XenaNav;
}(React.Component);

var ThemedNav = function (_React$Component3) {
	(0, _inherits3.default)(ThemedNav, _React$Component3);

	function ThemedNav() {
		(0, _classCallCheck3.default)(this, ThemedNav);
		return (0, _possibleConstructorReturn3.default)(this, (ThemedNav.__proto__ || (0, _getPrototypeOf2.default)(ThemedNav)).apply(this, arguments));
	}

	(0, _createClass3.default)(ThemedNav, [{
		key: 'render',
		value: function render() {
			return React.createElement(
				_reactCssThemr.ThemeProvider,
				{ theme: navTheme },
				React.createElement(XenaNav, this.props)
			);
		}
	}]);
	return ThemedNav;
}(React.Component);

var nav = document.getElementById('navMenuMain');

module.exports = function (props) {
	return ReactDOM.render(React.createElement(ThemedNav, props), nav);
};