'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _underscore_ext = require('./underscore_ext');

var _underscore_ext2 = _interopRequireDefault(_underscore_ext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var download = function download() {
	require.ensure(['pdfkit', 'svg-to-pdfkit', 'blob-stream'], function () {
		var PDFDocument = require('pdfkit');
		var blobStream = require('blob-stream');
		var SVGtoPDF = require('svg-to-pdfkit');
		var svg = document.getElementsByClassName('highcharts-root')[0],
		    r = svg.getBoundingClientRect(),
		    doc = new PDFDocument({ compress: false, size: [r.width, r.height] }),
		    buttons = document.getElementsByClassName('highcharts-button'),
		    scrollBars = document.getElementsByClassName('highcharts-scrollbar'),
		    btnDisplay = _underscore_ext2.default.map(buttons, function (b) {
			return b.style.display;
		}),
		    sBDisplay = _underscore_ext2.default.map(scrollBars, function (b) {
			return b.style.display;
		}),
		    stream = doc.pipe(blobStream());

		_underscore_ext2.default.forEach(buttons, function (b) {
			return b.style.display = 'none';
		});
		_underscore_ext2.default.forEach(scrollBars, function (b) {
			return b.style.display = 'none';
		});
		SVGtoPDF(doc, svg, 0, 0, { preserveAspectRatio: 'xMidYMid' });
		_underscore_ext2.default.forEach(buttons, function (b, i) {
			return b.style.display = btnDisplay[i];
		});
		_underscore_ext2.default.forEach(scrollBars, function (b, i) {
			return b.style.display = sBDisplay[i];
		});
		doc.end();

		stream.on('finish', function () {
			var url = stream.toBlobURL('application/pdf');

			var a = document.createElement('a');
			var filename = 'xenaDownload.pdf';
			(0, _assign2.default)(a, { id: filename, download: filename, href: url });
			document.body.appendChild(a);
			a.click();
			document.body.removeChild(a);
		});
	});
};

exports.default = download;