'use strict';

var _require = require('./drawMutations'),
    drawMutations = _require.drawMutations,
    drawSV = _require.drawSV;

var _ = require('./underscore_ext');
var widgets = require('./columnWidgets');

var pdf = _.curry(function (draw, id, column, vg, state, i) {
	var zoom = state.zoom,
	    colID = _.getIn(state, ['columnOrder', i]),
	    data = _.getIn(state, ['data', colID]),
	    index = _.getIn(state, ['index', colID]);


	draw(vg, {
		feature: column.sFeature,
		index: index,
		column: column,
		samples: state.samples,
		nodes: column.nodes,
		data: data,
		width: column.width,
		zoom: zoom
	});
});

widgets.pdf.add('mutation', pdf(drawMutations));
widgets.pdf.add('SV', pdf(drawSV));