'use strict';

var _require = require('./drawSegmented.js'),
    drawSegmented = _require.drawSegmented;

var _ = require('./underscore_ext');
var widgets = require('./columnWidgets');

var pdf = function pdf(id, column, vg, state, i) {
	var zoom = state.zoom,
	    samples = state.samples,
	    xzoom = column.zoom,
	    color = column.color,
	    nodes = column.nodes,
	    strand = column.strand,
	    width = column.width,
	    colID = _.getIn(state, ['columnOrder', i]),
	    data = _.getIn(state, ['data', colID]),
	    index = _.getIn(state, ['index', colID]);

	drawSegmented(vg, {
		index: index,
		column: column,
		samples: samples,
		nodes: nodes,
		strand: strand,
		data: data,
		width: width,
		zoom: zoom,
		xzoom: xzoom,
		color: color
	});
};

widgets.pdf.add('segmented', pdf);