'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _Rx$Observable;

var _minhash = require('minhash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Utility script to build minhash for cohort samples on public
// hubs

var request = require('request');
var Rx = require('rxjs');
var post = Rx.Observable.bindNodeCallback(request.post);
var fs = require('fs');

var _ = require('underscore');

var _require = require('../defaultServers'),
    publicServers = _require.publicServers,
    enabledServers = _require.enabledServers;

var enabledPublicServers = _.intersection(publicServers, enabledServers);

var allCohortsQuery = '\n    (map :cohort\n\t  (query\n\t\t{:select [[#sql/call [:distinct #sql/call [:ifnull :cohort "(unassigned)"]] :cohort]]\n\t\t :from [:dataset]}))';

var cohortSamplesQuery = function cohortSamplesQuery(cohort) {
	return '\n\t(map :value\n\t\t  (query\n\t\t\t{:select [:%distinct.value]\n\t\t\t :from [:dataset]\n\t\t\t :join [:field [:= :dataset.id :dataset_id]\n\t\t\t\t\t:code [:= :field_id :field.id]]\n\t\t\t :where [:and [:= :cohort "' + cohort + '"]\n\t\t\t\t\t\t  [:= :field.name "sampleID"]]}))';
};

function spy(msg, x) {
	console.log(msg, x);
	return x;
}

var uniq = function uniq(arrs) {
	var _ref;

	return [].concat((0, _toConsumableArray3.default)(new _set2.default((_ref = []).concat.apply(_ref, (0, _toConsumableArray3.default)(arrs)))));
};

var cohortList = (_Rx$Observable = Rx.Observable).zip.apply(_Rx$Observable, (0, _toConsumableArray3.default)(enabledPublicServers.map(function (host) {
	return post({
		url: host + '/data/',
		body: allCohortsQuery
	}).catch(function () {
		return Rx.Observable.of([spy('error host', host), '[]']);
	});
})).concat([function () {
	for (var _len = arguments.length, resps = Array(_len), _key = 0; _key < _len; _key++) {
		resps[_key] = arguments[_key];
	}

	return uniq(resps.map(function (_ref2) {
		var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
		    resp = _ref3[1];

		return JSON.parse(resp);
	}));
}])); //.map(cohorts => cohorts.slice(0, 2));

var sampleList = function sampleList(cohort) {
	var _Rx$Observable2;

	return (_Rx$Observable2 = Rx.Observable).zip.apply(_Rx$Observable2, (0, _toConsumableArray3.default)(enabledPublicServers.map(function (host) {
		return post({
			url: host + '/data/',
			body: cohortSamplesQuery(cohort)
		}).catch(function () {
			return Rx.Observable.of([host, '[]']);
		});
	})).concat([function () {
		for (var _len2 = arguments.length, resps = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			resps[_key2] = arguments[_key2];
		}

		return uniq(resps.map(function (_ref4) {
			var _ref5 = (0, _slicedToArray3.default)(_ref4, 2),
			    resp = _ref5[1];

			return JSON.parse(resp);
		}));
	}]));
};

function minHashFromList(list) {
	var mh = new _minhash.Minhash();
	list.forEach(function (p) {
		return mh.update(p);
	});
	return mh;
}

function writeCohortHashes() {
	//eslint-disable-line no-unused-vars
	var out = fs.openSync('cohortMinHashes', 'w');
	var first = true;
	cohortList.flatMap(function (cohorts) {
		var _Rx$Observable3;

		return (_Rx$Observable3 = Rx.Observable).merge.apply(_Rx$Observable3, (0, _toConsumableArray3.default)(cohorts.map(function (cohort) {
			return sampleList(cohort).map(function (samples) {
				return { cohort: cohort, samples: samples };
			});
		})));
	}).subscribe(function (_ref6) {
		var cohort = _ref6.cohort,
		    samples = _ref6.samples;

		fs.writeSync(out, first ? '[' : ',');
		var mh = minHashFromList(samples);
		fs.writeSync(out, (0, _stringify2.default)({ name: cohort, hash: mh.hashvalues }));
		first = false;
	}, function () {}, function () {
		fs.writeSync(out, ']');
		fs.closeSync(out);
	});
}

writeCohortHashes();