'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _minhash = require('minhash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Utility script to build minhash for probemaps on the
// reference hub.

var request = require('request');
var Rx = require('rxjs');
var post = Rx.Observable.bindNodeCallback(request.post);
var fs = require('fs');


var refHub = 'https://reference.xenahubs.net';

function minHashFromList(list) {
	var mh = new _minhash.Minhash();
	list.forEach(function (p) {
		return mh.update(p);
	});
	return mh;
}

function probemapList() {
	var probemaps = '\n\t\t(query {:select [:dataset.name :hash]\n\t\t\t\t:from [:dataset]\n\t\t\t\t:join [:dataset-source [:= :dataset.id :dataset_id]\n\t\t\t\t\t   :source [:= :source.id :source_id]]\n\t\t\t\t:where [:= :type "probeMap"]}))';

	return post({
		url: refHub + '/data/',
		body: probemaps
	}).map(function (_ref) {
		var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
		    resp = _ref2[1];

		return JSON.parse(resp);
	});
}

function probeList(probemap) {
	var probes = '(xena-query {:select ["name"] :from ["' + probemap.name + '"]})';
	return post({
		url: refHub + '/data/',
		body: probes
	}).retry(3).map(function (_ref3) {
		var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
		    resp = _ref4[1];

		try {
			return (0, _extends3.default)({}, probemap, { probes: JSON.parse(resp).name });
		} catch (e) {
			console.log('parsing error ', resp.slice(0, 1000));
			process.exit();
		}
	});
}

function buildFilters() {
	var out = fs.openSync('probemapMinHashes', 'w');
	var first = true;
	probemapList().flatMap(function (probemaps) {
		var _Rx$Observable;

		return (_Rx$Observable = Rx.Observable).merge.apply(_Rx$Observable, (0, _toConsumableArray3.default)(probemaps.map(probeList)));
	}).subscribe(function (_ref5) {
		var name = _ref5.name,
		    probes = _ref5.probes;

		console.log(name);
		fs.writeSync(out, first ? '[' : ',');
		var mh = minHashFromList(probes);
		fs.writeSync(out, (0, _stringify2.default)({ name: name, hash: mh.hashvalues }));
		first = false;
	}, function (err) {
		console.log('error', err);
	}, function () {
		fs.writeSync(out, ']');
		fs.closeSync(out);
	});
}

buildFilters();