"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = [{
    "goid": "GO:0007219",
    "golabel": "Notch signaling",
    "gene": ["DLL1", "DTX1", "JAG1", "JAG2", "ADAM10", "PSEN1", "PSEN2", "PSENEN"]
}, {
    "goid": "GO:0035329",
    "golabel": "Hippo signaling",
    "gene": ["LATS2", "MOB1B", "MOB1A", "SAV1", "STK3", "STK4", "TAZ", "YAP1", "MST1", "WWTR1"]
}, {
    "goid": "GO:0006281",
    "golabel": "DNA base excision repair",
    "gene": ["UNG", "SMUG1", "MBD4", "TDG", "OGG1", "MUTYH", "NTHL1", "MPG", "NEIL1", "NEIL2", "NEIL3"]
}, {
    "goid": "GO:0006281",
    "golabel": "DNA strand break joining",
    "gene": ["APEX1", "APEX2", "LIG3", "XRCC1", "PNKP", "APLF"]
}, {
    "goid": "GO:0006281",
    "golabel": "Poly(ADP-ribose) polymerase (PARP)",
    "gene": ["PARP1", "PARP2", "PARP3"]
}, {
    "goid": "GO:0006281",
    "golabel": "Direct reversal of DNA damage",
    "gene": ["MGMT", "ALKBH2", "ALKBH3"]
}, {
    "goid": "GO:0006281",
    "golabel": "Repair of DNA-topoisomerase crosslinks",
    "gene": ["TDP1", "TDP2"]
}, {
    "goid": "GO:0006281",
    "golabel": "Mismatch excision repair",
    "gene": ["MSH2", "MSH3", "MSH6", "MLH1", "PMS2", "MSH4", "MSH5", "MLH3", "PMS1", "PMS2L3"]
}, {
    "goid": "GO:0006281",
    "golabel": "Nucleotide excision repair",
    "gene": ["XPC", "RAD23B", "CETN2", "RAD23A", "XPA", "DDB1", "DDB2", "RPA1", "RPA2", "RPA3", "TFIIH", "ERCC3", "ERCC2", "GTF2H1", "GTF2H2", "GTF2H3", "HTF2H4", "GTF2H5", "CDK7", "CCNH", "MNAT1", "ERCC5", "34CC1", "ERCC4", "LIG1", "NER-related", "ERCC8", "E4CC6", "UVSSA", "XAB2", "MMS19"]
}, {
    "goid": "GO:0006281",
    "golabel": "Homologous recombination",
    "gene": ["RAD51", "RAD51B", "RAD51D", "DMC1", "XRCC2", "XRCC3", "RAD52", "RAD54L", "RAD54B", "BRCA1", "SHFM1", "RAD50", "MRE11A", "NBN", "RBBP8", "MUS81", "EME1", "EME2", "GIYD1", "GIYD2", "GEN1"]
}, {
    "goid": "GO:0006281",
    "golabel": "Fanconi anemia",
    "gene": ["FANCA", "FANCB", "FANCC", "BRCA2", "FANCD2", "FANCE", "FANCF", "FANCG", "FANCI", "BRIP1", "FANCL", "FANCM", "PALB2", "RAD51C", "BTBD12", "FAAP20", "FAAP24"]
}, {
    "goid": "GO:0006281",
    "golabel": "Non-homologous DNA end-joining",
    "gene": ["XRCC6", "XRCC5", "PRKDC", "LIG4", "XRCC4", "DCLRE1C", "NHEJ1"]

}, {
    "goid": "GO:0006281",
    "golabel": "Modulation of nucleotide pools",
    "gene": ["NUDT1", "DUT", "RRM2B"]
}, {
    "goid": "GO:0006281",
    "golabel": "DNA polymerase",
    "gene": ["POLB", "POLG", "POLD1", "POLE", "PCNA", "REV3L", "MAD2L2", "REV1L", "POLH", "POLI", "POLQ", "POLK", "POLL", "POLM", "POLN"]
}, {
    "goid": "GO:0006281",
    "golabel": "Editing and processing nucleases",
    "gene": ["FEN1", "FAN1", "TREX1", "TREX2", "EXO1", "APTX", "SPO11", "ENDOV"]
}, {
    "goid": "GO:0006281",
    "golabel": "Ubiquitination and modification",
    "gene": ["UBE2A", "UBE2B", "RAD18", "SHPRH", "HLTF", "RNF168", "SPRTN", "RNF8", "RNF4", "UBE2V2", "UBE2N"]
}, {
    "goid": "GO:0006281",
    "golabel": "Chromatin structure and modification",
    "gene": ["H2AFX", "CHAF1A", "SETMAR"]
}, {
    "goid": "GO:0006281",
    "golabel": "Sensitivity to DNA damaging agents",
    "gene": ["BLM", "WRN", "RECQL4", "ATM", "TTDN1"]
}, {
    "goid": "GO:0006281",
    "golabel": "Known/suspected DNA repair function",
    "gene": ["DCLRE1A", "DCLRE1B", "RPA4", "PRPF19", "RECQL", "RECQL5", "HELQ", "RDM1", "OBFC2B"]
}, {
    "goid": "GO:0006281",
    "golabel": "Conserved DNA damage response",
    "gene": ["ATR", "ATRIP", "MDC1", "RAD1", "RAD9A", "HUS1", "RAD17", "CHEK1", "CHEK2", "TP53", "TP53BP1", "RIF1", "TOPBP1", "CLK2", "PER1"]
}, {
    "goid": "GO:0000077",
    "golabel": "DNA damage checkpoint",
    "gene": ["TAOK1", "RPL26", "DONSON", "TIPIN", "DDX39B", "FBXO31", "SOX4", "HINFP", "CCND1", "WAC", "ETAA1", "BABAM2", "USP28", "UIMC1", "CDC14B", "RHNO1", "BRCC3", "FOXN3", "CLSPN", "CRADD", "THOC5", "FEM1B", "PIDD1", "ABRAXAS1", "BRSK1", "CCAR2", "CDC5L", "PLK1", "RPS27L", "CDKN1A", "TAOK2", "FZR1", "HMGA2", "MRNIP", "CLOCK", "NOP53", "E2F1", "THOC1", "CASP2", "RFWD3", "NEK11", "MUC1", "MAP3K20", "TAOK3", "CDK5RAP3", "TIPRL", "INTS7", "BABAM1", "MDM2", "DTL", "ATF2"]
}, {
    "goid": "GO:0048017",
    "golabel": "PI3-K signaling",
    "gene": ["AKT1", "AKT2", "AKT3", "BTK", "GRB10", "GRB2", "HSPB1", "ILK", "MTCP1", "PDK2", "PDPK1", "PIK3CA", "PIK3CG", "PIK3R1", "PIK3R2", "PAK1", "PRKCA", "PRKCB", "PRKCZ", "PTEN", "TCL1A"]
}, {
    "goid": "GO:0016055",
    "golabel": "Wnt signaling",
    "gene": ["AES", "APC", "AXIN1", "BCL9", "CSNK1A1", "CSNK1D", "CSNK1G1", "CSNK2A1", "CTBP1", "CTBP2", "CTNNB1", "CTNNBIP1", "CXXC4", "DIXDC1", "DKK1", "DVL1", "DVL2", "EP300", "FRAT1", "FZD1", "FZD2", "FZD3", "FZD4", "FZD5", "FZD6", "FZD7", "FZD8", "GSK3A", "GSK3B", "LEF1", "LRP5", "LRP6", "NKD1", "PORCN", "PPP2CA", "PPP2R1A", "PYGO1", "SENP2", "SFRP1", "SFRP4", "SOX17", "TCF7", "TCF7L1", "WIF1", "WNT1", "WNT10A", "WNT16", "WNT2", "WNT2B", "WNT3", "WNT3A", "WNT4", "WNT6", "WNT7A", "WNT7B", "WNT8A"]
}, {
    "goid": "GO:0097193",
    "golabel": "Intrinsic apoptotic pathway",
    "gene": ["PTTG1IP", "CHEK2", "NONO", "DDIAS", "MOAP1", "LRRK2", "YBX3", "S1OOAO", "LGALS12", "LCK", "RPL26", "CAV1", "SOD1", "DAPK2", "HERPUD1", "UBB", "TP53", "MYBBP1A", "SELENOS", "PLAUR", "PRKN", "TP53BP2", "SYVN1", "MPAK7", "MIF", "SRC", "TRIM32", "TP73", "CHAC1", "NOL3", "USP28", "ZNF385A", "SNW1", "CDKN2D", "RPS3", "CASP9", "PMAIP1", "SIAH1", "MMP9", "SFPQ", "EPO", "TMBIM6", "HYOU1", "BAD", "DNAJC10", "CCAR2", "MAGEA3", "SFN", "PARK7", "MAP3K5", "ENO1", "MSX1", "STK25", "STK11", "RACK1", "DNAJA1", "BRCA1", "PHLDA3", "RPS27L", "EP300", "DDIT3", "PDK2", "PDK1", "CXCL12", "URI1", "BRSK2", "BCAP31", "TNFRSF10B", "MLLT11", "CRIP1", "NCK1", "TPT1", "HSPA1A", "CASP4", "IFI16", "HIF1A", "KDM1A", "OPA1", "CYLD", "EPHA2", "PPP1R13B", "BCL2L11", "TRIAP1", "PPM1F", "HTRA2", "CREB3", "CLU", "PINK1", "SLC9A3R1", "CDIP1", "CD74", "BOK", "UBQLN1", "ESF1", "SEPT4", "FHIT", "HINT1", "XBP1", "DDX5", "ARL6IP5", "P4HB", "BCL3", "FIS1", "TMEM117", "SNAI2", "NACC2", "SOD1", "BNIP3", "GSDME", "IKBKE", "TOPORS", "GSKIP", "NDUFA13", "SNAI1", "STK24", "NFE2L2", "FBXO18", "BCL2", "SIRT1", "MUC1", "SELENOK", "ZNF385B", "BAG6", "EIF2AK3", "DYRK2", "RRP8", "HIC1", "BAG5", "PYCARD", "TXNDC12", "NOC2L", "NKX3-1", "AEN", "MCL1", "BCL2L1", "BAX", "ATP2A1", "URS00003D1AE3_9606", "NDUFS3", "DNM1L", "TMEM161A", "TRIB3", "PDCD10", "MDM2", "DDX3X", "BCLAF1", "ZNF622", "CD44", "FBXW7", "PPIF", "ACKR3", "S100A8"]
}, {
    "goid": "GO:0097191",
    "golabel": "Extrinsic apoptotic pathway",
    "gene": ["HIPK1", "SORT1", "MOAP1", "BAG3", "PELI3", "ERBB3", "ITGAV", "DEDD2", "FAIM2", "PSME3", "CAV1", "TLR3", "TRAF1", "HMOX1", "PTEN", "GSTP1", "GDNF", "THBS1", "TMC8", "IFI6", "RIPK1", "PAK2", "MAPK7", "FADD", "BID", "SRC", "NOL3", "FGG", "FGB", "FGA", "SH3RF1", "INHBA", "PMAIP1", "DEPTOR", "IL1B", "IFNG", "SFRP1", "FEM1B", "TNFAIP3", "AGT", "BAD", "PARK7", "LTBR", "UNC5B", "TNF", "ZMYND11", "TGFBR1", "ACVR1B", "MADD", "FAS", "HTT", "PHIP", "BRCA1", "PPP2R1B", "KIAAO141", "TIMP3", "TNFSF10", "TRAF2", "PEA15", "TGFB2", "FASLG", "TNFRSF10A", "ITGA6", "TERT", "MLLT11", "CSF2", "HSPA1A", "CD70", "BIRC6", "ICAM1", "CYLD", "FGFR3", "LGALS3", "DDX47", "BCL10", "HTRA2", "CASP8AP2", "DAB2IP", "PDPK1", "RNF41", "SIAH2", "G0S2", "GPX1", "SERPINE1", "PML", "IL12A", "ATF3", "SP100", "ACVR1", "BCL2", "GATA1", "CASP8", "HSPA1B", "RELA", "TNFRSF12A", "PYCARD", "TNFSF12", "BLOC1S2", "AR", "SMAD3", "TRADD", "MCL1", "BCL2L1", "BAX", "SCG2", "SIVA1", "URS00002C6949_9606", "NGF", "TGFB1", "CD27", "RFFL", "GABARAP", "AGTR2", "DDX3X", "STX4", "PF4", "TMBIM1", "RNF34", "CFLAR", "IGF1"]
}, {
    "goid": "GO:0022402",
    "golabel": "Cell cycle",
    "gene": ["GSK3B", "TGFB1", "SMAD3", "SMAD4", "CD2A2", "CDN1B", "CCND3", "CCND2", "CDK4", "CDK6", "SCF", "SKP2", "ABL1", "HDAC1", "HDAC2", "HDAC3", "HDAC4", "HDAC5", "HDAC6", "HDAC7", "HDAC8", "RB", "E2F1", "E2F2", "E2F3", "E2F4", "E2F5", "E2F6", "RBL1", "UBE2F", "TFDP1", "RBL1", "CCNE1", "CCNE2", "CDK2", "CDN1A", "CCNA1", "CCNA2", "CDK2", "CCNH", "CDC6", "ORC1", "ORC2", "ORC3", "ORC4", "ORC5", "ORC6", "CDC45", "ARF1", "MDM2", "P53", "EP000", "PRKDC", "GA45A", "1433G", "PCNA", "MPIP1", "ATR", "ATM", "CHK1", "CHK2", "CDK1", "CCNB1", "CCNB2", "CCNB3", "WEE1", "PMYT1", "MCM2", "MCM3", "MCM4", "MCM5", "MCM6", "MCM7", "MCM8", "MCM9", "MCM10", "CDC7", "DBF4A", "PLK1", "APC", "CADH1", "CC14A", "CC14B", "MEN1", "MPIP2", "MPIP3", "YWHAB", "YWHAE", "YWHAG", "YWHAH", "YWHAQ", "YWHAZ", "BUB1", "BUB3", "MPEG1", "BUB1B", "MD1L1", "MD2L2", "MD2L1", "SMC1A", "ESPL1", "PTTG3", "PTTG2", "PTTG1"]
}, {
    "goid": "GO:0016570",
    "golabel": "Histone modification",
    "gene": ["KANSL1", "KDM5A", "CTCFL", "KAT2A", "UBE2B", "USP3", "EYA3", "EYA1", "DOT1L", "RBBP5", "ACTL6A", "WDR5", "KDM8", "SETD6", "MIER2", "BAP1", "HASPIN", "USP49", "MSL2", "ELK4", "TAF7", "TAF5", "LEO1", "UBE2E1", "NCOA3", "KMT2A", "PHF19", "CTBP1", "MSL1", "UHRF1", "SETDB2", "SIN3A", "IWS1", "BEND3", "PHF20", "HAT1", "HDAC3", "DNMT1", "SART3", "EYA2", "KDM5C", "WBP2", "KAT14", "ATXN7L3", "PADI2", "KAT8", "NAA60", "CTR9", "CDK2", "CUL4B", "NSD3", "SETD2", "PCGF6", "KANSL2", "HDAC1", "NR1H4", "PIH1D1", "REST", "WAC", "ING3", "NTMT1", "KANSL3", "ATRX", "UBE2N", "NIPBL", "OGT", "ATXN7", "UIMC1", "WDR61", "PRDM12", "PRMT7", "KDM6B", "ELP3", "SETD1A", "RBM14", "JAK2", "EHMT1", "SNW1", "MSL3", "BRCC3", "BRPF1", "HDAC6", "SUPT7L", "TET2", "NAA40", "SKR16C5", "KDM4B", "RYBP", "USP51", "FOXP3", "HCFC1", "KAT2B", "ING5", "KAT6B", "CDK1", "AUTS2", "SETD7", "KAT5", "ZNF304", "DTX3L", "CHD5", "MIER1", "CHTOP", "HDAC2", "RNF2", "CREBBP", "KAT6A", "EZH2", "TAF1", "ZNF451", "KDM1A", "FMR1", "JADE1", "KMT5A", "SUV39H2", "PRMT6", "DPY30", "DDB2", "EP400", "JADE2", "NSD1", "ZNF335", "EHMT2", "DDB1", "TAF12", "PKN1", "UBE2A", "RPS6KA4", "ARRB1", "HMGA2", "SUV39H1", "EPC1", "RCOR1", "DNMT3B", "ASH2L", "RUVBL1", "TAF9", "LEF1", "PHC1", "KDM5D", "PAXIP1", "PER1", "CLOCK", "COPRS", "SETD1B", "SMARCAD1", "KMT2B", "BRD7", "DMAP1", "RING1", "ENY2", "RNF40", "MYSM1", "ZNF274", "BRD8", "RPS6KA5", "BAZ1B", "EED", "TAF5L", "TADA3", "NACC2", "PHF8", "SMYD3", "MBIP", "KDM7A", "POLE3", "PAF1", "CXXC1", "SIRT6", "HUWE1", "YEATS4", "JADE3", "PRMT2", "USP16", "H2AFY", "PRKCA", "HDAC11", "PRKCB", "TET1", "NEK11", "KDM5B", "SIRT1", "MAP3K7", "MAPK3", "MUC1", "saga_human", "CARM1", "MYB", "PHF1", "TET3", "KDM2A", "TRIP12", "CCNA2", "KMT5B", "KAT7", "KDM1B", "MT3", "PRDM5", "SNCA", "MCRS1", "TADA2A", "KDM2B", "RNF20", "AKAP8", "ELP4", "BFD1", "KMT2C", "KDM4A", "PHF2", "USP15", "TAF6L", "KDM3A", "TRRAP", "TADA1", "NOC2L", "OTUB1", "MORF4L1", "RUVBL2", "RAPGEF3", "TRIM16", "SPI1", "BCOR", "SETMAR", "PRMT1", "SUPT6H", "HDAC4", "CAMK1", "SUDS3", "PRKCD", "DCAF1", "FBL", "SUPT3H", "RNF168", "NAA50", "SUZ12", "KDM4D", "USP22", "LIF", "SMARCB1", "HDAC5", "HDAC10", "ATF2", "CDK9", "HLCS", "UBR5", "ING4", "PRMT8", "POLE4", "ASH1L"]
}, {
    "goid": "GO:0006979",
    "golabel": "Oxidative stress",
    "gene": ["APTX", "PTPRK", "PDGFRA", "SETX", "PNPT1", "LRRK2", "SOD2", "TP53", "ECT2", "SELENOS", "PRKN", "SLC25A24", "MAPK7", "AQP1", "TPM1", "CHUK", "DHRS2", "PLA2R1", "RPS3", "NET1", "HDAC6", "ETV5", "BRF2", "MMP9", "SESN2", "PLEKHA1", "AKT1", "MAPK1", "VKORC1L1", "ALDH3B1", "RAD52", "PARK7", "MAP3K5", "G6PD", "APOA4", "STK25", "PYROXD1", "MGST1", "DAPK1", "MAPK9", "MAPK8", "PRDX3", "PRDX5", "VRK2", "PRKD1", "PDK2", "TRPM2", "GBA", "HIF1A", "PXN", "EGFR", "ABL1", "HTRA2", "FXN", "NCF1", "PINK1", "PARP1", "ERCC6L2", "ATP13A2", "JUN", "ARL6IP5", "PYCR1", "SOD1", "FABP1", "ATF4", "GSKIP", "STK24", "PRDX2", "NFE2L2", "AKR1C3", "SIRT1", "CRYGD", "MAPK3", "RHOB", "ANKZF1", "CHD6", "RELA", "MT3", "IL6", "NOS3", "ARNT", "ZNF580", "WNT16", "URS0000324096_9606", "FOS", "PRKCD", "PYCR2", "TMEM161A", "ANKRD2", "PDCD10", "ZNF622", "ROMO1", "RBM11", "PPIF", "PRR5L"]
}, {
    "goid": "GO:0007265",
    "golabel": "Ras signaling",
    "gene": ["MAPK1", "MAPK3", "AKT1", "AKT2", "AKT3", "ALK", "ARHGAP35", "ARHGEF2", "CCND1", "CCND2", "CCND3", "CDK4", "CDK6", "CNKSR1", "CNKSR2", "CYTH2", "DUSP1", "DUSP2", "DUSP3", "DUSP4", "DUSP5", "DUSP6", "E2F1", "E2F2", "E2F3", "ECT2", "EGFR", "EIF4EBP1", "EIF4EBP2", "EIF4EBP3", "ERBB2", "ETS1", "ETS2", "EXOC1", "EXOC2", "EXOC3", "EXOC4", "EXOC5", "EXOC6", "EXOC7", "EXOC8", "FGFR1", "FGFR2", "FGFR3", "FGFR4", "FLT3", "FNTA", "FNTB", "FOS", "GFB2", "ICMT", "INSR", "INSRR", "IRS1", "IRS2", "JUN", "KSR1", "KSR2", "MDM2", "MAP2K1", "MAP2K2", "MET", "MLST8", "MTOR", "NF1", "NFE2L2", "NFKB1", "PAK1", "PAK2", "PAK3", "PAK4", "PDGFRA", "PDGFRB", "PDPK1", "PEBP1", "PIK3CA", "PICI3CB", "PIK3CD", "PIK3CG", "PIK3R1", "PIK3R2", "PIK3R3", "PIK3R4", "PIC3R5", "PIK3R6", "PIN1", "PLXNB1", "PPP1CA", "PREX2", "PRKAA1", "PRKAA2", "PRKAB1", "PRKAB2", "PRKAG1", "PRKAG2", "PRKAG2", "PRKAG3", "PTEN", "RAC1", "RAC2", "RAC3", "AFAF", "BRAF", "RAF1", "RALA", "RALB", "RALBP1", "RALGDS", "RAPGEF1", "RAPGEF2", "KRAS", "MRAS", "NRAS", "RASA1", "RASA2", "RASA3", "RASAL1", "RASAL2", "RASAL3", "RASGRF1", "RASGRF2", "RASGRP1", "RASGRP2", "RASGRP3", "RASGRP4", "RASSF1", "RASSF2", "RASSF3", "RASSF4", "RASSF5", "RASSF6", "RASSF7", "RASSF8", "RASSF9", "RASSF10", "RB1", "RCE1", "RHEB", "RHOA", "RHOB", "RHOC", "ROCK1", "ROCK2", "ROS1", "RPS6KA1", "RPS6KA2", "RPS6KA3", "RPS6KB1", "RPS6KB2", "RPTOR", "SAV1", "SCRIB", "SHC1", "SHC2", "SHC3", "SHC4", "SHOC2", "SOS1", "SOS2", "SPRED1", "SPRED2", "SPRED3", "SPRY1", "SPRY2", "SPRY3", "SPRY4", "STK3", "STK4", "STK11", "TBK1", "TFDP1", "TFDP2", "TIAM1", "TIAM2", "TP53", "TSC1", "TSC2", "VAV1", "YAP1"]
}, {
    "goid": "GO:0007179",
    "golabel": "TGF-B signaling",
    "gene": ["WFIKKN2", "PTPRK", "COL1A2", "CD109", "FSHB", "TGFBR3", "CAV1", "SMURF1", "SKI", "SKOR2", "WFIKKN1", "COL3A1", "ZNF703", "DAB2", "THBS1", "ADAMTSL2", "ITGA3", "PEG10", "BAMBI", "LDLRAD4", "SRC", "SMAD7", "APOA1", "IL17F", "SNW1", "BCL9L", "ADAM17", "NKX2-1", "HSP90AB1", "SMURF2", "ITGB5", "CDH5", "GCNT2", "ZYX", "ZNF451", "SDCBP", "BCL9", "CLDN5", "STK11", "TGFBR1", "SMAD2", "CDKN1C", "CITED1", "ASPN", "TGFB2", "MEN1", "HSPA1A", "SNX25", "ZFYVE9", "TGFBR2", "SNX6", "STUB1", "CDKN2B", "PXN", "NLK", "PIN1", "PDPK1", "ADAM9", "JUN", "ENG", "TRIM33", "SMAD4", "EID2", "ARRB2", "ACVR1", "VASN", "VASN", "SIRT1", "PRDM16", "FLCN", "TWSG1", "PMEPA1", "ACVRL1", "USP9X", "PPM1A", "SOX11", "PBLD", "STRAP", "LEMD3", "ING2", "FERMT2", "HIPK2", "HPGD", "TGFB3", "SMAD6", "TGFB1I1", "USP15", "SMAD3", "PTK2", "URS0000065D58_9606", "TGFB1", "FOS"]

}, {
    "goid": "GO:0072331",
    "golabel": "TP53 signaling",
    "gene": ["RPL26", "ATM", "RRS1", "UBB", "NDRG1", "TP53", "RPS7", "SOX4", "MYBBP1A", "PRKN", "TP53BP2", "PAK1IP1", "NOP2", "MIF", "MDM4", "TFAP4", "TP73", "USP28", "PLA2R1", "ZNF385A", "ATR", "SNW1", "RPL5", "PMAIP1", "CRADD", "SESN2", "HEXIM1", "PIDD1", "KAT5", "MAGEA2", "MSX1", "STK11", "ANKRD1", "PHLDA3", "RPS27L", "TWIST1", "SMYD2", "BOP1", "EP300", "CDKN1A", "PDK2", "MYO6", "IFI16", "KDM1A", "KMT5A", "PPP1R13B", "TRIAP1", "PAXIP1", "CDIP1", "CD74", "NOP53", "BCL3", "E2F7", "SNAI2", "RPL11", "CASP2", "BOK", "FHIT", "HINT1", "DDX5", "FOXM1", "SP100", "SNAI1", "RPL23", "PSMD10", "SIRT1", "MUC1", "ZNF385B", "PTTG1IP", "MDM2", "CD44", "RNF34", "ING4", "RPF2", "BAG6", "RRP8", "USP10", "HIPK2", "CDK5RAP3", "PYCARD", "PYHIN1", "RPS6KA6", "AEN", "URS000039ED8D_9606", "RFFL", "DYRK2"]
}];