'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('../underscore_ext');
var React = require('react');
var NameColumn = require('./NameColumn');
// const {Exons} = require('./Exons');
var ExonsOnly = require('./ExonsOnly');

var _require = require('./DensityPlot'),
    DensityPlot = _require.DensityPlot,
    bottomColor = _require.bottomColor,
    topColor = _require.topColor,
    plotWidth = _require.plotWidth;

var GeneSuggest = require('../views/GeneSuggest');

var _require2 = require('../scale'),
    linearTicks = _require2.linearTicks;

var nav = require('../nav');
var styles = require('./TranscriptPage.module.css');
var StateError = require('../StateError');

var _require3 = require('../schemaCheck'),
    schemaCheckThrow = _require3.schemaCheckThrow;

var spinner = require('../ajax-loader.gif');

function getStatusView(status, onReload) {
	if (status === 'loading') {
		return React.createElement(
			'div',
			{ 'data-xena': 'loading', className: styles.status },
			React.createElement('img', { style: { textAlign: 'center' }, src: spinner })
		);
	}
	if (status === 'error') {
		return React.createElement(
			'div',
			{ className: styles.status },
			React.createElement(
				'i',
				{ onClick: onReload,
					title: 'Error loading data. Click to reload.',
					'aria-hidden': 'true',
					className: 'material-icons ' + styles.errorIcon },
				'warning'
			)
		);
	}
	return null;
}

var Transcripts = function (_React$Component) {
	(0, _inherits3.default)(Transcripts, _React$Component);

	function Transcripts() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Transcripts);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Transcripts.__proto__ || (0, _getPrototypeOf2.default)(Transcripts)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			input: _.getIn(_this.props.state, ['transcripts', 'gene']), // XXX this is outside the selector
			scaleZoom: false,
			updateButton: false
		}, _this.onLoadData = function () {
			var subtypeA = _this.refs.A.value;
			var subtypeB = _this.refs.B.value;
			var unit = _this.refs.unit.value;
			var gene = _this.state.input;

			_this.setState({
				scaleZoom: false,
				updateButton: false
			});

			// Invoke action 'loadGene', which will load transcripts and
			// expression data.
			_this.props.callback(['loadGene', gene, subtypeA, subtypeB, unit]);
		}, _this.onZoom = function (name) {
			_this.props.callback(['transcriptZoom', name]);
		}, _this.scaleZoom = function () {
			_this.setState({
				scaleZoom: !_this.state.scaleZoom
			});
		}, _this.onNavigate = function (page, params) {
			_this.props.callback(['navigate', page, params]);
		}, _this.onImport = function (content) {
			try {
				_this.props.callback(['import', schemaCheckThrow(JSON.parse(content))]);
			} catch (err) {
				_this.props.callback(['import-error']);
			}
		}, _this.onHideError = function () {
			_this.props.callback(['stateError', undefined]);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Transcripts, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			var newGene = _.getIn(props.state, ['transcripts', 'gene']);
			if (newGene) {
				this.setState({ input: newGene });
			}
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var onImport = this.onImport,
			    getState = this.props.getState;

			// nested render to different DOM tree

			nav({ isPublic: true, getState: getState, onImport: onImport, onNavigate: this.onNavigate, activeLink: 'transcripts' });
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var state = this.props.state,
			    loadPending = state.loadPending,
			    stateError = state.stateError,
			    _ref2 = state.transcripts || {},
			    status = _ref2.status,
			    subtypes = _ref2.subtypes,
			    subtypeA = _ref2.subtypeA,
			    subtypeB = _ref2.subtypeB,
			    unit = _ref2.unit,
			    _ref2$zoom = _ref2.zoom,
			    zoom = _ref2$zoom === undefined ? {} : _ref2$zoom;

			if (loadPending) {
				return React.createElement(
					'p',
					{ style: { margin: 10 } },
					'Loading your view...'
				);
			}
			if (!subtypes) {
				return React.createElement(
					'h4',
					null,
					'Loading available subtypes...'
				);
			}

			var valueA = subtypeA ? subtypeA : subtypes[0],
			    valueB = subtypeB ? subtypeB : subtypes[subtypes.length - 1],
			    options = subtypes.map(function (name) {
				return React.createElement(
					'option',
					{ key: name, value: name },
					name
				);
			}),
			    unitLabels = {
				tpm: {
					dropdown: "TPM",
					axis: "log2 (TPM)"
				},
				isoformPercentage: {
					dropdown: "Isoform Percentage",
					axis: "Isoform Percentage"
				}
			};

			var _ref3 = state.transcripts || [],
			    genetranscripts = _ref3.genetranscripts;

			var genetranscriptsSorted = _.sortBy(genetranscripts, function (gtranscript) {
				// sort by start of transcript in transcript direction left to right
				// known issue: tie break
				return gtranscript.strand === '+' ? gtranscript.exonStarts[0] : -gtranscript.exonEnds[gtranscript.exonCount - 1];
				/*return _.sum(_.mmap(gtranscript.exonStarts, gtranscript.exonEnds, (exonStarts, exonEnds) => {
    	return exonStarts - exonEnds;
    }));*/ // sort by transcript size large to small
			}).map(function (t) {
				return _.assoc(t, 'zoom', zoom[t.name]);
			});

			//for the name column
			var transcriptNameData = _.map(genetranscriptsSorted, function (t) {
				return _.pick(t, 'name', 'exonCount', 'zoom');
			});

			//for the exon-intron visualization
			var transcriptExonData = _.map(genetranscriptsSorted, function (t) {
				return _.omit(t, ['chrom', 'expA', 'expB']);
			});

			// for the density plot
			var transcriptDensityData = {
				studyA: _.map(genetranscriptsSorted, function (t) {
					return { 'expA': t.expA.filter(function (x) {
							return !isNaN(x);
						}) };
				}),
				studyB: _.map(genetranscriptsSorted, function (t) {
					return { 'expB': t.expB.filter(function (x) {
							return !isNaN(x);
						}) };
				}),
				nameAndZoom: _.map(genetranscriptsSorted, function (t) {
					return _.pick(t, 'name', 'zoom');
				})
			};

			//calculation of max and min same as in DensityPlot.js and passing max, min as parameters to linearTicks
			var allData = _.flatten(_.pluck(transcriptDensityData.studyA, "expA").concat(_.pluck(transcriptDensityData.studyB, "expB")));
			var max = Math.max.apply(Math, (0, _toConsumableArray3.default)(allData));
			var min = Math.min.apply(Math, (0, _toConsumableArray3.default)(allData));
			var densityplotAxisLabel = isFinite(max) && isFinite(min) ? linearTicks(min, max) : [];
			var range = max - min;
			var hasPlots = genetranscripts && !_.isEmpty(genetranscripts);
			var dropdownBackgroundColorTop = hasPlots ? topColor : "white";
			var dropdownBackgroundColorBottom = hasPlots ? bottomColor : "white";
			var dropdownColor = hasPlots ? "white" : "black";

			return React.createElement(
				'div',
				{ className: styles.main },
				stateError ? React.createElement(StateError, { onHide: this.onHideError, error: stateError }) : null,
				React.createElement(
					'a',
					{ className: styles.selectorsLink, style: { fontSize: "0.85em" },
						href: 'https://ucsc-xena.gitbook.io/project/overview-of-features/transcript-view/' },
					'Help with transcripts'
				),
				React.createElement(
					'div',
					{ className: styles.selectors, style: { width: "1200px", height: "80px" } },
					React.createElement(
						'div',
						{ className: styles.geneBox, style: { float: "left", width: "300px" } },
						React.createElement(GeneSuggest, { assembly: 'hg38', label: 'Add Gene (e.g. KRAS)', value: this.state.input,
							onChange: function onChange(value) {
								_this2.setState({ input: value.trim(), updateButton: true });
							} })
					),
					this.state.updateButton ? React.createElement(
						'button',
						{ className: styles.horizontalSegmentButton, onClick: this.onLoadData },
						'Update Gene'
					) : null
				),
				React.createElement(
					'div',
					{ style: { width: "1200px", marginBottom: "40px" } },
					React.createElement(
						'div',
						{ style: { marginBottom: "10px" } },
						React.createElement(
							'span',
							{ className: styles.selectors },
							'Study A'
						),
						React.createElement(
							'select',
							{ ref: 'A', onChange: this.onLoadData, value: valueA,
								style: { color: dropdownColor, backgroundColor: dropdownBackgroundColorTop } },
							options
						),
						React.createElement(
							'span',
							{ className: styles.selectors },
							'Study B'
						),
						React.createElement(
							'select',
							{ ref: 'B', onChange: this.onLoadData, value: valueB,
								style: { color: dropdownColor, backgroundColor: dropdownBackgroundColorBottom } },
							options
						)
					),
					React.createElement(
						'div',
						null,
						React.createElement(
							'span',
							{ className: styles.selectors },
							'Expression Unit'
						),
						React.createElement(
							'select',
							{ ref: 'unit', onChange: this.onLoadData, value: unit },
							React.createElement(
								'option',
								{ value: 'tpm' },
								unitLabels.tpm.dropdown
							),
							React.createElement(
								'option',
								{ value: 'isoformPercentage' },
								unitLabels.isoformPercentage.dropdown
							)
						)
					)
				),
				hasPlots ? React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						{ className: styles["densityplot--label-div--zoom"], onClick: this.scaleZoom },
						React.createElement(
							'label',
							{ style: { fontSize: "0.85em", width: plotWidth } },
							unitLabels[unit].axis
						),
						React.createElement(
							'div',
							null,
							densityplotAxisLabel.map(function (label, i) {
								return React.createElement(
									'div',
									{ key: i },
									React.createElement(
										'label',
										{ className: styles["densityplot--label-x"], style: { left: (label - min) * plotWidth / range + 'px' } },
										label,
										unit === "isoformPercentage" && i === densityplotAxisLabel.length - 1 ? "%" : ""
									),
									React.createElement('div', { className: styles["densityplot--label-vertical-tick"], style: { left: (label - min) * plotWidth / range + 'px' } })
								);
							})
						),
						React.createElement('div', { className: styles["densityplot--label--axis-x"] })
					),
					React.createElement('div', { style: { width: "100%", height: "35px" } })
				) : null,
				React.createElement(
					'div',
					{ style: { position: 'relative' } },
					getStatusView(status, this.onLoadData),
					React.createElement(
						'div',
						{ className: styles[status || 'loaded'] + ' ' + styles.loadStatus },
						React.createElement(NameColumn, {
							data: transcriptNameData,
							gene: state.transcripts.gene
						}),
						genetranscripts && !_.isEmpty(genetranscripts) ? React.createElement(
							'label',
							{ className: styles["densityplot--label-y"] },
							'density'
						) : null,
						React.createElement(DensityPlot, {
							data: transcriptDensityData,
							getNameZoom: this.onZoom,
							max: max,
							min: min
						}),
						React.createElement(ExonsOnly, {
							data: transcriptExonData,
							getNameZoom: this.onZoom
						})
					)
				),
				React.createElement('div', { style: { clear: 'both' } })
			);
		}
	}]);
	return Transcripts;
}(React.Component);

var TranscriptsContainer = function (_React$Component2) {
	(0, _inherits3.default)(TranscriptsContainer, _React$Component2);

	function TranscriptsContainer() {
		var _ref4;

		var _temp2, _this3, _ret2;

		(0, _classCallCheck3.default)(this, TranscriptsContainer);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this3 = (0, _possibleConstructorReturn3.default)(this, (_ref4 = TranscriptsContainer.__proto__ || (0, _getPrototypeOf2.default)(TranscriptsContainer)).call.apply(_ref4, [this].concat(args))), _this3), _this3.getState = function () {
			return _.pick(_this3.props.state, 'version', 'page', 'transcripts');
		}, _temp2), (0, _possibleConstructorReturn3.default)(_this3, _ret2);
	}

	(0, _createClass3.default)(TranscriptsContainer, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    state = _props.state,
			    selector = _props.selector,
			    props = (0, _objectWithoutProperties3.default)(_props, ['state', 'selector']);

			return React.createElement(Transcripts, (0, _extends3.default)({}, (0, _extends3.default)({}, props, { state: selector(state) }), { getState: this.getState }));
		}
	}]);
	return TranscriptsContainer;
}(React.Component);

module.exports = TranscriptsContainer;