'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CanvasDrawing = require('../CanvasDrawing2');

var _CanvasDrawing2 = _interopRequireDefault(_CanvasDrawing);

var _color_helper = require('../color_helper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//// Styles
var compStyles = require('./BandLegend.module.css');

function draw(vg, opts) {
	var _opts$range = opts.range,
	    min = _opts$range.min,
	    max = _opts$range.max,
	    colorScale = opts.colorScale,
	    width = opts.width,
	    height = opts.zoom.height,
	    ctx = vg.context(),
	    img = ctx.createImageData(width, height);


	for (var i = 0; i < width; ++i) {
		var color = (0, _color_helper.rgb)(colorScale((max - min) * i / width + min));
		for (var j = 0; j < height + 4; ++j) {
			var k = 4 * (j * width + i);
			img.data[k] = color[0];
			img.data[k + 1] = color[1];
			img.data[k + 2] = color[2];
			img.data[k + 3] = 255;
		}
	}

	ctx.putImageData(img, 0, 0);
}

var addClass = function addClass(className) {
	return function (el, i) {
		return _react2.default.cloneElement(el, { className: className, key: i });
	};
};

var BandLegend = function (_React$Component) {
	(0, _inherits3.default)(BandLegend, _React$Component);

	function BandLegend() {
		(0, _classCallCheck3.default)(this, BandLegend);
		return (0, _possibleConstructorReturn3.default)(this, (BandLegend.__proto__ || (0, _getPrototypeOf2.default)(BandLegend)).apply(this, arguments));
	}

	(0, _createClass3.default)(BandLegend, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    range = _props.range,
			    multiScaled = _props.multiScaled,
			    width = _props.width,
			    height = _props.height,
			    footnotes = _props.footnotes,
			    colorScale = _props.colorScale,
			    labels = multiScaled ? { min: 'low', max: 'high' } : { min: range.min.toPrecision(2), max: range.max.toPrecision(2) },
			    drawing = _react2.default.createElement(_CanvasDrawing2.default, {
				style: { width: '100%', height: height },
				draw: draw,
				range: range,
				width: width,
				colorScale: colorScale,
				zoom: { height: height } });

			return _react2.default.createElement(
				'div',
				{ className: compStyles.Legend },
				_react2.default.createElement(
					'div',
					{ className: compStyles.container },
					_react2.default.createElement(
						'div',
						{ className: compStyles.right },
						labels.max
					),
					_react2.default.createElement(
						'div',
						{ className: compStyles.center },
						_react2.default.createElement(
							'div',
							{ className: compStyles.left },
							labels.min
						),
						_react2.default.createElement(
							'div',
							{ className: compStyles.center },
							drawing
						)
					)
				),
				footnotes ? footnotes.map(addClass(compStyles.footnotes)) : null
			);
		}
	}]);
	return BandLegend;
}(_react2.default.Component);

module.exports = BandLegend;