'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _menu = require('react-toolbox/lib/menu');

var _button = require('react-toolbox/lib/button');

var _link = require('react-toolbox/lib/link');

var _link2 = _interopRequireDefault(_link);

var _tooltip = require('react-toolbox/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _columnsParam = require('../columnsParam');

var _heatmapParam = require('../heatmapParam');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var konami = require('../konami');
var React = require('react');
var _ = require('../underscore_ext');
var Rx = require('../rx');

var _require = require('../bookmark'),
    createBookmark = _require.createBookmark,
    getRecent = _require.getRecent,
    setRecent = _require.setRecent;

var compStyles = require('./BookmarkMenu.module.css');
var gaEvents = require('../gaEvents');

// XXX This is a horrible work-around for react-toolbox menu limitations.
// We want the Bookmark MenuItem to not close the menu. Menu closes when
// a MenuItem is clicked by intercepting the onClick handler. However, it
// only intercepts onClick handlers of MenuItem children. By simply wrapping
// MenuItem, we avoid this.

var NoCloseMenuItem = function (_React$Component) {
	(0, _inherits3.default)(NoCloseMenuItem, _React$Component);

	function NoCloseMenuItem() {
		(0, _classCallCheck3.default)(this, NoCloseMenuItem);
		return (0, _possibleConstructorReturn3.default)(this, (NoCloseMenuItem.__proto__ || (0, _getPrototypeOf2.default)(NoCloseMenuItem)).apply(this, arguments));
	}

	(0, _createClass3.default)(NoCloseMenuItem, [{
		key: 'render',
		value: function render() {
			var otherProps = _.omit(this.props, 'tooltip');
			return React.createElement(_menu.MenuItem, otherProps);
		}
	}]);
	return NoCloseMenuItem;
}(React.Component);

var TooltipNoCloseMenuItem = (0, _tooltip2.default)(NoCloseMenuItem);

var privateWarning = 'Unable to create bookmark link due to private data in view. Use export instead';

var linking = false;

var BookmarkMenu = function (_React$Component2) {
	(0, _inherits3.default)(BookmarkMenu, _React$Component2);

	function BookmarkMenu() {
		var _ref;

		var _temp, _this2, _ret;

		(0, _classCallCheck3.default)(this, BookmarkMenu);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref = BookmarkMenu.__proto__ || (0, _getPrototypeOf2.default)(BookmarkMenu)).call.apply(_ref, [this].concat(args))), _this2), _this2.state = { loading: false, open: false, recent: false }, _this2.onRef = function (ref) {
			_this2.menuRef = ref;
		}, _this2.onBookmark = function () {
			gaEvents('bookmark', 'create');
			var getState = _this2.props.getState;

			_this2.setState({ loading: true });
			Rx.Observable.ajax({
				method: 'POST',
				url: '/api/bookmarks/bookmark',
				responseType: 'text',
				headers: {
					'X-CSRFToken': document.cookie.replace(/.*csrftoken=([0-9a-z]+)/, '$1'),
					'Content-Type': 'application/x-www-form-urlencoded'
				},
				body: 'content=' + encodeURIComponent(createBookmark(getState()))
			}).subscribe(_this2.onSetBookmark, function () {
				return _this2.setState({ loading: false });
			});
		}, _this2.onSetBookmark = function (resp) {
			var _JSON$parse = JSON.parse(resp.response),
			    id = _JSON$parse.id;

			setRecent(id);
			_this2.setState({ bookmark: location.href + '?bookmark=' + id, loading: false });
		}, _this2.onResetBookmark = function () {
			_this2.setState({ bookmark: null });
		}, _this2.onCopyBookmarkToClipboard = function () {
			_this2.bookmarkEl.select();
			document.execCommand('copy');
		}, _this2.onExport = function () {
			gaEvents('bookmark', 'export');
			var getState = _this2.props.getState;

			var url = URL.createObjectURL(new Blob([(0, _stringify2.default)(getState())], { type: 'application/json' }));
			var a = document.createElement('a');
			var filename = 'xenaState.json';
			_.extend(a, { id: filename, download: filename, href: url });
			document.body.appendChild(a);
			a.click();
			document.body.removeChild(a);
		}, _this2.onImport = function () {
			_this2.refs.import.click();
		}, _this2.onImportSelected = function (ev) {
			gaEvents('bookmark', 'import');
			var file = ev.target.files[0],
			    reader = new FileReader(),
			    onImport = _this2.props.onImport;


			reader.onload = function () {
				return onImport(reader.result);
			};
			reader.readAsText(file);
			ev.target.value = null;
		}, _this2.resetBookmark = function () {
			_this2.setState({ bookmark: null });
		}, _this2.onClick = function () {
			_this2.setState({ open: !(_this2.state.open || _this2.state.recent), recent: false });
		}, _this2.onRecent = function () {
			_this2.setState({ recent: !_this2.state.recent, open: false });
		}, _this2.onRecentHide = function () {
			_this2.setState({ recent: false });
		}, _this2.handleMenuHide = function () {
			_this2.setState({ open: false });
			if (_this2.props.onHide) {
				_this2.props.onHide();
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
	}

	(0, _createClass3.default)(BookmarkMenu, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var asciiC = 67;
			this.ksub = konami(asciiC).subscribe(function () {
				linking = true;
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.ksub.unsubscribe();
		}

		// RTB positions and clips the menu content according
		// to the initial menu render size, which causes problems
		// for dynamic content. This is a work-around which causes
		// the Menu component to re-calculate its size every time
		// we update.

	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			if (this.state.open && this.menuRef) {
				this.menuRef.show();
			}
		}
	}, {
		key: 'onViewBookmark',
		value: function onViewBookmark(id) {
			window.location = window.location.href + ('?bookmark=' + id);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _state = this.state,
			    bookmark = _state.bookmark,
			    loading = _state.loading,
			    open = _state.open,
			    recent = _state.recent,
			    _props = this.props,
			    isPublic = _props.isPublic,
			    getState = _props.getState,
			    recentBookmarks = getRecent(),
			    BookmarkElement = isPublic ? NoCloseMenuItem : TooltipNoCloseMenuItem;


			return React.createElement(
				'div',
				{ style: { display: 'inline', position: 'relative' } },
				React.createElement(
					_button.Button,
					{ onClick: this.onClick },
					'Bookmark'
				),
				React.createElement(
					_menu.Menu,
					{ innerRef: this.onRef, position: 'topLeft', active: open, onHide: this.handleMenuHide, className: compStyles.iconBookmark, iconRipple: false, onShow: this.resetBookmark },
					React.createElement(BookmarkElement, {
						tooltip: privateWarning,
						style: { pointerEvents: 'all' /* override MenuItem 'disabled' class */ },
						disabled: !isPublic,
						onClick: this.onBookmark,
						caption: 'Bookmark' }),
					recentBookmarks.length > (bookmark ? 1 : 0) ? React.createElement(_menu.MenuItem, { onClick: this.onRecent, title: null, caption: 'Recent bookmarks' }) : null,
					React.createElement(_menu.MenuItem, { onClick: this.onExport, title: null, caption: 'Export' }),
					React.createElement(_menu.MenuItem, { onClick: this.onImport, title: null, caption: 'Import' }),
					linking ? React.createElement(_link2.default, { target: '_blank', href: location.href.replace(/heatmap.*/, 'heatmap') + 'heatmap/?columns=' + (0, _columnsParam.getColumns)(getState()) + '&heatmap=' + (0, _heatmapParam.getHeatmap)(getState()), label: 'Link' }) : null,
					React.createElement(_link2.default, { className: compStyles.help, target: '_blank', href: 'https://ucsc-xena.gitbook.io/project/overview-of-features/bookmarks', label: 'Help' }),
					bookmark || loading ? React.createElement(_menu.MenuDivider, null) : null,
					bookmark || loading ? React.createElement(_menu.MenuItem, {
						onClick: bookmark ? this.onCopyBookmarkToClipboard : undefined,
						caption: bookmark ? 'Copy Bookmark' : 'Your Bookmark is Loading',
						disabled: !bookmark }) : null,
					bookmark ? React.createElement(
						'p',
						{ className: compStyles.warning },
						'Note: bookmarks are only guaranteed for 3 months after creation'
					) : null,
					React.createElement('input', { className: compStyles.bookmarkInput, ref: function ref(input) {
							return _this3.bookmarkEl = input;
						}, value: bookmark || '' }),
					React.createElement('input', { className: compStyles.importInput, ref: 'import', id: 'import', onChange: this.onImportSelected, type: 'file' })
				),
				React.createElement(
					_menu.Menu,
					{ onSelect: this.onViewBookmark,
						position: 'auto',
						active: recent && recentBookmarks.length > 0,
						className: compStyles.iconBookmark,
						iconRipple: false,
						onHide: this.onRecentHide },
					recentBookmarks.map(function (_ref2) {
						var id = _ref2.id,
						    time = _ref2.time;
						return React.createElement(_menu.MenuItem, { key: id, value: id, title: null, caption: time.replace(/ GMT.*/, '') + ' (' + id.slice(0, 4) + ')' });
					})
				)
			);
		}
	}]);
	return BookmarkMenu;
}(React.Component);

module.exports = BookmarkMenu;