'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Avatar displayed at top of wizard, col (visualization) and ghost cards. If ID is specified, avatar is shaded with
 * with grey background, otherwise avatar is displayed hollow with a dashed border.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B').
 */

// Core dependencies, components
var React = require('react');
var classNames = require('classnames');

// Styles
var compStyles = require('./CardAvatar.module.css');

var CardAvatar = function (_React$Component) {
  (0, _inherits3.default)(CardAvatar, _React$Component);

  function CardAvatar() {
    (0, _classCallCheck3.default)(this, CardAvatar);
    return (0, _possibleConstructorReturn3.default)(this, (CardAvatar.__proto__ || (0, _getPrototypeOf2.default)(CardAvatar)).apply(this, arguments));
  }

  (0, _createClass3.default)(CardAvatar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          colId = _props.colId,
          zoomCard = _props.zoomCard,
          ghost = !colId,
          noAvatar = zoomCard;

      return React.createElement(
        'div',
        { className: classNames((0, _defineProperty3.default)({}, compStyles.avatar, !noAvatar), (0, _defineProperty3.default)({}, compStyles.ghost, ghost), (0, _defineProperty3.default)({}, compStyles.noAvatar, noAvatar)) },
        colId
      );
    }
  }]);
  return CardAvatar;
}(React.Component);

module.exports = CardAvatar;