'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

var _underscore_ext = require('../underscore_ext');

var _underscore_ext2 = _interopRequireDefault(_underscore_ext);

require('./GeneSuggest.css');

var _XAutosuggest = require('./XAutosuggest');

var _XAutosuggest2 = _interopRequireDefault(_XAutosuggest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderInputComponent = function renderInputComponent(_ref) {
	var ref = _ref.ref,
	    _onChange = _ref.onChange,
	    props = (0, _objectWithoutProperties3.default)(_ref, ['ref', 'onChange']);
	return _react2.default.createElement(_input2.default, (0, _extends3.default)({
		spellCheck: false,
		innerRef: function innerRef(el) {
			return ref(el && el.inputNode);
		},
		onChange: function onChange(value, ev) {
			return _onChange(ev);
		},
		label: 'Search for a study'
	}, props));
}; // XXX rename file


var getSuggestions = function getSuggestions(value, cohorts) {
	var wordValues = value.toLowerCase().trim().split(/\s+/);
	return cohorts.filter(function (c) {
		return _underscore_ext2.default.every(wordValues, function (value) {
			return c.toLowerCase().indexOf(value) > -1;
		});
	}).sort();
};

var CohortSuggest = function (_PureComponent) {
	(0, _inherits3.default)(CohortSuggest, _PureComponent);

	function CohortSuggest() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, CohortSuggest);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = CohortSuggest.__proto__ || (0, _getPrototypeOf2.default)(CohortSuggest)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { suggestions: [], value: _this.props.cohort || "" }, _this.onSuggestionsFetchRequested = function (_ref3) {
			var value = _ref3.value;

			_this.setState({ suggestions: getSuggestions(value, _this.props.cohorts) });
		}, _this.onSuggestionsClearRequested = function () {
			_this.setState({ suggestions: [] });
		}, _this.onClear = function () {
			_this.setState({ value: '' });
			_underscore_ext2.default.defer(function () {
				return _this.props.onSelect(null);
			});
		}, _this.onChange = function (ev, _ref4) {
			var newValue = _ref4.newValue;

			_this.setState({ value: newValue });
		}, _this.onSelect = function (ev, _ref5) {
			var suggestionValue = _ref5.suggestionValue;

			// When props arrive we need to prefer user input, however that
			// prevents us setting state (setState here will be overwritten
			// by setState in componentWillReceiveProps, which will use the
			// old value of state). A horrible work-around is to defer
			// the call to onSelect. Similarly, with onClear, above.
			_this.setState({ value: '' });
			_underscore_ext2.default.defer(function () {
				return _this.props.onSelect(suggestionValue);
			});
		}, _this.onBlur = function () {
			_this.setState({ value: _this.props.cohort || _this.state.value });
		}, _this.shouldRenderSuggestions = function () {
			return true;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(CohortSuggest, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			var value = this.state.value || props.cohort || "";
			this.setState({
				value: value,
				suggestions: value.trim().length > 0 ? getSuggestions(value, props.cohorts) : []
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var onChange = this.onChange,
			    onBlur = this.onBlur,
			    _state = this.state,
			    suggestions = _state.suggestions,
			    value = _state.value;

			return _react2.default.createElement(_XAutosuggest2.default, {
				suggestions: suggestions,
				onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
				onSuggestionsClearRequested: this.onSuggestionsClearRequested,
				onSuggestionSelected: this.onSelect,
				getSuggestionValue: function getSuggestionValue(x) {
					return x;
				},
				shouldRenderSuggestions: this.shouldRenderSuggestions,
				renderSuggestion: function renderSuggestion(v) {
					return _react2.default.createElement(
						'span',
						null,
						v
					);
				},
				renderInputComponent: renderInputComponent,
				inputProps: { value: value, onChange: onChange, onBlur: onBlur },
				onClear: this.onClear,
				value: value });
		}
	}]);
	return CohortSuggest;
}(_PureComponent3.default);

module.exports = CohortSuggest;