'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _card = require('react-toolbox/lib/card');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Card displayed after (wizard-based) setup is complete, contains column visualization.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B').
 * controls - Icons and/or menu displayed at right of card title.
 * title - Text or element displayed as title.
 * subtitle - Text or element displayed as subtitle.
 * wizardMode - True if currently in wizard mode.
 */

// Core dependencies, components
var React = require('react');

var classNames = require('classnames');

// App dependencies
var CardAvatar = require('./CardAvatar');

// Styles
var compStyles = require('./ColCard.module.css');

var ColCard = function (_React$Component) {
	(0, _inherits3.default)(ColCard, _React$Component);

	function ColCard() {
		(0, _classCallCheck3.default)(this, ColCard);
		return (0, _possibleConstructorReturn3.default)(this, (ColCard.__proto__ || (0, _getPrototypeOf2.default)(ColCard)).apply(this, arguments));
	}

	(0, _createClass3.default)(ColCard, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    sortable = _props.sortable,
			    controls = _props.controls,
			    colId = _props.colId,
			    onClick = _props.onClick,
			    subtitle = _props.subtitle,
			    title = _props.title,
			    wizardMode = _props.wizardMode,
			    geneZoomed = _props.geneZoomed,
			    geneZoomPct = _props.geneZoomPct,
			    zoomCard = _props.zoomCard,
			    geneZoomText = geneZoomed ? 'Zoomed to ' + (geneZoomPct < 1 ? '< 1' : geneZoomPct) + '%' : '';

			return React.createElement(
				_card.Card,
				{ className: classNames('Column', (0, _defineProperty3.default)({}, compStyles.zoomCard, zoomCard)) },
				React.createElement(
					'div',
					{ className: classNames(compStyles.headerContainer, sortable && 'Sortable-handle') },
					React.createElement(CardAvatar, { colId: colId, zoomCard: zoomCard }),
					React.createElement(
						'div',
						{ className: compStyles.controls },
						controls,
						React.createElement('div', { className: classNames(compStyles.cover, (0, _defineProperty3.default)({}, compStyles.showOnHover, !wizardMode)) })
					)
				),
				React.createElement(
					'div',
					{ className: compStyles.titleContainer },
					React.createElement(_card.CardTitle, { className: compStyles.title, title: title, subtitle: subtitle }),
					geneZoomed ? React.createElement(
						'div',
						{ className: compStyles.zoomControl, onClick: onClick,
							title: geneZoomText },
						React.createElement(
							'span',
							null,
							geneZoomText
						),
						React.createElement(
							'i',
							{
								className: 'material-icons' },
							'cancel'
						)
					) : null
				),
				children
			);
		}
	}]);
	return ColCard;
}(React.Component);

module.exports = ColCard;