'use strict';

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _menu = require('react-toolbox/lib/menu');

var _tooltip = require('react-toolbox/lib/tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _refGeneExons = require('../refGeneExons');

var _refGeneExons2 = _interopRequireDefault(_refGeneExons);

var _geneLabelAnnotation = require('../geneLabelAnnotation');

var _staticIntervalTree = require('static-interval-tree');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('../underscore_ext');
var DefaultTextInput = require('./DefaultTextInput');
var DragSelect = require('./DragSelect');
var SpreadSheetHighlight = require('../SpreadSheetHighlight');
var ResizeOverlay = require('./ResizeOverlay');
var widgets = require('../columnWidgets');
var columnZoom = require('../columnZoom');
var aboutDatasetMenu = require('./aboutDatasetMenu');
var spinner = require('../ajax-loader.gif');
var mutationVector = require('../models/mutationVector');
//var ValidatedInput = require('./ValidatedInput');
var konami = require('../konami');
var Crosshair = require('./Crosshair');
var parsePos = require('../parsePos');

var _require = require('../colorScales'),
    categoryMore = _require.categoryMore;

var _require2 = require('../defaultServers'),
    publicServers = _require2.publicServers;

var ColCard = require('./ColCard');

var _require3 = require('../ChromPosition'),
    ChromPosition = _require3.ChromPosition;

var gaEvents = require('../gaEvents');
var crosshair = require('./cursor.png');
var ZoomHelpTag = require('./ZoomHelpTag');
var ZoomOverlay = require('./ZoomOverlay');
var config = require('../config');

var ESCAPE = 27;

var IconMenu = function (_React$Component) {
	(0, _inherits3.default)(IconMenu, _React$Component);

	function IconMenu() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, IconMenu);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = IconMenu.__proto__ || (0, _getPrototypeOf2.default)(IconMenu)).call.apply(_ref, [this].concat(args))), _this), _this.onKeyDown = function (ev) {
			if (ev.keyCode === ESCAPE) {
				_this.ref.handleMenuHide();
			}
		}, _this.onHide = function () {
			var onHide = _this.props.onHide;

			_this.cleanup();
			onHide && onHide();
		}, _this.onShow = function () {
			var onShow = _this.props.onShow;

			_this.curtain = document.createElement('div');
			_this.curtain.style = "position:absolute;top:0;left:0;width:100%;height:100%";
			document.body.appendChild(_this.curtain);
			document.addEventListener('keydown', _this.onKeyDown, false);
			onShow && onShow();
		}, _this.onRef = function (ref) {
			_this.ref = ref;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(IconMenu, [{
		key: 'cleanup',
		value: function cleanup() {
			// We get an onHide() call from setting state in Menu, *and*
			// from this.ref.handleMenuHide(), during this.onKeyDown. So,
			// check if 'curtain' still exists before tear down.
			if (this.curtain) {
				document.body.removeChild(this.curtain);
				document.removeEventListener('keydown', this.onKeyDown);
				delete this.curtain;
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.cleanup();
		}
	}, {
		key: 'render',
		value: function render() {
			var others = _.omit(this.props, 'onShow', 'onHide');
			return React.createElement(_menu.IconMenu, (0, _extends3.default)({ innerRef: this.onRef, onShow: this.onShow, onHide: this.onHide }, others));
		}
	}]);
	return IconMenu;
}(React.Component);

var TooltipMenuItem = (0, _tooltip2.default)(_menu.MenuItem);

var tooltipConfig = function tooltipConfig(message) {
	return {
		tooltipDelay: 750,
		tooltip: message,
		tooltipPosition: "horizontal",
		style: { pointerEvents: 'all' }
	};
};

// XXX move this?
function download(_ref2) {
	var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
	    fields = _ref3[0],
	    rows = _ref3[1];

	var txt = _.map([fields].concat(rows), function (row) {
		return row.join('\t');
	}).join('\n');
	// use blob for bug in chrome: https://code.google.com/p/chromium/issues/detail?id=373182
	var url = URL.createObjectURL(new Blob([txt], { type: 'text/tsv' }));
	var a = document.createElement('a');
	var filename = 'xenaDownload.tsv';
	_.extend(a, { id: filename, download: filename, href: url });
	document.body.appendChild(a);
	a.click();
	document.body.removeChild(a);
}

function downloadJSON(downloadData) {
	// use blob for bug in chrome: https://code.google.com/p/chromium/issues/detail?id=373182
	var url = URL.createObjectURL(new Blob([(0, _stringify2.default)(downloadData /*, undefined, 4*/)], { type: 'text/json' }));
	var a = document.createElement('a');
	var filename = 'xenaDownload.json';
	_.extend(a, { id: filename, download: filename, href: url });
	document.body.appendChild(a);
	a.click();
	document.body.removeChild(a);
}

var annotationHeight = 47,
    positionHeight = 17,
    scaleHeight = 12;

var styles = {
	status: {
		pointerEvents: 'none',
		textAlign: 'center',
		zIndex: 1,
		position: 'absolute',
		top: 0,
		left: 0,
		width: '100%',
		height: '100%',
		backgroundColor: 'rgba(255, 255, 255, 0.6)'
	},
	error: {
		textAlign: 'center',
		pointerEvents: 'all',
		cursor: 'pointer'
	}
};

// Manually set focus to avoid triggering dropdown (close) or anchor
// (navigate) actions.
/*var setFocus = ev => {
	ev.preventDefault();
	ev.stopPropagation();
	ev.target.focus();
};

var stopPropagation = ev => ev.stopPropagation();
*/

var addIdsToArr = function addIdsToArr(arr) {
	var list = arr.filter(function (el) {
		return el;
	}).map(function (el, id) {
		return React.cloneElement(el, { key: id });
	});
	return _.isEmpty(list) ? null : list;
};
var isIntString = function isIntString(str) {
	return !!str.trim().replace(/,/g, '').match(/^[0-9]+$/);
};
var parseExtendedInt = function parseExtendedInt(str) {
	return parseInt(str.trim().replace(/,/g, ''), 10);
};

var boundIsValid = _.curry(function (maxXZoom, str) {
	if (!maxXZoom) {
		return false; // no data
	}
	if (str.trim() === '') {
		return true;
	}
	if (!isIntString(str)) {
		// must be an int if it's not empty string
		return false;
	}
	var pos = parseExtendedInt(str);

	return maxXZoom.start <= pos && pos <= maxXZoom.end;
});

/*function zoomMenu(props) {
	var {column} = props,
		{xzoom, maxXZoom, assembly} = column,
		{start, end} = xzoom || maxXZoom || {start: 0, end: 0},
		bIV = boundIsValid(maxXZoom);
	return [
		<MenuItem header style={{fontSize: '80%'}}>Start position ( {assembly} )</MenuItem>,
		<MenuItem>
			<ValidatedInput defaultValue={start} isValid={bIV} ref='start' onSelect={stopPropagation} onClick={setFocus} type='text' bsSize='small' />
		</MenuItem>,
		<MenuItem header style={{fontSize: '80%'}}>End position ( {assembly} )</MenuItem>,
		<MenuItem>
			<ValidatedInput defaultValue={end} isValid={bIV} ref='end' onSelect={stopPropagation} onClick={setFocus} type='text' bsSize='small' />
		</MenuItem>];
}*/

function sortVisibleLabel(column, pos) {
	var sortVisible = _.get(column, 'sortVisible', true);

	return sortVisible ? pos ? 'Sort by full region avg' : 'Sort by gene average' : 'Sort by zoom region avg';
}

function segmentedVizOptions(onVizOptions) {
	return onVizOptions ? [React.createElement(_menu.MenuDivider, null), React.createElement(_menu.MenuItem, { onSelect: onVizOptions, 'data-renderer': 'line', caption: 'Line' }), React.createElement(_menu.MenuItem, { onSelect: onVizOptions, 'data-renderer': 'pixel', caption: 'Pixel' }), React.createElement(_menu.MenuItem, { onSelect: onVizOptions, 'data-renderer': 'power', caption: 'Power' }), React.createElement(_menu.MenuDivider, null)] : [];
}

function segmentedMenu(props, _ref4) {
	var onShowIntrons = _ref4.onShowIntrons,
	    onSortVisible = _ref4.onSortVisible,
	    onSpecialDownload = _ref4.onSpecialDownload,
	    onVizOptions = _ref4.onVizOptions;
	var column = props.column,
	    data = props.data,
	    pos = parsePos(column.fields[0]),
	    _column$showIntrons = column.showIntrons,
	    showIntrons = _column$showIntrons === undefined ? false : _column$showIntrons,
	    noData = !_.get(data, 'req'),
	    sortVisibleItemName = sortVisibleLabel(column, pos),
	    intronsItemName = showIntrons ? 'Hide introns' : "Show introns",
	    specialDownloadItemName = 'Download segments';


	return addIdsToArr([].concat((0, _toConsumableArray3.default)(pos ? [] : [React.createElement(_menu.MenuItem, { disabled: noData, onClick: onShowIntrons, caption: intronsItemName })]), (0, _toConsumableArray3.default)(segmentedVizOptions(onVizOptions)), [
	//...(xzoomable ? zoomMenu(props, {onSortVisible}) : []),
	React.createElement(_menu.MenuItem, { disabled: noData, onClick: onSortVisible, caption: sortVisibleItemName }), React.createElement(_menu.MenuItem, { disabled: noData, onClick: onSpecialDownload, caption: specialDownloadItemName })]));
}

function mutationMenu(props, _ref5) {
	var onMuPit = _ref5.onMuPit,
	    onShowIntrons = _ref5.onShowIntrons,
	    onSortVisible = _ref5.onSortVisible;
	var column = props.column,
	    data = props.data,
	    pos = parsePos(column.fields[0]),
	    valueType = column.valueType,
	    sortVisible = column.sortVisible,
	    assembly = column.assembly,
	    _column$showIntrons2 = column.showIntrons,
	    showIntrons = _column$showIntrons2 === undefined ? false : _column$showIntrons2,
	    rightValueType = valueType === 'mutation',
	    wrongDataSubType = column.fieldType !== 'mutation',
	    rightAssembly = ["hg19", "hg38", "GRCh37", "GRCh38"].indexOf(assembly) !== -1 ? true : false,
	    noMuPit = !rightValueType || !rightAssembly || !!wrongDataSubType || !!pos,
	    noData = !_.get(data, 'req'),
	    mupitItemName = noData ? 'MuPIT 3D Loading' : 'MuPIT 3D (' + assembly + ' coding)',
	    sortVisibleItemName = sortVisible ? 'Sort using full region' : 'Sort using zoom region',
	    intronsItemName = showIntrons ? 'Hide introns' : "Show introns",
	    mupitMenuItem = null;


	if (data && !_.isEmpty(data.refGene)) {
		mupitMenuItem = pos ? React.createElement(TooltipMenuItem, (0, _extends3.default)({ disabled: noMuPit }, tooltipConfig("Only available for gene view"), { caption: mupitItemName })) : noMuPit ? React.createElement(TooltipMenuItem, (0, _extends3.default)({ disabled: noMuPit }, tooltipConfig("Only available for SNPs on hg19 and hg38"), { caption: mupitItemName })) : React.createElement(_menu.MenuItem, { onClick: function onClick(e) {
				return onMuPit(assembly, e);
			}, caption: mupitItemName });
	}

	return addIdsToArr([mupitMenuItem, pos ? null : React.createElement(_menu.MenuItem, { disabled: noData, onClick: onShowIntrons, caption: intronsItemName }),
	//...(xzoomable ? zoomMenu(props, {onSortVisible}) : []),
	React.createElement(_menu.MenuItem, { disabled: noData, onClick: onSortVisible, caption: sortVisibleItemName })]);
}

var isSig = function isSig(column) {
	return column.fetchType === 'signature';
};

function tumorMapCompatible(column) {
	var fieldType = column.fieldType,
	    dsID = column.dsID,
	    fields = column.fields;
	// link to tumorMap from any public xena hub columns
	// data be queried directly from xena

	var foundPublicHub = dsID && publicServers.indexOf(JSON.parse(dsID).host) !== -1;

	// The intent is to support anything that can be queried as a single value
	// with (xena-query {:select}). Here 'fields' is the fields or probes list.
	// We can only send a single probe, so check for length 1. Note in
	// particular the case of an ensembl genes probemap, which is a geneProbes
	// column with probe list of one, which is supported.
	// We can't support gene average, so no 'genes' columns.
	if (!foundPublicHub || ['geneProbes', 'probes', 'clinical'].indexOf(fieldType) === -1 || isSig(column) || fields.length !== 1) {
		return false;
	}

	return true;
}

var isChrom = function isChrom(column) {
	return parsePos(_.get(column.fieldList || column.fields, 0), _.getIn(column, ['assembly']));
};

// Maybe put in a selector.
var supportsGeneAverage = function supportsGeneAverage(column) {
	return !isChrom(column) && !isSig(column) && _.contains(['geneProbes', 'genes'], column.fieldType) && (column.fieldList || column.fields).length === 1;
};

// Duplicated in denseMatrix.js, because of the weirdness with
// fields vs. probes.
var supportsClustering = function supportsClustering(_ref6) {
	var fieldType = _ref6.fieldType,
	    fields = _ref6.fields;
	return _.contains(['genes', 'probes', 'geneProbes'], fieldType) && fields.length > 2;
};

function matrixMenu(props, _ref7) {
	var onTumorMap = _ref7.onTumorMap,
	    thisTumorMap = _ref7.thisTumorMap,
	    onMode = _ref7.onMode,
	    onCluster = _ref7.onCluster;
	var column = props.column,
	    fieldType = column.fieldType,
	    clustering = column.clustering,
	    supportTumorMap = thisTumorMap && tumorMapCompatible(column),
	    order = clustering == null ? 'Cluster' : 'Uncluster';


	return addIdsToArr([supportsClustering(column) ? React.createElement(_menu.MenuItem, { onClick: onCluster, caption: order, disabled: config.singlecell }) : null, supportsGeneAverage(column) ? fieldType === 'genes' ? React.createElement(_menu.MenuItem, { onClick: function onClick(e) {
			return onMode(e, 'geneProbes');
		}, caption: 'Detailed view' }) : React.createElement(_menu.MenuItem, { onClick: function onClick(e) {
			return onMode(e, 'genes');
		}, caption: 'Gene average' }) : null, supportTumorMap ? React.createElement(_menu.MenuItem, { onClick: function onClick(e) {
			return onTumorMap(thisTumorMap, e);
		}, caption: 'Tumor Map' }) : null]);
}

// We could try to drive this from the column widgets, but it gets rather complex making
// the widgets care about a menu in their container.
function optionMenu(props, opts) {
	var valueType = props.column.valueType;

	return (valueType === 'mutation' ? mutationMenu : valueType === 'segmented' ? segmentedMenu : matrixMenu)(props, opts);
}

function getStatusView(status, onReload) {
	if (status === 'loading') {
		return React.createElement(
			'div',
			{ 'data-xena': 'loading', style: styles.status },
			React.createElement('img', { style: { textAlign: 'center' }, src: spinner })
		);
	}
	if (status === 'error') {
		return React.createElement(
			'div',
			{ style: styles.status },
			React.createElement(
				'i',
				{ onClick: onReload,
					style: styles.error,
					title: 'Error loading data. Click to reload.',
					'aria-hidden': 'true',
					className: 'material-icons' },
				'warning'
			)
		);
	}
	return null;
}

function getPosition(maxXZoom, pStart, pEnd) {
	if (!boundIsValid(maxXZoom, pStart) || !boundIsValid(maxXZoom, pEnd)) {
		return false;
	}

	var _ref8 = pStart < pEnd ? [pStart, pEnd] : [pEnd, pStart],
	    _ref9 = (0, _slicedToArray3.default)(_ref8, 2),
	    start = _ref9[0],
	    end = _ref9[1];

	start = start.trim() === '' ? maxXZoom.start : parseExtendedInt(start);
	end = end.trim() === '' ? maxXZoom.end : parseExtendedInt(end);

	return maxXZoom.start <= start && start <= end && end <= maxXZoom.end ? { start: start, end: end } : null;
}

var specialDownloadMenu = false;
//var annotationHelpText =  'Drag zoom. Shift-click zoom out.';

if (process.env.NODE_ENV !== 'production') {
	specialDownloadMenu = true;
}

// For geneProbes we will average across probes to compute KM. For
// other types, we can't support multiple fields.
function disableKM(column, hasSurvival) {
	if (!hasSurvival) {
		return [true, 'No survival data for cohort'];
	}
	// XXX need to refactor column.fields & column.fieldList
	if ((column.fieldList || column.fields).length > 1) {
		return [true, 'Unsupported for multiple genes/ids'];
	}
	return [false, ''];
}

function disableChart(column) {
	if (_.contains(['mutation', 'SV'], column.fieldType)) {
		return true;
	}
	return false;
}

function getCodingVariants(index, exons) {
	var resultSet = new _set2.default();

	exons.forEach(function (_ref10) {
		var _ref11 = (0, _slicedToArray3.default)(_ref10, 2),
		    start = _ref11[0],
		    end = _ref11[1];

		(0, _staticIntervalTree.matches)(index, { start: start, end: end }).forEach(function (item) {
			return resultSet.add(item.variant);
		});
	});

	return [].concat((0, _toConsumableArray3.default)(resultSet));
}

function filterExonsByCDS(exonStarts, exonEnds, cdsStart, cdsEnd) {
	return _.zip(exonStarts, exonEnds).filter(function (_ref12) {
		var _ref13 = (0, _slicedToArray3.default)(_ref12, 2),
		    start = _ref13[0],
		    end = _ref13[1];

		return !(end < cdsStart || start > cdsEnd);
	}).map(function (_ref14) {
		var _ref15 = (0, _slicedToArray3.default)(_ref14, 2),
		    start = _ref15[0],
		    end = _ref15[1];

		return [Math.max(start, cdsStart), Math.min(end, cdsEnd)];
	});
}

var geneHeight = function geneHeight() {
	return annotationHeight + scaleHeight + 4;
};

var showPosition = function showPosition(column) {
	return _.contains(['segmented', 'mutation', 'SV', 'geneProbes'], column.fieldType) && _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) !== 'regulon';
};

var showGeneLabel = function showGeneLabel(column) {
	return _.contains(['genes', 'probes', 'clinical'], column.fieldType) || column.fieldType === 'geneProbes' && _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) === 'regulon';
};

// Drag mapped to: direction, samples start, samples end, indicator start, indicator end (where indicator is either
// annotation or sample zoom), offset x, offset y, samples height
// Select mapped to: direction, data start and data end
var zoomTranslateSelection = function zoomTranslateSelection(props, selection, zone) {
	var column = props.column,
	    yZoom = props.zoom,
	    crosshair = selection.crosshair,
	    start = selection.start,
	    end = selection.end,
	    offset = selection.offset,
	    fieldType = column.fieldType,
	    annotated = showPosition(column),
	    direction = columnZoom.direction({ fieldType: fieldType, start: start, end: end, zone: zone }),
	    startEndPx = columnZoom.startEndPx({ direction: direction, start: start, end: end }),
	    overlay = columnZoom.overlay((0, _extends3.default)({ annotated: annotated, column: column, direction: direction, fieldType: fieldType }, startEndPx, { zone: zone })),
	    zoomTo = columnZoom.zoomTo((0, _extends3.default)({ annotated: annotated, column: column, direction: direction, fieldType: fieldType }, overlay, { yZoom: yZoom }));


	return {
		crosshair: crosshair,
		direction: direction,
		offset: offset,
		overlay: overlay,
		zone: zone,
		zoomTo: zoomTo
	};
};

var Column = function (_PureComponent) {
	(0, _inherits3.default)(Column, _PureComponent);

	function Column() {
		var _ref16;

		var _temp2, _this2, _ret2;

		(0, _classCallCheck3.default)(this, Column);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref16 = Column.__proto__ || (0, _getPrototypeOf2.default)(Column)).call.apply(_ref16, [this].concat(args))), _this2), _this2.state = {
			dragZoom: {},
			subColumnIndex: {},
			specialDownloadMenu: specialDownloadMenu
		}, _this2.enableHiddenFeatures = function () {
			specialDownloadMenu = true;
			_this2.setState({ specialDownloadMenu: true });
		}, _this2.toggleInteractive = function (interactive) {
			_this2.props.onInteractive('zoom', interactive);
		}, _this2.onMouseMove = function (e) {
			var column = _this2.props.column,
			    width = column.width,
			    subColumnIndex = _this2.state.subColumnIndex;


			if (!_.isEmpty(subColumnIndex)) {
				var aveSize = subColumnIndex.aveSize,
				    laneNum = Math.ceil(column.fields.length / (width / aveSize)),
				    subColumnWidth = width / column.fields.length;

				if (laneNum <= _geneLabelAnnotation.maxLane) {
					var offsetX = e.clientX - e.currentTarget.getBoundingClientRect().left,
					    index = Math.floor(offsetX / subColumnWidth);

					_this2.setState({ subColumnIndex: (0, _extends3.default)({}, _this2.state.subColumnIndex, {
							index: index,
							mousing: true
						}) });
				}
			}
		}, _this2.onMouseOut = function () {
			var subColumnIndex = _this2.state.subColumnIndex;
			if (!_.isEmpty(subColumnIndex)) {
				_this2.setState({ subColumnIndex: (0, _extends3.default)({}, _this2.state.subColumnIndex, {
						index: -1,
						mousing: false
					}) });
			}
		}, _this2.initSubColumnIndex = function () {
			var column = _this2.props.column;

			if (_.contains(['probes', 'genes'], column.fieldType) || _.getIn(column, ['dataset', 'probemapMeta', 'dataSubType']) === 'regulon') {
				var aveSize = _geneLabelAnnotation.geneLableFont * (column.fields.reduce(function (total, x) {
					return total + (x ? x.length : 0);
				}, 0) / column.fields.length);

				_this2.setState({ subColumnIndex: {
						index: -1,
						aveSize: aveSize,
						mousing: false
					} });
			}
		}, _this2.onResizeStop = function (size) {
			_this2.props.onResize(_this2.props.id, size);
		}, _this2.onRemove = function () {
			_this2.props.onRemove(_this2.props.id);
		}, _this2.onDownload = function () {
			var _this2$props = _this2.props,
			    column = _this2$props.column,
			    data = _this2$props.data,
			    samples = _this2$props.samples,
			    index = _this2$props.index,
			    sampleFormat = _this2$props.sampleFormat;

			gaEvents('spreadsheet', 'download', 'column');
			download(widgets.download({ column: column, data: data, samples: samples, index: index, sampleFormat: sampleFormat }));
		}, _this2.onViz = function () {
			_this2.props.onViz(_this2.props.id);
		}, _this2.onEdit = function () {
			_this2.props.onEdit(_this2.props.id);
		}, _this2.onKm = function () {
			gaEvents('spreadsheet', 'km');
			_this2.props.onKm(_this2.props.id);
		}, _this2.onChart = function () {
			gaEvents('spreadsheet', 'columnChart-open');
			_this2.props.onChart(_this2.props.id);
		}, _this2.onSortDirection = function () {
			var newDir = _.get(_this2.props.column, 'sortDirection', 'forward') === 'forward' ? 'reverse' : 'forward';
			_this2.props.onSortDirection(_this2.props.id, newDir);
		}, _this2.onMode = function (ev, newMode) {
			_this2.props.onMode(_this2.props.id, newMode);
		}, _this2.onColumnLabel = function (value) {
			_this2.props.onColumnLabel(_this2.props.id, value);
		}, _this2.onFieldLabel = function (value) {
			_this2.props.onFieldLabel(_this2.props.id, value);
		}, _this2.onShowIntrons = function () {
			_this2.props.onShowIntrons(_this2.props.id);
		}, _this2.onCluster = function () {
			_this2.props.onCluster(_this2.props.id, _this2.props.column.clustering ? undefined : 'probes', _this2.props.data);
		}, _this2.onDragZoom = function (selection, zone) {
			_this2.toggleInteractive(false);
			var translatedSelection = zoomTranslateSelection(_this2.props, selection, zone);
			_this2.setState({ dragZoom: { selection: translatedSelection } });
		}, _this2.onDragZoomSelect = function (selection, zone) {
			_this2.toggleInteractive(true);
			var _this2$props2 = _this2.props,
			    id = _this2$props2.id,
			    onXZoom = _this2$props2.onXZoom,
			    onYZoom = _this2$props2.onYZoom,
			    zoom = _this2$props2.zoom,
			    translatedSelection = zoomTranslateSelection(_this2.props, selection, zone),
			    h = translatedSelection.direction === 'h',
			    zoomTo = translatedSelection.zoomTo;

			_this2.setState({ dragZoom: {} });
			h ? onXZoom(id, { start: zoomTo.start, end: zoomTo.end }) : onYZoom(_.merge(zoom, zoomTo));
		}, _this2.onSortVisible = function () {
			var _this2$props3 = _this2.props,
			    id = _this2$props3.id,
			    column = _this2$props3.column;

			var value = _.get(column, 'sortVisible', column.valueType === 'segmented' ? true : false);
			_this2.props.onSortVisible(id, !value);
		}, _this2.onSpecialDownload = function () {
			var _this2$props4 = _this2.props,
			    column = _this2$props4.column,
			    data = _this2$props4.data,
			    samples = _this2$props4.samples,
			    index = _this2$props4.index,
			    sampleFormat = _this2$props4.sampleFormat,
			    _widgets$specialDownl = widgets.specialDownload({ column: column, data: data, samples: samples, index: index, sampleFormat: sampleFormat }),
			    type = _widgets$specialDownl.type,
			    downloadData = _widgets$specialDownl.downloadData;

			if (type === "txt") {
				download(downloadData);
			} else if (type === "json") {
				downloadJSON(downloadData);
			}
		}, _this2.onXZoomClear = function () {
			var _this2$props5 = _this2.props,
			    id = _this2$props5.id,
			    maxXZoom = _this2$props5.column.maxXZoom,
			    onXZoom = _this2$props5.onXZoom,
			    position = getPosition(maxXZoom, '', '');

			onXZoom(id, position);
		}, _this2.onMenuToggle = function (open) {
			var xzoomable = _this2.state.xzoomable,
			    _this2$props6 = _this2.props,
			    _this2$props6$column = _this2$props6.column,
			    xzoom = _this2$props6$column.xzoom,
			    maxXZoom = _this2$props6$column.maxXZoom,
			    valueType = _this2$props6$column.valueType,
			    onXZoom = _this2$props6.onXZoom,
			    id = _this2$props6.id;

			if (xzoomable && !open && ['mutation', 'segmented'].indexOf(valueType) !== -1) {
				var start = _this2.refs.start.getValue(),
				    end = _this2.refs.end.getValue(),
				    position = getPosition(maxXZoom, start, end);

				if (position && !_.isEqual(position, xzoom)) {
					onXZoom(id, position);
				}
			}
		}, _this2.onMuPit = function (assembly) {
			// Construct the url, which will be opened in new window
			// total = newRows.length,
			// k fixed at 1000
			// gene, protein, etc size is fixed at 1000
			// this could be actual size of protein or gene, but it is complicated due to mutations could be from exon region and display could be genomics region
			// for the same gene it is a constant, does it really matter to be different between genes?
			var k = 1000,
			    indexByPos = _this2.props.index.byPosition,
			    _$values$ = _.values(_this2.props.data.refGene)[0],
			    exonStarts = _$values$.exonStarts,
			    exonEnds = _$values$.exonEnds,
			    cdsStart = _$values$.cdsStart,
			    cdsEnd = _$values$.cdsEnd;


			var exons = filterExonsByCDS(exonStarts, exonEnds, cdsStart, cdsEnd),
			    variants = getCodingVariants(indexByPos, exons); //coding variants

			var SNVPs = mutationVector.SNVPvalue(variants, variants.length, k);
			if (_this2.props.column.xzoom) {
				var _this2$props$column$x = _this2.props.column.xzoom,
				    zoomStart = _this2$props$column$x.start,
				    zoomEnd = _this2$props$column$x.end;

				SNVPs = _.filter(SNVPs, function (value) {
					var valueStart = parseInt(value.start);
					return valueStart >= zoomStart && valueStart <= zoomEnd;
				});
			}

			var uriList = _.map(SNVPs, function (n) {
				return n.chr + ':' + n.start + ':' + (1 - n.pValue);
			}).join(','),
			    mupitUrl = {
				"hg19": 'http://hg19.cravat.us/MuPIT_Interactive?gm=', // mupit hg19 server
				"GRCh37": 'http://hg19.cravat.us/MuPIT_Interactive?gm=', // mupit hg19 server
				"hg38": 'http://mupit.icm.jhu.edu/MuPIT_Interactive?gm=', //mupit hg38 server
				"GRCh38": 'http://mupit.icm.jhu.edu/MuPIT_Interactive?gm=' //mupit hg38 server
			},
			    url = mupitUrl[assembly];

			window.open(url + ('' + uriList));
		}, _this2.onTumorMap = function (tumorMap) {
			// TumorMap/Xena API https://tumormap.ucsc.edu/query/addAttributeXena.html
			var _this2$props7 = _this2.props,
			    data = _this2$props7.data,
			    column = _this2$props7.column,
			    valueType = column.valueType,
			    url = "https://tumormap.ucsc.edu/?xena=addAttr&p=" + tumorMap.map + "&layout=" + tumorMap.layout;


			var ds = JSON.parse(_this2.props.column.dsID),
			    hub = ds.host,
			    dataset = ds.name,
			    feature = _this2.props.column.fields[0],
			    // gene or probe
			customColors = _.getIn(column, ['colors', 0, 2]);

			url = url + "&hub=" + hub + "/data/";
			url = url + "&dataset=" + dataset;
			url = url + "&attr=" + feature;

			if (valueType === "coded") {
				var codes = _.getIn(data, ['codes']),
				    cat,
				    colorhex;
				_.map(codes, function (code, i) {
					cat = code;
					colorhex = customColors ? customColors[i] : categoryMore[i % categoryMore.length];
					colorhex = colorhex.slice(1, colorhex.length);
					url = url + "&cat=" + encodeURIComponent(cat);
					url = url + "&color=" + colorhex;
				});
			}

			window.open(url);
		}, _this2.onReload = function () {
			_this2.props.onReload(_this2.props.id);
		}, _this2.getControlWidth = function () {
			return 90;
			//		return 136;
		}, _this2.onAbout = function (ev, host, dataset) {
			ev.preventDefault();
			_this2.props.onAbout(host, dataset);
		}, _temp2), (0, _possibleConstructorReturn3.default)(_this2, _ret2);
	}

	//	addAnnotationHelp(target) {
	//		var tooltip = (
	//			<Tooltip>
	//				{annotationHelpText}
	//			</Tooltip>
	//		);
	//		return (
	//			<OverlayTrigger trigger={['hover']} placement='top' overlay={tooltip}>
	//				{target}
	//			</OverlayTrigger>);
	//	},


	(0, _createClass3.default)(Column, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var asciiA = 65;
			this.ksub = konami(asciiA).subscribe(this.enableHiddenFeatures);
			this.initSubColumnIndex();
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.ksub.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    first = _props.first,
			    id = _props.id,
			    label = _props.label,
			    samples = _props.samples,
			    samplesMatched = _props.samplesMatched,
			    column = _props.column,
			    index = _props.index,
			    zoom = _props.zoom,
			    data = _props.data,
			    fieldFormat = _props.fieldFormat,
			    sampleFormat = _props.sampleFormat,
			    hasSurvival = _props.hasSurvival,
			    searching = _props.searching,
			    onClick = _props.onClick,
			    tooltip = _props.tooltip,
			    wizardMode = _props.wizardMode,
			    onReset = _props.onReset,
			    interactive = _props.interactive,
			    append = _props.append,
			    cohort = _props.cohort,
			    tumorMap = _props.tumorMap,
			    _state = this.state,
			    specialDownloadMenu = _state.specialDownloadMenu,
			    dragZoom = _state.dragZoom,
			    subColumnIndex = _state.subColumnIndex,
			    selection = dragZoom.selection,
			    width = column.width,
			    dataset = column.dataset,
			    columnLabel = column.columnLabel,
			    fieldLabel = column.fieldLabel,
			    user = column.user,
			    onMode = this.onMode,
			    onTumorMap = this.onTumorMap,
			    onMuPit = this.onMuPit,
			    onCluster = this.onCluster,
			    onShowIntrons = this.onShowIntrons,
			    onSortVisible = this.onSortVisible,
			    onSpecialDownload = this.onSpecialDownload,
			    thisTumorMap = _.getIn(tumorMap, [cohort.name]),
			    menu = optionMenu(this.props, { onMode: onMode, onMuPit: onMuPit, onTumorMap: onTumorMap, thisTumorMap: thisTumorMap, onShowIntrons: onShowIntrons, onSortVisible: onSortVisible,
				onCluster: onCluster, onSpecialDownload: onSpecialDownload, specialDownloadMenu: specialDownloadMenu, isSig: isSig }),
			    geneZoomable = columnZoom.supportsGeneZoom(column),
			    geneZoomed = columnZoom.geneZoomed(column),
			    geneZoomPct = Math.round(columnZoom.geneZoomLength(column) / columnZoom.maxGeneZoomLength(column) * 100),
			    _disableKM = disableKM(column, hasSurvival),
			    _disableKM2 = (0, _slicedToArray3.default)(_disableKM, 2),
			    kmDisabled = _disableKM2[0],
			    kmTitle = _disableKM2[1],
			    chartDisabled = disableChart(column),
			    status = _.get(data, 'status'),
			    refreshIcon = React.createElement(
				'i',
				{ className: 'material-icons', onClick: onReset },
				'close'
			),
			    annotation = showPosition(column) ? React.createElement(_refGeneExons2.default, {
				id: id,
				column: column,
				position: _.getIn(column, ['layout', 'chrom', 0]),
				refGene: _.getIn(data, ['refGene'], {}),
				probePosition: column.position,
				tooltip: tooltip,
				layout: column.layout,
				height: annotationHeight,
				positionHeight: column.position ? positionHeight : 0,
				width: width,
				mode: isChrom(column) ? "coordinate" : _.getIn(column, ['showIntrons']) === true ? "geneIntron" : "geneExon" }) : null,
			    scale = showPosition(column) ? React.createElement(ChromPosition, {
				layout: column.layout,
				width: width,
				scaleHeight: scaleHeight,
				mode: isChrom(column) ? "coordinate" : _.getIn(column, ['showIntrons']) === true ? "geneIntron" : "geneExon" }) : null,
			    geneLabel = showGeneLabel(column) ? React.createElement(_geneLabelAnnotation.GeneLabelAnnotation, {
				width: width,
				height: annotationHeight + scaleHeight,
				list: column.fields,
				subColumnIndex: this.state.subColumnIndex }) : null;

			// FF 'button' tag will not emit 'mouseenter' events (needed for
			// tooltips) for children. We must use a different tag, e.g. 'label'.
			// Button and Dropdown.Toggle will allow overriding the tag.  However
			// Splitbutton will not pass props down to the underlying Button, so we
			// can't use Splitbutton.
			// XXX put position into a css module


			return React.createElement(
				'div',
				{ style: { width: width, position: 'relative' } },
				React.createElement(
					ZoomOverlay,
					{ geneHeight: geneHeight(), height: zoom.height,
						positionHeight: column.position ? positionHeight : 0, selection: selection },
					React.createElement(
						ColCard,
						{ colId: label,
							sortable: !first,
							title: React.createElement(DefaultTextInput, {
								disabled: !interactive,
								onChange: this.onColumnLabel,
								value: { default: columnLabel, user: user.columnLabel } }),
							subtitle: React.createElement(DefaultTextInput, {
								disabled: !interactive,
								onChange: this.onFieldLabel,
								value: { default: fieldLabel, user: user.fieldLabel } }),
							onClick: this.onXZoomClear,
							geneZoomPct: geneZoomPct,
							geneZoomed: geneZoomable && geneZoomed,
							controls: !interactive ? first ? refreshIcon : null : React.createElement(
								'div',
								null,
								first ? null : React.createElement(
									IconMenu,
									{ icon: 'more_vert', menuRipple: true, iconRipple: false },
									menu,
									menu && React.createElement(_menu.MenuDivider, null),
									React.createElement(_menu.MenuItem, { title: kmTitle, onClick: this.onKm, disabled: kmDisabled,
										caption: 'Kaplan Meier Plot' }),
									React.createElement(_menu.MenuItem, { onClick: this.onChart, disabled: chartDisabled,
										caption: 'Chart & Statistics' }),
									React.createElement(_menu.MenuItem, { onClick: this.onSortDirection, caption: 'Reverse sort' }),
									React.createElement(_menu.MenuItem, { onClick: this.onDownload, caption: 'Download' }),
									aboutDatasetMenu(this.onAbout, _.get(dataset, 'dsID')),
									React.createElement(_menu.MenuItem, { onClick: this.onViz, caption: 'Display' }),
									React.createElement(_menu.MenuItem, { disabled: !this.props.onEdit, onClick: this.onEdit, caption: 'Edit' }),
									React.createElement(_menu.MenuItem, { onClick: this.onRemove, caption: 'Remove' })
								)
							),
							wizardMode: wizardMode },
						React.createElement(
							'div',
							{ style: { cursor: selection ? 'none' : annotation ? 'url(' + crosshair + ') 12 12, crosshair' : 'default', height: geneHeight() } },
							React.createElement(
								DragSelect,
								{ enabled: !wizardMode,
									onDrag: function onDrag(s) {
										return _this3.onDragZoom(s, 'a');
									}, onSelect: function onSelect(s) {
										return _this3.onDragZoomSelect(s, 'a');
									} },
								annotation ? React.createElement(
									'div',
									null,
									scale,
									React.createElement('div', { style: { height: 2 } }),
									annotation
								) : geneLabel
							)
						),
						React.createElement(
							ResizeOverlay,
							{
								enable: interactive,
								onResizeStop: this.onResizeStop,
								width: width,
								minWidth: this.getControlWidth,
								height: zoom.height },
							React.createElement(SpreadSheetHighlight, {
								animate: searching,
								width: width,
								height: zoom.height,
								samples: samples.slice(zoom.index, zoom.index + zoom.count),
								samplesMatched: samplesMatched }),
							React.createElement(
								'div',
								{ style: { position: 'relative' }, onMouseMove: this.onMouseMove, onMouseOut: this.onMouseOut },
								React.createElement(
									Crosshair,
									{ frozen: !interactive || this.props.frozen, mousing: subColumnIndex.mousing, geneHeight: geneHeight(), height: zoom.height, selection: selection },
									React.createElement(
										DragSelect,
										{ enabled: !wizardMode,
											onDrag: function onDrag(s) {
												return _this3.onDragZoom(s, 's');
											}, onSelect: function onSelect(s) {
												return _this3.onDragZoomSelect(s, 's');
											} },
										widgets.column({ ref: 'plot', id: id, column: column, data: data, index: index, zoom: zoom, samples: samples, onClick: onClick, fieldFormat: fieldFormat, sampleFormat: sampleFormat, tooltip: tooltip })
									),
									getStatusView(status, this.onReload),
									React.createElement(ZoomHelpTag, { column: column, selection: selection })
								)
							)
						)
					)
				),
				append
			);
		}
	}]);
	return Column;
}(_PureComponent3.default);

module.exports = Column;