'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Column add component, displayed between column cards and after last column card. Used as click handler for inserting
 * or adding new card.
 *
 * State
 * -----
 * actionKey - Index of add column.
 * height - Height of add column component.
 * last - True if add column is after the last visualization column.
 *
 * Actions
 * -------
 * onClick - called on click of component.
 * onHover - called on mouse over and mouse out on component.
 */

// Core dependencies, components
var React = require('react');
var classNames = require('classnames');

// Styles
var compStyles = require('./ColumnAdd.module.css');

var ColumnAdd = function (_React$Component) {
	(0, _inherits3.default)(ColumnAdd, _React$Component);

	function ColumnAdd() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ColumnAdd);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ColumnAdd.__proto__ || (0, _getPrototypeOf2.default)(ColumnAdd)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
			_this.props.onClick(_this.props.actionKey);
		}, _this.onMouseOut = function () {
			var _this$props = _this.props,
			    last = _this$props.last,
			    onHover = _this$props.onHover,
			    actionKey = _this$props.actionKey;

			if (!last) {
				onHover(actionKey, false);
			}
		}, _this.onMouseOver = function () {
			var _this$props2 = _this.props,
			    last = _this$props2.last,
			    onHover = _this$props2.onHover,
			    actionKey = _this$props2.actionKey;

			if (!last) {
				onHover(actionKey, true);
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ColumnAdd, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    show = _props.show,
			    last = _props.last;

			return React.createElement(
				'div',
				{ className: classNames(compStyles.ColumnAdd, (0, _defineProperty3.default)({}, compStyles.last, last && show)),
					style: { visibility: show ? 'visible' : 'hidden' },
					onClick: this.onClick,
					onMouseOut: this.onMouseOut,
					onMouseOver: this.onMouseOver },
				React.createElement(
					'div',
					{ className: compStyles.text },
					'Click to ',
					last ? 'Add' : 'Insert',
					' Column'
				)
			);
		}
	}]);
	return ColumnAdd;
}(React.Component);

module.exports = ColumnAdd;