'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _XAutosuggest = require('./XAutosuggest');

var _XAutosuggest2 = _interopRequireDefault(_XAutosuggest);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RETURN = 13;
var returnPressed = function returnPressed(ev) {
	return ev.keyCode === RETURN;
};

var renderInputComponent = function renderInputComponent(_ref) {
	var ref = _ref.ref,
	    _onChange = _ref.onChange,
	    label = _ref.label,
	    error = _ref.error,
	    props = (0, _objectWithoutProperties3.default)(_ref, ['ref', 'onChange', 'label', 'error']);
	return _react2.default.createElement(
		_input2.default,
		(0, _extends3.default)({
			spellCheck: false,
			innerRef: function innerRef(el) {
				return ref(el && el.inputNode);
			},
			onChange: function onChange(value, ev) {
				return _onChange(ev);
			},
			label: label || 'Enter concept or text'
		}, props),
		_react2.default.createElement(
			'i',
			{ style: { color: 'red', opacity: error ? 1 : 0 }, className: 'material-icons' },
			'error'
		)
	);
};

var ConceptSuggest = function (_PureComponent) {
	(0, _inherits3.default)(ConceptSuggest, _PureComponent);

	function ConceptSuggest() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ConceptSuggest);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = ConceptSuggest.__proto__ || (0, _getPrototypeOf2.default)(ConceptSuggest)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { suggestions: [], value: '' }, _this.onSuggestionsFetchRequested = function (_ref3) {
			var value = _ref3.value;

			// need to trim value?
			var concepts = _this.props.concepts,
			    lcv = value.toLowerCase();

			_this.setState({ suggestions: concepts.filter(function (c) {
					return c.toLowerCase().indexOf(lcv) !== -1;
				}) });
		}, _this.onSuggestionsClearRequested = function () {
			_this.setState({ suggestions: [] });
		}, _this.onChange = function (ev, _ref4) {
			var newValue = _ref4.newValue,
			    method = _ref4.method;

			// Don't update the value for 'up' and 'down' keys. If we do update
			// the value, it gives us an in-place view of the suggestion (pasting
			// the value into the input field), but the drawback is that it moves
			// the cursor to the end of the line. This messes up multi-word input.
			// We could try to preserve the cursor position, perhaps by passing a
			// custom input renderer. But for now, just don't update the value for
			// these events.
			if (method !== 'up' && method !== 'down') {
				_this.setState({ value: newValue });
			}
		}, _this.onKeyDown = function (ev) {
			var value = ev.target.value.trim();
			if (returnPressed(ev) && value.length > 0) {
				_this.props.onAddTerm(value);
				_this.setState({ value: '' });
			}
		}, _this.getSuggestionValue = function (suggestion) {
			return suggestion;
		}, _this.shouldRenderSuggestions = function (value) {
			return value.trim().length > 2;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ConceptSuggest, [{
		key: 'render',
		value: function render() {
			var onChange = this.onChange,
			    onKeyDown = this.onKeyDown,
			    _props = this.props,
			    label = _props.label,
			    error = _props.error,
			    _state = this.state,
			    suggestions = _state.suggestions,
			    value = _state.value;


			return _react2.default.createElement(_XAutosuggest2.default, {
				inputRef: this.setInput,
				suggestions: suggestions,
				renderSuggestion: function renderSuggestion(v) {
					return _react2.default.createElement(
						'span',
						null,
						v
					);
				},
				onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
				onSuggestionsClearRequested: this.onSuggestionsClearRequested,
				getSuggestionValue: this.getSuggestionValue,
				shouldRenderSuggestions: this.shouldRenderSuggestions,
				renderInputComponent: renderInputComponent,
				inputProps: { value: value, label: label, error: error, onKeyDown: onKeyDown, onChange: onChange } });
		}
	}]);
	return ConceptSuggest;
}(_PureComponent3.default);

exports.default = ConceptSuggest;