'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'); /**
                               * UCSC Xena Client
                               * http://xena.ucsc.edu
                               *
                               * Crosshair component.
                               */

// Core dependencies, components

var _require = require('react-overlays'),
    Portal = _require.Portal;

// Styles


var compStyles = require('./Crosshair.module.css');
var classNames = require('classnames');

var Crosshair = function (_PureComponent) {
	(0, _inherits3.default)(Crosshair, _PureComponent);

	function Crosshair() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Crosshair);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Crosshair.__proto__ || (0, _getPrototypeOf2.default)(Crosshair)).call.apply(_ref, [this].concat(args))), _this), _this.state = { mousing: false, x: -1, y: -1 }, _this.onMouseMove = function (ev) {
			var x = ev.clientX - ev.currentTarget.getBoundingClientRect().left;
			if (!_this.props.frozen) {
				_this.setState({ mousing: true, x: x, y: ev.clientY });
			}
		}, _this.onMouseOut = function () {
			if (!_this.props.frozen) {
				_this.setState({ mousing: false });
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Crosshair, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			if (!nextProps.frozen && !nextProps.mousing) {
				this.setState({ mousing: false, x: -1, y: -1 });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _state = this.state,
			    mousing = _state.mousing,
			    x = _state.x,
			    y = _state.y,
			    onMouseMove = this.onMouseMove,
			    onMouseOut = this.onMouseOut,
			    _props = this.props,
			    frozen = _props.frozen,
			    geneHeight = _props.geneHeight,
			    height = _props.height,
			    selection = _props.selection,
			    children = _props.children,
			    zoomMode = selection ? true : false,
			    cursor = zoomMode ? 'none' : frozen ? 'default' : 'none';

			if (selection) {
				var crosshair = selection.crosshair,
				    offset = selection.offset,
				    zone = selection.zone,
				    xZoomTarget = crosshair.x - 6,
				    yZoomTarget = crosshair.y - 6,
				    crosshairVHeight = geneHeight + 8 + height,
				    crosshairVTop = zone === 'a' ? offset.y - 8 : offset.y - geneHeight - 8;
			}
			var getCrosshairVClassName = function getCrosshairVClassName(zoomMode) {
				var _classNames;

				return classNames((_classNames = {}, (0, _defineProperty3.default)(_classNames, compStyles.crosshairV, !zoomMode), (0, _defineProperty3.default)(_classNames, compStyles.inspectCrosshair, !zoomMode), (0, _defineProperty3.default)(_classNames, compStyles.zoomCrosshairV, zoomMode), _classNames));
			};
			var getCrosshairHClassName = function getCrosshairHClassName(zoomMode) {
				var _classNames2;

				return classNames((_classNames2 = {}, (0, _defineProperty3.default)(_classNames2, compStyles.crosshairH, !zoomMode), (0, _defineProperty3.default)(_classNames2, compStyles.inspectCrosshair, !zoomMode), (0, _defineProperty3.default)(_classNames2, compStyles.zoomCrosshairH, zoomMode), _classNames2));
			};
			return React.createElement(
				'div',
				{ style: { cursor: cursor }, onMouseMove: onMouseMove, onMouseOut: onMouseOut },
				children,
				zoomMode || mousing ? React.createElement('div', {
					className: classNames(compStyles.crosshair, getCrosshairVClassName(zoomMode)),
					style: { bottom: zoomMode ? 'unset' : 0, left: zoomMode ? crosshair.x : x, height: zoomMode ? crosshairVHeight : height, top: zoomMode ? crosshairVTop : 'unset' } }) : null,
				zoomMode ? React.createElement('div', { className: classNames(compStyles.crosshair, compStyles.crosshairTarget),
					style: { left: xZoomTarget, top: yZoomTarget } }) : null,
				zoomMode || mousing ? React.createElement(
					Portal,
					{ container: document.body },
					React.createElement(
						'div',
						{ className: classNames(compStyles.crosshairs) },
						React.createElement('span', {
							className: classNames(compStyles.crosshair, getCrosshairHClassName(zoomMode)),
							style: { top: zoomMode ? crosshair.y : y } })
					)
				) : null
			);
		}
	}]);
	return Crosshair;
}(_PureComponent3.default);

module.exports = Crosshair;