'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
/*
 * Text input element with a default value which will
 * - Style the text if the user has entered a non-default value
 * - Restore the default if the user deletes the text
 */

// Core dependencies, components

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

// Comp styles


var compStyles = require('./DefaultTextInput.module.css');

var DefaultTextInput = function (_PureComponent) {
	(0, _inherits3.default)(DefaultTextInput, _PureComponent);

	function DefaultTextInput() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, DefaultTextInput);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DefaultTextInput.__proto__ || (0, _getPrototypeOf2.default)(DefaultTextInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = { value: _this.props.value.user, focused: false }, _this.resetIfNull = function () {
			var _this$props = _this.props,
			    onChange = _this$props.onChange,
			    defaultValue = _this$props.value['default'],
			    val = _this.refs.input.value;


			if (val === "") {
				_this.setState({ value: defaultValue });
				onChange(defaultValue);
			}
		}, _this.onBlur = function () {
			_this.setState({ focused: false });
			_this.resetIfNull();
		}, _this.onFocus = function () {
			_this.setState({ focused: true });
		}, _this.update = function () {
			var onChange = _this.props.onChange,
			    value = _this.state.value;


			onChange(value);
		}, _this.onKeyUp = function (ev) {
			if (ev.key === 'Enter' && _this) {
				_this.resetIfNull();
				_this.refs.input.blur();
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(DefaultTextInput, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var events = rxEvents(this, 'change');
			this.change = events.change.do(function () {
				return _this2.setState({ value: _this2.refs.input.value });
			}).debounceTime(100).subscribe(this.update);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.change.unsubscribe();
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			this.setState({ value: newProps.value.user });
		}
	}, {
		key: 'render',
		value: function render() {
			var _state = this.state,
			    value = _state.value,
			    focused = _state.focused,
			    _props$disabled = this.props.disabled,
			    disabled = _props$disabled === undefined ? false : _props$disabled;


			return React.createElement(
				'span',
				{ style: { position: 'relative' } },
				React.createElement(
					'label',
					{ className: focused ? compStyles.labelFocused : compStyles.label },
					'Customize label'
				),
				React.createElement('input', {
					className: focused ? compStyles.inputFocused : compStyles.input,
					spellCheck: false,
					ref: 'input',
					disabled: disabled,
					onChange: this.on.change,
					onKeyUp: this.onKeyUp,
					onBlur: this.onBlur,
					onFocus: this.onFocus,
					type: 'text',
					title: value,
					value: value })
			);
		}
	}]);
	return DefaultTextInput;
}(_PureComponent3.default);

module.exports = DefaultTextInput;