'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

var _XAutosuggest = require('./XAutosuggest');

var _XAutosuggest2 = _interopRequireDefault(_XAutosuggest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

var _ = require('../underscore_ext');
require('./GeneSuggest.css'); // XXX rename file
var lcs = require('../lcs');

var XRadioGroup = require('./XRadioGroup');

function toLCWords(str) {
	return str.toLowerCase().split(/[ \t]/);
}

function applyBias(bias, x) {
	return x > 0 ? (x - 1) * bias + 1 : 0;
}

// tag and input are ordered lists of words, from strings that have
// been normalized to lower case, and split on whitespace.
//
// We count each word match. We count multiple word matches more
// strongly than a sum of the word matches. We count ordered
// word matches more strongly than multiple word matches

var multiWordBias = 1.5,
    orderBias = 1.7;
function scoreTag(tag, input) {
	var matches = _.intersection(tag, input),
	    wordBiased = applyBias(multiWordBias, matches.length),
	    ordered = matches.length > 0 ? lcs(tag, input) : 0;

	return wordBiased * applyBias(orderBias, ordered);
}

function scoreCohorts(cohortMeta, tags, weights) {
	return tags.reduce(function (cohorts, tag, i) {
		var w = weights[i];
		if (w > 0) {
			cohortMeta[tag].forEach(function (cohort) {
				return cohorts[cohort] = (cohorts[cohort] || 0) + w;
			});
		}
		return cohorts;
	}, {});
}

// Return list of cohorts ordered by strength of match to input.
function match(cohortMeta, input) {
	//eslint-disable-line no-unused-vars
	var tags = (0, _keys2.default)(cohortMeta),
	    normInput = toLCWords(input),
	    normTags = tags.map(toLCWords),
	    weights = normTags.map(function (t) {
		return scoreTag(t, normInput);
	}),
	    cohortScores = scoreCohorts(cohortMeta, tags, weights);

	return (0, _keys2.default)(cohortScores).sort(function (c, d) {
		return cohortScores[d] - cohortScores[c];
	});
}

function scoreTag2(tag, input) {
	var matches = _.intersection(tag, input),
	    wordBiased = applyBias(multiWordBias, matches.length),
	    ordered = matches.length > 0 ? lcs(tag, input) : 0;

	return { matches: matches.sort(), tag: tag, weight: wordBiased * applyBias(orderBias, ordered) };
}

// For each set of matched input words, pick the highest-scoring match
function scoreCohorts2(cohortMeta, tags, weights) {
	//eslint-disable-line no-unused-vars
	var byCohort = _.groupBy(_.flatmap(cohortMeta, function (cohorts, tag) {
		return cohorts.map(function (cohort) {
			return { cohort: cohort, tag: tag };
		});
	}), 'cohort'),
	    tagWeights = _.object(tags, weights),
	    cohortWeights = _.map(byCohort, function (cohortTags, cohort) {
		var cohortTagWeights = _.pick(tagWeights, _.pluck(cohortTags, 'tag')),
		    groups = _.map(_.groupBy(cohortTagWeights, 'matches'), function (weights) {
			return _.maxWith(weights, function (x, y) {
				return x.weight - y.weight;
			});
		}).filter(function (_ref) {
			var weight = _ref.weight;
			return weight > 0;
		});
		return { cohort: cohort, weight: _.sum(_.pluck(groups, 'weight')), groups: groups };
	});
	return _.sortBy(cohortWeights.filter(function (_ref2) {
		var weight = _ref2.weight;
		return weight > 0;
	}), function (_ref3) {
		var weight = _ref3.weight;
		return -weight;
	});
}

// For each set of matched input words, pick the highest-scoring match,
// scale by number of matches for the set / total tag count for the cohort
function scoreCohorts3(cohortMeta, tags, weights) {
	//eslint-disable-line no-unused-vars
	var byCohort = _.groupBy(_.flatmap(cohortMeta, function (cohorts, tag) {
		return cohorts.map(function (cohort) {
			return { cohort: cohort, tag: tag };
		});
	}), 'cohort'),
	    tagWeights = _.object(tags, weights),
	    cohortWeights = _.map(byCohort, function (cohortTags, cohort) {
		var cohortTagWeights = _.pick(tagWeights, _.pluck(cohortTags, 'tag')),
		    groups = _.map(_.groupBy(cohortTagWeights, 'matches'), function (weights) {
			return _.updateIn(_.maxWith(weights, function (x, y) {
				return x.weight - y.weight;
			}), ['weight'], function (w) {
				return w * weights.length / Math.sqrt(cohortTags.length);
			});
		}).filter(function (_ref4) {
			var weight = _ref4.weight;
			return weight > 0;
		});
		return { cohort: cohort, weight: _.sum(_.pluck(groups, 'weight')), groups: groups };
	});
	return _.sortBy(cohortWeights.filter(function (_ref5) {
		var weight = _ref5.weight;
		return weight > 0;
	}), function (_ref6) {
		var weight = _ref6.weight;
		return -weight;
	});
}

// XXX
var DEBUG = false;
//var scoreFn = scoreCohorts2;
var scoreFn = scoreCohorts3;
// XXX

function matchSimplified(cohortMeta, input) {
	var tags = (0, _keys2.default)(cohortMeta),
	    normInput = toLCWords(input),
	    normTags = tags.map(toLCWords),
	    weights = normTags.map(function (t) {
		return scoreTag2(t, normInput);
	});

	//return scoreFn(cohortMeta, tags, weights);

	// cohort's matching weight is linearly normalized (multiplication) by the number of normalized input found divided by the length of the inputs
	var ma = scoreFn(cohortMeta, tags, weights);
	ma.map(function (maObj) {
		var matchedPerCohort = _.flatten(maObj.groups.map(function (g) {
			return g.matches;
		}));
		var foundLength = normInput.filter(function (i) {
			return matchedPerCohort.indexOf(i) !== -1;
		}).length;
		maObj.weight = maObj.weight * foundLength / normInput.length;
	});
	ma = _.sortBy(ma, function (maObj) {
		return maObj.weight;
	}).reverse();
	return ma;
}

// match by logical AND, instead of a scoring system
function matchExact(cohortMeta, input) {
	//eslint-disable-line no-unused-vars
	var tags = (0, _keys2.default)(cohortMeta),
	    normInput = toLCWords(input),
	    matches = tags.filter(function (tag) {
		return _.contains(normInput, tag.toLowerCase());
	});
	return _.intersection.apply(_, (0, _toConsumableArray3.default)(matches.map(function (t) {
		return cohortMeta[t];
	})));
}

// Return the start and end indices of the word in 'value'
// under the cursor position.
function currentWordPosition(value, position) {
	var li = value.slice(0, position).lastIndexOf(' '),
	    i = li === -1 ? 0 : li + 1,
	    lj = value.slice(position).indexOf(' '),
	    j = lj === -1 ? value.length : position + lj;
	return [i, j];
}

// Return the word in 'value' under the cursor position
function currentWord(value, position) {
	var _currentWordPosition = currentWordPosition(value, position),
	    _currentWordPosition2 = (0, _slicedToArray3.default)(_currentWordPosition, 2),
	    i = _currentWordPosition2[0],
	    j = _currentWordPosition2[1];

	return value.slice(i, j);
}

var renderInputComponent = function renderInputComponent(_ref7) {
	var ref = _ref7.ref,
	    _onChange = _ref7.onChange,
	    props = (0, _objectWithoutProperties3.default)(_ref7, ['ref', 'onChange']);
	return React.createElement(_input2.default, (0, _extends3.default)({
		spellCheck: false,
		innerRef: function innerRef(el) {
			return ref(el && el.inputNode);
		},
		onChange: function onChange(value, ev) {
			return _onChange(ev);
		},
		label: 'Primary Disease or Tissue of Origin'
	}, props));
};

var DiseaseSuggest = function (_PureComponent) {
	(0, _inherits3.default)(DiseaseSuggest, _PureComponent);

	function DiseaseSuggest() {
		var _ref8;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, DiseaseSuggest);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref8 = DiseaseSuggest.__proto__ || (0, _getPrototypeOf2.default)(DiseaseSuggest)).call.apply(_ref8, [this].concat(args))), _this), _this.state = { suggestions: [], value: "" }, _this.onSuggestionsFetchRequested = function (_ref9) {
			var value = _ref9.value;
			var position = _this.input.selectionStart,
			    word = currentWord(value, position),
			    lcValue = word.toLowerCase(),
			    cohortMeta = _this.props.cohortMeta,
			    tags = (0, _keys2.default)(cohortMeta);

			_this.setState({
				suggestions: _.filter(tags, function (t) {
					return t.toLowerCase().indexOf(lcValue) === 0;
				})
			});
		}, _this.onSuggestionsClearRequested = function () {
			_this.setState({ suggestions: [] });
		}, _this.onChange = function (ev, _ref10) {
			var newValue = _ref10.newValue,
			    method = _ref10.method;

			// Don't update the value for 'up' and 'down' keys. If we do update
			// the value, it gives us an in-place view of the suggestion (pasting
			// the value into the input field), but the drawback is that it moves
			// the cursor to the end of the line. This messes up multi-word input.
			// We could try to preserve the cursor position, perhaps by passing a
			// custom input renderer. But for now, just don't update the value for
			// these events.
			if (method !== 'up' && method !== 'down') {
				_this.setState({ value: newValue });
			}
		}, _this.onSelect = function (ev, _ref11) {
			var suggestionValue = _ref11.suggestionValue;

			_this.setState({ value: suggestionValue });
		}, _this.onClear = function () {
			_this.setState({ value: "" });
		}, _this.onCohort = function (value) {
			_this.props.onSelect(value);
		}, _this.shouldRenderSuggestions = function () {
			return true;
		}, _this.getSuggestionValue = function (suggestion) {
			var position = _this.input.selectionStart,
			    value = _this.input.value,
			    _currentWordPosition3 = currentWordPosition(value, position),
			    _currentWordPosition4 = (0, _slicedToArray3.default)(_currentWordPosition3, 2),
			    i = _currentWordPosition4[0],
			    j = _currentWordPosition4[1];

			// splice the suggestion into the current word
			return value.slice(0, i) + suggestion + value.slice(j);
		}, _this.setInput = function (input) {
			_this.input = input;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(DiseaseSuggest, [{
		key: 'render',
		value: function render() {
			var onChange = this.onChange,
			    _state = this.state,
			    suggestions = _state.suggestions,
			    value = _state.value,
			    _props = this.props,
			    cohortMeta = _props.cohortMeta,
			    cohort = _props.cohort,
			    results = matchSimplified(cohortMeta, value);

			var buildStudyDebugLabel = function buildStudyDebugLabel(c, weight, groups) {
				var groupsText = groups.map(function (_ref12) {
					var tag = _ref12.tag,
					    weight = _ref12.weight;
					return tag.join(' ') + ' ' + weight.toPrecision(2);
				});
				return c + ' [' + weight.toPrecision(2) + ' ' + groupsText + ']';
			};
			var studyProps = {
				label: 'Study',
				value: cohort,
				onChange: this.onCohort,
				options: results.map(function (_ref13) {
					var c = _ref13.cohort,
					    weight = _ref13.weight,
					    groups = _ref13.groups;

					return {
						label: DEBUG ? buildStudyDebugLabel(c, weight, groups) : c,
						value: c
					};
				})
			};
			return React.createElement(
				'div',
				null,
				React.createElement(_XAutosuggest2.default, {
					inputRef: this.setInput,
					suggestions: suggestions,
					onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
					onSuggestionsClearRequested: this.onSuggestionsClearRequested,
					onSuggestionSelected: this.onSelect,
					getSuggestionValue: this.getSuggestionValue,
					shouldRenderSuggestions: this.shouldRenderSuggestions,
					renderSuggestion: function renderSuggestion(v) {
						return React.createElement(
							'span',
							null,
							v
						);
					},
					renderInputComponent: renderInputComponent,
					inputProps: { value: value, onChange: onChange },
					value: value,
					onClear: this.onClear }),
				results.length > 0 ? React.createElement(XRadioGroup, studyProps) : null
			);
		}
	}]);
	return DiseaseSuggest;
}(_PureComponent3.default);

module.exports = DiseaseSuggest;