'use strict';

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
//var ReactDOM = require('react-dom');
var Rx = require('../rx');
var _ = require('../underscore_ext');

var styles = {
	wrapper: {
		position: 'relative'
	}
};

var clip = function clip(min, max, x) {
	return x < min ? min : x > max ? max : x;
};

function crosshairXPos(target, ev, width) {
	var bb = target.getBoundingClientRect();
	return clip(bb.left, bb.left + width - 1, ev.clientX);
}

function crosshairYPos(target, ev, height) {
	var bb = target.getBoundingClientRect();
	return clip(bb.top, bb.top + height - 1, ev.clientY);
}

function targetXPos(target, ev, width) {
	var bb = target.getBoundingClientRect();
	return clip(0, width - 1, ev.clientX - bb.left);
}

function targetYPos(target, ev, height) {
	var bb = target.getBoundingClientRect();
	return clip(0, height - 1, ev.clientY - bb.top);
}

// Browsers give us coordinates that aren't always within the element. We
// would expect coords [0, width - 1] to indicate which pixel the mouse is over,
// but sometimes get coords outside that range.
//
// We clip start and end to [0, width - 1].

var DragSelect = function (_React$Component) {
	(0, _inherits3.default)(DragSelect, _React$Component);

	function DragSelect() {
		(0, _classCallCheck3.default)(this, DragSelect);
		return (0, _possibleConstructorReturn3.default)(this, (DragSelect.__proto__ || (0, _getPrototypeOf2.default)(DragSelect)).apply(this, arguments));
	}

	(0, _createClass3.default)(DragSelect, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var mousedown = new Rx.Subject();
			var mousedrag = mousedown.flatMap(function (down) {
				var target = down.currentTarget,
				    bb = target.getBoundingClientRect(),
				    startX = targetXPos(target, down, bb.width),
				    startY = targetYPos(target, down, bb.height),
				    selection;

				return Rx.Observable.fromEvent(window, 'mousemove').map(function (mm) {
					var width = bb.width,
					    height = bb.height,
					    endX = targetXPos(target, mm, width),
					    endY = targetYPos(target, mm, height),
					    crosshairX = crosshairXPos(target, mm, width),
					    crosshairY = crosshairYPos(target, mm, height);


					selection = {
						start: { x: startX, y: startY },
						end: { x: endX, y: endY },
						offset: { x: bb.left, y: bb.top },
						crosshair: { x: crosshairX, y: crosshairY }
					};
					return (0, _extends3.default)({ dragging: true }, selection);
				}).takeUntil(Rx.Observable.fromEvent(window, 'mouseup')).concat(Rx.Observable.defer(function () {
					return Rx.Observable.of({ selection: selection });
				}));
			});
			this.subscription = mousedrag.subscribe(function (ev) {
				var dragging = ev.dragging,
				    selection = (0, _objectWithoutProperties3.default)(ev, ['dragging']);

				if (dragging) {
					_this2.props.onDrag && _this2.props.onDrag(selection);
				}
				if (ev.selection) {
					_this2.props.onSelect && _this2.props.onSelect(ev.selection);
				}
			});
			this.dragStart = function (ev) {
				return _this2.props.enabled && mousedown.next(ev);
			};
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.subscription.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var containerProps = _.omit(this.props, 'onSelect', 'enabled');
			return React.createElement(
				'div',
				(0, _extends3.default)({}, containerProps, { style: styles.wrapper, onMouseDown: this.dragStart }),
				this.props.children
			);
		}
	}]);
	return DragSelect;
}(React.Component);

DragSelect.defaultProps = { enabled: true };


module.exports = DragSelect;