'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _XAutosuggest = require('./XAutosuggest');

var _XAutosuggest2 = _interopRequireDefault(_XAutosuggest);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

var _rx = require('../rx');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

var _require = require('../xenaQuery'),
    matchPartialField = _require.matchPartialField,
    sparseDataMatchPartialField = _require.sparseDataMatchPartialField,
    refGene = _require.refGene;

var _ = require('../underscore_ext');

var _require2 = require('../react-utils'),
    rxEvents = _require2.rxEvents;

require('./GeneSuggest.css'); // react-autosuggest, global styles
var styles = require('./GeneSuggest.module.css'); // react-toolbox, module styles
var limit = 8;

// Return the start and end indices of the word in 'value'
// under the cursor position.
function currentWordPosition(value, position) {
	var li = value.slice(0, position).lastIndexOf(' '),
	    i = li === -1 ? 0 : li + 1,
	    lj = value.slice(position).indexOf(' '),
	    j = lj === -1 ? value.length : position + lj;
	return [i, j];
}

// Return the word in 'value' under the cursor position
function currentWord(value, position) {
	var _currentWordPosition = currentWordPosition(value, position),
	    _currentWordPosition2 = (0, _slicedToArray3.default)(_currentWordPosition, 2),
	    i = _currentWordPosition2[0],
	    j = _currentWordPosition2[1];

	return value.slice(i, j);
}

var renderInputComponent = function renderInputComponent(_ref) {
	var ref = _ref.ref,
	    _onChange = _ref.onChange,
	    label = _ref.label,
	    error = _ref.error,
	    props = (0, _objectWithoutProperties3.default)(_ref, ['ref', 'onChange', 'label', 'error']);
	return React.createElement(
		_input2.default,
		(0, _extends3.default)({
			theme: styles,
			error: _.isString(error) ? error : null,
			spellCheck: false,
			innerRef: function innerRef(el) {
				return ref(el && el.inputNode);
			},
			onChange: function onChange(value, ev) {
				return _onChange(ev);
			},
			label: label || 'Add Gene or Position'
		}, props),
		React.createElement(
			'i',
			{ style: { color: 'red', opacity: error ? 1 : 0 }, className: 'material-icons' },
			'error'
		)
	);
};

var empty = _rx.Observable.of([], _rx.Scheduler.asap);

// host and name are for gene lookup.
// dataset is for probe lookup
var fetchSuggestions = function fetchSuggestions(assembly, dataset, value) {
	return _rx.Observable.zip(assembly ? sparseDataMatchPartialField(assembly.host, 'name2', assembly.name, value, limit).catch(function () {
		return empty;
	}) : empty, dataset ? matchPartialField(dataset, value, limit).catch(function () {
		return empty;
	}) : empty, function (genes, probes) {
		return genes.sort().concat(_.difference(probes, genes).sort());
	});
};

// Currently we only match against refGene hg38 genes. We could, instead, match
// on specific datasets (probemap, mutation, segmented, refGene), but that will
// require some more work to dispatch the query for each type.

var GeneSuggest = function (_PureComponent) {
	(0, _inherits3.default)(GeneSuggest, _PureComponent);

	function GeneSuggest() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, GeneSuggest);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = GeneSuggest.__proto__ || (0, _getPrototypeOf2.default)(GeneSuggest)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { suggestions: [] }, _this.onSuggestionsFetchRequested = function (_ref3) {
			var value = _ref3.value;

			var position = _this.input.selectionStart,
			    word = currentWord(value, position);

			_this.on.change(word);
		}, _this.shouldRenderSuggestions = function () {
			return true;
		}, _this.onSuggestionsClearRequested = function () {
			_this.on.change(undefined);
		}, _this.onChange = function (ev, _ref4) {
			var newValue = _ref4.newValue,
			    method = _ref4.method;

			// Don't update the value for 'up' and 'down' keys. If we do update
			// the value, it gives us an in-place view of the suggestion (pasting
			// the value into the input field), but the drawback is that it moves
			// the cursor to the end of the line. This messes up multi-word input.
			// We could try to preserve the cursor position, perhaps by passing a
			// custom input renderer. But for now, just don't update the value for
			// these events.
			if (method !== 'up' && method !== 'down') {
				_this.props.onChange(newValue);
			}
		}, _this.getSuggestionValue = function (suggestion) {
			var position = _this.input.selectionStart,
			    value = _this.input.value,
			    _currentWordPosition3 = currentWordPosition(value, position),
			    _currentWordPosition4 = (0, _slicedToArray3.default)(_currentWordPosition3, 2),
			    i = _currentWordPosition4[0],
			    j = _currentWordPosition4[1],
			    withSuggestion = value.slice(0, i) + suggestion + value.slice(j);

			// splice the suggestion into the current word
			return withSuggestion;
		}, _this.setInput = function (input) {
			var inputRef = _this.props.inputRef;

			_this.input = input;
			if (inputRef) {
				inputRef(_this.input);
			}
		}, _this.setAutosuggest = function (v) {
			_this.autosuggest = v;
		}, _this.onKeyDown = function (ev) {
			// We'd like <return> to select a suggestion when suggestions are shown,
			// but invoke "Done" when suggestions are not shown. react-autosuggest
			// won't tell us when it's open. So, we have to inspect the child state
			// to infer when it's open.
			if (_this.props.onKeyDown && (!_.getIn(_this, ['autosuggest', 'state', 'isFocused']) || _.getIn(_this, ['autosuggest', 'state', 'isCollapsed']))) {

				_this.props.onKeyDown(ev);
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(GeneSuggest, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var events = rxEvents(this, 'change');
			this.change = events.change.debounceTime(200).switchMap(function (value) {
				return value === undefined ? empty : fetchSuggestions(refGene[_this2.props.assembly], _this2.props.dataset, value);
			}).subscribe(function (matches) {
				return _this2.setState({ suggestions: matches });
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.change.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var onChange = this.onChange,
			    onKeyDown = this.onKeyDown,
			    _props = this.props,
			    _props$value = _props.value,
			    value = _props$value === undefined ? '' : _props$value,
			    label = _props.label,
			    error = _props.error,
			    suggestions = this.state.suggestions;


			return React.createElement(_XAutosuggest2.default, {
				inputRef: this.setInput,
				autosuggestRef: this.setAutosuggest,
				suggestions: suggestions,
				onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
				onSuggestionsClearRequested: this.onSuggestionsClearRequested,
				getSuggestionValue: this.getSuggestionValue,
				shouldRenderSuggestions: this.shouldRenderSuggestions,
				renderSuggestion: function renderSuggestion(v) {
					return React.createElement(
						'span',
						null,
						v
					);
				},
				renderInputComponent: renderInputComponent,
				inputProps: { value: value, label: label, error: error, onKeyDown: onKeyDown, onChange: onChange } });
		}
	}]);
	return GeneSuggest;
}(_PureComponent3.default);

module.exports = GeneSuggest;