'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena ghost variable select card, displaying during wizard setup.
 *
 * State
 * -----
 * title - Text displayed as title.
 * width - Width of card.
 */

// Core dependencies, components
var React = require('react');

// App dependencies
var CardAvatar = require('./CardAvatar');

// Styles
var compStyles = require('./GhostVariableSelect.module.css');

var GhostVariableSelect = function (_React$Component) {
	(0, _inherits3.default)(GhostVariableSelect, _React$Component);

	function GhostVariableSelect() {
		(0, _classCallCheck3.default)(this, GhostVariableSelect);
		return (0, _possibleConstructorReturn3.default)(this, (GhostVariableSelect.__proto__ || (0, _getPrototypeOf2.default)(GhostVariableSelect)).apply(this, arguments));
	}

	(0, _createClass3.default)(GhostVariableSelect, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    title = _props.title,
			    width = _props.width;

			return React.createElement(
				'div',
				{ className: compStyles.GhostVariableSelect, style: { width: width } },
				React.createElement(
					'div',
					{ className: compStyles.headerContainer },
					React.createElement(CardAvatar, null)
				),
				React.createElement(
					'div',
					{ className: compStyles.title },
					title
				)
			);
		}
	}]);
	return GhostVariableSelect;
}(React.Component);

module.exports = GhostVariableSelect;