'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('../underscore_ext');

// Styles
var compStyles = require('./Legend.module.css');

var nodata = {
	text: "null: no data",
	color: "#808080"
};

var Legend = function (_React$Component) {
	(0, _inherits3.default)(Legend, _React$Component);

	function Legend() {
		(0, _classCallCheck3.default)(this, Legend);
		return (0, _possibleConstructorReturn3.default)(this, (Legend.__proto__ || (0, _getPrototypeOf2.default)(Legend)).apply(this, arguments));
	}

	(0, _createClass3.default)(Legend, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    labels = _props.labels,
			    colors = _props.colors,
			    titles = _props.titles,
			    max = _props.max,
			    labelheader = _props.labelheader,
			    footnotes = _props.footnotes,
			    _props$addBreakend = _props.addBreakend,
			    addBreakend = _props$addBreakend === undefined ? 0 : _props$addBreakend,
			    _props$addNullNotatio = _props.addNullNotation,
			    addNullNotation = _props$addNullNotatio === undefined ? 0 : _props$addNullNotatio,
			    ellipsis = labels.length > max,
			    items = _.map(_.last(_.zip(labels, colors, titles), max), function (_ref, i) {
				var _ref2 = (0, _slicedToArray3.default)(_ref, 3),
				    l = _ref2[0],
				    c = _ref2[1],
				    t = _ref2[2];

				return React.createElement(
					'div',
					{ key: i, title: t, className: compStyles.item },
					React.createElement('div', { className: compStyles.colorBox,
						style: { backgroundColor: c } }),
					React.createElement(
						'label',
						{ className: compStyles.label },
						l
					)
				);
			}).reverse(),
			    footnotesItems = footnotes ? footnotes.map(function (text, i) {
				return React.createElement(
					'div',
					{ key: i, className: compStyles.footnotes },
					text
				);
			}) : null,
			    breakend = React.createElement(
				'div',
				{ className: compStyles.item },
				React.createElement('div', { className: compStyles.breakendBar }),
				React.createElement(
					'label',
					{ className: compStyles.label },
					'breakend'
				)
			),
			    nullNotation = React.createElement(
				'div',
				{ title: nodata.text },
				React.createElement(
					'label',
					{ className: compStyles.null, style: { backgroundColor: nodata.color } },
					nodata.text
				)
			);

			return React.createElement(
				'div',
				{ className: compStyles.Legend },
				items ? React.createElement(
					'div',
					{ className: compStyles.column },
					labelheader ? React.createElement(
						'label',
						{ className: compStyles.header },
						labelheader
					) : null,
					items,
					addBreakend ? breakend : null,
					addNullNotation ? nullNotation : null
				) : null,
				ellipsis ? React.createElement(
					'div',
					null,
					'...'
				) : null,
				footnotes ? footnotesItems : null
			);
		}
	}]);
	return Legend;
}(React.Component);

Legend.defaultProps = { max: 40 };


module.exports = Legend;