'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('../underscore_ext');

var _require = require('../react-utils'),
    rxEvents = _require.rxEvents;

var isValid = _.curry(function (min, max, value) {
	var v = value.trim(),
	    i = parseInt(v);
	return v === '' || !(isNaN(i) || i < min || i > max);
});

function parseValue(value, dflt) {
	var v = value.trim();
	return v === '' ? dflt : parseInt(v);
}

// initialValue is int or null.
// dflt, min, max are int.

var NumberForm = function (_React$Component) {
	(0, _inherits3.default)(NumberForm, _React$Component);

	function NumberForm(props) {
		(0, _classCallCheck3.default)(this, NumberForm);

		var _this = (0, _possibleConstructorReturn3.default)(this, (NumberForm.__proto__ || (0, _getPrototypeOf2.default)(NumberForm)).call(this, props));

		_this.onBlur = function () {
			_this.setState({ focused: false });
		};

		_this.onFocus = function () {
			_this.setState({ focused: true });
		};

		var initialValue = props.initialValue;

		_this.state = { value: initialValue == null ? '' : '' + initialValue, focused: false };
		return _this;
	}

	(0, _createClass3.default)(NumberForm, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var _props = this.props,
			    dflt = _props.dflt,
			    min = _props.min,
			    max = _props.max;

			var events = rxEvents(this, 'change');
			this.change = events.change.do(function (value) {
				return _this2.setState({ value: value });
			}).debounceTime(200).filter(isValid(min, max)).subscribe(function (value) {
				return _this2.props.onChange(parseValue(value, dflt));
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.change.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    min = _props2.min,
			    max = _props2.max,
			    other = _.omit(this.props, 'min', 'max', 'dflt', 'initialValue'),
			    _state = this.state,
			    value = _state.value,
			    focused = _state.focused;

			return React.createElement(
				'form',
				{ className: 'form-horizontal' },
				React.createElement(_input2.default, (0, _extends3.default)({}, other, {
					onBlur: this.onBlur,
					onFocus: this.onFocus,
					type: 'text',
					value: '' + value,
					label: 'Custom survival time cutoff',
					placeholder: focused ? 'Enter a number between ' + min + ' and ' + max : undefined,
					onChange: this.on.change }))
			);
		}
	}]);
	return NumberForm;
}(React.Component);

module.exports = NumberForm;