'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _XAutosuggest = require('./XAutosuggest');

var _XAutosuggest2 = _interopRequireDefault(_XAutosuggest);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

require('./GeneSuggest.css'); // XXX rename file

var renderInputComponent = function renderInputComponent(_ref) {
	var ref = _ref.ref,
	    _onChange = _ref.onChange,
	    error = _ref.error,
	    props = (0, _objectWithoutProperties3.default)(_ref, ['ref', 'onChange', 'error']);
	return React.createElement(
		_input2.default,
		(0, _extends3.default)({
			spellCheck: false,
			innerRef: function innerRef(el) {
				return ref(el && el.inputNode);
			},
			onChange: function onChange(value, ev) {
				return _onChange(ev);
			},
			label: 'Search Phenotype'
		}, props),
		React.createElement(
			'i',
			{ style: { color: 'red', opacity: error ? 1 : 0 }, className: 'material-icons' },
			'error'
		)
	);
};

var filterFeatures = function filterFeatures(lcValue, features) {
	return features.filter(function (f) {
		return f.label.toLowerCase().indexOf(lcValue) !== -1;
	});
};

var PhenotypeSuggest = function (_PureComponent) {
	(0, _inherits3.default)(PhenotypeSuggest, _PureComponent);

	function PhenotypeSuggest() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, PhenotypeSuggest);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = PhenotypeSuggest.__proto__ || (0, _getPrototypeOf2.default)(PhenotypeSuggest)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { suggestions: [] }, _this.onSuggestionsFetchRequested = function (_ref3) {
			var value = _ref3.value;
			var lcValue = value.toLowerCase(),
			    features = _this.props.features;


			_this.setState({
				suggestions: filterFeatures(lcValue, features)
			});
		}, _this.onSuggestionsClearRequested = function () {
			_this.setState({ suggestions: [] });
		}, _this.onChange = function (ev, _ref4) {
			var newValue = _ref4.newValue;

			_this.props.onChange(newValue);
		}, _this.setInput = function (input) {
			var inputRef = _this.props.inputRef;

			_this.input = input;
			if (inputRef) {
				inputRef(_this.input);
			}
		}, _this.shouldRenderSuggestions = function () {
			return true;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(PhenotypeSuggest, [{
		key: 'render',
		value: function render() {
			var onChange = this.onChange,
			    _props = this.props,
			    onKeyDown = _props.onKeyDown,
			    _props$value = _props.value,
			    value = _props$value === undefined ? '' : _props$value,
			    error = _props.error,
			    suggestions = this.state.suggestions;


			return React.createElement(_XAutosuggest2.default, {
				inputRef: this.setInput,
				suggestions: suggestions,
				onSuggestionSelected: this.props.onSuggestionSelected,
				onSuggestionsFetchRequested: this.onSuggestionsFetchRequested,
				onSuggestionsClearRequested: this.onSuggestionsClearRequested,
				getSuggestionValue: function getSuggestionValue(x) {
					return x.label;
				},
				shouldRenderSuggestions: this.shouldRenderSuggestions,
				renderSuggestion: function renderSuggestion(v) {
					return React.createElement(
						'span',
						null,
						v.label
					);
				},
				renderInputComponent: renderInputComponent,
				inputProps: { value: value, error: error, onKeyDown: onKeyDown, onChange: onChange } });
		}
	}]);
	return PhenotypeSuggest;
}(_PureComponent3.default);

module.exports = PhenotypeSuggest;