'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var Resizable = require('react-resizable').Resizable;
var _ = require('../underscore_ext');

// Styles
require('./ResizeOverlay.css');

var max = function max(x, y) {
	return x > y ? x : y;
};
var minWidthSize = function minWidthSize(minWidth, _ref) {
	var width = _ref.width,
	    height = _ref.height;
	return { width: max(minWidth, width), height: height };
};

var ResizeOverlay = function (_React$Component) {
	(0, _inherits3.default)(ResizeOverlay, _React$Component);

	function ResizeOverlay() {
		var _ref2;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ResizeOverlay);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = ResizeOverlay.__proto__ || (0, _getPrototypeOf2.default)(ResizeOverlay)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { zooming: false }, _this.onResizeStart = function () {
			var _this$props = _this.props,
			    width = _this$props.width,
			    height = _this$props.height,
			    minWidth = _this.props.minWidth();

			_this.setState({ zooming: true, zoomSize: { width: width, height: height }, minWidth: minWidth });
		}, _this.onResize = function (ev, _ref3) {
			var size = _ref3.size;
			var width = size.width,
			    height = size.height,
			    minWidth = _this.state.minWidth;

			_this.setState({ zoomSize: { width: max(width, minWidth), height: height } });
		}, _this.onResizeStop = function (ev, _ref4) {
			var size = _ref4.size;
			var onResizeStop = _this.props.onResizeStop,
			    minWidth = _this.state.minWidth;

			_this.setState({ zooming: false });
			if (onResizeStop) {
				onResizeStop(minWidthSize(minWidth, size));
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ResizeOverlay, [{
		key: 'render',
		value: function render() {
			var _state = this.state,
			    zooming = _state.zooming,
			    zoomSize = _state.zoomSize,
			    _props = this.props,
			    width = _props.width,
			    height = _props.height,
			    children = _props.children,
			    enable = _props.enable,
			    content = React.createElement(
				'div',
				{ style: { position: 'relative', cursor: 'none', zIndex: 0 } },
				children
			);

			return React.createElement(
				'div',
				{ className: enable ? 'resize-enable' : '', style: { position: 'relative' } },
				React.createElement('div', { style: {
						display: zooming ? 'block' : 'none',
						width: _.get(zoomSize, 'width', 0),
						height: _.get(zoomSize, 'height', 0),
						position: 'absolute',
						top: 0,
						left: 0,
						zIndex: 999,
						backgroundColor: 'rgba(0, 0, 0, 0.12)' } }),
				React.createElement(
					Resizable,
					{ handleSize: [20, 20],
						axis: 'both',
						onResizeStop: this.onResizeStop,
						onResize: this.onResize,
						onResizeStart: this.onResizeStart,
						width: width,
						height: height },
					content
				)
			);
		}
	}]);
	return ResizeOverlay;
}(React.Component);

module.exports = ResizeOverlay;