'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _ZoomCarriage = require('./ZoomCarriage');

var _ZoomCarriage2 = _interopRequireDefault(_ZoomCarriage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

// App dependencies
/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet sample zoom indicator. Displays original state of samples when in zoom mode.
 *
 */

// TODO review insertion of div with height refer Column.js line 688

// Core dependencies
var _ = require('../underscore_ext');
var CanvasDrawing = require('../CanvasDrawing');
var ColCard = require('./ColCard');

var _require = require('../drawSamples'),
    drawSamples = _require.drawSamples;

// Styles
var compStyles = require('./SampleZoomIndicator.module.css');

function noZoom(samples, zoom) {
	return _.merge(zoom, { count: samples, index: 0 });
}

var SampleZoomIndicator = function (_PureComponent) {
	(0, _inherits3.default)(SampleZoomIndicator, _PureComponent);

	function SampleZoomIndicator() {
		(0, _classCallCheck3.default)(this, SampleZoomIndicator);
		return (0, _possibleConstructorReturn3.default)(this, (SampleZoomIndicator.__proto__ || (0, _getPrototypeOf2.default)(SampleZoomIndicator)).apply(this, arguments));
	}

	(0, _createClass3.default)(SampleZoomIndicator, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    data = _props.data,
			    column = _props.column,
			    addColumnAddHover = _props.addColumnAddHover,
			    enableTransition = _props.enableTransition,
			    samples = _props.samples,
			    zoom = _props.zoom,
			    heatmap = column.heatmap,
			    codes = _.get(data, 'codes'),
			    width = 10;

			return React.createElement(
				'div',
				{ className: compStyles.sampleZoomIndicator, style: { width: width } },
				React.createElement(
					ColCard,
					{ zoomCard: true },
					React.createElement('div', { style: { height: 63 } }),
					React.createElement(
						'div',
						{ style: { position: 'relative' } },
						React.createElement(CanvasDrawing, {
							ref: 'plot',
							draw: drawSamples,
							codes: codes,
							width: width,
							zoom: noZoom(samples.length, zoom),
							heatmapData: heatmap }),
						React.createElement(_ZoomCarriage2.default, { addColumnAddHover: addColumnAddHover, enableTransition: enableTransition, samplesCount: samples.length, width: width, zoom: zoom })
					)
				)
			);
		}
	}]);
	return SampleZoomIndicator;
}(_PureComponent3.default);

;

module.exports = SampleZoomIndicator;