'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('../underscore_ext'),
    times = _require.times,
    maxnull = _require.maxnull,
    minnull = _require.minnull;

var CanvasDrawing = require('../CanvasDrawing');
var React = require('react');

function drawScatterPlot(vg, opts) {
	var data = opts.data,
	    width = opts.width,
	    height = opts.zoom.height,
	    inc = opts.inc,
	    _data = (0, _slicedToArray3.default)(data, 2),
	    x = _data[0],
	    y = _data[1];

	vg.box(0, 0, width, height, "white");
	if (inc % 2) {
		return;
	}

	var ctx = vg.context(),

	//		img = ctx.createImageData(width, height),
	img = ctx.getImageData(0, 0, width, height),
	    xmax = maxnull(x),
	    xmin = minnull(x),
	    ymax = maxnull(y),
	    ymin = minnull(y),
	    scalex = function scalex(x) {
		return Math.round((x - xmin) * (width - 1) / (xmax - xmin));
	},
	    scaley = function scaley(y) {
		return Math.round((y - ymin) * (height - 1) / (ymax - ymin));
	};

	var white = [255, 255, 255, 255],
	    black = [0, 0, 0, 255],
	    mark = [[white, black, white], [black, black, black], [white, black, white]];

	x.forEach(function (xi, i) {
		var yi = y[i],
		    xc = scalex(xi),
		    yc = scaley(yi),
		    istart = xc <= 0 ? 1 : 0,
		    iend = xc >= width - 1 ? 2 : 3,
		    jstart = yc <= 0 ? 1 : 0,
		    jend = yc >= height - 1 ? 2 : 3;

		for (var j = jstart; j < jend; ++j) {
			var pxRow = (yc - 1 + j) * width,
			    buffStart = pxRow * 4;
			for (var _i = istart; _i < iend; _i++) {
				if (mark[j][_i] === black) {
					img.data[buffStart + 4 * (xc + _i - 1) + 0] = mark[j][_i][0];
					img.data[buffStart + 4 * (xc + _i - 1) + 1] = mark[j][_i][1];
					img.data[buffStart + 4 * (xc + _i - 1) + 2] = mark[j][_i][2];
					img.data[buffStart + 4 * (xc + _i - 1) + 3] = mark[j][_i][3];
				}
			}
		}
	});

	ctx.putImageData(img, 0, 0);
}

var count = 1000 * 1000;
var rndx = times(count, function () {
	return 1 + 10 * Math.sin(Math.random());
}),
    rndy = rndx.map(function (x) {
	return 1 + 10 * Math.sin(x + Math.random());
});
//	rndy = times(count, () => 1 + 10 * Math.sin(Math.random()));

//var data = [[...rndx, ...rndx.map(x => -x)], [...rndy, ...rndy.map(x => -x)]];
var data = [rndx, rndy];

var ScatterPlot = function (_React$Component) {
	(0, _inherits3.default)(ScatterPlot, _React$Component);

	function ScatterPlot() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ScatterPlot);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ScatterPlot.__proto__ || (0, _getPrototypeOf2.default)(ScatterPlot)).call.apply(_ref, [this].concat(args))), _this), _this.state = { x: 0 }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ScatterPlot, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			return React.createElement(
				'div',
				{ style: { margin: 40 } },
				React.createElement(
					'button',
					{ onClick: function onClick() {
							return _this2.setState({ x: _this2.state.x + 1 });
						} },
					'inc'
				),
				React.createElement(CanvasDrawing, {
					inc: this.state.x,
					draw: drawScatterPlot,
					width: 800,
					zoom: { height: 400 },
					data: data })
			);
		}
	}]);
	return ScatterPlot;
}(React.Component);

module.exports = ScatterPlot;