'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet status indicator. Displays label with state and,
 * additional actions to delete state.
 *
 */

// Core dependencies, components
var React = require('react');

// Styles
var classNames = require('classnames');
var compStyles = require('./SheetStatus.module.css');

var SheetStatus = function (_React$Component) {
	(0, _inherits3.default)(SheetStatus, _React$Component);

	function SheetStatus() {
		(0, _classCallCheck3.default)(this, SheetStatus);
		return (0, _possibleConstructorReturn3.default)(this, (SheetStatus.__proto__ || (0, _getPrototypeOf2.default)(SheetStatus)).apply(this, arguments));
	}

	(0, _createClass3.default)(SheetStatus, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    disabled = _props.disabled,
			    label = _props.label,
			    sheetState = _props.sheetState;

			return React.createElement(
				'div',
				{ className: classNames(compStyles.status, (0, _defineProperty3.default)({}, compStyles.disabled, disabled), (0, _defineProperty3.default)({}, compStyles.zoomAnimation, sheetState !== 'None')) },
				label ? React.createElement(
					'div',
					{ className: compStyles.label },
					label
				) : null,
				React.createElement(
					'div',
					{ className: compStyles.state },
					sheetState
				)
			);
		}
	}]);
	return SheetStatus;
}(React.Component);

module.exports = SheetStatus;