'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
// Horizontal sortable widget, with Rx and React.
//
// <Sortable Component={Component} onReorder={this.onReorder}>
// 	{map(order, id => child[id]}
// </Sortable>
//
// Children must set class Sortable-handle on their drag handle. Children
// must have keys.
//
// The setOrder callback is invoked when a sort is completed, and
// should re-render the component with the childen in the new order.

var ReactDOM = require('react-dom');
var Rx = require('../rx');
var _ = require('../underscore_ext');
require('./Sortable.css');

var skip = 1; // Don't allow sort of <skip> elements on the left

function leftWidth(rect, width) {
	return {
		left: rect.left,
		width: width
	};
}

function hasClass(el, c) {
	return el.className.split(/ +/).indexOf(c) !== -1;
}

function repeat(n, v) {
	var arr = new Array(n);
	for (var i = 0; i < n; ++i) {
		arr[i] = v;
	}
	return arr;
}

var zeros = function zeros(n) {
	return repeat(n, 0);
};

// If right edge crosses middle of next element, move next element to left.
// If left edge crosses middle of prev element, move prev element to right.
//
// Each element only moves as much as the width of the dragged element,
// and only moves if the dragged edge has crossed the midpoint of the element.
//
// left1             left2
// |   width1   |    |   width2  |
//
// Dragging left1 to the right
// We cross the midpoint when left1 + offset1 + width1 >= left2 + width2 / 2.
// At that point, we set offset2 to left1 - left2.
//
// Dragging left2 to the left
// We cross the midpoint when left2 + offset2 <= left1 + width1 / 2.
// At that point, we set offset1 to left2 - left1.

var transitionLength = 400;

var Sortable = function (_PureComponent) {
	(0, _inherits3.default)(Sortable, _PureComponent);

	function Sortable() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Sortable);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Sortable.__proto__ || (0, _getPrototypeOf2.default)(Sortable)).call.apply(_ref, [this].concat(args))), _this), _this.initialPositions = function () {
			return _.object(_.map(_this.props.children, function (c) {
				return [c.props['data-actionKey'], 0];
			}));
		}, _this.state = { pos: _this.initialPositions(), dragging: null }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Sortable, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			var _this2 = this;

			var mousedownSub = new Rx.Subject();
			var mousedown = mousedownSub.filter(function (_ref2) {
				var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
				    md = _ref3[1];

				return hasClass(md.target, 'Sortable-handle');
			});
			var mousedrag = mousedown.flatMap(function (_ref4) {
				var _ref5 = (0, _slicedToArray3.default)(_ref4, 2),
				    id = _ref5[0],
				    md = _ref5[1];

				// find starting positions on mouse down

				var order = _.map(_this2.props.children, function (c) {
					return c.props['data-actionKey'];
				});
				var startX = md.clientX;
				var widths = _this2.props.widths;

				var positions = _.map(order, function (id, i) {
					return leftWidth(ReactDOM.findDOMNode(_this2.refs[id]).getBoundingClientRect(), widths[i]);
				});
				var N = positions.length;
				var index = _.indexOf(order, id);
				var target = positions[index];
				var max = positions[N - 1].left - target.left - target.width + positions[N - 1].width;
				var min = positions[skip].left - target.left;
				var newPos = zeros(N);
				var finalPos;

				// Calculate delta with mousemove until mouseup
				return Rx.Observable.fromEvent(window, 'mousemove').map(function (mm) {
					mm.preventDefault();

					var shift, edge, finalEl;
					var dragLeft = mm.clientX - startX;

					dragLeft = dragLeft < min ? min : dragLeft > max ? max : dragLeft;

					if (dragLeft < 0) {
						// dragging left
						shift = target.left - positions[index - 1].left - (positions[index - 1].width - target.width);
						edge = target.left + dragLeft;
						finalEl = _.findIndexDefault(positions, function (_ref6) {
							var left = _ref6.left,
							    width = _ref6.width;
							return edge < left + width / 2;
						}, 0);
						newPos = [].concat((0, _toConsumableArray3.default)(zeros(finalEl)), (0, _toConsumableArray3.default)(repeat(index - finalEl, shift)), [dragLeft], (0, _toConsumableArray3.default)(zeros(N - index - 1))), finalPos = positions[finalEl].left - target.left;
					} else if (dragLeft > 0) {
						// dragging right
						shift = target.left - positions[index + 1].left;
						edge = target.left + dragLeft + target.width;
						finalEl = _.findLastIndexDefault(positions, function (_ref7) {
							var left = _ref7.left,
							    width = _ref7.width;
							return edge >= left + width / 2;
						}, index);
						newPos = [].concat((0, _toConsumableArray3.default)(zeros(index)), [dragLeft], (0, _toConsumableArray3.default)(repeat(finalEl - index, shift)), (0, _toConsumableArray3.default)(zeros(N - finalEl - 1)));
						finalPos = positions[finalEl].left - target.left + positions[finalEl].width - target.width;
					}

					return { pos: _.object(order, newPos), dragging: index };
				}).takeUntil(Rx.Observable.fromEvent(window, 'mouseup')).concat(Rx.Observable.defer(function () {
					// Send a re-order event on mouse-up.
					var finalNewPos = _.assoc(newPos, index, finalPos),
					    indexOrder = _.range(order.length).sort(function (i, j) {
						return positions[i].left + finalNewPos[i] - (positions[j].left + finalNewPos[j]);
					}),
					    newOrder = _.map(indexOrder, function (i) {
						return order[i];
					});
					if (_.isEqual(order, newOrder)) {
						// dragging -1 enables slide transition on all elements.
						return Rx.Observable.of({ dragging: -1, pos: _.object(order, zeros(N)) }).concat(Rx.Observable.of({ dragging: null }).delay(transitionLength));
					} else {
						return Rx.Observable.of({ dragging: -1, pos: _.object(order, finalNewPos) }).concat(Rx.Observable.of({ dragging: null, order: newOrder }).delay(transitionLength));
					}
				}));
			});

			// Update position
			this.subscription = mousedrag.subscribe(function (ev) {
				if (_.has(ev, 'order')) {
					_this2.props.onReorder(ev.order);
				}
				_this2.setState(_.pick(ev, 'pos', 'dragging'));
				_this2.props.onDragging(!!ev.dragging);
			});

			this.sortStart = function (ev) {
				return mousedownSub.next(ev);
			};
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps() {
			this.setState({ pos: this.initialPositions() });
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.subscription.unsubscribe();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var dragging = this.state.dragging,
			    _props = this.props,
			    Component = _props.Component,
			    children = _props.children,
			    otherProps = (0, _objectWithoutProperties3.default)(_props, ['Component', 'children']),
			    wizardMode = this.props.appState.wizardMode;


			var columns = React.Children.map(children, function (child, i) {
				var actionKey = child.props['data-actionKey'];
				return React.cloneElement(child, {
					onMouseDown: wizardMode || i < skip ? undefined : function (ev) {
						return _this3.sortStart([actionKey, ev]);
					},
					className: 'Sortable-container' + (dragging !== null && i !== dragging ? ' Sortable-slide' : ''),
					style: { left: _this3.state.pos[actionKey] },
					id: actionKey,
					ref: actionKey
				});
			});

			return React.createElement(
				Component,
				(0, _extends3.default)({}, otherProps, { className: 'Sortable' }),
				columns
			);
		}
	}]);
	return Sortable;
}(_PureComponent3.default);

module.exports = Sortable;