'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _app_bar = require('react-toolbox/lib/app_bar');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Stepper component, displayed initially when user is in "set up" mode. Component displays label and completed
 * indicator for the three core steps required for Xena setup.
 *
 * View-only component, that is, there are no outputs or callbacks invoked from this component.
 *
 * Takes a single input, mode, which is used to highlight the step that is currently in progress. mode
 * can be one of "COHORT", "FIRST_COLUMN", "SECOND_COLUMN" or "DONE".
 *
 * Steps to the left of the active step are considered complete. Steps to the right of the active step are considered
 * to do.
 *
 * Displayed initially when user is in "set up" mode.
 */

// Core dependencies, components
var classNames = require('classnames');
var React = require('react');

var _ = require('../underscore_ext');

// Styles
var compStyles = require('./Stepper.module.css');

var Stepper = function (_React$Component) {
	(0, _inherits3.default)(Stepper, _React$Component);

	function Stepper() {
		(0, _classCallCheck3.default)(this, Stepper);
		return (0, _possibleConstructorReturn3.default)(this, (Stepper.__proto__ || (0, _getPrototypeOf2.default)(Stepper)).apply(this, arguments));
	}

	(0, _createClass3.default)(Stepper, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    steps = _props.steps,
			    stateIndex = _props.stateIndex,
			    mode = _props.mode,
			    flat = _props.flat,
			    wideStep = _props.wideStep;


			var getStepClassName = function getStepClassName(index) {
				var _classNames;

				return classNames((_classNames = {}, (0, _defineProperty3.default)(_classNames, compStyles.step, true), (0, _defineProperty3.default)(_classNames, compStyles.wideStep, wideStep), (0, _defineProperty3.default)(_classNames, compStyles.completed, index < stateIndex[mode]), (0, _defineProperty3.default)(_classNames, compStyles.active, index === stateIndex[mode]), _classNames));
			};
			return React.createElement(
				_app_bar.AppBar,
				{ flat: flat },
				React.createElement(
					'ul',
					{ className: compStyles.Stepper },
					_.map(steps, function (step, index) {
						return React.createElement(
							'li',
							{ className: getStepClassName(index), key: index },
							React.createElement(
								'div',
								{ className: compStyles.stepperCircle },
								index + 1
							),
							React.createElement(
								'div',
								{ className: compStyles.stepperText },
								step.label
							)
						);
					})
				)
			);
		}
	}]);
	return Stepper;
}(React.Component);

module.exports = { Stepper: Stepper };