'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _ConceptSuggest = require('./ConceptSuggest');

var _ConceptSuggest2 = _interopRequireDefault(_ConceptSuggest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

var _require = require('../underscore_ext'),
    times = _require.times,
    mapObject = _require.mapObject,
    values = _require.values;

var styles = {
	section: {
		borderTop: '1px solid black'
	},
	doc: {
		marginTop: 0,
		marginBottom: 0,
		cursor: 'pointer'
	},
	show: {
		backgroundColor: '#EEEEFF'
	}
};

var setKey = function setKey(arr) {
	return arr.map(function (el, i) {
		return React.cloneElement(el, { key: i });
	});
};

var pageSizes = [10, 20, 50, 100];

var filterIcon = function filterIcon(hasDoc, filter) {
	return !hasDoc ? '-' : filter == null ? '\xA0' : filter ? 'y' : 'n';
};

var Ties = function (_PureComponent) {
	(0, _inherits3.default)(Ties, _PureComponent);

	function Ties() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Ties);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Ties.__proto__ || (0, _getPrototypeOf2.default)(Ties)).call.apply(_ref, [this].concat(args))), _this), _this.onForward = function () {
			var _this$props = _this.props,
			    onPage = _this$props.onPage,
			    _this$props$state$tie = _this$props.state.ties.page,
			    i = _this$props$state$tie.i,
			    n = _this$props$state$tie.n;

			onPage({ i: i + 1, n: n });
		}, _this.onBack = function () {
			var _this$props2 = _this.props,
			    onPage = _this$props2.onPage,
			    _this$props2$state$ti = _this$props2.state.ties.page,
			    i = _this$props2$state$ti.i,
			    n = _this$props2$state$ti.n;

			onPage({ i: i - 1, n: n });
		}, _this.onPage = function (ev) {
			var i = parseInt(ev.target.value, 10) - 1,
			    _this$props3 = _this.props,
			    onPage = _this$props3.onPage,
			    n = _this$props3.state.ties.page.n;

			onPage({ i: i, n: n });
		}, _this.onPageSize = function (ev) {
			var _this$props4 = _this.props,
			    onPage = _this$props4.onPage,
			    page = _this$props4.state.ties.page,
			    n = parseInt(ev.target.value, 10),
			    i = Math.floor(page.n * page.i / n);

			onPage({ i: i, n: n });
		}, _this.onShowDoc = function (ev) {
			var index = parseInt(ev.target.dataset.index, 10);
			_this.props.onShowDoc(index);
		}, _this.onKeepRow = function (ev) {
			var keep = ev.target.dataset.keep === 'true',
			    _this$props5 = _this.props,
			    onKeepRow = _this$props5.onKeepRow,
			    showDoc = _this$props5.state.ties.showDoc;


			onKeepRow(showDoc, keep);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Ties, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    onHideDoc = _props.onHideDoc,
			    onAddTerm = _props.onAddTerm,
			    state = _props.state,
			    _state$ties = state.ties,
			    _state$ties$terms = _state$ties.terms,
			    terms = _state$ties$terms === undefined ? [] : _state$ties$terms,
			    docs = _state$ties.docs,
			    _state$ties$matches = _state$ties.matches,
			    matches = _state$ties$matches === undefined ? {} : _state$ties$matches,
			    filter = _state$ties.filter,
			    showDoc = _state$ties.showDoc,
			    doc = _state$ties.doc,
			    page = _state$ties.page,
			    _state$ties$concepts = _state$ties.concepts,
			    concepts = _state$ties$concepts === undefined ? [] : _state$ties$concepts,
			    pageCount = Math.ceil((docs || []).length / page.n),
			    byTerm = mapObject(matches, function (_ref2) {
				var matches = _ref2.matches;
				return new _set2.default(matches);
			}); // XXX put in selector

			return React.createElement(
				'div',
				null,
				React.createElement(
					'p',
					{ style: styles.section },
					React.createElement(
						'button',
						{ onClick: this.props.onDismiss },
						'dismiss'
					)
				),
				React.createElement(
					'div',
					{ style: styles.section },
					'Terms: ',
					terms.map(function (t) {
						return matches[t] ? t : t + ' (loading)';
					}).join(', '),
					' ',
					React.createElement('br', null),
					React.createElement(_ConceptSuggest2.default, { onAddTerm: onAddTerm, concepts: concepts })
				),
				React.createElement(
					'p',
					{ style: styles.section },
					'Filter',
					React.createElement('br', null),
					'Keep ',
					values(filter).filter(function (v) {
						return v === true;
					}).length,
					React.createElement('br', null),
					'Drop ',
					values(filter).filter(function (v) {
						return v === false;
					}).length
				),
				React.createElement(
					'p',
					{ style: styles.section },
					'showDoc ',
					showDoc,
					showDoc && React.createElement(
						'button',
						{ onClick: onHideDoc },
						'hide'
					),
					React.createElement('br', null),
					showDoc && React.createElement(
						'button',
						{ 'data-keep': true, onClick: this.onKeepRow },
						'keep'
					),
					React.createElement('br', null),
					showDoc && React.createElement(
						'button',
						{ 'data-keep': false, onClick: this.onKeepRow },
						'discard'
					),
					React.createElement('br', null),
					'doc ',
					doc && doc.id,
					' ',
					doc && doc.text.slice(0, 100)
				),
				React.createElement(
					'div',
					{ style: styles.section },
					'Page',
					React.createElement(
						'select',
						{ value: page.i + 1, onChange: this.onPage },
						times(pageCount, function (i) {
							return React.createElement(
								'option',
								{ key: i, value: i + 1 },
								i + 1
							);
						})
					),
					React.createElement(
						'button',
						{ disabled: page.i === 0, onClick: this.onBack },
						'<'
					),
					React.createElement(
						'button',
						{ disabled: page.i > pageCount - 2, onClick: this.onForward },
						'>'
					),
					React.createElement('br', null),
					'Page length',
					React.createElement(
						'select',
						{ value: page.n, onChange: this.onPageSize },
						pageSizes.map(function (s) {
							return React.createElement(
								'option',
								{ key: s, value: s },
								s
							);
						})
					),
					React.createElement('br', null),
					'showing ',
					page.i * page.n,
					' - ',
					(page.i + 1) * page.n - 1,
					React.createElement('br', null),
					docs ? setKey(docs.slice(page.i * page.n, (page.i + 1) * page.n).map(function (_ref3, i) {
						var patient = _ref3.patient,
						    doc = _ref3.doc;
						return React.createElement(
							'p',
							{ style: (0, _extends3.default)({}, styles.doc, page.i * page.n + i === showDoc ? styles.show : {}),
								'data-index': page.i * page.n + i,
								onClick: doc ? _this2.onShowDoc : undefined },
							filterIcon(doc, filter[page.i * page.n + i]),
							' ',
							patient,
							': ',
							doc,
							' ',
							terms.map(function (t) {
								return byTerm[t] && byTerm[t].has(patient) ? t : '';
							}).join(' ')
						);
					})) : "loading docs..."
				)
			);
		}
	}]);
	return Ties;
}(_PureComponent3.default);

exports.default = Ties;