'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');
var _ = require('../underscore_ext');
var meta = require('../meta');
var classNames = require('classnames');

// Styles
var compStyles = require('./Tooltip.module.css');

var element = {
	value: function value(i, v) {
		return React.createElement(
			'span',
			{ key: i },
			v
		);
	},
	label: function label(i, l) {
		return React.createElement(
			'span',
			{ key: i },
			l
		);
	},
	labelValue: function labelValue(i, l, v) {
		return React.createElement(
			'span',
			{ key: i },
			l,
			': ',
			v
		);
	},
	sig: function sig(i, lHover, lFrozen, val, frozen) {
		return React.createElement(
			'span',
			{ key: i },
			frozen ? lFrozen : lHover,
			': ',
			val
		);
	},
	url: function url(i, text, _url) {
		return React.createElement(
			'span',
			{ key: i },
			React.createElement(
				'a',
				{ href: _url, target: '_blank' },
				text
			)
		);
	},
	urls: function urls(i, _urls, frozen) {
		var visibleCount = frozen ? _urls.length : 3,
		    visible = _urls.slice(0, visibleCount),
		    moreCount = _urls.length - visibleCount;
		return React.createElement(
			'span',
			{ key: i },
			visible.map(function (_ref, j) {
				var _ref2 = (0, _toArray3.default)(_ref),
				    type = _ref2[0],
				    args = _ref2.slice(1);

				return element[type].apply(element, [j].concat((0, _toConsumableArray3.default)(args)));
			}),
			moreCount > 0 ? React.createElement(
				'span',
				{ className: compStyles.moreGene },
				'+ ',
				moreCount,
				' more'
			) : null
		);
	}
	//	popOver: (i, text, dataList) => (
	//		<span key={i}><a><PopOverVariants label={text} body={dataList}/></a></span>
	//	),
};

function overlay() {
	return React.createElement('div', { className: compStyles.overlay });
}

//var PopOverVariants = React.createClass({
//  getInitialState() {
//    return { showModal: false };
//  },
//
//  close() {
//    this.setState({ showModal: false });
//  },
//
//  open() {
//    this.setState({ showModal: true });
//  },
//
//  render() {
//	var label = this.props.label,
//		dataList = this.props.body;
//
//	var rowsOut = _.map(dataList, (row, i) => (
//		<tr key={i}>
//			{row.map(([type, ...args], i) => element[type](i, ...args))}
//		</tr>
//	));
//
//
//    return (
//      <div>
//        <span
//          onClick={this.open}
//        >
//        {label}
//        </span>
//
//        <Modal show={this.state.showModal} onHide={this.close}>
//          <Modal.Header closeButton>
//            <Modal.Title>Variants</Modal.Title>
//          </Modal.Header>
//          <Modal.Body>
//			<div>
//				<table> {rowsOut} </table>
//			</div>
//          </Modal.Body>
//          <Modal.Footer>
//            <Button onClick={this.close}>Close</Button>
//          </Modal.Footer>
//        </Modal>
//      </div>
//    );
//  }
//});

var Tooltip = function (_PureComponent) {
	(0, _inherits3.default)(Tooltip, _PureComponent);

	function Tooltip() {
		(0, _classCallCheck3.default)(this, Tooltip);
		return (0, _possibleConstructorReturn3.default)(this, (Tooltip.__proto__ || (0, _getPrototypeOf2.default)(Tooltip)).apply(this, arguments));
	}

	(0, _createClass3.default)(Tooltip, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    data = _props.data,
			    onClick = _props.onClick,
			    onClose = _props.onClose,
			    frozen = _props.frozen,
			    rows = _.getIn(data, ['rows']),
			    sampleID = _.getIn(data, ['sampleID']);

			// no tooltip, helper links


			if (!rows && !sampleID) {
				return React.createElement(
					'div',
					{ className: compStyles.Tooltip },
					React.createElement(
						'ul',
						{ className: compStyles.content },
						React.createElement(
							'li',
							{ className: compStyles.tooltipHint },
							React.createElement(
								'a',
								{
									href: 'https://ucsc-xena.gitbook.io/project/',
									target: '_blank', rel: 'noopener noreferrer' },
								'User Guide'
							)
						),
						React.createElement(
							'li',
							{ className: compStyles.tooltipHint },
							React.createElement(
								'a',
								{
									href: 'https://ucsc-xena.gitbook.io/project/overview-of-features/visual-spreadsheet#zooming',
									target: '_blank', rel: 'noopener noreferrer' },
								'Zoom Help'
							)
						),
						React.createElement(
							'li',
							{ className: compStyles.tooltipHint },
							React.createElement(
								'a',
								{
									href: 'https://ucsc-xena.gitbook.io/project/how-do-i/freeze-and-un-freeze-tooltip',
									target: '_blank', rel: 'noopener noreferrer' },
								'Tooltip Help'
							)
						)
					)
				);
			}

			var rowsOut = _.map(rows, function (row, i) {
				return React.createElement(
					'li',
					{ key: i },
					row.map(function (_ref3, k) {
						var _ref4 = (0, _toArray3.default)(_ref3),
						    type = _ref4[0],
						    args = _ref4.slice(1);

						return type === 'urls' ? element[type](k, args, frozen) : type === 'sig' ? element[type].apply(element, [k].concat((0, _toConsumableArray3.default)(args), [frozen])) : element[type].apply(element, [k].concat((0, _toConsumableArray3.default)(args)));
					})
				);
			});
			var closeIcon = frozen ? React.createElement(
				'i',
				{ className: 'material-icons', onClick: onClose },
				'close'
			) : null;
			var sample = sampleID ? React.createElement(
				'span',
				null,
				sampleID
			) : null;

			return React.createElement(
				'div',
				{ onClick: onClick },
				frozen ? overlay(onClick) : null,
				React.createElement(
					'div',
					{ key: sampleID, className: classNames(compStyles.Tooltip, (0, _defineProperty3.default)({}, compStyles.frozen, frozen)) },
					React.createElement(
						'ul',
						{ className: compStyles.content },
						sampleID ? "sample: " : null,
						sampleID ? React.createElement(
							'li',
							{ className: compStyles.title },
							sample
						) : null,
						React.createElement(
							'li',
							{
								className: compStyles.tooltipHint },
							meta.name + '-click to ' + (frozen ? 'unfreeze' : 'freeze') + ' tooltip'
						),
						rowsOut
					),
					closeIcon
				)
			);
		}
	}]);
	return Tooltip;
}(_PureComponent3.default);

module.exports = Tooltip;