'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dialog = require('react-toolbox/lib/dialog');

var _dropdown = require('react-toolbox/lib/dropdown');

var _button = require('react-toolbox/lib/button');

var _input = require('react-toolbox/lib/input');

var _VizSettingsModule = require('./VizSettings.module.css');

var _VizSettingsModule2 = _interopRequireDefault(_VizSettingsModule);

var _colorScales = require('../colorScales');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*eslint camelcase: 0, no-use-before-define: 0 */
// Config UI for custom viz settings for heatmaps.
//
// State schema. This is the goal, not the current implementation. If
// the user has never modified the default settings, vizSettings is undefined.
//
// When the user modifies colNormalization or color parameters, they are
// written into vizSettings. vizSettings can have normalization or color
// parameters, or both. All color parameters are present if any are set.
// The minStart/maxStart are optional, so may be null if other color parameters
// are set.
//
// vizSettings = undefined |
//               {
//                 colNormalization: 'subset' | 'none'
//               } |
//               {
//                 min: float,
//                 minStart: float | null,
//                 maxStart: float | null,
//                 max: float
//               } |
//               {
//                 colNormalization: 'subset' | 'none'
//                 min: float,
//                 minStart: float | null,
//                 maxStart: float | null,
//                 max: float
//               }

// Refactoring notes:
// The default column normalization is fetched from the server. Instead it should come from
// the state, or from a data cache, because we've fetched that already.

var _ = require('../underscore_ext');
var React = require('react');
var ReactDOM = require('react-dom');

var _require = require("react-material-responsive-grid"),
    Row = _require.Row,
    Col = _require.Col;

function vizSettingsWidget(node, onVizSettings, vizState, id, hide, defaultNormalization, defaultColorClass, valueType, fieldType, data, units, column) {
	var DatasetSetting = function (_React$Component) {
		(0, _inherits3.default)(DatasetSetting, _React$Component);

		function DatasetSetting() {
			(0, _classCallCheck3.default)(this, DatasetSetting);
			return (0, _possibleConstructorReturn3.default)(this, (DatasetSetting.__proto__ || (0, _getPrototypeOf2.default)(DatasetSetting)).apply(this, arguments));
		}

		(0, _createClass3.default)(DatasetSetting, [{
			key: 'render',
			value: function render() {
				var settingsContent = valueType === "float" || valueType === 'segmented' ? React.createElement(AllFloat, null) : valueType === "mutation" && fieldType === 'SV' ? React.createElement(Sv, null) : valueType === "coded" ? React.createElement(Coded, null) : React.createElement(NoSettings, null);
				return React.createElement(
					'div',
					null,
					settingsContent,
					React.createElement(FinishButtonBar, null)
				);
			}
		}]);
		return DatasetSetting;
	}(React.Component);

	var AllFloat = function (_React$Component2) {
		(0, _inherits3.default)(AllFloat, _React$Component2);

		function AllFloat() {
			(0, _classCallCheck3.default)(this, AllFloat);
			return (0, _possibleConstructorReturn3.default)(this, (AllFloat.__proto__ || (0, _getPrototypeOf2.default)(AllFloat)).apply(this, arguments));
		}

		(0, _createClass3.default)(AllFloat, [{
			key: 'render',
			value: function render() {
				return React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						null,
						React.createElement(ColorDropDown, null)
					),
					React.createElement('br', null),
					React.createElement(
						'div',
						null,
						React.createElement(ScaleChoice, null)
					),
					React.createElement('br', null)
				);
			}
		}]);
		return AllFloat;
	}(React.Component);

	var Sv = function (_React$Component3) {
		(0, _inherits3.default)(Sv, _React$Component3);

		function Sv() {
			(0, _classCallCheck3.default)(this, Sv);
			return (0, _possibleConstructorReturn3.default)(this, (Sv.__proto__ || (0, _getPrototypeOf2.default)(Sv)).apply(this, arguments));
		}

		(0, _createClass3.default)(Sv, [{
			key: 'render',
			value: function render() {
				return React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						null,
						React.createElement(SvColorDropDown, null)
					),
					React.createElement('br', null)
				);
			}
		}]);
		return Sv;
	}(React.Component);

	var Coded = function (_React$Component4) {
		(0, _inherits3.default)(Coded, _React$Component4);

		function Coded() {
			(0, _classCallCheck3.default)(this, Coded);
			return (0, _possibleConstructorReturn3.default)(this, (Coded.__proto__ || (0, _getPrototypeOf2.default)(Coded)).apply(this, arguments));
		}

		(0, _createClass3.default)(Coded, [{
			key: 'render',
			value: function render() {
				return React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						null,
						React.createElement(CategoricalTable, null)
					),
					React.createElement('br', null)
				);
			}
		}]);
		return Coded;
	}(React.Component);

	var NoSettings = function (_React$Component5) {
		(0, _inherits3.default)(NoSettings, _React$Component5);

		function NoSettings() {
			(0, _classCallCheck3.default)(this, NoSettings);
			return (0, _possibleConstructorReturn3.default)(this, (NoSettings.__proto__ || (0, _getPrototypeOf2.default)(NoSettings)).apply(this, arguments));
		}

		(0, _createClass3.default)(NoSettings, [{
			key: 'render',
			value: function render() {
				return React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						null,
						'No setting adjustments available.'
					),
					React.createElement('br', null),
					React.createElement('br', null)
				);
			}
		}]);
		return NoSettings;
	}(React.Component);

	// discard user changes & close.


	var FinishButtonBar = function (_React$Component6) {
		(0, _inherits3.default)(FinishButtonBar, _React$Component6);

		function FinishButtonBar() {
			var _ref;

			var _temp, _this6, _ret;

			(0, _classCallCheck3.default)(this, FinishButtonBar);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this6 = (0, _possibleConstructorReturn3.default)(this, (_ref = FinishButtonBar.__proto__ || (0, _getPrototypeOf2.default)(FinishButtonBar)).call.apply(_ref, [this].concat(args))), _this6), _this6.handleCancelClick = function () {
				hide();
				onVizSettings(id, oldSettings);
			}, _this6.handleDoneClick = function () {
				hide();
			}, _temp), (0, _possibleConstructorReturn3.default)(_this6, _ret);
		}

		(0, _createClass3.default)(FinishButtonBar, [{
			key: 'render',
			value: function render() {
				return React.createElement(
					'div',
					null,
					React.createElement(
						_button.Button,
						{ onMouseUp: this.handleCancelClick,
							className: _VizSettingsModule2.default.cancelButton },
						'Cancel'
					),
					React.createElement(
						_button.Button,
						{ onMouseUp: this.handleDoneClick,
							className: _VizSettingsModule2.default.confirmButton },
						'Done'
					)
				);
			}
		}]);
		return FinishButtonBar;
	}(React.Component);

	function getInputSettingsFloat(settings) {
		return _.fmap(settings, parseFloat);
	}

	var validateSettings = {
		float: function float(s) {
			var vals = _.fmap(s, parseFloat),
			    fmtErrors = _.fmap(vals, function (v, k) {
				return isNaN(v) && s[k] ? "Invalid number." : "";
			}),
			    missing = _.fmap(s, _.constant(null)),
			    rangeErrors;

			/*jshint -W018 */ /* allow xor idiom */
			if (!s.minstart !== !s.maxstart) {
				// xor
				missing.minstart = 'Both 0% values must be given to take effect.';
			}
			// XXX check for missin min & max

			if (s.minstart && s.maxstart && !fmtErrors.minstart && !fmtErrors.maxstart) {
				// wrong if missing maxStart: we compare against the wrong thing.
				rangeErrors = {
					max: null,
					maxstart: vals.maxstart <= vals.max ? null : 'Should be lower than max',
					minstart: vals.minstart <= vals.maxstart ? null : 'Should be lower than maxStart',
					min: vals.min <= vals.minstart ? null : 'Should be lower than minStart'
				};
			} else {
				rangeErrors = {
					max: null,
					min: vals.min <= vals.max ? null : 'Should be lower than max'
				};
			}

			return _.fmap(fmtErrors, function (err, k) {
				return _.filter([err, rangeErrors[k], missing[k]], _.identity).join(' ');
			});
		},
		segmented: function segmented(s) {
			var vals = _.fmap(s, parseFloat),
			    fmtErrors = _.fmap(vals, function (v) {
				return isNaN(v) ? "Invalid number." : "";
			}),
			    rangeErrors = {
				thresh: vals.thresh >= 0 ? null : 'Should be positive',
				max: vals.max >= 0 ? null : 'Should be positive'
			};
			return _.fmap(fmtErrors, function (err, k) {
				return _.filter([err, rangeErrors[k]], _.identity).join(' ');
			});
		}
	};

	function settingsValid(errors) {
		return _.every(errors, function (s) {
			return !s;
		});
	}

	var scaleAnnotations = {
		float: {
			"max": "max: high color 100% saturation",
			"maxstart": "maxStart: high color 0% saturation",
			"minstart": "minStart: low color 0% saturation",
			"min": "min: low color 100% saturation"
		},
		segmented: {
			"origin": "Origin: value for copy number normal (typically: 0 or 2)",
			"thresh": "Threshold: absolute value from origin to start showing color",
			"max": "Saturation: absolute value to draw full color"
		}
	};
	var scaleDefaults = {
		float: {
			max: 1,
			maxstart: null,
			minstart: null,
			min: -1
		},
		segmented: {
			origin: 0,
			thresh: 0,
			max: 1
		}
	};

	var ScaleChoice = function (_React$Component7) {
		(0, _inherits3.default)(ScaleChoice, _React$Component7);

		function ScaleChoice(props) {
			(0, _classCallCheck3.default)(this, ScaleChoice);

			//check if there is custom value
			var _this7 = (0, _possibleConstructorReturn3.default)(this, (ScaleChoice.__proto__ || (0, _getPrototypeOf2.default)(ScaleChoice)).call(this, props));

			_this7.autoClick = function () {
				_this7.setState({ mode: "Auto" });
				_this7.setState({ errors: {} });
				onVizSettings(id, _.omit(currentSettings.state, colorParams[valueType]));
			};

			_this7.customClick = function () {
				_this7.setState({ mode: "Custom" });
				onVizSettings(id, _.merge(currentSettings.state, getInputSettingsFloat(_this7.state.settings)));
			};

			_this7.handleChange = function (name, value) {
				var settings = _this7.state.settings,
				    newSettings = _.assoc(settings, name, value),
				    errors = validateSettings[valueType](newSettings);

				_this7.setState((0, _defineProperty3.default)({ settings: newSettings,
					errors: errors
				}, name, value));

				if (settingsValid(errors)) {
					onVizSettings(id, _.merge(currentSettings.state, getInputSettingsFloat(newSettings)));
				}
			};

			_this7.buildCustomColorScale = function () {
				var node = colorParams[valueType].map(function (param) {
					var label = scaleAnnotations[valueType][param],
					    error = _this7.state.errors[param];

					return React.createElement(
						Row,
						{ key: param },
						React.createElement(
							Col,
							{ xs4: 4, xs8: 8, sm: 6, smOffset: 6 },
							React.createElement(
								'label',
								{ className: _VizSettingsModule2.default.errorLabel },
								error
							)
						),
						React.createElement(
							Col,
							{ xs4: 4, xs8: 4, sm: 6 },
							React.createElement(
								'div',
								{ className: _VizSettingsModule2.default.inputLabel },
								label
							)
						),
						React.createElement(
							Col,
							{ xs4: 4, xs8: 4, sm: 6 },
							React.createElement(_input.Input, { type: 'text',
								value: _this7.state[param],
								className: _VizSettingsModule2.default.rangeInput,
								hint: _.contains(['minThresh', 'maxThresh'], param) ? 'Auto' : '',
								onChange: _this7.handleChange.bind(_this7, param) })
						)
					);
				});
				return node;
			};

			var custom = colorParams[valueType].some(function (param) {
				if (getVizSettings(param)) {
					return true;
				}
			}),
			    dataMin = void 0,
			    dataMax = void 0;

			if (valueType === "float") {
				dataMin = _.minnull(_.map(data.req.values, function (values) {
					return _.minnull(values);
				}));
				dataMax = _.maxnull(_.map(data.req.values, function (values) {
					return _.maxnull(values);
				}));
				scaleDefaults[valueType].min = dataMin;
				scaleDefaults[valueType].max = dataMax;
			} else if (valueType === 'segmented') {
				dataMin = _.minnull(_.map(data.req.rows, function (row) {
					return row.value;
				}));
				dataMax = _.maxnull(_.map(data.req.rows, function (row) {
					return row.value;
				}));
				if (dataMin >= 0) {
					scaleDefaults[valueType].origin = 2;
					scaleDefaults[valueType].max = 6;
				} else {
					scaleDefaults[valueType].origin = 0;
					scaleDefaults[valueType].max = dataMax;
				}
			}

			_this7.state = {
				mode: custom ? "Custom" : "Auto",
				settings: custom ? _.pick(oldSettings, colorParams[valueType]) : scaleDefaults[valueType],
				errors: {}
			};
			return _this7;
		}

		(0, _createClass3.default)(ScaleChoice, [{
			key: 'componentWillMount',
			value: function componentWillMount() {
				var _this8 = this;

				var initStates = colorParams[valueType].map(function (colorParam) {
					return _.valToStr(_this8.state.settings[colorParam]);
				});
				this.setState(_.object(colorParams[valueType], initStates));
			}
		}, {
			key: 'render',
			value: function render() {
				var _this9 = this;

				var mode = this.state.mode,
				    autoMode = this.state.mode === "Auto",
				    modes = ["Auto", "Custom"],
				    funcMapping = {
					"Auto": this.autoClick,
					"Custom": this.customClick
				},
				    buttons = modes.map(function (mode) {
					var active = _this9.state.mode === mode,
					    style = _VizSettingsModule2.default[active ? 'activeModeButton' : 'inactiveModeButton'],
					    func = funcMapping[mode];
					return React.createElement(
						_button.Button,
						{ key: mode, onMouseUp: func, className: style },
						mode
					);
				}),
				    enterInput = autoMode ? null : this.buildCustomColorScale(),
				    autocolorTransformation = valueType === "float" && fieldType !== 'clinical' ? React.createElement(NormalizationDropDown, null) : valueType === 'segmented' ? React.createElement(SegCNVnormalizationDropDown, null) : null,
				    notransformation = React.createElement(
					Row,
					null,
					React.createElement(
						Col,
						{ xs4: 4, xs8: 3, sm: 3 },
						'Color transformation'
					),
					React.createElement(
						Col,
						{ xs4: 4, xs8: 5, sm: 9 },
						'no transformation'
					)
				),
				    colorTransformation = autoMode ? autocolorTransformation : notransformation;

				return React.createElement(
					'div',
					null,
					React.createElement(
						Row,
						null,
						React.createElement(
							Col,
							{ xs4: 4, xs8: 3, sm: 3 },
							React.createElement(
								'div',
								{ className: _VizSettingsModule2.default.buttonGroupLabel },
								'Mode'
							)
						),
						React.createElement(
							Col,
							{ xs4: 4, xs8: 5, sm: 9 },
							buttons,
							React.createElement(
								'div',
								null,
								enterInput
							)
						)
					),
					React.createElement('br', null),
					colorTransformation
				);
			}
		}]);
		return ScaleChoice;
	}(React.Component);

	function setVizSettings(key, value) {
		onVizSettings(id, _.assoc(currentSettings.state, key, value));
	}

	function getVizSettings(key) {
		return _.getIn(state, [key]);
	}

	//color transformation for dense genomics matrix floats

	var NormalizationDropDown = function (_React$Component8) {
		(0, _inherits3.default)(NormalizationDropDown, _React$Component8);

		function NormalizationDropDown(props) {
			(0, _classCallCheck3.default)(this, NormalizationDropDown);

			var _this10 = (0, _possibleConstructorReturn3.default)(this, (NormalizationDropDown.__proto__ || (0, _getPrototypeOf2.default)(NormalizationDropDown)).call(this, props));

			_initialiseProps.call(_this10);

			var value = getVizSettings('colNormalization') || defaultNormalization || 'none',
			    mapping = {
				"none": "none",
				"subset": "subset",
				"log2(x)": "log2(x)",
				true: "subset"
			};

			_this10.state = {
				optionValue: mapping[value] || "none"
			};
			return _this10;
		}

		(0, _createClass3.default)(NormalizationDropDown, [{
			key: 'render',
			value: function render() {
				var dataMin = _.minnull(_.map(data.req.values, function (values) {
					return _.minnull(values);
				})),
				    optionValue = this.state.optionValue,
				    options = [{ "key": "none", "label": "none" }, { "key": "subset", "label": "center by column mean : x - column average" }];
				if (dataMin >= 0 && !_.any(units, function (unit) {
					return unit && unit.search(/log/i) !== -1;
				})) {
					// we allow log(0), necessary for RNAseq data, value =0 (no expression is very common).
					// display can handle this
					options.push({ "key": "log2(x)", "label": "log scale : log2(x+1)" });
				}
				var normalizations = options.map(function (option) {
					return {
						value: option.key,
						label: option.label
					};
				});
				return React.createElement(
					Row,
					null,
					React.createElement(
						Col,
						{ xs4: 4, xs8: 3, sm: 3 },
						React.createElement(
							'div',
							{ className: _VizSettingsModule2.default.selectLabel },
							'Color transformation'
						)
					),
					React.createElement(
						Col,
						{ xs4: 4, xs8: 5, sm: 9 },
						React.createElement(_dropdown.Dropdown, {
							auto: true,
							onChange: this.handleChange,
							source: normalizations,
							value: optionValue,
							className: _VizSettingsModule2.default.dropDown,
							theme: {
								selected: _VizSettingsModule2.default.selected
							} })
					)
				);
			}
		}]);
		return NormalizationDropDown;
	}(React.Component);

	//color transformation for segmented cnv


	var _initialiseProps = function _initialiseProps() {
		var _this15 = this;

		this.handleChange = function (value) {
			var key = "colNormalization";
			setVizSettings(key, value);
			_this15.setState({ optionValue: value });
		};
	};

	var SegCNVnormalizationDropDown = function (_React$Component9) {
		(0, _inherits3.default)(SegCNVnormalizationDropDown, _React$Component9);

		function SegCNVnormalizationDropDown(props) {
			(0, _classCallCheck3.default)(this, SegCNVnormalizationDropDown);

			var _this11 = (0, _possibleConstructorReturn3.default)(this, (SegCNVnormalizationDropDown.__proto__ || (0, _getPrototypeOf2.default)(SegCNVnormalizationDropDown)).call(this, props));

			_initialiseProps2.call(_this11);

			var value = getVizSettings('colNormalization') || defaultNormalization || 'none',
			    mapping = {
				"none": "none",
				"normal2": "normal2"
			};

			_this11.state = {
				optionValue: mapping[value] || "none"
			};
			return _this11;
		}

		(0, _createClass3.default)(SegCNVnormalizationDropDown, [{
			key: 'render',
			value: function render() {
				var optionValue = this.state.optionValue,
				    options = [{ "key": "none", "label": "normal = 0" }, { "key": "normal2", "label": "normal = 2" }],
				    normalizations = options.map(function (option) {
					return {
						value: option.key,
						label: option.label
					};
				});
				return React.createElement(
					Row,
					null,
					React.createElement(
						Col,
						{ xs4: 4, xs8: 3, sm: 3 },
						React.createElement(
							'div',
							{ className: _VizSettingsModule2.default.selectLabel },
							'Color transformation'
						)
					),
					React.createElement(
						Col,
						{ xs4: 4, xs8: 5, sm: 9 },
						React.createElement(_dropdown.Dropdown, {
							auto: true,
							onChange: this.handleChange,
							source: normalizations,
							value: optionValue,
							className: _VizSettingsModule2.default.dropDown,
							theme: {
								selected: _VizSettingsModule2.default.selected
							} })
					)
				);
			}
		}]);
		return SegCNVnormalizationDropDown;
	}(React.Component);

	//color palette dense matrix floats and segmented CNV


	var _initialiseProps2 = function _initialiseProps2() {
		var _this16 = this;

		this.handleChange = function (value) {
			var key = "colNormalization";
			setVizSettings(key, value);
			_this16.setState({ optionValue: value });
		};
	};

	var ColorDropDown = function (_React$Component10) {
		(0, _inherits3.default)(ColorDropDown, _React$Component10);

		function ColorDropDown(props) {
			(0, _classCallCheck3.default)(this, ColorDropDown);

			var _this12 = (0, _possibleConstructorReturn3.default)(this, (ColorDropDown.__proto__ || (0, _getPrototypeOf2.default)(ColorDropDown)).call(this, props));

			_initialiseProps3.call(_this12);

			var value = getVizSettings('colorClass') || 'default';

			_this12.state = {
				optionValue: value
			};
			return _this12;
		}

		(0, _createClass3.default)(ColorDropDown, [{
			key: 'render',
			value: function render() {
				var optionValue = this.state.optionValue,
				    options = {
					float: [{ "key": "default", "label": "red-white-blue" }, { "key": "expression", "label": "red-black-green" }, { "key": "blueBlackYellow", "label": "yellow-black-blue" }, { "key": "whiteBlack", "label": "black-white" }],
					segmented: [{ "key": "default", "label": "red-white-blue" }, { "key": "expression", "label": "red-white-green" }, { "key": "blueBlackYellow", "label": "yellow-white-blue" }]
				},
				    colors = options[valueType].map(function (option) {
					return {
						value: option.key,
						label: option.label
					};
				});
				return React.createElement(
					Row,
					null,
					React.createElement(
						Col,
						{ xs4: 4, xs8: 3, sm: 3 },
						React.createElement(
							'div',
							{ className: _VizSettingsModule2.default.selectLabel },
							'Color palette'
						)
					),
					React.createElement(
						Col,
						{ xs4: 4, xs8: 5, sm: 9 },
						React.createElement(_dropdown.Dropdown, {
							auto: true,
							onChange: this.handleChange,
							source: colors,
							value: optionValue,
							className: _VizSettingsModule2.default.dropDown,
							theme: {
								selected: _VizSettingsModule2.default.selected
							} })
					)
				);
			}
		}]);
		return ColorDropDown;
	}(React.Component);

	//color palette for SV


	var _initialiseProps3 = function _initialiseProps3() {
		var _this17 = this;

		this.handleChange = function (value) {
			var key = "colorClass";
			setVizSettings(key, value);
			_this17.setState({ optionValue: value });
		};
	};

	var SvColorDropDown = function (_React$Component11) {
		(0, _inherits3.default)(SvColorDropDown, _React$Component11);

		function SvColorDropDown(props) {
			(0, _classCallCheck3.default)(this, SvColorDropDown);

			var _this13 = (0, _possibleConstructorReturn3.default)(this, (SvColorDropDown.__proto__ || (0, _getPrototypeOf2.default)(SvColorDropDown)).call(this, props));

			_initialiseProps4.call(_this13);

			var value = getVizSettings('svColor') || 'default';

			_this13.state = {
				optionValue: value
			};
			return _this13;
		}

		(0, _createClass3.default)(SvColorDropDown, [{
			key: 'render',
			value: function render() {
				var optionValue = this.state.optionValue,
				    options = {
					SV: [{ "key": "default", "label": "lavender" }, { "key": "chromosomeGB", "label": "by chromosome (Genome Browser)" }, { "key": "chromosomePCAWG", "label": "by chromosome (PCAWG)" }]
				},
				    colors = options[fieldType].map(function (option) {
					return {
						value: option.key,
						label: option.label
					};
				});
				return React.createElement(
					Row,
					null,
					React.createElement(
						Col,
						{ xs4: 4, xs8: 3, sm: 3 },
						React.createElement(
							'div',
							{ className: _VizSettingsModule2.default.selectLabel },
							'Color palette'
						)
					),
					React.createElement(
						Col,
						{ xs4: 4, xs8: 5, sm: 9 },
						React.createElement(_dropdown.Dropdown, {
							auto: true,
							onChange: this.handleChange,
							source: colors,
							value: optionValue,
							className: _VizSettingsModule2.default.dropDown,
							theme: {
								selected: _VizSettingsModule2.default.selected
							} })
					)
				);
			}
		}]);
		return SvColorDropDown;
	}(React.Component);

	//user label for Categories


	var _initialiseProps4 = function _initialiseProps4() {
		var _this18 = this;

		this.handleChange = function (value) {
			var key = "svColor";
			setVizSettings(key, value);
			_this18.setState({ optionValue: value });
		};
	};

	var CategoricalTable = function (_React$Component12) {
		(0, _inherits3.default)(CategoricalTable, _React$Component12);

		function CategoricalTable(props) {
			(0, _classCallCheck3.default)(this, CategoricalTable);

			var parseVizSettingCodes = function parseVizSettingCodes(str) {
				if (!_.isString(str)) {
					return undefined;
				}

				var codes = JSON.parse(str),
				    observed = (0, _stringify2.default)(_.keys(codes).sort(function sortNumber(a, b) {
					return a - b;
				})),
				    expected = (0, _stringify2.default)(_.range(_.keys(codes).length).map(function (x) {
					return x.toString();
				}));

				if (observed === expected) {
					return codes;
				}
				return undefined;
			};

			var _this14 = (0, _possibleConstructorReturn3.default)(this, (CategoricalTable.__proto__ || (0, _getPrototypeOf2.default)(CategoricalTable)).call(this, props));

			_this14.handleChange = function (i, value) {
				var codes = _this14.state;

				codes[i] = value;
				setVizSettings('codes', (0, _stringify2.default)(codes));
				_this14.setState((0, _defineProperty3.default)({}, i, value));
			};

			_this14.onRest = function (i, originalCode) {
				var codes = _this14.state,
				    value = originalCode;

				codes[i] = value;
				setVizSettings('codes', (0, _stringify2.default)(codes));
				_this14.setState((0, _defineProperty3.default)({}, i, value));
			};

			_this14.buildCoded = function (index, codes, originalCodes, customColors) {
				var node = index.map(function (i) {
					var code = codes[i.toString()],
					    originalCode = originalCodes[i],
					    backgroundColor = customColors ? customColors[i] : _colorScales.categoryMore[i % _colorScales.categoryMore.length];

					return React.createElement(
						Row,
						{ key: i },
						React.createElement(
							Col,
							{ xs4: 1, xs8: 1, sm: 1 },
							React.createElement('div', { className: _VizSettingsModule2.default.categoryColor,
								style: { backgroundColor: backgroundColor } })
						),
						React.createElement(
							Col,
							{ xs4: 4, xs8: 4, sm: 6 },
							React.createElement(_input.Input, { type: 'text',
								value: code,
								className: _VizSettingsModule2.default.categoryInput,
								onChange: _this14.handleChange.bind(_this14, i) })
						),
						code !== originalCode ? React.createElement(
							Col,
							null,
							React.createElement(
								_button.Button,
								{ onMouseUp: _this14.onRest.bind(_this14, i, originalCode),
									className: _VizSettingsModule2.default.cancelButton },
								'Reset'
							)
						) : null
					);
				});
				return node;
			};

			_this14.state = parseVizSettingCodes(getVizSettings('codes')) || _.object(_.range(data.codes.length), data.codes);
			return _this14;
		}

		(0, _createClass3.default)(CategoricalTable, [{
			key: 'render',
			value: function render() {
				var customColors = _.getIn(column, ['colors', 0, 2]),
				    codes = this.state,
				    originalCodes = _.getIn(data, ['codes']),
				    index = _.intersection(_.getIn(data, ['req', 'values', 0]), _.range(data.codes.length));

				index.sort(function sortNumber(a, b) {
					return a - b;
				}).reverse();

				return React.createElement(
					'div',
					null,
					React.createElement(
						Row,
						null,
						React.createElement(
							Col,
							{ xs4: 1, xs8: 1, sm: 1 },
							React.createElement(
								'div',
								{ className: _VizSettingsModule2.default.selectLabel },
								'Color'
							)
						),
						React.createElement(
							Col,
							{ xs4: 4, xs8: 4, sm: 6 },
							React.createElement(
								'div',
								{ className: _VizSettingsModule2.default.selectLabel },
								'Label'
							)
						)
					),
					this.buildCoded(index, codes, originalCodes, customColors)
				);
			}
		}]);
		return CategoricalTable;
	}(React.Component);

	var state = vizState,
	    oldSettings = state,
	    currentSettings = { state: state },
	    colorParams = {
		float: ["max", "maxstart", "minstart", "min"],
		segmented: ["origin", "thresh", "max"]
	};

	ReactDOM.render(React.createElement(DatasetSetting), node);
	return currentSettings;
}

// react wrapper for the legacy DOM code, above.

var SettingsWrapper = function (_React$Component13) {
	(0, _inherits3.default)(SettingsWrapper, _React$Component13);

	function SettingsWrapper() {
		(0, _classCallCheck3.default)(this, SettingsWrapper);
		return (0, _possibleConstructorReturn3.default)(this, (SettingsWrapper.__proto__ || (0, _getPrototypeOf2.default)(SettingsWrapper)).apply(this, arguments));
	}

	(0, _createClass3.default)(SettingsWrapper, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate() {
			return false;
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			this.currentSettings.state = newProps.vizSettings;
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var content = this.refs.content,
			    _props = this.props,
			    data = _props.data,
			    column = _props.column,
			    units = _props.units,
			    onVizSettings = _props.onVizSettings,
			    vizSettings = _props.vizSettings,
			    id = _props.id,
			    defaultNormalization = _props.defaultNormalization,
			    colorClass = _props.colorClass,
			    valueType = _props.valueType,
			    fieldType = _props.fieldType,
			    onRequestHide = _props.onRequestHide;


			this.currentSettings = vizSettingsWidget(content, onVizSettings, vizSettings, id, onRequestHide, defaultNormalization, colorClass, valueType, fieldType, data, units, column);
		}
	}, {
		key: 'render',
		value: function render() {
			return React.createElement('div', { ref: 'content' });
		}
	}]);
	return SettingsWrapper;
}(React.Component);

var VizSettings = function (_React$Component14) {
	(0, _inherits3.default)(VizSettings, _React$Component14);

	function VizSettings() {
		(0, _classCallCheck3.default)(this, VizSettings);
		return (0, _possibleConstructorReturn3.default)(this, (VizSettings.__proto__ || (0, _getPrototypeOf2.default)(VizSettings)).apply(this, arguments));
	}

	(0, _createClass3.default)(VizSettings, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.documentElement.scrollTop = 0;
			var body = document.getElementById("body");
			body.style.overflow = "auto";
		}
	}, {
		key: 'render',
		value: function render() {
			var onRequestHide = this.props.onRequestHide;


			var actions = [{
				children: [React.createElement(
					'i',
					{ className: 'material-icons' },
					'close'
				)],
				className: _VizSettingsModule2.default.dialogClose,
				onClick: onRequestHide
			}];

			return React.createElement(
				_dialog.Dialog,
				{
					actions: actions,
					active: true,
					title: 'Adjust Display Settings',
					className: _VizSettingsModule2.default.dialog,
					onEscKeyDown: onRequestHide,
					onOverlayClick: onRequestHide,
					theme: {
						wrapper: _VizSettingsModule2.default.dialogWrapper,
						overlay: _VizSettingsModule2.default.dialogOverlay } },
				React.createElement(SettingsWrapper, this.props)
			);
		}
	}]);
	return VizSettings;
}(React.Component);

module.exports = VizSettings;