'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _underscore_ext = require('./../underscore_ext');

var _WelcomeModule = require('./Welcome.module.css');

var _WelcomeModule2 = _interopRequireDefault(_WelcomeModule);

var _typographyModule = require('../../css/typography.module.css');

var _typographyModule2 = _interopRequireDefault(_typographyModule);

var _iconXena = require('../../images/iconXena.png');

var _iconXena2 = _interopRequireDefault(_iconXena);

var _iconXena2x = require('../../images/iconXena@2x.png');

var _iconXena2x2 = _interopRequireDefault(_iconXena2x);

var _iconXena3x = require('../../images/iconXena@3x.png');

var _iconXena3x2 = _interopRequireDefault(_iconXena3x);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var welcomeSrcSet = _iconXena2x2.default + ' 2x, ' + _iconXena3x2.default + ' 3x';

// Images


// Styles
/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Welcome bar component, displayed when user visits Xena. Dismissed by close icon in top right corner.
 *
 * Visibility of welcome bar is controlled by parent component.
 *
 * Single action, onClick, is invoked to update the visibility state of the welcome bar.
 */

// Core dependencies, components

var Welcome = function (_Component) {
	(0, _inherits3.default)(Welcome, _Component);

	function Welcome() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, Welcome);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Welcome.__proto__ || (0, _getPrototypeOf2.default)(Welcome)).call.apply(_ref, [this].concat(args))), _this), _this.dismissWelcome = function () {
			_this.props.onClick();
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(Welcome, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$link = (0, _slicedToArray3.default)(_props.link, 3),
			    app = _props$link[0],
			    bookmark = _props$link[1],
			    text = _props$link[2],
			    count = _props.count,
			    i = _props.i,
			    linkProps = _props.linkProps,
			    bulletProps = _props.bulletProps,
			    link = document.location.origin + '/' + app + '/?bookmark=' + bookmark;

			return _react2.default.createElement(
				'div',
				{ className: _WelcomeModule2.default.Welcome },
				_react2.default.createElement(
					'div',
					{ className: _WelcomeModule2.default.welcomeIcon },
					_react2.default.createElement('img', { className: _WelcomeModule2.default.imgXena, src: _iconXena2.default, srcSet: welcomeSrcSet })
				),
				_react2.default.createElement(
					'div',
					{ className: _WelcomeModule2.default.welcomeText },
					_react2.default.createElement(
						'h1',
						{ className: _typographyModule2.default.mdHeadline },
						'Welcome to the Xena Functional Genomics Explorer'
					),
					_react2.default.createElement(
						'h2',
						{ className: _typographyModule2.default.mdSubhead },
						'UCSC Xena allows users to explore functional genomic data sets for correlations between genomic and/or phenotypic variables.'
					),
					_react2.default.createElement(
						'h2',
						{ className: _typographyModule2.default.mdSubhead },
						'View live example: ',
						_react2.default.createElement(
							'a',
							(0, _extends3.default)({}, linkProps, { href: link,
								target: '_blank' }),
							text
						)
					),
					_react2.default.createElement(
						'div',
						{ className: _WelcomeModule2.default.bulletWrapper },
						_react2.default.createElement(
							'div',
							{ className: _WelcomeModule2.default.bullets },
							(0, _underscore_ext.times)(count, function (j) {
								return _react2.default.createElement(
									'div',
									(0, _extends3.default)({
										key: j,
										'data-index': j
									}, bulletProps, {
										className: i === j ? _WelcomeModule2.default.bulletActive : _WelcomeModule2.default.bullet }),
									'\u2022'
								);
							})
						)
					)
				),
				_react2.default.createElement(
					'div',
					{ className: _WelcomeModule2.default.closeIcon, onClick: this.dismissWelcome },
					_react2.default.createElement(
						'i',
						{ className: 'material-icons' },
						'close'
					)
				)
			);
		}
	}]);
	return Welcome;
}(_react.Component);

module.exports = Welcome;