'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _button = require('react-toolbox/lib/button');

var _card = require('react-toolbox/lib/card');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Card displayed during (wizard-based) setup.
 *
 * State
 * -----
 * colId - ID of column (eg 'A', 'B'). Only applicable on edit of column.
 * controls - Icons and/or menu displayed at right of card title.
 * helpText - Text displayed under title/subtitle and above children.
 * title - Text displayed as title.
 * valid - True if wizard card is complete and done button is enabled.
 * width - Width of card.
 *
 * Actions
 * -------
 * onDone - Called when DONE button is clicked.
 */

// Core dependencies, components
var React = require('react');


var spinner = require('../ajax-loader.gif');

// App dependencies
var CardAvatar = require('./CardAvatar');

// Styles
var compStyles = require('./WizardCard.module.css');
var cardStyles = require('./RTCardTheme.module.css');
var classname = require('classnames');

var WizardCard = function (_React$Component) {
	(0, _inherits3.default)(WizardCard, _React$Component);

	function WizardCard() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, WizardCard);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = WizardCard.__proto__ || (0, _getPrototypeOf2.default)(WizardCard)).call.apply(_ref, [this].concat(args))), _this), _this.onDone = function () {
			_this.props.onDone();
		}, _this.onDoneInvalid = function (ev) {
			var _this$props = _this.props,
			    valid = _this$props.valid,
			    onDoneInvalid = _this$props.onDoneInvalid;

			if (onDoneInvalid && !valid) {
				onDoneInvalid(ev);
			}
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(WizardCard, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    colId = _props.colId,
			    controls = _props.controls,
			    contentSpecificHelp = _props.contentSpecificHelp,
			    title = _props.title,
			    subtitle = _props.subtitle,
			    valid = _props.valid,
			    loading = _props.loading,
			    loadingCohort = _props.loadingCohort,
			    width = _props.width;

			return React.createElement(
				_card.Card,
				{ style: { width: width }, className: compStyles.WizardCard },
				React.createElement(
					'div',
					{ className: compStyles.headerContainer },
					React.createElement(CardAvatar, { colId: colId }),
					React.createElement(
						'div',
						{ className: compStyles.controls },
						controls
					)
				),
				React.createElement(
					'div',
					{ className: compStyles.titleContainer },
					React.createElement(_card.CardTitle, { className: classname(compStyles.title, subtitle ? cardStyles.warning : ''), title: title, subtitle: subtitle })
				),
				React.createElement(
					'div',
					{ className: compStyles.content },
					contentSpecificHelp ? React.createElement(
						_card.CardText,
						null,
						contentSpecificHelp
					) : null,
					loadingCohort ? React.createElement(
						_card.CardText,
						null,
						'Loading datasets...'
					) : null,
					children
				),
				React.createElement(
					_card.CardActions,
					{ className: compStyles.actions },
					loading ? React.createElement('img', { src: spinner }) : null,
					valid ? React.createElement(
						'i',
						{ className: 'material-icons' },
						'done'
					) : null,
					React.createElement(
						'span',
						{ onClick: this.onDoneInvalid },
						React.createElement(
							_button.Button,
							{ accent: true, disabled: !valid, onClick: this.onDone },
							'Done'
						)
					)
				)
			);
		}
	}]);
	return WizardCard;
}(React.Component);

module.exports = WizardCard;