'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAutosuggest = require('react-autosuggest');

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _AutosuggestThemeModule = require('./AutosuggestTheme.module.css');

var _AutosuggestThemeModule2 = _interopRequireDefault(_AutosuggestThemeModule);

var _XAutosuggestModule = require('./XAutosuggest.module.css');

var _XAutosuggestModule2 = _interopRequireDefault(_XAutosuggestModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Styles
/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena autosuggest, with UI/UX based on Material Design's full-width inputs. Light wrapper around
 * react-autosuggest package.
 *
 * All props with the exception of the state and actions specified below, are passed directly to Autosuggest.
 *
 * State
 * -----
 * value - Current selected value.
 *
 * Actions
 * -------
 * onClear - Called on click of clear (X) button.
 */

/*
 * Unfortunate behaviors of react-autosuggest
 * ghost suggestions
 *   https://github.com/moroshko/react-autosuggest/issues/596
 * escape clears input
 *   This is part of ARIA specification, but react-autosuggest implements it
 *   at variance with the spec (an editable autosuggest should clear the
 *   suggested text, not all text), and in practice the prescribed AIRA
 *   behavior is not usable, because escape also closes suggestions, making
 *   it very common to lose input accidentally.
 *
 */

// Core dependencies, components
var XAutosuggest = function (_React$Component) {
  (0, _inherits3.default)(XAutosuggest, _React$Component);

  function XAutosuggest() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, XAutosuggest);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = XAutosuggest.__proto__ || (0, _getPrototypeOf2.default)(XAutosuggest)).call.apply(_ref, [this].concat(args))), _this), _this.callInputRef = function (autosuggest) {
      var _this$props = _this.props,
          inputRef = _this$props.inputRef,
          autosuggestRef = _this$props.autosuggestRef;

      if (inputRef) {
        inputRef(autosuggest && autosuggest.input);
      }
      if (autosuggestRef) {
        autosuggestRef(autosuggest);
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(XAutosuggest, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          onClear = _props.onClear,
          autoProps = (0, _objectWithoutProperties3.default)(_props, ['value', 'onClear']);

      return _react2.default.createElement(
        'div',
        { className: _XAutosuggestModule2.default.XAutosuggest },
        _react2.default.createElement(_reactAutosuggest2.default, (0, _extends3.default)({}, autoProps, { ref: this.callInputRef, theme: _AutosuggestThemeModule2.default })),
        value ? _react2.default.createElement(
          'i',
          { className: 'material-icons', onClick: onClear },
          'close'
        ) : null
      );
    }
  }]);
  return XAutosuggest;
}(_react2.default.Component);

exports.default = XAutosuggest;