'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

var _checkbox = require('react-toolbox/lib/checkbox');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react'); /**
                               * UCSC Xena Client
                               * http://xena.ucsc.edu
                               *
                               * Standard Xena checkbox group, with UI/UX based on Material Design's full-width inputs. This is a light wrapper
                               * component around React Toolbox's Checkbox (applies custom class name for styling checkbox group).
                               *
                               * State
                               * -----
                               * label - checkbox group field name.
                               * additionalAction - display text of additional action.
                               * options - array of checkbox option objects in format, {label?, options: [{label, value}]}. If top-level label is
                               *           specified, nested options array is grouped under that label (for advanced view functionality).
                               *
                               * Actions
                               * -------
                               * onAdditionalAction - called when additional action link is clicked.
                               * onChange - called when a checkbox value is changed.
                               */

// Core dependencies, components


var _ = require('../underscore_ext');
var XInputToolbar = require('./XInputToolbar');
var classNames = require('classnames');

// Styles
var compStyles = require('./XCheckboxGroup.module.css');

var XCheckboxGroup = function (_PureComponent) {
	(0, _inherits3.default)(XCheckboxGroup, _PureComponent);

	function XCheckboxGroup() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, XCheckboxGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = XCheckboxGroup.__proto__ || (0, _getPrototypeOf2.default)(XCheckboxGroup)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (isOn, ev) {
			var value = ev.target.dataset.value;
			_this.props.onChange(value, isOn);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(XCheckboxGroup, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    additionalAction = _props.additionalAction,
			    label = _props.label,
			    onAdditionalAction = _props.onAdditionalAction,
			    options = _props.options,
			    hideBadge = _props.hideBadge;

			return React.createElement(
				'div',
				{ className: classNames(compStyles.XCheckboxGroup, hideBadge && compStyles.hideBadge) },
				React.createElement(XInputToolbar, { label: label, additionalAction: additionalAction, onAdditionalAction: onAdditionalAction }),
				_.map(options, function (group) {
					return [group.label ? React.createElement(
						'span',
						{ className: compStyles.subgroupHeader },
						group.label
					) : null, _.map(group.options, function (o) {
						return React.createElement(
							'span',
							null,
							React.createElement(_checkbox.Checkbox, { className: o.badge ? compStyles.withBadge : null,
								children: o.badge ? React.createElement(
									'div',
									{ className: compStyles.badge,
										style: o.badge.style },
									o.badge.label
								) : [],
								'data-value': o.value,
								key: o.label,
								label: o.label,
								checked: o.checked,
								onChange: _this2.onChange })
						);
					})];
				})
			);
		}
	}]);
	return XCheckboxGroup;
}(_PureComponent3.default);

module.exports = XCheckboxGroup;