'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena input toolbar, displayed above radio group or checkbox group. Displays input field name and optionally,
 * an additional action with corresponding click handler.
 *
 * State
 * -----
 * - Label
 * - Additional Action
 *
 * Actions
 * -------
 * - onAdditionalAction
 */

// Core dependencies, components
var React = require('react');

// Styles
var compStyles = require('./XInputToolbar.module.css');

var XInputGroup = function (_React$Component) {
  (0, _inherits3.default)(XInputGroup, _React$Component);

  function XInputGroup() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, XInputGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = XInputGroup.__proto__ || (0, _getPrototypeOf2.default)(XInputGroup)).call.apply(_ref, [this].concat(args))), _this), _this.onAdditionalAction = function (value) {
      _this.props.onAdditionalAction(value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(XInputGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          additionalAction = _props.additionalAction,
          label = _props.label;

      return React.createElement(
        'div',
        { className: compStyles.toolbar },
        label ? React.createElement(
          'span',
          { className: compStyles.label },
          label
        ) : null,
        additionalAction ? React.createElement(
          'span',
          { className: compStyles.additionalAction,
            onClick: this.onAdditionalAction },
          additionalAction
        ) : null
      );
    }
  }]);
  return XInputGroup;
}(React.Component);

module.exports = XInputGroup;