'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _radio = require('react-toolbox/lib/radio');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena radio group, with UI/UX based on Material Design's full-width inputs. This is a light wrapper component
 * around React Toolbox's RadioGroup (applies custom class name for styling radio group).
 *
 * State
 * -----
 * label - radio group field name.
 * additionalAction - display text of additional action.
 * options - array of radio options in format {label, value, meta: [{label, value}]}
 *
 * Actions
 * -------
 * onAdditionalAction - called when additional action link is clicked.
 * onChange - called when selected radio value is changed.
 */

// Core dependencies, components
var React = require('react');

//import {RadioButton} from 'react-toolbox/lib/radio';
var _ = require('../underscore_ext');
var XRadioMeta = require('./XRadioMeta');
var XInputToolbar = require('./XInputToolbar');

// Styles
var compStyles = require('./XRadioGroup.module.css');

var XRadioGroup = function (_React$Component) {
  (0, _inherits3.default)(XRadioGroup, _React$Component);

  function XRadioGroup() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, XRadioGroup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = XRadioGroup.__proto__ || (0, _getPrototypeOf2.default)(XRadioGroup)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (value) {
      _this.props.onChange(value);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(XRadioGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          additionalAction = _props.additionalAction,
          label = _props.label,
          onAdditionalAction = _props.onAdditionalAction,
          options = _props.options,
          value = _props.value;

      return React.createElement(
        'div',
        { className: compStyles.XRadioGroup },
        React.createElement(XInputToolbar, { label: label, additionalAction: additionalAction, onAdditionalAction: onAdditionalAction }),
        React.createElement(
          _radio.RadioGroup,
          { value: value, onChange: this.onChange },
          _.map(options, function (o) {
            return [React.createElement(_radio.RadioButton, { label: o.label, value: o.value }), o.meta ? React.createElement(XRadioMeta, { meta: o.meta }) : null];
          })
        )
      );
    }
  }]);
  return XRadioGroup;
}(React.Component);

module.exports = XRadioGroup;