'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _PureComponent2 = require('../PureComponent');

var _PureComponent3 = _interopRequireDefault(_PureComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var React = require('react');

// Styles
/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Standard Xena spreadsheet zoom carriage. Displays zoom carriage and zoom reference lines to Columns spreadsheet.
 *
 */

var compStyles = require('./ZoomCarriage.module.css');
var classNames = require('classnames');

var ZoomCarriage = function (_PureComponent) {
	(0, _inherits3.default)(ZoomCarriage, _PureComponent);

	function ZoomCarriage() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ZoomCarriage);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ZoomCarriage.__proto__ || (0, _getPrototypeOf2.default)(ZoomCarriage)).call.apply(_ref, [this].concat(args))), _this), _this.getRotation = function (angle) {
			return 'rotate(' + angle + 'deg)';
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ZoomCarriage, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    addColumnAddHover = _props.addColumnAddHover,
			    enableTransition = _props.enableTransition,
			    samplesCount = _props.samplesCount,
			    zoom = _props.zoom,
			    zoomCarriageMargin = addColumnAddHover ? 3 : 11,
			    carriageStart = Math.floor(zoom.height / samplesCount * zoom.index),
			    carriageHeight = Math.floor(zoom.height / samplesCount * zoom.count),
			    carriageEnd = carriageStart + carriageHeight,
			    heightBelowCarriage = zoom.height - carriageStart - carriageHeight,
			    upperAngle = -Math.atan(carriageStart / zoomCarriageMargin) * 180 / Math.PI,
			    upperLine = Math.sqrt(Math.pow(zoomCarriageMargin, 2) + Math.pow(carriageStart, 2)),
			    lowerAngle = Math.atan(heightBelowCarriage / zoomCarriageMargin) * 180 / Math.PI,
			    lowerLine = Math.sqrt(Math.pow(zoomCarriageMargin, 2) + Math.pow(heightBelowCarriage, 2));

			return React.createElement(
				'div',
				{ className: compStyles.zoomCarriage },
				React.createElement('div', { className: compStyles.carriage, style: { height: carriageHeight, top: carriageStart } }),
				React.createElement('div', { className: classNames(compStyles.carriageLines, compStyles.upper, (0, _defineProperty3.default)({}, compStyles.transitionRotate, enableTransition)),
					style: { top: carriageStart, transform: this.getRotation(upperAngle), width: upperLine } }),
				React.createElement('div', { className: classNames(compStyles.carriageLines, compStyles.lower, (0, _defineProperty3.default)({}, compStyles.transitionRotate, enableTransition)),
					style: { top: carriageEnd, transform: this.getRotation(lowerAngle), width: lowerLine } })
			);
		}
	}]);
	return ZoomCarriage;
}(_PureComponent3.default);

;

module.exports = ZoomCarriage;