'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UCSC Xena Client
 * http://xena.ucsc.edu
 *
 * Overlay displayed on mousedown and drag over gene or samples zoom.
 */

// Core dependencies, components
var React = require('react');
var classNames = require('classnames');

// Styles
var compStyles = require('./ZoomOverlay.module.css');

var ZoomOverlay = function (_React$Component) {
	(0, _inherits3.default)(ZoomOverlay, _React$Component);

	function ZoomOverlay() {
		(0, _classCallCheck3.default)(this, ZoomOverlay);
		return (0, _possibleConstructorReturn3.default)(this, (ZoomOverlay.__proto__ || (0, _getPrototypeOf2.default)(ZoomOverlay)).apply(this, arguments));
	}

	(0, _createClass3.default)(ZoomOverlay, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    geneHeight = _props.geneHeight,
			    height = _props.height,
			    positionHeight = _props.positionHeight,
			    selection = _props.selection,
			    children = _props.children;

			if (selection) {
				var direction = selection.direction,
				    offset = selection.offset,
				    overlay = selection.overlay,
				    annotationZoom = direction === 'h',
				    noSamples = overlay.send === null && overlay.sstart === null,
				    iEnd = overlay.iend,
				    iStart = overlay.istart,
				    sEnd = annotationZoom && noSamples ? (iEnd - iStart) / 2 + iStart : overlay.send,
				    sStart = annotationZoom && noSamples ? (iEnd - iStart) / 2 + iStart : overlay.sstart,
				    sEndSamples = sEnd + offset.y,
				    sStartSamples = sStart + offset.y,
				    iStartSamples = iStart ? iStart + offset.y : sStartSamples,
				    iEndSamples = iEnd ? iEnd + offset.y : sEndSamples,
				    posY1Annotation = 0,
				    posY2Annotation = 8,
				    posY5Annotation = posY2Annotation + geneHeight + height,
				    posY4Annotation = posY5Annotation - height - 2,
				    posY3Annotation = posY4Annotation - positionHeight + 2,
				    posX1Samples = iStartSamples === sStartSamples && iEndSamples === sEndSamples ? 20 : 26,
				    posX2Samples = iStartSamples === sStartSamples && iEndSamples === sEndSamples ? posX1Samples : posX1Samples + 12,
				    posX3Samples = window.innerWidth,
				    polygonPoints = annotationZoom ? iStart + ',' + posY1Annotation + ' ' + iEnd + ',' + posY1Annotation + ' ' + iEnd + ',' + posY3Annotation + ' ' + sEnd + ',' + posY4Annotation + ' ' + sEnd + ',' + posY5Annotation + ' ' + sStart + ',' + posY5Annotation + ' ' + sStart + ',' + posY4Annotation + ' ' + iStart + ',' + posY3Annotation + ' ' + iStart + ',' + posY1Annotation : '0,' + iStartSamples + ' ' + posX1Samples + ',' + iStartSamples + ' ' + posX2Samples + ',' + sStartSamples + ' ' + posX3Samples + ',' + sStartSamples + ' ' + posX3Samples + ',' + sEndSamples + ' ' + posX2Samples + ',' + sEndSamples + ' ' + posX1Samples + ',' + iEndSamples + ' 0,' + iEndSamples + ' 0,' + sStartSamples;
			}
			return React.createElement(
				'div',
				{ className: compStyles.ZoomOverlay },
				children,
				selection ? React.createElement(
					'svg',
					{
						className: classNames(compStyles.overlay, (0, _defineProperty3.default)({}, compStyles.overlayV, !annotationZoom), (0, _defineProperty3.default)({}, compStyles.overlayH, annotationZoom)),
						style: { height: annotationZoom ? posY5Annotation : '100%' } },
					React.createElement('polygon', { points: polygonPoints })
				) : null
			);
		}
	}]);
	return ZoomOverlay;
}(React.Component);

module.exports = ZoomOverlay;