'use strict';

/*global define: false */
var Rx = require('./rx');

var _require = require('./util'),
    encodeObject = _require.encodeObject;

var _require2 = require('./underscore_ext'),
    isArray = _require2.isArray,
    merge = _require2.merge;

function update(host, files, flags) {
	files = isArray(files) ? files : [files];
	return {
		headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
		url: host + '/update/',
		body: encodeObject(merge({ file: files }, flags)),
		method: 'POST',
		crossDomain: true
	};
}

module.exports = {
	load: function load(host, files, always) {
		return Rx.Observable.ajax(update(host, files, always ? { always: true } : {}));
	},
	delete: function _delete(host, files) {
		return Rx.Observable.ajax(update(host, files, { delete: true }));
	}
};